// 基本スクリプト.
//

////////////////////////////////////////////////////////////////////////////////
// 基本JavaObject定義.
////////////////////////////////////////////////////////////////////////////////
JsDef = pkg("org.maachang.seabass.httpd.engine.script.js.JsDef") ;
ConvertTag = pkg("org.maachang.seabass.httpd.engine.script.js.ConvertTag") ;
SeabassDef = pkg("org.maachang.seabass.SeaBassDef") ;
HttpdDef = pkg("org.maachang.seabass.httpd.engine.HttpdDef") ;
ScriptDef = pkg("org.maachang.seabass.httpd.engine.script.ScriptDef") ;
HttpdTimestamp = pkg( "org.maachang.seabass.httpd.engine.HttpdTimestamp" ) ;
PageCache = pkg("org.maachang.seabass.httpd.engine.script.scripts.PageCache") ;
HttpdMode = pkg("org.maachang.seabass.httpd.HttpdMode") ;
HttpdVersionDef = pkg("org.maachang.seabass.httpd.HttpdVersionDef") ;
CacheScriptManager = pkg("org.maachang.seabass.httpd.engine.script.cache.CacheScriptManager") ;
DigestUtil = pkg("org.maachang.util.Digest") ;
StringUtil = pkg("org.maachang.util.StringUtil") ;
RandomUtil = pkg("org.maachang.util.RandomUtil") ;
OutputFactory = pkg("org.maachang.seabass.httpd.engine.script.scripts.OutputHtmlFactory") ;
URLEncoder = pkg("java.net.URLEncoder") ;
URLDecoder = pkg("java.net.URLDecoder") ;
RoundingMode = pkg( "java.math.RoundingMode" ) ;
_$SeabassState = pkg( "org.maachang.seabass.State" ) ;

////////////////////////////////////////////////////////////////////////////////
// const 定義.
////////////////////////////////////////////////////////////////////////////////
var Day = {
    SUN : 0,    // 日曜日.
    MON : 1,    // 月曜日.
    TUES : 2,   // 火曜日.
    WED : 3,    // 水曜日.
    THURS : 4,  // 木曜日.
    FRY : 5,    // 金曜日.
    SAT : 6     // 土曜日
} ;

////////////////////////////////////////////////////////////////////////////////
// path系.
////////////////////////////////////////////////////////////////////////////////

// 現在読み込みスクリプト名を取得.
currentName = function() {
    return _$current$name ;
} ;

// カレントパスを取得.
currentPath = function() {
    return _$path$currentPath ;
} ;

// スクリプトパスを取得.
scriptPath = function() {
    return _$path$scriptPath ;
} ;

// モデルパスを取得.
modelPath = function() {
    return _$path$modelPath ;
} ;

// コンパイル結果を破棄.
clearApp = function() {
    _$$seabass_manager.get( "WEBAPP_FACTORY" ).clear() ;
}

// Seabassステータス関係.
SeabassState = {
    changeTime : function() {
        return _$SeabassState.getInstance().time() ;
    },
    getState : function() {
        return _$SeabassState.getInstance().state() ;
    },
    getStateString : function() {
        return _$SeabassState.getInstance().toString() ;
    },
    setState : function( state ) {
        return _$SeabassState.getInstance().state( state ) ;
    }
}

////////////////////////////////////////////////////////////////////////////////
// 基本系.
////////////////////////////////////////////////////////////////////////////////

// シングルコート.
S = function() {
    return "\'" ;
}

// ダブルコート.
D = function() {
    return "\"" ;
}

// 指定内容に対して、情報が存在するかチェックする.
useEmpty = function( value ) {
    if( isNull( value ) ) {
        return false ;
    }
    if( value instanceof org.maachang.seabass.httpd.HttpdBinary ) {
        return value.getLength() > 0 ;
    }
    return ( isEmpty( value ) == false ) ;
}

// startsWith.
startsWith = function(str,o) {
    if( useString( str ) == false ) {
        str = convertString( o ) ;
        if( useString( str ) == false ) {
            return false ;
        }
    }
    if( useString( o ) == false ) {
        o = convertString( o ) ;
        if( useString( o ) == false ) {
            return false ;
        }
    }
    return str.startsWith( o ) ;
}

// endsWith.
endsWith = function(str,o) {
    if( useString( str ) == false ) {
        str = convertString( o ) ;
        if( useString( str ) == false ) {
            return false ;
        }
    }
    if( useString( o ) == false ) {
        o = convertString( o ) ;
        if( useString( o ) == false ) {
            return false ;
        }
    }
    return str.endsWith( o ) ;
}

// toLowerCase.
toLowerCase = function(str){
    if( useString( str ) == false ) {
        return convertString( str ) ;
    }
    return str.toLowerCase() ;
} ;

// toUpperCase.
toUpperCase = function(str){
    if( useString( str ) == false ) {
        return convertString( str ) ;
    }
    return str.toUpperCase() ;
} ;

// 文字列を指定文字でカット.
split = function( cote,coteFlg,str,check ) {
    return StringUtil.cutString( cote,coteFlg,str,check ) ;
}

// 指定名の最後のシンボル以降の情報を取得.
toLast = function(str,sim) {
    var p = str.lastIndexOf( sim ) ;
    if( p <= -1 ) {
        return "" ;
    }
    return str.substring( p ) ;
}

// コーテーション内を変換しない、チェンジ処理.
changeByNoCote = function( str,src,dest ) {
    return StringUtil.changeStringByNoCote( str,src,dest ) ;
}

// SeaBassバージョン取得.
version = function() {
    return HttpdVersionDef.getVersion() ;
} ;

// SeaBass更新日取得.
update = function() {
    return HttpdVersionDef.getDate() ;
} ;

// データベースが利用可能かチェック.
isDatabase = function() {
    if( isNull( super._$$seabass_manager.get( "DBMS_POOL" ) ) ) {
        return false ;
    }
    return true ;
}

// スクリプトキャッシュリロード.
reload = function() {
    CacheScriptManager.getInstance().reload() ;
} ;

// スクリプトタイプを取得.
getScriptType = function() {
    if( isNull( super.__$type$script ) ) {
        return null ;
    }
    return __$type$script ;
} ;

// スクリプト詳細を取得.
getScriptDetail = function() {
    if( isNull( super.__$detail$script ) ) {
        return null ;
    }
    return __$detail$script ;
} ;

// eval実装用をセット.
_eval = eval ;

// スクリプト強制終了用.
_exit = exit ;

// Bindingsセット.
putBindings = function( key,value ) {
    if( isNull( super.context ) ) {
        return ;
    }
    if( useString( key ) == true && isNull( value ) == false ) {
        context.put( key,value ) ;
    }
} ;

// Bindings削除.
removeBindings = function( key ) {
    if( isNull( super.context ) ) {
        return ;
    }
    if( useString( key ) == true ) {
        context.remove( key ) ;
    }
} ;

// Bindings取得.
getBindings = function( key ) {
    if( isNull( super.context ) ) {
        return null ;
    }
    if( useString( key ) == true ) {
        return context.get( key ) ;
    }
    return null ;
} ;

// 数値(小数点)チェック.
isDouble = function(num){
    if( isNumeric( num ) == false ) {
        return false ;
    }
    num = num.toString() ;
    if( useString( num ) == false ) {
        return false ;
    }
    if( startsWith( num,"-" ) == true ) {
        num = num.substring( 1 ) ;
    }
    if( regexp( "/[^0-9]/",num ) ) {
        return false ;
    }
    else if ( regexp("/[^0-9.0-9]/",num)) {
        return true;
    }
    return false ;
} ;

// 小数点を含む場合の桁あわせ処理.
// v:対象データ.
// num:小数点第いくつまで表示するかの数値を設定.
// mode:[true]の場合、四捨五入.
viewDouble = function( v,num,mode ) {
    if( isNumeric( num ) == false ) {
        return v ;
    }
    if( isNull( num ) || num <= 0 ) {
        num = 0 ;
    }
    if( !isNull( mode ) && ( mode == true || mode == "true" ) ) {
        mode = true ;
    }
    else {
        mode = false ;
    }
    var d = new BigDecimal( v ) ;
    if( mode ) {
        return d.setScale(num, RoundingMode.HALF_UP) ;
    }
    return d.setScale(num, RoundingMode.FLOOR) ;
}

// 数値表示整理.
trimNumber = function( no,len ) { 
    no = ""+no ; 
    if( len <= no.length ) { 
        return no ; 
    } 
    var buf = createStrBuf() ; 
    for( var i = 0 ; i < len ; i ++ ) { 
        buf.ad( "0" ) ; 
    } 
    var s = buf.ts() ; 
    no = ""+no ; 
    return s.substring( 0,s.length-no.length ) + no ; 
}

// println偽造.
alert = function(str){
    println( str );
} ;

// println偽造.
p = function(str){
    println( str ) ;
} ;

// println偽装.
puts = function(str) {
    println( str ) ;
} ;

// 郵便番号表示.
formatZip = function( zip ) {
    zip = ""+zip ;
    if( zip.indexOf( "-" ) != -1 ) {
        return zip ;
    }
    return zip.substring( 0,3 ) + "-" + zip.substring( 3 ) ;
}

// 金額表示(円).
formatYen = function( val ) {
    if( isNull( val ) || isNumeric( val ) == false ) {
        return val ;
    }
    var minusFlag = false ;
    val = convertString( val ) ;
    if( val.startsWith( "-" ) ) {
        val = val.substring( 1 ) ;
        minusFlag = true ;
    }
    var len = val.length ;
    var cnt = 0 ;
    var ret = "" ;
    for( var i = len-1 ; i >= 0 ; i -- ) {
        if( cnt >= 3 ) {
            ret = "," + ret ;
            cnt = 0 ;
        }
        ret = val.substring( i,i+1 ) + ret ;
        cnt ++ ;
    }
    if( minusFlag ) {
        return "-"+ret ;
    }
    return ret ;
}

// 指定フォーマットに対して数値から文字列変換(simpelDateFormat).
parseFormatDate = function(format,value) {
    if( isNull( format ) || isNull( value ) ) {
        return null ;
    }
    return dateFormat( format,value ) ;
} ;

// 指定フォーマットに対して文字列から数値変換(simpleDateFormat).
formatDate = function(format,value) {
    if( isNull( format ) || isNull( value ) ) {
        return null ;
    }
    return parseDateFormat( format,value ) ;
} ;

// 日付を表示形式で取得.
viewDate = function( date,time,parse ) {
    if( isNull( date ) ) {
        date = new Date() ;
    }
    if( isNull( parse ) ) {
        parse = ["/","/"," ",":",""] ;
    }
    var fmt = createStrBuf() ;
    fmt.append( "yyyy" ).append( parse[ 0 ] ).
        append( "MM" ).append( parse[ 1 ] ).
        append( "dd" ).append( parse[ 2 ] ) ;
    if( time == true || time == "true" ) {
        if( parse.length == 5 ) {
            fmt.append( "HH" ).append( parse[ 3 ] ).
                append( "mm" ).append( parse[ 4 ] ) ;
        }
        else if( parse.length >= 6 ) {
            fmt.append( "HH" ).append( parse[ 3 ] ).
                append( "mm" ).append( parse[ 4 ] ).
                append( "ss" ).append( parse[ 5 ] ) ;
        }
    }
    return dateFormat( fmt.ts(),date ) ;
}

// 現在日付を取得.
nowDate = function( mode ) {
    return formatDateByString( new Date(),mode )
} ;

// 日付を変換.
formatDateByString = function( date,mode ) {
    if( isNull( date ) ) {
        date = new Date() ;
    }
    if( mode == true || mode == "true" ) {
        return dateFormat( "yyyy/MM/dd",date ) ;
    }
    else {
        return dateFormat( "yyyy/MM/dd HH:mm:ss",date ) ;
    }
} ;

// 同日日付チェック.
equalsDate = function( src,dest ) {
    if( typeof( src ) == "date" && typeof( dest ) == "date" ) {
        return !( src.getYear() != dest.getYear() ||
            src.getMonth() != dest.getMonth() ||
            src.getDate() != dest.getDate() ) ;
    }
    return false ;
}

// 指定Dateオブジェクトの開始日付を取得.
getStartDate = function( date ) {
    if( valueof( date ) != "date" ) {
        date = new Date() ;
    }
    return new Date( date.getYear(),date.getMonth(),date.getDate() ) ;
}

// 指定Dateオブジェクトの終了日付を取得.
getEndDate = function( date ) {
    if( valueof( date ) != "date" ) {
        date = new Date() ;
    }
    date = new Date( date.getYear(),date.getMonth(),date.getDate() ) ;
    return new Date( date.getTime() + ( ( 86400000L ) - 1L ) ) ;
}

// 指定日付の月末を取得.
getLastDate = function( date ) {
    if( valueof( date ) != "date" ) {
        date = new Date() ;
    }
    // その月の最終日を取得.
    var lastDate = new Date( date.getYear(),date.getMonth()+1,0 ) ;
}

// 指定Dateオブジェクトの開始日付、終了日付を取得.
getStartEndByOneDate = function( date ) {
    if( valueof( date ) != "date" ) {
        date = new Date() ;
    }
    var startDate = new Date( date.getYear(),date.getMonth(),date.getDate() ) ;
    var endDate = new Date( startDate.getTime() + ( ( 86400000L ) - 1L ) ) ;
    return [startDate,endDate] ;
}

// 指定Dateオブジェクトから指定曜日のDateオブジェクトを取得.
// date : 対象日付.
// week : 0:日曜日,1:月曜日,2:火曜日,3:水曜日,4:木曜日,5:金曜日,6:土曜日
// updown : true => 指定日付から先の指定曜日の日付を取得.
searchDay = function( date,week,updown ) {
    if( !isNumeric( week ) ) {
        return null ;
    }
    week = week % 7 ;
    if( valueof( date ) != "date" ) {
        date = new Date() ;
    }
    var n = 0 ;
    var d = date.getDay() ;
    if( updown == true || updown == "true" ) {
        n = week - d ;
        if( n <= -1 ) {
            n = (6-d) + 1 + week ;
        }
        return new Date( date.getTime() + ( 86400000L * (long)n ) ) ;
    }
    else {
        n = d - week ;
        if( n <= -1 ) {
            n = d + 1 + ( 6-week ) ;
        }
        return new Date( date.getTime() - ( 86400000L * (long)n ) ) ;
    }
}

// 対象日を１日すすめる.
incOneDate = function( targetDate ) {
    if( valueof( targetDate ) != "date" ) {
        return null ;
    }
    return new Date( date.getTime() + 86400000L ) ;
}

// 対象日を１日戻す.
decOneDate = function( targetDate ) {
    if( valueof( targetDate ) != "date" ) {
        return null ;
    }
    return new Date( date.getTime() - 86400000L ) ;
}

// スクリプト実行開始時間を取得.
getScriptDate = function() {
    if( super._$script$date == null ) {
        super._$script$date = new Date() ;
    }
    return super._$script$date ;
}

// スクリプト実行開始日付(時間は00時00分00秒)を取得.
getScriptDateByStart = function() {
    if( super._$script$date_startDate == null ) {
        super._$script$date_startDate = getStartDate( getScriptDate() ) ;
    }
    return super._$script$date_startDate ;
}

// スクリプト実行開始日付(時間は23時59分59秒)を取得.
getScriptDateByEnd = function() {
    if( super._$script$date_endDate == null ) {
        super._$script$date_endDate = getEndDate( getScriptDate() ) ;
    }
    return super._$script$date_endDate ;
}

// 指定ドメインのIPアドレスを取得.
ip = function(name) {
    if( isNull( name ) ) {
        return ;
    }
    var addrs = pkg("java.net.InetAddress").getAllByName(name);
    for (var i : addrs) {
        println(addrs[i]);
    }
} ;

// 指定ドメインのIPアドレスを取得.
convertDomainToIp = function(name) {
    if( isNull( name ) ) {
        return [] ;
    }
    var addrs = pkg("java.net.InetAddress").getAllByName(name);
    var ret = [] ;
    var cnt = 0 ;
    for (var i : addrs) {
        ret[ cnt ] = addrs[i];
        cnt ++ ;
    }
    return ret ;
} ;

// 指定文字列の全角内容を半角変換.
convertZenToHan = function(string,mode) {
    if( useString( string ) == false ) {
        return "" ;
    }
    else if( typeof(string) != "string" ) {
        return string ;
    }
    if( mode == false || mode == "false" ) {
        mode = false ;
    }
    else {
        mode = true ;
    }
    return JsDef.convertHankaku( string,mode ) ;
}

// カナ半角変換.
kanaHan= function(string) {
    if( useString( string ) == false ) {
        return "" ;
    }
    else if( typeof(string) != "string" ) {
        return string ;
    }
    return JsDef.kanaHankaku( string ) ;
}

// カナ全角変換.
kanaZen= function(string) {
    if( useString( string ) == false ) {
        return "" ;
    }
    else if( typeof(string) != "string" ) {
        return string ;
    }
    return JsDef.kanaZenkaku( string ) ;
}

// ランダム文字列を生成.
randomString = function( len,zen,han,num ) {
    return RandomUtil.randomString( len,zen,han,num ) ;
}

// 英数に対して、振り仮名を取得.
britishNumberToKana = function( str ) {
    if( useString( str ) == false ) {
        return "" ;
    }
    return pkg("org.maachang.util.EStoKana").convert( str ) ;
}

// Map内容をコピー.
copyMap = function( src,dest ) {
    if( isNull( src ) || isNull( dest ) ||
        typeof( src ) != "map" || typeof( dest ) != "map" ) {
        return ;
    }
    for( var k : src ) {
        dest[ k ] = src[ k ] ;
    }
}

// Map内容をマージ.
margeMap = function( a,b ) {
    var ta = typeof( a ) ;
    var tb = typeof( b ) ;
    if( ta != "map" || tb != "map" ) {
        if( ta == "map" ) {
            return a ;
        }
        if( tb == "map" ) {
            return b ;
        }
        return null ;
    }
    var c = {} ;
    for( var k in a ) {
        c[k] = a[k] ;
    }
    for( var k in b ) {
        c[k] = b[k] ;
    }
    return c ;
}

// リストソート.
sortList = function( list ) {
    if( isNull( list ) || typeof( list ) != "array" ) {
        return null ;
    }
    pkg( "java.util.Collections" ).sort( list ) ;
    return list ;
}

// リスト内検索.
searchList = function( list,value ) {
    if( isNull( list ) || typeof( list ) != "array" ) {
        return -1 ;
    }
    var len = list.length ;
    for( var i = 0 ; i < len ; i ++ ) {
        if( list[ i ] == value ) {
            return i ;
        }
    }
    return -1 ;
}

// リストマージ.
margeList = function( a,b ) {
    var ta = typeof( a ) ;
    var tb = typeof( b ) ;
    if( ta != "array" || tb != "array" ) {
        if( ta == "array" ) {
            return a ;
        }
        if( tb == "array" ) {
            return b ;
        }
        return null ;
    }
    var c = [] ;
    var len = a.length ;
    for( var i = 0 ; i < len ; i ++ ) {
        c.add( a[ i ] ) ;
    }
    var len = b.length ;
    for( var i = 0 ; i < len ; i ++ ) {
        c.add( b[ i ] ) ;
    }
    return c ;
}

// map内のキーを昇順ソートして取得.
keyMapSort = function( map,mode ) {
    if( isNull( map ) || typeof( map ) != "map" ) {
        if( isNull( map ) ) {
            return null ;
        }
        return map ;
    }
    var ret = [] ;
    if( mode != true ) {
        if( isNull( map["_$_$sort_key$_$_"] ) ) {
            var lst = new org.maachang.util.ObjectArray() ;
            for( var k : map ) {
                lst.add( k ) ;
            }
            lst.sort() ;
            var len = lst.size() ;
            for( var i = 0 ; i < len ; i ++ ) {
                ret.add( lst.get( i ) ) ;
            }
            lst.clear() ;
            map["_$_$sort_key$_$_"] = ret ;
        }
        else {
            ret = map["_$_$sort_key$_$_"] ;
        }
    }
    else {
        var lst = new org.maachang.util.ObjectArray() ;
        for( var k : map ) {
            lst.add( k ) ;
        }
        lst.sort() ;
        var len = lst.size() ;
        for( var i = 0 ; i < len ; i ++ ) {
            ret.add( lst.get( i ) ) ;
        }
        lst.clear() ;
    }
    return ret ;
}

// データ内容をコンソール出力.
varPrint = function( o,index ) {
    var topFlag = false ;
    if( isNull( index ) || index <= 0 ) {
        index = 1 ;
        topFlag = true ;
    }
    var indSp = "" ;
    if( index > 0 ) {
        for( var i = 0 ; i < index ; i ++ ) {
            indSp += "   " ;
        }
    }
    var t = typeof( o ) ;
    if( topFlag ) {
        print( "[" + t + "]" ) ;
    }
    else {
        print( indSp + "[" + t + "] " ) ;
    }
    switch( t ) {
        case "string" :
            println( "\""+o+"\"" ) ;
            break ;
        case "number" :
        case "boolean" :
            println( o ) ;
            break ;
        case "map" :
            println() ;
            for( var k : o ) {
                var tt = typeof( o[k] ) ;
                println( indSp+"*[" + k + "] " ) ;
                varPrint( o[k],index+1 ) ;
            }
            break ;
        case "array" :
            println() ;
            var len = o.length ;
            for( var i = 0 ; i < len ; i ++ ) {
                println( indSp+"*[" + (i+1) + "] " ) ;
                varPrint( o[i],index+1 ) ;
            }
            break ;
        case "date" :
            println( formatDateByCustomString( o ) ) ;
            break ;
        case "binary" :
            println( o.length ) ;
            break ;
        default :
            println( o ) ;
            break ;
    }
}

// 指定コンフィグセクションが存在するかチェック.
isConfigSection = function( section ) {
    if( useString( section ) == false ) {
        return false ;
    }
    var conf = _$$seabass_manager.get( "CONFIG_MANAGER" ) ;
    if( isNull( conf ) ) {
        return false ;
    }
    return conf.getConfig().isSection( section ) ;
}

// 指定コンフィグ内容を取得.
getConfig = function( section,key,no ) {
    var conf = _$$seabass_manager.get( "CONFIG_MANAGER" ) ;
    if( isNull( conf ) ) {
        return null ;
    }
    if( useString( section ) == false || useString( key ) == false ) {
        return null ;
    }
    if( isNull( no ) || isNumeric( no ) == false ) {
        no = 0 ;
    }
    return parseValue( conf.get( section,key,no ) ) ;
} ;

// システムロックオブジェクトを取得.
systemLock = function() {
    return _$$seabass_manager.get( "SYSTEM_LOCK_MANAGER" ) ;
}

// 同期オブジェクトを取得.
Lock = function( name ) {
    var man = _$$seabass_manager.get( "LOCK_MANAGER" ) ;
    systemLock().lock() ;
    try {
        o = man.get( "Lock_"+name ) ;
        if( o == null ) {
            o = new java.util.concurrent.locks.ReentrantLock() ;
            man.put( "Lock_"+name,o ) ;
        }
    } finally {
        systemLock().unlock() ;
    }
    return o ;
}

// Digest系.
Digest = {
    // md5.
    md5 : function( value ) {
        if( value instanceof java.lang.String ) {
            return DigestUtil.convert( "md5",value.getBytes( "UTF8" ) ) ;
        }
        return "" ;
    },
    sha1 : function( value ) {
        if( value instanceof java.lang.String ) {
            return DigestUtil.convert( "sha1",value.getBytes( "UTF8" ) ) ;
        }
        return "" ;
    }
} ;

// 共有メモリオブジェクト.
SharedMemory = {
    put : function( name,value ) {
        _$shared$params.put( name,value ) ;
    },
    remove : function( name ) {
        _$shared$params.remove( name ) ;
    },
    get : function( name ) {
        return _$shared$params.get( name ) ;
    },
    containsKey : function( name ) {
        return _$shared$params.containsKey( name ) ;
    },
    size : function() {
        return _$shared$params.size() ;
    }
} ;

// システム情報系.
MSys = {
    MSystem : pkg("org.maachang.seabass.MSystem"),
    JavaCpu : pkg("org.maachang.util.JavaCpu"),
    Runtime : pkg("java.lang.Runtime"),
    // JavaCPU.
    cpu : function() {
        return this.JavaCpu.getInstance().cpu() ;
    },
    // 最大アクセス数.
    getNetUsePooling : function() {
        return this.MSystem.getNetUsePooling() ;
    },
    // アクティブアクセス数.
    getNetActivePooling : function() {
        return this.MSystem.getNetActivePooling() ;
    },
    // NioPoolThreadオブジェクトを取得.
    getNioPoolThread : function( no ) {
        return this.MSystem.getPoolThread( no ) ;
    },
    // トータルメモリを取得.
    mtotal : function() {
        return this.Runtime.getRuntime().totalMemory() ;
    },
    // 最大メモリを取得.
    mmax : function() {
        return this.Runtime.getRuntime().maxMemory() ;
    },
    // 空きメモリを取得.
    mfree : function() {
        return this.Runtime.getRuntime().freeMemory() ;
    },
    // CPU利用率を取得.
    useCpu : function() {
        return this.MSystem.useCpu() ;
    },
    // プロセスIDを取得.
    getProcessId : function() {
        return this.MSystem.getProcessId() ;
    },
    // ステータスを取得.
    state : function() {
        return _$SeabassState.getInstance().toString() ;
    }
} ;

