//
// HTTP系スクリプト.
//

////////////////////////////////////////////////////////////////////////////////
// 基本JavaObject定義.
////////////////////////////////////////////////////////////////////////////////
ServerTreeList = pkg( "org.maachang.seabass.httpd.engine.script.ServerTreeList" ) ;
ReadLineToPoint = pkg( "org.maachang.seabass.httpd.engine.script.ReadLineToPoint" ) ;
HttpdTimestamp = pkg( "org.maachang.seabass.httpd.engine.HttpdTimestamp" ) ;
HttpdCookie = pkg( "org.maachang.seabass.httpd.engine.HttpdCookie" ) ;

////////////////////////////////////////////////////////////////////////////////
// HTML変換系処理.
////////////////////////////////////////////////////////////////////////////////

// HTMLに対して表示可能な形式に変換.
convertViewHtml = function(string,mode) {
    if( useString( string ) == false ) {
        return "" ;
    }
    else if( typeof(string) != "string" ) {
        return string ;
    }
    if( mode == false ) {
        mode = false ;
    }
    else {
        mode = true ;
    }
    return JsDef.convertByViewHtml( mode,string ) ;
} ;

// HTMLに対して表示可能な形式に変換.
// (コーテーション範囲外の条件のみを変換).
convertViewHtmlByNotCote = function(string,mode) {
    if( useString( string ) == false ) {
        return "" ;
    }
    else if( typeof(string) != "string" ) {
        return string ;
    }
    if( mode == false ) {
        mode = false ;
    }
    else {
        mode = true ;
    }
    return JsDef.convertByViewHtmlNotCode( mode,string ) ;
} ;

// HTML変換された内容を、元に戻す.
// (コーテーション範囲外の条件のみを変換).
convertHtmlByCodeNotCote = function(string,mode) {
    if( useString( string ) == false ) {
        return "" ;
    }
    else if( typeof(string) != "string" ) {
        return string ;
    }
    if( mode == false ) {
        mode = false ;
    }
    else {
        mode = true ;
    }
    return JsDef.convertHtmlByCodeNotCode( mode,string ) ;
} ;

// 動的なHTMLタグを含む条件かチェック.
isDirectHtmlTag = function(string) {
    if( useString( string ) == false ) {
        return false ;
    }
    else if( typeof(string) != "string" ) {
        return false ;
    }
    return ConvertTag.isTag( string ) ;
} ;

// 動的なHTMLタグを表示可能な形式に変換.
convertDirectHtml = function(string) {
    if( useString( string ) == false ) {
        return "" ;
    }
    else if( typeof(string) != "string" ) {
        return string ;
    }
    return ConvertTag.convert( string ) ;
} ;

////////////////////////////////////////////////////////////////////////////////
// リクエスト取得省略形メソッド群.
////////////////////////////////////////////////////////////////////////////////

// コード.
var _ERROR_="@error,"
var _SUCCESS_="@success,"

// 指定内容のリクエストパラメータを取得.
$ = function(name,num) {
    return getRequestParam(name,num) ;
} ;

// Javascript情報取得互換用.
$$ = function(name,num) {
    if( !name.endsWith( "Id" ) ) {
        name = name.substring( 0,name.length-"Id".length ) ;
    }
    return getRequestParam(name,num) ;
}

// 指定内容のリクエストパラメータ数を取得.
$s = function(name) {
    return getRequestParamBySize(name) ;
} ;

// 指定内容のリクエストヘッダを取得.
$h = function(name,num) {
    return getRequestHeader(name,num) ;
}

// 指定内容のリクエストヘッダサイズを取得.
$hs = function(name) {
    return getRequestHeaderBySize(name) ;
}

// 指定内容をタグ系文字をHTML表示可能に変換.
$html = function( value,mode ) {
    if( mode == true ) {
        mode = true ;
    }
    else {
        mode = false ;
    }
    if( isNull( value ) == false ) {
        if( value instanceof java.lang.String ) {
            return JsDef.convertByViewHtml(
                mode,value ) ;
        }
        return value ;
    }
    return "" ;
} ;

// 指定内容をタグ系文字をHTML表示可能に変換.
// (コーテーション範囲外の条件のみを変換).
_$html = function( value,mode ) {
    if( mode == true ) {
        mode = true ;
    }
    else {
        mode = false ;
    }
    if( isNull( value ) == false ) {
        if( value instanceof java.lang.String ) {
            return JsDef.convertByViewHtmlNotCode(
                mode,value ) ;
        }
        return value ;
    }
    return "" ;
} ;

// HTML変換された内容を、元に戻す.
// (コーテーション範囲外の条件のみを変換).
_$code = function( value,mode ) {
    if( mode == true ) {
        mode = true ;
    }
    else {
        mode = false ;
    }
    if( isNull( value ) == false ) {
        if( value instanceof java.lang.String ) {
            return JsDef.convertHtmlByCodeNotCode(
                mode,value ) ;
        }
        return value ;
    }
    return "" ;
} ;


// リクエストパラメータを出力(文字列の場合、タグ系文字をHTML表示可能に変換).
$params = function( name,num ) {
    var x = getRequestParam( name,num ) ;
    if( useString( x ) ) {
        return $html(x) ;
    }
    else {
        return "" ;
    }
} ;

////////////////////////////////////////////////////////////////////////////////
// HTTP系.
////////////////////////////////////////////////////////////////////////////////

// 生成中のHTMLを出力.
httpFlush = function() {
    if( !isNull( super.___$_$_$rs$buf$_$ ) ) {
        httpPrintln( super.___$_$_$rs$buf$_$.get() ) ;
        super.___$_$_$rs$buf$_$ = OutputFactory.get() ;
    }
}

// 相対パスの場合、絶対パスに変換.
toFullUrl = function( path ) {
    if( isRequest() ) {
        return HttpdDef.toFullUrl( _$script$request,path ) ;
    }
    return "" ;
} ;

// 対象パスをフルパスに変換.
toFullPath = function( path ) {
    if( isRequest() ) {
        if( !path.startsWith( "/" ) ) {
            path = toFullUrl( path ) ;
        }
        var cPath = path.substring( 1 ) ;
        var p = SeabassDef.NOW_APPLICATION_PATH + cPath  ;
        if( Io.isFileExists( p ) ) {
            return p ;
        }
        var p = SeabassDef.NOW_PUBLIC_PATH + cPath  ;
        if( Io.isFileExists( p ) ) {
            return p ;
        }
        return path ;
    }
    if( !path.startsWith( "/" ) ) {
        return path ;
    }
    var cPath = path.substring( 1 ) ;
    var p = SeabassDef.NOW_APPLICATION_PATH + cPath  ;
    if( Io.isFileExists( p ) ) {
        return p ;
    }
    var p = SeabassDef.NOW_PUBLIC_PATH + cPath  ;
    if( Io.isFileExists( p ) ) {
        return p ;
    }
    return path ;
}

// パス変換.
convPath = function( name ) {
    if( name.startsWith( "/" ) ) {
        return Io.getFullPath( name.substring( 1 ) ) ;
    }
    else if( name.startsWith( "./" ) || name.startsWith( "../" ) ) {
        return Io.getFullPath( Io.getFullPath( toFullPath( name ) ) ) ;
    }
    return Io.getFullPath( name ) ;
}

// 現在のスクリプトパスを取得.
getPath = function() {
    var ret = null ;
    if( ( ret = context.get( "_$script$path" ) ) == null ) {
        ret = getURLPath() ;
        var p = ret.lastIndexOf( "/" ) ;
        if( p != -1 ) {
            ret = ret.substring( 0,p+1 ) ;
        }
        else {
            ret = "/" ;
        }
        context.put( "_$script$path",ret ) ;
    }
    return ret ;
} ;

// 現在のファイルパスを取得.
getFileName = function() {
    var ret = null ;
    if( ( ret = context.get( "_$script$file" ) ) == null ) {
        ret = getURLPath() ;
        var p = ret.lastIndexOf( "/" ) ;
        if( p != -1 ) {
            ret = ret.substring( p+1 ) ;
        }
        context.put( "_$script$file",ret ) ;
    }
    return ret ;
}

// アクセス先がSSLであるかチェック.
isSsl = function() {
    if( super.__$type$script != "console" && isNull( super._$script$request ) == false ) {
        if( _$script$request.isSsl() == true ) {
            return true ;
        }
        else {
            return false ;
        }
    }
    return false ;
}

// Host名を取得.
getHostName = function() {
    if( super.__$type$script != "console" && isNull( super._$script$request ) == false ) {
        var ret = null ;
        var buf = new StrBuf() ;
        if( _$script$request.isSsl() == true ) {
            buf.append( "https://" ) ;
        }
        else {
            buf.append( "http://" ) ;
        }
        return buf.append( _$script$header.getHeader("Host",0) ).toString() ;
    }
    return "" ;
}

// SSLが有効であるかチェック.
isUseSsl = function() {
    return ( getConfig( "ssl","ssl",0 ) == true ) ;
}

// 指定モードで、現在のURLを取得.
getUrlByMode = function( mode ) {
    if( super.__$type$script != "console" && isNull( super._$script$request ) == false ) {
        var ret = null ;
        var port = -1 ;
        var buf = new StrBuf() ;
        if( mode == true ) {
            mode = isUseSsl() ;
        }
        var host = _$script$header.getHeader("Host",0) ;
        var p = host.indexOf( ":" ) ;
        if( p != -1 ) {
            host = host.substring( 0,p ) ;
        }
        if( mode == true ) {
            buf.append( "https://" ).append( host ) ;
            port = getConfig( "ssl","port",0 ) ;
            if( port != 443 ) {
                buf.append( ":" ).append( port ) ;
            }
        }
        else {
            buf.append( "http://" ).append( host ) ;
            port = getConfig( "net","server-port",0 ) ;
            if( port != 80 ) {
                buf.append( ":" ).append( port ) ;
            }
        }
        return buf.toString() ;
    }
    return "" ;
}

// セッションパラメータ名.
sessionParam = function() {
    return "_maachang-session" ;
} ;

// セッション付加条件を取得.
isSessionLink = function() {
    var req = getRequest() ;
    if( isNull( req ) == false ) {
        return ( req.isCookie() == true ) ;
    }
    return false ;
}

// 指定パスをマージ.
margePathName = function( name ) {
    if( useString( name ) == false ) {
        getPath() ;
    }
    return ScriptDef.convertApplicationName(
        getPath(),name ) ;
}

// 指定パスをマージしてURL形式で出力.
margeAndFullPathName = function( name ) {
    name = margePathName( name ) ;
    var x = toLowerCase( name ) ;
    if( startsWith( x,"http://" ) || startsWith( x,"https://" ) ) {
        return name ;
    }
    else {
        if( startsWith( name,"/" ) ) {
            return new StrBuf().append( getHostName() ).append( name ).toString() ;
        }
        else {
            return new StrBuf().append( getHostName() ).append( "/" ).append( name ) ;
        }
    }
}

// リクエストが利用可能かチェック.
isRequest = function() {
    if( super.__$type$script != "console" && isNull( super._$script$request ) == false ) {
        return true ;
    }
    return false ;
} ;

// リクエストパラメータが利用可能かチェック.
isRequestParam = function() {
    if( super.__$type$script != "console" && isNull( super._$script$query ) == false ) {
        return true ;
    }
    return false ;
} ;

// リクエスト情報を取得.
getRequest = function() {
    if( isRequest() ) {
        return _$script$request ;
    }
    return null ;
} ;

// リクエストパラメータを設定.
setRequestParam = function(name,num,value ) {
    if( isNull( name ) ) {
        return "" ;
    }
    if( isRequestParam() ) {
        if( !isNumeric( num ) ) {
            num = 0 ;
        }
        _$script$request.getQuery().update(name,num,value) ;
    }
}

// リクエストパラメータを文字列で取得.
getRequestParam = function(name,num) {
    if( isRequestParam() ) {
        if( isNull( name ) ) {
            return "" ;
        }
        if( !isNumeric( num ) ) {
            num = 0 ;
        }
        return _$script$request.getQuery().getParam( name,num ) ;
    }
    return "" ;
} ;

// リクエストパラメータ内容を取得.
// こちらの処理は、[getRequestParam]と違い、バイナリモードも
// 取得対象とします.
getRequestAttribute = function(name,num) {
    if( isRequestParam() ) {
        if( isNull( name ) ) {
            return "" ;
        }
        if( !isNumeric( num ) ) {
            num = 0 ;
        }
        var qu = _$script$request.getQuery() ;
        if( qu.getParamType( name,num ) ) {
            return qu.getParamByBinary( name,num ) ;
        }
        else {
            return qu.getParam(name,num) ;
        }
    }
    return "" ;
} ;

// リクエストパラメータ数を取得.
getRequestParamBySize = function(name) {
    if( isNull( name ) ) {
        return 0 ;
    }
    if( isRequestParam() ) {
        return _$script$request.getQuery().size(name) ;
    }
    return 0 ;
} ;


// リクエストヘッダ情報を取得.
getRequestHeader = function(key,num) {
    if( isNull( key ) ) {
        return "" ;
    }
    if( isRequest() ) {
        if( !isNumeric( num ) ) {
            num = 0 ;
        }
        return _$script$header.getHeader(key,num) ;
    }
} ;

// リクエストヘッダ情報の指定キー名数を取得.
getRequestHeaderBySize = function(key) {
    if( isNull( key ) ) {
        return 0 ;
    }
    if( isRequest() ) {
        return _$script$header.size(key) ;
    }
    return 0 ;
} ;

// リクエストBodyをBinaryで取得.
getRequestBodyByBinary = function() {
    if( isRequest() && getScriptDetail() != "comet" ) {
        var ret = _$script$request.getBodyByBinary() ;
        if( ret != null && binaryLength( ret ) <= 0 ) {
            return ret ;
        }
    }
    return null ;
} ;

// リクエストBodyを文字列で取得.
getRequestBody = function( charset ) {
    if( isNull( charset ) ) {
        charset = "UTF8" ;
    }
    var ret = getRequestBody() ;
    if( isNull( ret ) == false ) {
        return convertBinaryByString( ret,charset ) ;
    }
    return null ;
} ;

// HTTPバージョンを取得.
getHttpVersion = function() {
    if( isRequest() ) {
        return _$script$request.getVersion() ;
    }
    return null ;
} ;

// HTTPメソッドを取得.
getHttpMethod = function() {
    if( isRequest() ) {
        return _$script$request.getMethod() ;
    }
    return null ;
} ;

// HTTP-URLPathを取得.
getURLPath = function() {
    if( isRequest() ) {
        return _$script$request.getUrlPath() ;
    }
    return null ;
} ;

// ランダムオブジェクトを取得.
getRandomObject = function() {
    if( isRequest() ) {
        return _$script$request.getRandom() ;
    }
    return null ;
}

// 現在読み込まれているMTHMLファイル名を取得.
getMTHMLPath = function() {
    if( isRequest() ) {
        return _$script$lastMHTML ;
    }
    return null ;
} ;

// クッキーを取得.
getCookie = function( key ) {
    if( useString( key ) && isRequest() ) {
        var map = _$script$request.getCookie() ;
        if( !isNull( map ) ) {
            return map[key] ;
        }
    }
    return null ;
}

// クッキーを設定.
setCookie = function( key,value,path,expire,charset ) {
    if( useString( key ) && !isNull( value ) && isResponse() ) {
        if( !useString( path ) ) {
            path = "/" ;
        }
        if( !useString( charset ) ) {
            charset = "UTF8" ;
        }
        if( isNull( expire ) ) {
            expire = "Tue, 31-Dec-2030 23:59:59 GMT ;" ;
        }
        if( typeof( expire ) == "date" ) {
            expire = expire.getTime() ;
        }
        if( typeof( expire ) == "number" ) {
            expire = HttpdTimestamp.getTimestamp( expire ) ;
        }
        expire = trim( expire ) ;
        if( !expire.endsWith( ";" ) ) {
            expire += " ;" ;
        }
        HttpdCookie.putCookie( _$script$response,new StrBuf().
            ad( key ).ad( "=" ).ad( URLEncoder.encode( value,charset ) ).
            ad( " ; path=" ).ad( path ).ad( "; " ).ad( expire ).ts() ) ;
    }
}

// 正常メッセージを登録.
setSuccessMessage = function(msg,id) {
    if( isRequestParam() == false ) {
        return false ;
    }
    if( isNull( id ) ) {
        id = "main" ;
    }
    if( super.__$type$script == "script" && useString( msg ) == true ) {
        if( useString( super._$script$query.get("_validateSuccess"+id) ) == false ) {
            super._$script$query.put(new StrBuf().append( "_validateSuccess" ).append( id ).toString(),msg+"<br>") ;
        }
        else {
            var m = super._$script$query.get("_validateSuccess"+id) ;
            super._$script$query.put(new StrBuf().append( "_validateSuccess" ).append( id ).toString(),
                new StrBuf().append( m ).append( msg ).append( "<BR>" ).toString() ) ;
        }
    }
} ;

// Validateエラーが存在するかチェック.
isErrorMessage = function(id) {
    if( isRequestParam() == false ) {
        return false ;
    }
    if( super.__$type$script == "script" ) {
        if( isEmpty( id ) ) {
            return useString( super._$script$query.get( "_validateError" ) ) ;
        }
        return useString( super._$script$query.get( "_validateError"+id ) ) ;
    }
    return false ;
} ;

// seabass32アクセスかチェック.
isSeabass32 = function() {
    if( isRequest() ) {
        return _$script$request.isSeabass32() ;
    }
    return false ;
}

// Validateエラーメッセージを登録.
setErrorMessage = function(msg,id) {
    if( isRequestParam() == false ) {
        return false ;
    }
    if( isNull( id ) ) {
        id = "main" ;
    }
    if( super.__$type$script == "script" && useString( msg ) == true ) {
        super._$script$query.put("_validateError","true" ) ;
        if( isDebugEnabled() ) {
            debugLog( "validateError:" + msg + " id:" + id  ) ;
        }
        if( useString( super._$script$query.get("_validateError"+id) ) == false ) {
            super._$script$query.put(new StrBuf().append( "_validateError" ).append( id ).toString(),msg+"<br>") ;
        }
        else {
            var m = super._$script$query.get("_validateError"+id) ;
            super._$script$query.put(new StrBuf().append( "_validateError" ).append( id ).toString(),
                new StrBuf().append( m ).append( msg ).append( "<BR>" ).toString() ) ;
        }
    }
} ;

// レスポンスが利用可能かチェック.
isResponse = function() {
    if( super.__$type$script != "console" && isNull( super._$script$response ) == false ) {
        return true ;
    }
    return false ;
} ;

// HttpdResponseを取得.
getHttpdResponse = function() {
    if( isResponse() ) {
        return _$script$response ;
    }
    return null ;
} ;

// GZIPをOFFに設定.
gzipOff = function() {
    if( isResponse() ) {
        _$script$response.setGzip( false ) ;
    }
} ;

// GZIPをONに設定.
gzipOn = function() {
    if( isResponse() ) {
        _$script$response.setGzip( true ) ;
    }
} ;

// GZIPモードを取得.
getGzipMode = function() {
    if( isResponse() ) {
        return _$script$response.getGzip() ;
    }
    return false ;
} ;

// キャッシュOFFに設定.
cacheOff = function() {
    if( isResponse() ) {
        _$script$response.setHttpCache( true ) ;
    }
} ;

// キャッシュONに設定.
cacheOn = function() {
    if( isResponse() ) {
        _$script$response.setHttpCache( false ) ;
    }
} ;

// キャッシュONに設定.
getCacheMode = function() {
    if( isResponse() ) {
        return _$script$response.getHttpCache() ;
    }
    return false ;
} ;

// KeepAliveをOFFに設定.
keepAliveOff = function() {
    if( isResponse() ) {
        _$script$response.setHttpClose( true ) ;
    }
} ;

// KeepAliveをONに設定.
keepAliveOn = function( timer ) {
    if( isResponse() ) {
        _$script$response.setHttpClose( false ) ;
        if( isNumeric( timer ) == true ) {
            getRequest.setKeepAliveTimeout( timer ) ;
        }
    }
} ;

// KeepAliveモードを取得.
getKeepAliveMode = function() {
    if( isResponse() ) {
        return ( _$script$response.getHttpClose() == false ) ;
    }
    return false ;
} ;

// レスポンスヘッダ情報を設定.
addResponseHeader = function(key,value) {
    if( isNull( key ) ) {
        return -1 ;
    }
    if( isNull( value ) ) {
        value = null ;
    }
    if( isResponse() ) {
        _$script$response.getHeader().addHeader( key,value ) ;
    }
} ;

// レスポンスヘッダ情報を設定.
setResponseHeader = function(key,value) {
    if( isNull( key ) ) {
        return -1 ;
    }
    if( isNull( value ) ) {
        value = null ;
    }
    if( isResponse() ) {
        _$script$response.getHeader().setHeader( key,value ) ;
    }
} ;

// レスポンスにコンテンツタイプを設定.
setContentType = function(contentType) {
    if( isNull( contentType ) ) {
        return -1 ;
    }
    setResponseHeader( "Content-Type",contentType ) ;
} ;

// 最終更新日を設定.
setLastModified = function(time) {
    if( isNumeric( time ) ) {
        setResponseHeader( "Last-Modified",HttpdTimestamp.getTimestamp( time ) ) ;
    }
} ;

// ダウンロード情報として、レスポンスを設定.
setDownloadContent = function(name) {
    if( useString( name ) == false ) {
        return -1 ;
    }
    if( isBrowser() != "mozilla" && isBrowser() != "opera" ) {
        name = encodeURL(name) ;
    }
    setResponseHeader( "Content-Disposition","inline; attachment; filename="+name ) ;
    //setResponseHeader( "Content-Disposition","attachment; filename="+name ) ;
    setResponseHeader( "Content-Type",getMimeType(name) ) ;
    // keepAliveをOffにする.
    keepAliveOff() ;
} ;

// リダイレクト処理.
redirect = function(url,pms) {
    if( isNull( url ) ) {
        return -1 ;
    }
    if( super.__$type$script == "script" && isResponse() ) {
        if( url.startsWith( "http://" ) == false && url.startsWith( "https://" ) == false ) {
            if( url.startsWith( "/" ) == false ) {
                url = toFullUrl( url ) ;
            }
            url = getUrlByMode( isSsl() ) + url ;
        }
        if( !isNull( pms ) && pms instanceof java.util.Map && pms.length > 0 ) {
            if( url.indexOf( "?" ) != -1 ) {
                url += "&" + convertMapToGetParams( pms ) ;
            }
            else {
                url += "?" + convertMapToGetParams( pms ) ;
            }
        }
        cacheOff() ;
        if( isSessionLink() == true ) {
            if( url.indexOf( "?" ) == -1 ) {
                url = new StrBuf().append( url ).append( "?t=" ).append( ( currentTime() ) ).toString() ;
            }
            else {
                url = new StrBuf().append( url ).append( "&t=" ).append( currentTime() ).toString() ;
            }
        }
        else if( url.indexOf( sessionParam() ) == -1 ) {
            if( url.indexOf( "?" ) == -1 ) {
                url = new StrBuf().append( url ).append( "?t=" ).append( currentTime() ).append( "&" ).
                    append( sessionParam() ).append( "=" ).append( getSessionId() ).toString() ;
            }
            else {
                url = new StrBuf().append( url ).append( "&t=" ).append( currentTime() ).append( "&" ).
                    append( sessionParam() ).append( "=" ).append( getSessionId() ).toString() ;
            }
        }
        if( isDebugEnabled() ) {
            debugLog( "redirect:" + url + " にリダイレクト" ) ;
        }
        getHttpdResponse().setState( 303 ) ;
        _exit( "@redirect"+url ) ;
    }
} ;

// 現在のページにリダイレクト.
redirectNowPage = function( mode ) {
    var url = ( mode == true ) ? getUrlByMode( true ) : ( ( mode == false ) ? getUrlByMode( false ) : getHostName() ) ;
    if( isNull( params ) || params.length <= 0 ) {
        redirect( new StrBuf().append( url ).append( getURLPath() ).toString() ) ;
    }
    else {
        redirect( new StrBuf().append( url ).append( getURLPath() ).append( "?" ).append( convertMapToGetParams( params ) ).toString() ) ;
    }
}

// 指定URLにforward.
forwardURL = function(name) {
    if( isNull( name ) ) {
        return -1 ;
    }
    //name = "" + name ;
    if( isResponse() ) {
        if( getHttpdResponse().isOutputStream() == true ) {
            _exit( "forward" ) ;
        }
        if( !startsWith( name,"/" ) ) {
            name = toFullUrl( name ) ;
        }
        var target = margePathName( name ) ;
        var factory = _$$seabass_manager.get( "WEBAPP_FACTORY" ) ;
        if( factory.isApplication( target ) == false ) {
            if( isDebugEnabled() ) {
                debugLog( "forwardController:" + name + " は存在しません(404)" ) ;
            }
            _exit( "error404" ) ;
        }
        if( isDebugEnabled() ) {
            debugLog( "forward:" + name + " に遷移" ) ;
        }
        _exit( "@forward"+target ) ;
    }
} ;

// 指定MHTMLにforward.
forwardMHTML = function(name) {
    if( useString( name ) == false ) {
        return -1 ;
    }
    if( isResponse() ) {
        if( getHttpdResponse().isOutputStream() == true ) {
            _exit( "forward" ) ;
        }
        if( !startsWith( name,"/" ) ) {
            name = toFullUrl( name ) ;
        }
        if( endsWith( name,".ms" ) ) {
            return -1 ;
        }
        if( endsWith( name,"/" ) ) {
            name += "index.mhtml" ;
        }
        else if( !endsWith( name,".mhtml" ) ) {
            name += ".mhtml" ;
        }
        name = margePathName( name ) ;
        var factory = _$$seabass_manager.get( "WEBAPP_FACTORY" ) ;
        if( factory.isApplication( name ) == false ) {
            if( isDebugEnabled() ) {
                debugLog( "forwardMHTML:" + name + " は存在しません(404)" ) ;
            }
            _exit( "error404" ) ;
        }
        if( isDebugEnabled() ) {
            debugLog( "forwardMHTML:" + name + " に遷移" ) ;
        }
        _exit( "@forward"+name ) ;
    }
} ;

// 指定コントローラにforward.
forwardController = function(name) {
    if( isNull( name ) ) {
        return -1 ;
    }
    //name = "" + name ;
    if( isResponse() ) {
        if( getHttpdResponse().isOutputStream() == true ) {
            _exit( "forward" ) ;
        }
        if( !startsWith( name,"/" ) ) {
            name = toFullUrl( name ) ;
        }
        if( endsWith( name,".mhtml" ) == true ) {
            name = name.substring( 0,name.length - ".mhtml".length ) ;
        }
        else if( endsWith( name,".ms" ) == true ) {
            name = name.substring( 0,name.length - ".ms".length ) ;
        }
        if( endsWith( name,"Controller" ) == true ) {
            name = name.substring( 0,name.length - "Controller".length ) ;
        }
        var cnt = name + "Controller.ms" ;
        cnt = margePathName( cnt ) ;
        var factory = _$$seabass_manager.get( "WEBAPP_FACTORY" ) ;
        if( factory.isApplication( cnt ) == false ) {
            var mhtml = name + ".mhtml" ;
            mhtml = margePathName( mhtml ) ;
            if( factory.isApplication( mhtml ) == false ) {
                if( isDebugEnabled() ) {
                    debugLog( "forwardController:" + name + " は存在しません(404)" ) ;
                }
                _exit( "error404" ) ;
            }
            name = mhtml ;
        }
        else {
            name = cnt ;
        }
        if( isDebugEnabled() ) {
            debugLog( "forwardController:" + name + " に遷移" ) ;
        }
        _exit( "@forward"+name ) ;
    }
} ;

// 指定スクリプトを取り込む.
include = function(name) {
    if( isNull( name ) ) {
        return "" ;
    }
    if( isResponse() ) {
        if( endsWith( name,".mhtml" ) == true ) {
            return "" ;
        }
        if( !startsWith( name,"/" ) ) {
            name = toFullUrl( name ) ;
        }
        if( endsWith( name,".ms" ) == false ) {
            name += ".ms" ;
        }
        if( name == currentName() ) {
            return "" ;
        }
        // include先が静的ページの場合.
        if( name.endsWith( ".html" ) || name.endsWith( ".htm" ) ) {
            return JsDef.readStaticHtml( name ) ;
        }
        else {
            // ページキャッシュが有効な場合はこちらを利用する.
            var buf = PageCache.getInstance().get( "@inner@"+name ) ;
            if( useString( buf ) ) {
                httpPrint( buf ) ;
            }
            else {
                var factory = _$$seabass_manager.get( "WEBAPP_FACTORY" ) ;
                if( factory.isApplication( name ) == false ) {
                    _exit( "error404" ) ;
                }
                var exec = factory.getApplication( name ) ;
                httpPrint( exec.getScript().eval( context ) ) ;
            }
        }
    }
    return "" ;
} ;

// 指定ファイルで、HTTPレスポンスに返す.
responseToFile = function(fileName,isMimeType) {
    if( isNull( fileName ) ) {
        return -1 ;
    }
    if( isMimeType == false ) {
        isMimeType = false ;
    }
    else {
        isMimeType = true ;
    }
    if( isResponse() ) {
        if( isMimeType ) {
            setResponseHeader( "Content-Type",getMimeType( fileName ) ) ;
        }
        JsDef.putResponseByData( _$script$response,
            new java.io.BufferedInputStream( new java.io.FileInputStream( fileName ) ) ) ;
    }
} ;

// 指定名のMimeタイプを取得.
getMimeType = function(fileName) {
    if( isNull( fileName ) ) {
        return "Application/Octet-Stream" ;
    }
    if( isNull( super._$$seabass_manager ) == false &&
        isNull( super._$$seabass_manager.get( "MIME_TYPE" ) ) == false ) {
        return _$$seabass_manager.get( "MIME_TYPE" ).getNameByMimeType( fileName ) ;
    }
    return "Application/Octet-Stream" ;
} ;

// 指定バイナリを、HTTPレスポンスに返す.
responseToBinary = function(binary,mimeType) {
    if( isNull( binary ) ) {
        return -1 ;
    }
    if( isResponse() ) {
        if( useString( mimeType ) ) {
            setResponseHeader( "Content-Type",mimeType ) ;
        }
        var indata = new java.io.ByteArrayInputStream( binary ) ;
        //setResponseHeader( 'Content-Length',convertString( binary.length ) ) ;
        JsDef.putResponseByData( _$script$response,indata ) ;
    }
} ;

// レスポンス用OutputStreamを取得.
getResponseToOutputStream = function() {
    if( isResponse() ) {
        return _$script$response.getOutput() ;
    }
    return null ;
}

// 指定文字列をHTTPレスポンスに渡す.
httpPrint = function(data) {
    if( !useString( data ) ) {
        return "" ;
    }
    if( isResponse() ) {
        try {
            _$script$response.getPrint().print( convertString( data ) ) ;
        } catch( Exception e ) {
            exit() ;
        }
    }
    return "" ;
} ;

// 指定文字列をHTTPレスポンスに渡す.
httpPrintln = function(data) {
    if( !useString( data ) ) {
        return "" ;
    }
    if( isResponse() ) {
        try {
            _$script$response.getPrint().println( convertString( data ) ) ;
        } catch( Exception e ) {
            exit() ;
        }
    }
    return "" ;
} ;

// エラープリント.
errorPrint = function( message ) {
    if( useString( message ) ) {
        httpPrint( "@error," + message ) ;
    }
}

// 成功プリント.
successPrint = function( message ) {
    if( useString( message ) ) {
        httpPrint( "@success," + message ) ;
    }
}

// Seabass32Ajax用:正常処理.
seabass32Success = function() {
    httpPrint( "@success" ) ;
    exit() ;
}

// Seabass32Ajax用:エラー処理.
seabass32Error = function( message ) {
    if( useString( message ) ) {
        httpPrint( "@error:" + message ) ;
    }
    else {
        httpPrint( "@error" ) ;
    }
    exit() ;
}

// 単一URLエンコード.
encodeURL = function( string,charset ) {
    if( isNull( string ) ) {
        return "" ;
    }
    if( useString( string ) == false ) {
        return string.toString() ;
    }
    if( useString( charset ) == false ) {
        charset = "UTF8" ;
    }
    return URLEncoder.encode( string,charset ) ;
} ;

// 単一URLデコード.
decodeURL = function( string,charset ) {
    if( useString( string ) == false ) {
        return "" ;
    }
    if( useString( charset ) == false ) {
        charset = "UTF8" ;
    }
    return URLDecoder.decode( string,charset ) ;
} ;

// 指定バイナリパラメータ内容のオリジナル名を取得.
paramOriginal = function( name,no ) {
    if( isRequestParam() == true && useString( name ) == true ) {
        var o = getRequestAttribute( name,no ) ;
        if( isNull( o ) || ( o instanceof org.maachang.seabass.httpd.HttpdBinary ) == false ) {
            return null ;
        }
        return o.getOriginalName() ;
    }
    return "" ;
} ;

// 指定バイナリパラメータ内容のバイナリを取得.
paramBinary = function( name,no ) {
    if( isRequestParam() == true && useString( name ) == true ) {
        if( !isNumeric( no ) ) {
            no = 0 ;
        }
        var o = getRequestAttribute( name,no ) ;
        if( isNull( o ) || ( o instanceof org.maachang.seabass.httpd.HttpdBinary ) == false ) {
            return null ;
        }
        return o.getBinary();
    }
    return null ;
} ;

// 指定バイナリパラメータ内容のバイナリ長を取得.
paramBinaryLength = function( name,no ) {
    var o = paramBinary( name,no ) ;
    if( isNull( o ) ) {
        return -1 ;
    }
    return o.length ;
} ;

// 指定パラメータをSHA1化して取得.
paramSha1 = function( name,no ) {
    if( isRequestParam() == true && useString( name ) == true ) {
        if( !isNumeric( no ) ) {
            no = 0 ;
        }
        var o = getRequestAttribute( name,no ) ;
        if( isNull( o ) || !( o instanceof String ) ) {
            return null ;
        }
        return DigestUtil.convert( "SHA1",o.getBytes( "UTF8" ) ) ;
    }
    return null ;
}

// 認証ユーザ名を取得.
getSuccessAuthUser = function() {
    if( isRequestParam() == true ) {
        return super._$script$query.get( "_success_auth_user" ) ;
    }
    return null ;
} ;

// 認証パスワードを取得.
getSuccessAuthPasswd = function() {
    if( isRequestParam() == true ) {
        return super._$script$query.get( "_success_auth_passwd" ) ;
    }
    return null ;
} ;

// xhtmlモードを取得.
isXhtml = function() {
    return HttpdMode.xhtml ;
} ;

// xhtmlモードがONの場合の閉じタグ処理.
endTag = function( mode ) {
    if( mode != true ) {
        if( HttpdMode.xhtml ) {
            return " / >" ;
        }
    }
    return " >" ;
}

////////////////////////////////////////////////////////////////////////////////
// ブラウザ判別.
////////////////////////////////////////////////////////////////////////////////

// アクセスブラウザ種別を取得.
isBrowser = function() {
    if( isRequest() ) {
        var agent = _$script$header.getHeader( "User-Agent" ) ;
        if( agent.indexOf( "MSIE" ) != -1 ) {
            return "msie" ;
        }
        else if( agent.indexOf( "Chrome/" ) != -1 ) {
            return "chrome" ;
        }
        else if( agent.indexOf( "Safari" ) != -1 ) {
            return "safari" ;
        }
        else if( agent.indexOf( "Opera" ) != -1 ) {
            return "opera" ;
        }
        else if( agent.indexOf( "Netscape" ) != -1 ) {
            return "netscape" ;
        }
        else if( agent.indexOf( "Mozilla/" ) != -1 ) {
            return "mozilla" ;
        }
        return "unknow" ;
    }
    return "unknow" ;
}


////////////////////////////////////////////////////////////////////////////////
// Session系.
////////////////////////////////////////////////////////////////////////////////

// セッションが利用可能かチェック.
isSession = function() {
    if( super.__$type$script != "console" && isNull( super._$script$session ) == false ) {
        return true ;
    }
    return false ;
} ;

// 現在アクセスされているセッション情報を破棄.
destroySession = function() {
    if( isSession() && isRequest() ) {
        var man = _$$seabass_manager.get( "SESSION_MANAGER" ) ;
        if( useString( _$script$session.getSessionId() ) ) {
            man.removeSession( getRequest().getBdbKeyValue(),_$script$session.getSessionId() ) ;
        }
    }
}

// セッション条件を追加.
putSession = function(key,value) {
    if( isNull( key ) || isNull( value ) ) {
        return false ;
    }
    if( isSession() ) {
        if( typeof( value ) == "string" ) {
            _$script$session.setElement(key,"\""+value+"\"") ;
        }
        else {
            _$script$session.setElement(key,encodeJSON( value )) ;
        }
        return true ;
    }
    return false ;
} ;

// セッション条件を削除.
removeSession = function(key) {
    if( isNull( key ) ) {
        return false ;
    }
    if( isSession() ) {
        _$script$session.removeElement(key) ;
        return true ;
    }
    return false ;
} ;

// セッション条件を取得.
getSession = function(key) {
    if( isNull( key ) ) {
        return null ;
    }
    if( isSession() ) {
        var ret = _$script$session.getElement(key) ;
        if( useString( ret ) ) {
            return decodeJSON( ret ) ;
        }
    }
    return null ;
} ;

// セッションIDを取得.
getSessionId = function() {
    if( isSession() ) {
        return _$script$session.getSessionId() ;
    }
    return null ;
} ;

// sessionMap.
sessionMap = function() {
    return createJSAdapter({
        __get__ : function(name) {
            var ret = getSession( name ) ;
            return parseValue( ret ) ;
        },
        __has__ :  function(name) {
            return isNull( getSession( name ) ) ;
        },
        __delete__ : function (name) {
            return removeSession( name ) ;
        },
        __put__ : function(name, value) {
            putSession( name,parseValue( value ) ) ;
        },
        __getIds__ : function() {
            return null ;
        },
        __length__ : function() {
            return 0 ;
        }
    });
} ;

////////////////////////////////////////////////////////////////////////////////
// その他.
////////////////////////////////////////////////////////////////////////////////

// HTMLアクセス範囲内のスクリプトを実行.
executionApplicationScript = function( name,charset ) {
    return Io.execution( toFullPath( name ),charset ) ;
}

// 指定ディレクトリのTree情報を取得.
getTreeInfo = function( mode,base,dir,head,foot,full ) {
    var ret = "" ;
    Io.lock( dir ) ;
    try {
        ret = ServerTreeList.get( mode,base,dir,head,foot,full ) ;
    } finally {
        Io.unlock( dir ) ;
    }
    return ret ;
}

// 定義ファイルを読み込む.
seabassDefine = function( name ) {
    if( !useString( name ) ) {
        return null ;
    }
    if( name.startsWith( "/" ) ) {
        return Io.execution( Io.getFullPath( name.substring( 1 ) ) ,"UTF8" ) ;
    }
    else if( name.startsWith( "./" ) ) {
        return Io.execution( Io.getFullPath( toFullPath( name ) ) ,"UTF8" ) ;
    }
    else if( name.startsWith( "../" ) ) {
        return Io.execution( Io.getFullPath( toFullPath( name ) ) ,"UTF8" ) ;
    }
    if( !name.startsWith( "@" ) ) {
        name = "@" + name ;
    }
    return Io.execution( toFullPath( name ),"UTF8" ) ;
}

// 定義ファイルを更新.
seabassDefineW = function( name,value ) {
    if( !useString( name ) || isNull( value ) ) {
        return false ;
    }
    if( typeof( value ) == 'map' ) {
        var buf = new StrBuf() ;
        for( var k in value ) {
            buf.ad( k ).ad( "=" ).ad( encodeJSON( value[k] ) ).ad( ";" ).ad( "\n" ) ;
        }
        value = buf.ts() ;
        buf = null ;
        k = null ;
    }
    if( name.startsWith( "/" ) ) {
        name = Io.getFullPath( name.substring( 1 ) ) ;
        Io.writeFileByString( true,name,value,"UTF8" ) ;
        return true ;
    }
    else if( name.startsWith( "./" ) ) {
        name = Io.getFullPath( toFullPath( name ) ) ;
        Io.writeFileByString( true,name,value,"UTF8" ) ;
        return true ;
    }
    else if( name.startsWith( "../" ) ) {
        name = Io.getFullPath( toFullPath( name ) ) ;
        Io.writeFileByString( true,name,value,"UTF8" ) ;
        return true ;
    }
    if( !name.startsWith( "@" ) ) {
        name = "@" + name ;
    }
    name = toFullPath( name ) ;
    Io.writeFileByString( true,name,value,"UTF8" ) ;
    return true ;
}

// １つの変数で、定義ファイルを更新.
SeabassDefineW1 = function( name,key,value ) {
    if( !useString( name ) || isNull( value ) ) {
        return false ;
    }
    var buf = new StrBuf() ;
    buf.ad( key ).ad( "=" ).ad( encodeJSON( value ) ).ad( ";" ) ;
    value = buf.ts() ;
    buf = null ;
    if( name.startsWith( "/" ) ) {
        name = Io.getFullPath( name.substring( 1 ) ) ;
        Io.writeFileByString( true,name,value,"UTF8" ) ;
        return true ;
    }
    else if( name.startsWith( "./" ) ) {
        name = Io.getFullPath( toFullPath( name ) ) ;
        Io.writeFileByString( true,name,value,"UTF8" ) ;
        return true ;
    }
    else if( name.startsWith( "../" ) ) {
        name = Io.getFullPath( toFullPath( name ) ) ;
        Io.writeFileByString( true,name,value,"UTF8" ) ;
        return true ;
    }
    if( !name.startsWith( "@" ) ) {
        name = "@" + name ;
    }
    name = toFullPath( name ) ;
    Io.writeFileByString( true,name,value,"UTF8" ) ;
    return true ;
}

// 指定範囲のファイル内容をレスポンスに渡す.
putFileToPosByResponse = function( name,start,size,mimeType,charset ) {
    if( !useString( mimeType ) ) {
        mimeType = "text/html" ;
    }
    setResponseHeader( "Content-Type",mimeType ) ;
    ReadLineToPoint.read( seabassIO.getTargetLock(),_$script$response.getPrint(),name,charset,start,size ) ;
}

// 指定文字列のうち、指定文字数を越した場合は、その分表示させない.
viewStringByCut = function( hankaku,p,string,length,name ) {
    if( useString( name ) ) {
        string = getRequestParam(name,0) ;
    }
    if( hankaku != true ) {
        hankaku = false ;
    }
    if( p != true ) {
        p = false ;
    }
    return JsDef.viewString( hankaku,false,p,string,length ) ;
}

// 指定文字列のうち、指定文字数を越した場合は、改行で折り返す.
viewStringByEnter = function( hankaku,p,string,length,name ) {
    if( useString( name ) ) {
        string = getRequestParam(name,0) ;
    }
    if( hankaku != true ) {
        hankaku = false ;
    }
    if( p != true ) {
        p = false ;
    }
    return JsDef.viewString( hankaku,true,p,string,length ) ;
}

// 全角を半角に変換.
zenToHan = function( string,name ) {
    if( useString( name ) ) {
        string = getRequestParam(name,0) ;
    }
    return JsDef.convertHankaku( string ) ;
}

// イントラネット回線(LAN)での実行かチェック.
isLAN = function() {
    if( isRequest() ) {
        return getRequest().isIntranetAddress() ;
    }
    return false ;
}

// select配列条件に変換.
convertSelectList = function( list,head,idColumns,nameColumns ) {
    var len = list.length ;
    var ret = [] ;
    if( head != null && typeof( head ) == "array" && head.length == 2 ) {
        ret.add( head[ 0 ] ) ;
        ret.add( head[ 1 ] ) ;
    }
    for( var i = 0 ; i < len ; i ++ ) {
        var m = list[ i ] ;
        ret.add( m[idColumns] ) ;
        ret.add( "&nbsp;"+m[nameColumns]+"&nbsp;" ) ;
    }
    return ret ;
}
