// HttpClientスクリプト.
//

////////////////////////////////////////////////////////////////////////////////
// 基本JavaObject定義.
////////////////////////////////////////////////////////////////////////////////

// HttpClientオブジェクト.
HttpClient = {
    HttpService : pkg("org.maachang.seabass.service.client.HttpService"),
    // HTTPサーバに接続.
    connection : function( method,url,params,header,userAgent ) {
        if( !useString( url ) ) {
            return null ;
        }
        if( !useString( method ) ) {
            method = "GET" ;
        }
        if( isNull( params ) ) {
            params = null ;
        }
        var httpHeader = HttpClient.convert( false,header ) ;
        if( !useString( userAgent ) ) {
            userAgent = null ;
        }
        var res = null ;
        if( method.toLowerCase() == "post" ) {
            res = this.HttpService.post( url,params,httpHeader,userAgent ) ;
        }
        else {
            res = this.HttpService.get( url,params,httpHeader,userAgent ) ;
        }
        if( res != null ) {
            return {"body":res.getBinary(),"state":res.getState(),"mime":res.getContentType()} ;
        }
        return null ;
    },
    // HTTPサーバにBody情報を付加して接続.
    connectionBody : function( url,body,mime,header,userAgent ) {
        if( useString( url ) == false || useString( body ) == false ) {
            return null ;
        }
        var httpHeader = HttpClient.convert( false,header ) ;
        if( !useString( userAgent ) ) {
            userAgent = null ;
        }
        var t = typeof( body ) ;
        if( t == "map" || t == "array" ) {
            body = encodeJSON( body ) ;
        }
        t = typeof( body ) ;
        if( t == "string" ) {
            body = convertStringByBinary( body,"UTF8" ) ;
        }
        t = typeof( body ) ;
        if( t != "binary" ) {
            return null ;
        }
        var res = null ;
        if( useString( mime ) == true ) {
            res = this.HttpService.body( url,body,null,httpHeader,mime,userAgent ) ;
        }
        else {
            res = this.HttpService.body( url,body,null,httpHeader,null,userAgent ) ;
        }
        if( res != null ) {
            return {"body":res.getBinary(),"state":res.getState(),"mime":res.getContentType()} ;
        }
        return null ;
    },
    // HTTPクライアントオブジェクトに変換.
    convert : function( mode,params ) {
        if( isNull( params ) || typeof( params ) != "map" ) {
            return null ;
        }
        if( mode == true ) {// param.
            var ret = new org.maachang.seabass.service.client.HttpParam() ;
            for( var k in params ) {
                var t = typeof( params[k] ) ;
                if( t == "array" ) {
                    var val = params[k] ;
                    var len = val.length ;
                    for( var i = 0 ; i < len ; i ++ ) {
                        ret.addParam( k,""+val[i] ) ;
                    }
                }
                else if( t == "map" ) {
                    continue ;
                }
                else {
                    ret.addParam( k,""+params[k] ) ;
                }
            }
            return ret ;
        }
        else {// header.
            var ret = new org.maachang.seabass.service.client.HttpHeader() ;
            for( var k in params ) {
                var t = typeof( params[k] ) ;
                if( t == "array" ) {
                    var val = params[k] ;
                    var len = val.length ;
                    for( var i = 0 ; i < len ; i ++ ) {
                        ret.addHeader( k,""+val[i] ) ;
                    }
                }
                else if( t == "map" ) {
                    continue ;
                }
                else {
                    ret.addHeader( k,""+params[k] ) ;
                }
            }
            return ret ;
        }
    }
}

// URLを取得.
readUrl = function( url,charset ) {
    if( useString( url ) == false ) {
        return null ;
    }
    var res = HttpClient.connection( "GET",url,null,null,"SeaBass1.0" ) ;
    if( isNull( res["body"] ) ) {
        return null ;
    }
    if( useString( charset ) == false ) {
        charset = "UTF8" ;
    }
    return new java.lang.String( res["body"],charset ) ;
} ;

