// (テーブル定義)入力系部品.
//

// (テーブル定義)入力タグ.
InputTag = {
    DEFAULT_TEXT_SIZE:80,
    TEXT : function( em ) {
        type = em.type ;
        return ( typeof( type ) == "string" && type.trim().startsWith( "text" ) ) ;
    },
    TEXTAREA : function( em ) {
        type = em.type ;
        return ( typeof( type ) == "string" && type.trim() == "textarea" ) ;
    },
    PASSWD : function( em ) {
        type = em.type ;
        return ( typeof( type ) == "string" && type.trim() == "passwd" ) ;
    },
    CHECH : function( em ) {
        type = em.type ;
        return ( typeof( type ) == "string" && type.trim() == "check" ) ;
    },
    DATE : function( em ) {
        type = em.type ;
        if( typeof( type ) == "array" && type.length == 2 ) {
            return type[ 0 ].trim() == "date" ;
        }
        return ( typeof( type ) == "string" && type.trim() == "date" ) ;
    },
    TIME : function( em ) { type = em.type ;return ( typeof( type ) == "string" && type.trim() == "time" ) ; },
    TIMESTAMP : function( em ) {
        type = em.type ;
        if( typeof( type ) == "array" && type.length == 2 ) {
            return type[ 0 ].trim() == "timestamp" ;
        }
        return ( typeof( type ) == "string" && type.trim() == "timestamp" ) ;
    },
    SELECT : function( em ) {
        type = em.type ;
        if( typeof( type ) == "map" ) {
            for( var k in type ) {
                if( "select" == k.trim() ) {
                    return true ;
                }
            }
        }
        else if( typeof( type ) == "string" ) {
            return type.trim() == "select" ;
        }
        return false ;
    },
    POPUP : function( em ) {
        type = em.type ;
        if( typeof( type ) == "map" ) {
            for( var k in type ) {
                if( "popup" == k.trim() ) {
                    return true ;
                }
            }
        }
        return false ;
    },
    CALC : function( em ) {
        type = em.type ;
        if( typeof( type ) == "map" ) {
            for( var k in type ) {
                if( "calc" == k.trim() ) {
                    return true ;
                }
            }
        }
        return false ;
    },
    // 入力枠に対するIMEモードを取得.
    getIMEMode : function( name,master ) {
        if( typeof( master ) == "string" ) {
            master = Models[master] ;
        }
        if( master == null ||  master._$detail$ == null ) {
            return null ;
        }
        var cols = master._$detail$.colsMap ;
        var no = cols[ name ] ;
        if( no == null ) {
            return null ;
        }
        var em = master._$detail$.element ;
        var size = master._$detail$.size ;
        // 入力数の先頭に＄が存在する場合は、数値入力.
        if( size[no].startsWith( "$" ) ) {
            return TextMode.NUMBER ;
        }
        // 入力タイプから、IMEモードを取得.
        if( em[no].type == null ) {
            return null ;
        }
        var type = em[no].type ;
        if( typeof( type ) == "string" ) {
            if( type.endsWith( ".number" ) ) {
                return TextMode.NUMBER ;
            }
            if( type.indexOf( ".alpha" ) != 0 ) {
                return TextMode.ALPHA ;
            }
            if( type.endsWith( ".hira" ) ) {
                return TextMode.HIRA ;
            }
            if( type.endsWith( ".kana" ) ) {
                return TextMode.KATA ;
            }
        }
        return null ;
    },
    // validate処理.
    validate : function( name,option ) {
        if( !useString( name ) ||
            isNull( option ) || typeof( option ) != "map" ) {
            return "" ;
        }
        // validate.
        var vdt = option[ "validate" ] ;
        if( typeof( vdt ) != "map" ) {
            return "" ;
        }
        var target = option[ "name" ] ;
        var message = vdt[ "message" ] ;
        var type = vdt[ "type" ] ;
        if( typeof( type ) == "array" && type.length == 2 ) {
            var mode = type[1] ;
            type = type[0] ;
            if( typeof( type ) == "string" ) {
                if( type == "string" ) {
                    mode = parseInt( mode ) ;
                    if( !useString( message ) ) {
                        message = target + "は" ;
                        var cnt = 0 ;
                        if( ( mode & STR_HIRA ) == STR_HIRA ) {
                            message += "(平仮名)";
                            cnt ++ ;
                        }
                        if( ( mode & STR_KANA ) == STR_KANA ) {
                            message += "(カタカナ)";
                            cnt ++ ;
                        }
                        if( ( mode & STR_ASCII ) == STR_ASCII ) {
                            message += "(ASCII)";
                            cnt ++ ;
                        }
                        else {
                            if( ( mode & STR_NUMBER ) == STR_NUMBER ) {
                                message += "(数値)" ;
                                cnt ++ ;
                            }
                            if( ( mode & STR_ALPHABET ) == STR_ALPHABET ) {
                                message += "(英語)";
                                cnt ++ ;
                            }
                        }
                        if( cnt == 0 ) {
                            return "" ;
                        }
                        else {
                            message += "で入力してください" ;
                        }
                    }
                    else if( ( mode & STR_NUMBER ) == 0 &&
                        ( mode & STR_ALPHABET ) == 0 &&
                        ( mode & STR_ASCII ) == 0 &&
                        ( mode & STR_KANA ) == 0 &&
                        ( mode & STR_HIRA ) == 0 ) {
                        return "" ;
                    }
                    VLTag.toStringTag( message,mode,name )
                    return VLTag.outError( name ) ;
                }
                else if( type == "match" ) {
                    if( !useString( message ) ) {
                        message = target + "の入力内容はを正しい形式で入力してください" ;
                    }
                    VLTag.toMatchTag( message,mode,name )
                    return VLTag.outError( name ) ;
                }
                else if( type == "min" ) {
                    mode = parseInt( mode ) ;
                    if( !useString( message ) ) {
                        message = target + "は、" + mode + "より少ない文字数で入力してください" ;
                    }
                    VLTag.toMinString( message,mode,name )
                    return VLTag.outError( name ) ;
                }
                else if( type == "max" ) {
                    mode = parseInt( mode ) ;
                    mode = parseInt( mode ) ;
                    if( !useString( message ) ) {
                        message = target + "は、" + mode + "より多い文字数で入力してください" ;
                    }
                    VLTag.toMaxString( message,mode,name ) ;
                    return VLTag.outError( name ) ;
                }
            }
        }
        else if( typeof( type ) == "string" ) {
            if( type == "req" ) {
                if( !useString( message ) ) {
                    message = target + "は必須です" ;
                }
                VLTag.toRequired( message,name ) ;
                return VLTag.outError( name ) ;
            }
            else if( type == "zip" ) {
                if( !useString( message ) ) {
                    message = target + "は郵便番号形式(000-0000)で入力してください" ;
                }
                VLTag.toZipTag( message,name ) ;
                return VLTag.outError( name ) ;
            }
            else if( type == "tel" ) {
                if( !useString( message ) ) {
                    message = target + "は電話番号形式(0000-00-0000)ではありません" ;
                }
                VLTag.toTelTag( message,name ) ;
                return VLTag.outError( name ) ;
            }
            else if( type == "ip" ) {
                if( !useString( message ) ) {
                    message = target + "はIPアドレス(V4)形式ではありません" ;
                }
                VLTag.toIpTag( message,name ) ;
                return VLTag.outError( name ) ;
            }
            else if( type == "url" ) {
                if( !useString( message ) ) {
                    message = target + "はURL形式ではありません" ;
                }
                VLTag.toUrlTag( message,name ) ;
                return VLTag.outError( name ) ;
            }
            else if( type == "email" || type == "mail" ) {
                if( !useString( message ) ) {
                    message = target + "はメールアドレス形式ではありません" ;
                }
                VLTag.toEmailTag( message,name ) ;
                return VLTag.outError( name ) ;
            }
        }
        return "" ;
    },
    // 指定要素のValidateが存在するかチェック.
    useValidate : function( option ) {
        return !( isNull( option ) || typeof( option ) != "map" ||
            typeof( option[ "validate" ] ) != "map" ) ;
    },
    // validate終了処理.
    exitValidate : function() {
        return VLTag.output() ;
    },
    // 文字コードを半角変換.
    convertHankaku : function( name ) {
        if( name.length <= 0 ) {
            return "" ;
        }
        name = zenToHan( name ) ;
        var c = name.substring( 0,1 ) ;
        if( c == 'a' || c == 'A' ) { return 'ｴ)' + name ; }
        if( c == 'b' || c == 'B' ) { return 'ﾋﾞ)' + name ; }
        if( c == 'c' || c == 'C' ) { return 'ｼ)' + name ; }
        if( c == 'd' || c == 'D' ) { return 'ﾃﾞｨ)' + name ; }
        if( c == 'e' || c == 'E' ) { return 'ｲ)' + name ; }
        if( c == 'f' || c == 'F' ) { return 'ｴﾌ)' + name ; }
        if( c == 'g' || c == 'G' ) { return 'ｼﾞ)' + name ; }
        if( c == 'h' || c == 'H' ) { return 'ｴｲﾁ)' + name ; }
        if( c == 'i' || c == 'I' ) { return 'ｱｲ)' + name ; }
        if( c == 'j' || c == 'J' ) { return 'ｼﾞｪｲ)' + name ; }
        if( c == 'k' || c == 'K' ) { return 'ｹ)' + name ; }
        if( c == 'l' || c == 'L' ) { return 'ｴﾙ)' + name ; }
        if( c == 'm' || c == 'M' ) { return 'ｴﾑ)' + name ; }
        if( c == 'n' || c == 'N' ) { return 'ｴﾇ)' + name ; }
        if( c == 'o' || c == 'O' ) { return 'ｵ)' + name ; }
        if( c == 'p' || c == 'P' ) { return 'ﾋﾟ)' + name ; }
        if( c == 'q' || c == 'Q' ) { return 'ｷｭｳ)' + name ; }
        if( c == 'r' || c == 'R' ) { return 'ｱｰﾙ)' + name ; }
        if( c == 's' || c == 'S' ) { return 'ｴｽ)' + name ; }
        if( c == 't' || c == 'T' ) { return 'ﾃｨ)' + name ; }
        if( c == 'u' || c == 'U' ) { return 'ﾕ)' + name ; }
        if( c == 'v' || c == 'V' ) { return 'ﾌﾞｲ)' + name ; }
        if( c == 'w' || c == 'W' ) { return 'ﾀﾞﾌﾞﾙ)' + name ; }
        if( c == 'x' || c == 'X' ) { return 'ｴｯｸｽ)' + name ; }
        if( c == 'y' || c == 'Y' ) { return 'ﾜｲ)' + name ; }
        if( c == 'z' || c == 'Z' ) { return 'ｾﾞｯﾄ)' + name ; }
        if( c == '0' ) { return 'ｾﾞﾛ)' + name ; }
        if( c == '1' ) { return 'ｲﾁ)' + name ; }
        if( c == '2' ) { return 'ﾆ)' + name ; }
        if( c == '3' ) { return 'ｻﾝ)' + name ; }
        if( c == '4' ) { return 'ﾖﾝ)' + name ; }
        if( c == '5' ) { return 'ｺﾞ)' + name ; }
        if( c == '6' ) { return 'ﾛｸ)' + name ; }
        if( c == '7' ) { return 'ﾅﾅ)' + name ; }
        if( c == '8' ) { return 'ﾊﾁ)' + name ; }
        if( c == '9' ) { return 'ｷｭｳ)' + name ; }
        return name ;
    },
    // POST/GETパラメータ内容からModelカラム内容を抽出.
    targetColumns : function( modelName ) {
        if( typeof( modelName ) == "map" ) {
            modelName = modelName.name ;
        }
        var model = null ;
        if( !useString( modelName ) || ( model = Models[modelName] ) == null ) {
            return {} ;
        }
        if( model._$detail$ == null ) {
            return {} ;
        }
        var def = model._$detail$ ;
        var columns = def.maintenanceDef ;
        var types = model.types ;
        var ems = def.element ;
        var len = columns.length ;
        var ret = {} ;
        var name = null ;
        for( var i = 0 ; i < len ; i ++ ) {
            name = columns[ i ] ;
            ret[ name ] = params[ name ] ;
            // 半角変換が必要なカラムについては、半角変換処理を行う.
            if( useString( ret[ name ] ) && ( ems[ i ].hankaku == true ||
                ems[ i ].hankaku == "true" ) ) {
                ret[ name ] = InputTag.convertHankaku( ret[ name ] ) ;
            }
            // フラグ条件に対して、フラグ設定が存在しない場合は、falseを設定.
            else if( !useString( ret[ name ] ) && types[ i ] == "boolean" ) {
                ret[ name ] = "false" ;
            }
        }
        return ret ;
    },
    // テキスト編集.
    text : function( name,option,size,clazz,style ) {
        if( !useString( name ) || isNull( size ) ||
            isNull( option ) || typeof( option ) != "map" ) {
            return "" ;
        }
        var type = option[ "type" ] ;
        if( typeof( type ) != "string" ) {
            return "" ;
        }
        if( typeof( size ) == "string" ) {
            if( size.startsWith( "$" ) ) {
                size = parseInt( size.substring( 1 ) ) ;
            }
            else if( !size.startsWith( "#" ) ) {
                size = parseInt( size ) ;
            }
            else {
                size = 4096 ;
            }
        }
        if( typeof( size ) != "number" ) {
            return "" ;
        }
        type = type.substring( 5 ).toLowerCase() ;
        var textMode = null ;
        if( type == "number" ) {
            textMode = TextMode.NUMBER ;
        }
        else if( type == "alpha" ) {
            textMode = TextMode.ALPHA ;
        }
        else if( type == "hira" ) {
            textMode = TextMode.HIRA ;
        }
        else if( type == "kana" ) {
            textMode = TextMode.KATA ;
        }
        return textTag( name,null,clazz,this.DEFAULT_TEXT_SIZE,size,style,textMode ) ;
    },
    // パスワード編集.
    passwd : function( name,option,size,clazz,style ) {
        if( !useString( name ) || isNull( size ) ||
            isNull( option ) || typeof( option ) != "map" ) {
            return "" ;
        }
        if( typeof( size ) == "string" ) {
            if( size.startsWith( "$" ) ) {
                size = parseInt( size.substring( 1 ) ) ;
            }
            else if( !size.startsWith( "#" ) ) {
                size = parseInt( size ) ;
            }
            else {
                size = 4096 ;
            }
        }
        if( typeof( size ) != "number" ) {
            return "" ;
        }
        return passwordTag( name,null,clazz,this.DEFAULT_TEXT_SIZE,size,style,TextMode.ALPHA ) ;
    },
    // テキストエリア編集.
    textarea : function( name,option,cols,rows,clazz,style ) {
        if( !useString( name ) ||
            isNull( option ) || typeof( option ) != "map" ||
            !isNumeric( cols ) || !isNumeric( rows ) ) {
            return "" ;
        }
        return textAreaTag( name,null,clazz,cols,rows,style,TextMode.HIRA ) ;
    },
    // チェックボックス編集.
    checkbox : function( name,option,clazz ) {
        if( !useString( name ) ||
            isNull( option ) || typeof( option ) != "map" ) {
            return "" ;
        }
        return new StrBuf().ad( checkBoxTag( name,"true",null,clazz ) ).
            ad( "&nbsp;" ).ad( option["name"] ).ad( "をONにする" ).ts() ; 
    },
    // 日付指定.
    date : function( name,option ) {
        if( !useString( name ) ||
            isNull( option ) || typeof( option ) != "map" ) {
            return "" ;
        }
        var type = option[ "type" ] ;
        if( typeof( type ) == "string" ) {
            return selectYMD( name,5,true,null ) ;
        }
        else if( typeof( type ) == "array" && type.length == 2 ) {
            return selectYMD( name,parseInt( type[1] ),true,null ) ;
        }
        return "" ;
    },
    // 時間指定.
    time : function( name,option ) {
        if( !useString( name ) ||
            isNull( option ) || typeof( option ) != "map" ) {
            return "" ;
        }
        return selectTime( name,true,null ) ;
    },
    // タイムスタンプ指定.
    timestamp : function( name,option ) {
        if( !useString( name ) ||
            isNull( option ) || typeof( option ) != "map" ) {
            return "" ;
        }
        var type = option[ "type" ] ;
        if( typeof( type ) == "string" ) {
            return selectYMD( name,5,true,null ) + "&nbsp;" +
                selectTime( name,true,null ) ;
        }
        else if( typeof( type ) == "array" && type.length == 2 ) {
            return selectYMD( name,parseInt( type[1] ),true,null ) + "&nbsp;" +
                selectTime( name,true,null ) ;
        }
        return "" ;
    },
    // セレクトボックス指定.
    select : function( name,option ) {
        if( !useString( name ) ||
            isNull( option ) || typeof( option ) != "map" ) {
            return "" ;
        }
        var type = option[ "type" ] ;
        if( typeof( type ) != "map" ) {
            return "" ;
        }
        var masterName = type.select ;
        var vname = type.view ;
        if( !useString( masterName ) ) {
            return "" ;
        }
        if( !useString( vname ) ) {
            vname = "name" ;
        }
        return MasterTag.selectTag( name,masterName,vname )
    },
    // ポップアップ指定.
    popup : function( name,option,popupInfo,mode ) {
        if( !useString( name ) || ( typeof( popupInfo ) != "map" && typeof( popupInfo ) != "jsadapter" ) ) {
            return "" ;
        }
        popupInfo = popupInfo.type ;
        if( popupInfo == null ) {
            return "" ;
        }
        var popupOp = popupInfo ;
        if( popupInfo.containsKey( "popup" ) ) {
            popupInfo = popupInfo.popup ;
            if( typeof( popupInfo ) != "map" && typeof( popupInfo ) != "jsadapter" ) {
                return "" ;
            }
        }
        if( isNull( option ) || typeof( option ) != "map" ) {
            var inputclazz = "text_class" ;
            var btnclazz = "bun1_class" ;
        }
        else {
            var inputclazz = option.input ;
            if( !useString( inputclazz ) ) {
                inputclazz = "text_class" ;
            }
            var btnclazz = option.btn ;
            if( !useString( btnclazz ) ) {
                btnclazz = "bun1_class" ;
            }
        }
        var popupParams = popupInfo.params ;
        var url = popupInfo.url ;
        var title = popupInfo.title ;
        var width = popupInfo.width ;
        var height = popupInfo.height ;
        var group = popupInfo.group ;
        if( !useString( title ) ) {
            title = "検索" ;
        }
        if( typeof( group ) != "string" || !useString( group ) ) {
            group = SearchTag.POPUP_GROUP ;
        }
        if( !isNumeric( width ) ) {
            width = -1 ;
        }
        if( !isNumeric( height ) ) {
            height = -1 ;
        }
        if( typeof( popupParams ) == "map" ) {
            var val = null ;
            for( var k in popupParams ) {
                val = popupParams[ k ] ;
                if( typeof( val ) == "string" ) {
                    if( val.startsWith( SearchTag.ITEM_HEAD ) ) {
                        val = val.substring( SearchTag.ITEM_HEAD.length ) ;
                    }
                }
                popupParams[k] = val ;
            }
            popupParams = convertMapToGetParams( popupParams ) ;
        }
        if( useString( popupParams ) ) {
            popupParams += "&_src="+name+"&_$masterType="+params['_$masterType'] ;
        }
        else if( !useString( popupParams ) ) {
            popupParams = "_src="+name+"&_$masterType="+params['_$masterType'] ;
        }
        if( mode == true || mode == "true" ) {
            mode = true ;
        }
        else {
            mode = false ;
            if( popupInfo.readOnly == true || popupInfo.readOnly == "true" ) {
                mode = true ;
            }
        }
        var type = TextMode.NUMBER ;
        if( popupOp.type != null ) {
            type = popupOp.type ;
        }
        var viewInfo = SearchTag.popupView( false,name,popupOp ) ;
        var buf = new StrBuf() ;
        buf.ad( textTag( name,null,inputclazz,this.DEFAULT_RANGE_SIZE,this.DEFAULT_RANGE_SIZE,null,type,null,false ) ) ;
        buf.ad( "\n<script>\n _$mm_popup_i$" ).ad( name ).ad( "$btn_func = function() { " ).
            ad( "var pms=\"" ).ad( popupParams ).ad( "\"; " ).
            ad( "if(!$base.useString(pms)){ pms = \"nowParams=\"+$('" ).ad( name ).ad( "').value;} else {" ).
                ad( "pms += \"&nowParams=\"+$('" ).ad( name ).ad( "').value;} " ).
            ad( "popup.ajax( \"" ).ad( url ).ad( "\",pms,\"" ).
                ad( title ).ad( "\"," ).ad( width ).ad( "," ).ad( height ).ad( ",\"" ).ad( group ).ad( "\",null," ).
                ad( "function( r ){" ).
                ad( "$(\"" ).ad( name ).ad( "\").value=r;" ).
                ad( "} ); }\n</script>" ).
        ad( "\n<input type=button class=\"" ).ad( btnclazz ).ad( "\" value=\"索&nbsp;&nbsp;引\"" ).
            ad( " onclick='javascript:_$mm_popup_i$" ).ad( name ).ad( "$btn_func();' / >" ) ;
        buf.ad( "&nbsp;&nbsp;<span id=" ).ad( name ).ad( "_ViewId" ).ad( ">" ).ad( viewInfo ).ad( "</span>" ) ;
        return buf.ts() ;
    },
    // 計算指定.
    calc : function( name,option,calcInfo,mode ) {
        if( !useString( name ) || ( typeof( calcInfo ) != "map" && typeof( calcInfo ) != "jsadapter" ) ) {
            return "" ;
        }
        calcInfo = calcInfo.type ;
        if( calcInfo == null ) {
            return "" ;
        }
        var calcOp = calcInfo ;
        if( calcInfo.containsKey( "calc" ) ) {
            calcInfo = calcInfo.calc ;
            if( typeof( calcInfo ) != "map" && typeof( calcInfo ) != "jsadapter" ) {
                return "" ;
            }
        }
        var exec = calcInfo.execution ;
        if( !useString( exec ) ) {
            exec = calcInfo.exec ;
            if( !useString( exec ) ) {
                return "" ;
            }
        }
        if( isNull( option ) || typeof( option ) != "map" ) {
            var inputclazz = "text_class" ;
            var btnclazz = "bun1_class" ;
        }
        else {
            var inputclazz = option.input ;
            if( !useString( inputclazz ) ) {
                inputclazz = "text_class" ;
            }
            var btnclazz = option.btn ;
            if( !useString( btnclazz ) ) {
                btnclazz = "bun1_class" ;
            }
        }
        if( mode == true || mode == "true" ) {
            mode = true ;
        }
        else {
            mode = false ;
            if( calcOp.readOnly == true || calcOp.readOnly == "true" ) {
                mode = true ;
            }
        }
        var buttonInfo = calcInfo.button ;
        if( !useString( buttonInfo ) ) {
            buttonInfo = "計&nbsp;&nbsp;算" ;
        }
        var type = TextMode.NUMBER ;
        if( calcOp.type != null ) {
            type = calcOp.type ;
        }
        var buf = new StrBuf() ;
        buf.ad( textTag( name,null,inputclazz,this.DEFAULT_RANGE_SIZE,this.DEFAULT_RANGE_SIZE,null,type,null,true ) ) ;
        buf.ad( "\n<script>\n _$mm_calc_i$" ).ad( name ).ad( "$btn_func = function()" ).ad( exec ).ad( "\n</script>\n" ) ;
        buf.ad( "\n<input type=button class=\"" ).ad( btnclazz ).ad( "\" value=\"" ).ad( buttonInfo ).ad( "\"" ).
            ad( " onclick='javascript:_$mm_calc_i$" ).ad( name ).ad( "$btn_func();' / >" ) ;
        return buf.ts() ;
    }
}
