// I/Oスクリプト.
//


////////////////////////////////////////////////////////////////////////////////
// I/O系.
////////////////////////////////////////////////////////////////////////////////

// I/Oオブジェクト.
Io = {
    _INCLUDE_SCRIPT:pkg( "org.maachang.seabass.httpd.engine.script.scripts.IncludeScript" ),
    // 指定ディレクトリを生成.
    mkdir : function( dirName ) {
        return seabassIO.mkdir( dirName ) ;
    },
    // ファイルを削除.
    deleteFile : function( fileName ) {
        return seabassIO.removeFile( fileName ) ;
    },
    // ディレクトリを削除.
    deleteDirectory : function( dirName ) {
        return seabassIO.removeDirectory( dirName ) ;
    },
    // ファイルを移動.
    moveFile : function( src,dest ) {
        return seabassIO.move( src,dest ) ;
    },
    // ファイルをコピー.
    copyFile : function( src,dest ) {
        return seabassIO.copyFile( src,dest ) ;
    },
    // ディレクトリをコピー.
    copyDirectory : function( src,dest ) {
        return seabassIO.copyDirectory( src,dest ) ;
    },
    // ファイル長を取得.
    fileLength : function( name ) {
        return seabassIO.getLength( name ) ;
    },
    // ファイル最終時間を取得.
    fileLastTime : function( name ) {
        return seabassIO.getLastTime( name ) ;
    },
    // フルパス名を取得.
    getFullPath : function( name ) {
        return seabassIO.getFullPath( name ) ;
    },
    // 指定パスからディレクトリ名を取得.
    getDirName : function( name ) {
        return seabassIO.getDirName( name ) ;
    },
    // 指定パスからファイル名を取得.
    getFileName : function( name ) {
        return seabassIO.getFileName( name ) ;
    },
    // 指定ファイルが存在するかチェック.
    isFileExists : function( name ) {
        return seabassIO.isFileExists( name ) ;
    },
    // 指定ディレクトリが存在するかチェック.
    isDirExists : function( name ) {
        return seabassIO.isDirExists( name ) ;
    },
    // 指定内容が読み込み可能かチェック.
    isReadFile : function( name ) {
        return seabassIO.isRead( name ) ;
    },
    // 指定内容が書き込み可能かチェック.
    isWriteFile : function( name ) {
        return seabassIO.isWrite( name ) ;
    },
    // 指定ディレクトリ以下の存在情報名を取得.
    getDirList : function( name ) {
        return seabassIO.getListByArray( name ) ;
    },
    // 指定ディレクトリ以下のすべてのファイル一覧を取得.
    getListByAllFile : function( name ) {
        return seabassIO.getListAll( name ) ;
    },
    // 指定ディレクトリ以下のファイルだけを一覧で取得.
    getListByOnlyFile : function( name ) {
        return seabassIO.getOnlyFileToArray( name ) ;
    },
    // ファイル内容をロード(String).
    readFileByString : function(fileName,charset) {
        return seabassIO.getFileByString( fileName,charset ) ;
    },
    // ファイル内容をロード(Binary).
    readFileByBinary : function(fileName) {
        return seabassIO.getFile( fileName ) ;
    },
    // ファイル内容を保存(String).
    writeFileByString : function(mode,fileName,value,charset) {
        if( !(value instanceof java.lang.String) ) {
            return false ;
        }
        return seabassIO.setFileByString( fileName,mode,value,charset ) ;
    },
    // ファイル内容を保存(Binary).
    writeFileBinary : function(mode,fileName,value) {
        if( !(value instanceof byte[]) ) {
            return false ;
        }
        return seabassIO.setFile( fileName,mode,value ) ;
    },
    // 空のファイルを作成.
    createFile : function( fileName ) {
        return seabassIO.createFile( fileName ) ;
    },
    // 指定ファイルを実行.
    execution : function( name,charset ) {
        if( Io.isFileExists( name ) == false ) {
            return ;
        }
        return eval( this._INCLUDE_SCRIPT.readScript( name,charset ) ) ;
    },
    // 指定ファイルをコンパイル.
    compile : function( name,charset ) {
        if( Io.isFileExists( name ) == false ) {
            return ;
        }
        return compile( this._INCLUDE_SCRIPT.readScript( name,charset ) ) ;
    },
    // 指定ファイルを実行(スコープ実行).
    exec : function( name,charset ) {
        if( Io.isFileExists( name ) == false ) {
            return ;
        }
        return eval( new StrBuf().ad( "(function(){\n" ).
            ad( this._INCLUDE_SCRIPT.readScript( name,charset ) ).ad( "\n})();" ).ts() ) ;
    },
    // 指定ファイルをコンパイル(スコープ実行).
    comp : function( name,charset ) {
        if( Io.isFileExists( name ) == false ) {
            return ;
        }
        return compile( new StrBuf().ad( "(function(){\n" ).
            ad( this._INCLUDE_SCRIPT.readScript( name,charset ) ).ad( "\n})();" ).ts() ) ;
    },
    // 指定ファイル内容を行指定で取得.
    getLines : function( name,start,size,charset ) {
        if( Io.isFileExists( name ) == false ) {
            return "" ;
        }
        return seabassIO.getLines( name,charset,start,size ) ;
    },
    // InputStreamでファイルをオープン.
    readStream : function( name ) {
        if( Io.isFileExists( name ) == false ) {
            return null ;
        }
        return new java.io.BufferedInputStream( new java.io.FileInputStream( name ) ) ;
    },
    // Readerでファイルをオープン.
    readReader : function( name,charset ) {
        if( Io.isFileExists( name ) == false ) {
            return null ;
        }
        if( !useString( charset ) ) {
            charset = "UTF8" ;
        }
        return new java.io.BufferedReader( new java.io.InputStreamReader(
            new java.io.FileInputStream( name ),charset ) ) ;
    },
    // OutputStreamでファイルをオープン.
    writeStream : function( name,append ) {
        if( append != true || append != "true" ) {
            append = false ;
        }
        else {
            append = true ;
        }
        return new java.io.BufferedOutputStream( new java.io.FileOutputStream( name,append ) ) ;
    },
    // Writerでファイルをオープン.
    writeWriter : function( name,charset,append ) {
        if( append != true || append != "true" ) {
            append = false ;
        }
        else {
            append = true ;
        }
        if( !useString( charset ) ) {
            charset = "UTF8" ;
        }
        return new java.io.BufferedWriter( new java.io.OutputStreamWriter(
            new java.io.FileOutputStream( name,append ),charset ) ) ;
    },
    // ターゲットロック.
    lock : function( name ) {
        return seabassIO.lock( name ) ;
    },
    // ターゲットアンロック.
    unlock : function( name ) {
        return seabassIO.unlock( name ) ;
    },
    // ターゲットロックを取得.
    getLock : function() {
        return seabassIO.getTargetLock() ;
    },
    // Read/Writeロックを取得.
    getRWLock : function( spin ) {
        return seabassIO.createRWLock( spin ) ;
    }
}

// CSV読み込み処理.
CsvReader = {
    prototype : {
        obj : null,
        // コンストラクタ.
        _constructor : function( name,charset,cutCode ) {
            if( useString( name ) ) {
                this.open( name,charset,cutCode ) ;
            }
        },
        // 情報生成.
        open : function( name,charset,cutCode ) {
            if( !Io.isFileExists( name ) ) {
                return false ;
            }
            this.close() ;
            if( !useString( charset ) ) {
                charset = "UTF8" ;
            }
            if( !useString( cutCode ) ) {
                cutCode = "," ;
            }
            this.obj = new org.maachang.util.CsvReader( name,charset,cutCode ) ;
        },
        // 情報生成(java.io.Readerを指定して生成).
        openToReader : function( r,cutCode ) {
            this.close() ;
            if( !useString( cutCode ) ) {
                cutCode = "," ;
            }
            this.obj = new org.maachang.util.CsvReader( r,cutCode ) ;
        },
        // ファイルクローズ.
        close : function() {
            if( this.obj != null ) {
                this.obj.close() ;
                this.obj = null ;
            }
        },
        // 次の情報を取得.
        next : function() {
            if( this.obj == null ) {
                return false ;
            }
            return this.obj.next() ;
        },
        // 現在のカーソル位置の情報を取得.
        get : function() {
            if( this.obj == null ) {
                return null ;
            }
            return this.obj.get() ;
        },
        // 現在のカーソル位置を取得.
        count : function() {
            if( this.obj == null ) {
                return -1 ;
            }
            return this.obj.count() ;
        },
        // カーソルが最後に到達しているかチェック.
        isEOF : function() {
            if( this.obj == null ) {
                return true ;
            }
            return this.obj.isEOF() ;
        },
        // オブジェクトがオープン中かチェック.
        isOpen : function() {
            return this.obj != null && this.obj.isOpen() ;
        }
    }
}

// CSV書き込みバッファ.
CsvBuf = {
    prototype : {
        // コンストラクタ.
        _constructor : function( cutCode ) {
            this.create( cutCode ) ;
        },
        // 情報生成.
        create : function( cutCode ) {
            if( !useString( cutCode ) ) {
                cutCode = "," ;
            }
            this.buf = new StrBuf() ;
            this.cnt = 0 ;
            this.cutCd = cutCode ;
            return this.getThisObject() ;
        },
        // 情報クリア.
        clear : function() {
            this.buf = null ;
            this.cnt = 0 ;
        },
        // 行終端処理.
        next : function() {
            if( this.cnt > 0 ) {
                this.buf.ad( "\n" ) ;
                this.cnt = 0 ;
            }
            return this.getThisObject() ;
        },
        // データ追加.
        add : function( value ) {
            if( this.cnt > 0 ) {
                this.buf.ad( this.cutCd ) ;
            }
            this.buf.ad( value ) ;
            this.cnt ++ ;
            return this.getThisObject() ;
        },
        // 文字コードを追加.
        addStr : function( value ) {
            if( this.cnt > 0 ) {
                this.buf.ad( this.cutCd ) ;
            }
            this.cnt ++ ;
            this.buf.ad( "\"" ).ad( value ).ad( "\"" ) ;
            return this.getThisObject() ;
        },
        // 文字データ取得.
        ts : function() {
            var ret = this.buf.ad( "\n" ).ts() ;
            this.buf = new StrBuf() ;
            this.cnt = 0 ;
            return ret ;
        },
        // 対象Writerファイルに出力.
        write : function( writerObj ) {
            var b = this.ts() ;
            writerObj.write( b,0,b.length ) ;
        }
    }
    
}
