// mailスクリプト.
//

// Mailオブジェクト.
Mail = {
    // テンプレートを使ったSendMailQueueメール送信.
    sendByTemplateFileQ : function( templateFileName,params,from,to,attached,setting ) {
        return Mail.sendByTemplateFile( templateFileName,params,from,to,attached,setting,true ) ;
    },
    // テンプレートを使ったメール送信.
    sendByTemplateFile : function( templateFileName,params,from,to,attached,setting,queueFlag ) {
        var template = MaachangTemplate.readTemplateFile( templateFileName ) ;
        return Mail.sendByTemplateData( template,params,from,to,attached,setting,queueFlag ) ;
    },
    // テンプレートデータを引数で指定して、SendMailQueueメール送信.
    sendByTemplateDataQ : function( template,params,from,to,attached,setting ) {
        return Mail.sendByTemplateData( template,params,from,to,attached,setting,true ) ;
    },
    // テンプレートデータを引数で指定して、メール送信.
    sendByTemplateData : function( template,params,from,to,attached,setting,queueFlag ) {
        if( !useString( template ) ) {
            return false ;
        }
        template = MaachangTemplate.executionTemplate( template,params ) ;
        if( !useString( template ) ) {
            return false ;
        }
        var title = Mail.getTemplateByMailTitle( template ) ;
        var body = Mail.getTemplateByBody( template ) ;
        template = null ;
        return Mail.send( from,to,title,body,attached,setting,queueFlag ) ;
    },
    // １行目をタイトルとして、メールテンプレート内容から抜き出す.
    getTemplateByMailTitle : function( template ) {
        if( useString( template ) == false ) {
            return null ;
        }
        var p = template.indexOf( "\n" ) ;
        if( p <= -1 ) {
            return "" ;
        }
        var ret = template.substring( 0,p ) ;
        ret = changeString( ret,"\r","" ) ;
        return changeString( ret,"\n","" ) ;
    },
    // ２行目以降を、本文として、メールテンプレート内容から抜き出す.
    getTemplateByBody : function( template ) {
        if( useString( template ) == false ) {
            return null ;
        }
        var p = template.indexOf( "\n" ) ;
        if( p <= -1 ) {
            return template ;
        }
        var ret = template.substring( p ) ;
        if( startsWith( ret,"\r" ) ) {
            ret = ret.substring( 1 ) ;
        }
        if( startsWith( ret,"\n" ) ) {
            ret = ret.substring( 1 ) ;
        }
        return ret;
    },
    // SendMailQueueメール送信.
    sendQ : function( from,to,subject,body,attached,setting ) {
        Mail.send( from,to,subject,body,attached,setting,true ) ;
    },
    // メール送信.
    send : function( from,to,subject,body,attached,setting,queueFlag ) {
        if( isNull( from ) || isNull( to ) ) {
            return false ;
        }
        var sendMail = pkg("org.maachang.seabass.service.mail.CreateMailBean").getSendMail() ;
        if( isNull( sendMail ) ) {
            return false ;
        }
        sendMail.setFrom( from ) ;
        if( typeof( to ) == "array" ) {
            var lst = [] ;
            var len = to.length ;
            for( var i = 0 ; i < len ; i ++ ) {
                lst.add( to[i] ) ;
            }
            sendMail.setTo( lst ) ;
        }
        else {
            var lst = [] ;
            lst.add( ""+to ) ;
            sendMail.setTo( lst ) ;
        }
        if( useString( subject ) == false ) {
            subject = "no title" ;
        }
        sendMail.setSubject( subject ) ;
        if( useString( body ) == false ) {
            body = "" ;
        }
        sendMail.setBody( body ) ;
        if( isNull( attached ) ) {
            var t = typeof( attached ) ;
            if( t == "map" ) {
                if( isNull( attached["name"] ) == false && isNull( attached["body"] ) == false ) {
                    var at = new org.maachang.seabass.service.mail.ResultAttached() ;
                    at.setFileName( attached["name"] ) ;
                    at.setAttached( attached["body"] ) ;
                    var lst = [] ;
                    lst.add( at ) ;
                    sendMail.setAttached( lst ) ;
                }
            }
            else if( t == "array" ) {
                var len = attached.length ;
                if( len > 0 ) {
                    var lst = [] ;
                    for( var i = 0 ; i < len ; i ++ ) {
                        var one = attached[i] ;
                        if( isNull( one ) == false && typeof( one ) == "map" &&
                            isNull( one["name"] ) == false && isNull( one["body"] ) == false ) {
                            var at = new org.maachang.seabass.service.mail.ResultAttached() ;
                            at.setFileName( one["name"] ) ;
                            at.setAttached( one["body"] ) ;
                            lst.add( at ) ;
                        }
                    }
                    if( lst.size() > 0 ) {
                        sendMail.setAttached( lst ) ;
                    }
                }
            }
        }
        Mail.settingMailParams( true,sendMail,setting ) ;
        if( queueFlag == true ) {
            pkg("org.maachang.seabass.service.mail.SendMailQueue").getInstance().sendMail( sendMail ) ;
            return true ;
        }
        else {
            return pkg("org.maachang.seabass.service.mail.SendMailService").sendMailTo( sendMail ) ;
        }
    },
    // メール受信.
    receive : function( mode,removeFlag,setting ) {
        var receiveMail = pkg("org.maachang.seabass.service.mail.CreateMailBean").getReceiveMail() ;
        if( isNull( receiveMail ) ) {
            return null ;
        }
        receiveMail.setDelete( ( ( removeFlag == true ) ? true : false ) ) ;
        Mail.settingMailParams( false,receiveMail,setting ) ;
        mode = ( mode == true ) ? true : false ;
        var result = pkg("org.maachang.seabass.service.mail.ReceiveMailService").receiveMailTo( mode,receiveMail ) ;
        if( isNull( result ) ) {
            return null ;
        }
        return Mail.convertResultMail( result ) ;
    },
    // パラメータセッティング.
    settingMailParams : function( mode,out,setting ) {
        if( isNull( out ) || isNull( setting ) || typeof( setting ) != "map" ) {
            return null ;
        }
        if( isNull( setting["host"] ) == false ) {
            out.setHost( setting["host"] ) ;
        }
        if( isNull( setting["port"] ) == false ) {
            out.setPort( setting["port"] ) ;
        }
        if( isNull( setting["timeout"] ) == false ) {
            out.setTimeout( setting["timeout"] ) ;
        }
        if( isNull( setting["ssl"] ) == false ) {
            out.setSsl( setting["ssl"] ) ;
        }
        
        if( mode == true ) {
            if( isNull( setting["auth"] ) == false ) {
                out.setAuth( setting["auth"] ) ;
            }
            if( out.isAuth() == true ) {
                if( isNull( setting["user"] ) == false ) {
                    out.setUser( setting["user"] ) ;
                }
                if( isNull( setting["passwd"] ) == false ) {
                    out.setPasswd( setting["passwd"] ) ;
                }
            }
            else {
                out.setUser( null ) ;
                out.setPasswd( null ) ;
            }
        }
        else {
            if( isNull( setting["user"] ) == false ) {
                out.setUser( setting["user"] ) ;
            }
            if( isNull( setting["passwd"] ) == false ) {
                out.setPasswd( setting["passwd"] ) ;
            }
        }
        return out ;
    },
    // 受信メール結果を変換.
    convertResultMail : function( result ) {
        if( isNull( result ) ||
            ( result instanceof java.util.List ) == false ||
            result.size() <= 0 ) {
            return [] ;
        }
        var ret = [] ;
        var len = result.size() ;
        for( var i = 0 ; i < len ; i ++ ) {
            var one = result.get( i ) ;
            var oneMail = {} ;
            if( one.getTo() != null && one.getTo().size() > 0 ) {
                oneMail["to"] = Mail.convertMailByArray( one.getTo() ) ;
            }
            else {
                oneMail["to"] = "" ;
            }
            if( one.getFrom() != null && one.getFrom().size() > 0 ) {
                oneMail["from"] = Mail.convertMailByArray( one.getFrom() ) ;
            }
            else {
                oneMail["from"] = "" ;
            }
            if( one.getSubject() != null ) {
                oneMail["subject"] = one.getSubject() ;
            }
            else {
                oneMail["subject"] = "" ;
            }
            if( one.getBody() != null ) {
                oneMail["body"] = one.getBody() ;
            }
            else {
                oneMail["body"] = "" ;
            }
            if( one.getAttached() != null && one.getAttached().size() > 0 ) {
                var atList = one.getAttached() ;
                var lenJ = atList.size() ;
                var atRes = [] ;
                for( var j = 0 ; j < lenJ ; j ++ ) {
                    var data = atList.get( j ) ;
                    var atBin = {} ;
                    atBin["name"] = data.getFileName() ;
                    atBin["body"] = data.getAttached() ;
                    atRes[j] = atBin ;
                }
                oneMail["attached"] = atRes ;
            }
            ret[i] = oneMail ;
        }
        return ret ;
    },
    // １つの内容を配列変換.
    convertMailByArray : function( list ) {
        var len = list.size() ;
        var ret = [] ;
        for( var i = 0 ; i < len ; i ++ ) {
            ret[i] = list.get( i ) ;
        }
        return ret ;
    }
}
