//
// HTMLタグスクリプト.
//
var StringUtil = pkg( "org.maachang.util.StringUtil" ) ;

////////////////////////////////////////////////////////////////////////////////
// イベント処理.
////////////////////////////////////////////////////////////////////////////////
Event = {
    // イベントキャッシュクリア.
    exit : function() {
        context.remove( "_$script$event" ) ;
    },
    // イベントキャッシュ追加.
    add : function( name,value ) {
        var map = context.get( "_$script$event" ) ;
        if( map == null ) {
            map = {} ;
            context.put( "_$script$event",map ) ;
        }
        var buf = map.get( name ) ;
        if( buf == null ) {
            buf = createStrBuf() ;
            map.put( name,buf ) ;
            buf.ad( value ) ;
        }
        else {
            buf.ad( "; " ).ad( value ) ;
        }
    },
    // イベント反映.
    flush : function( buf ) {
        var map = context.get( "_$script$event" ) ;
        if( map != null ) {
            for( k in map ) {
                var esc = pkg("org.maachang.seabass.httpd.engine.script.js.JsDef").convetByCote( false,map[k].ts() ) ;
                buf.ad( " " ).ad( k ) ;
                if( !esc.startsWith( "javascript:" ) ) {
                    buf.ad( "=\'javascript:" ) ;
                }
                else {
                    buf.ad( "=\'" ) ;
                }
                buf.ad( esc ).ad( "\' " ) ;
            }
            map.clear() ;
        }
    },
    // イベントMapをコピー.
    copy : function() {
        var map = context.get( "_$script$event" ) ;
        if( map != null ) {
            var m = {} ;
            for( var k in map ) {
                var s = createStrBuf() ;
                s.ad( map[k].ts() ) ;
                m.put( k,s ) ;
            }
            return m ;
        }
        return null ;
    },
    // イベントMapをセット.
    write : function( map ) {
        if( typeof( map ) == "map" ) {
            var m = {} ;
            for( var k in map ) {
                m[k] = map[k] ;
            }
            context.put( "_$script$event",m ) ;
        }
    },
    // イベントクリア.
    clear : function() {
        var map = context.get( "_$script$event" ) ;
        if( map != null ) {
            map.clear() ;
        }
    },
    // onclick.
    onclick : function( value ) {
        this.add( "onclick",value ) ;
        return "" ;
    },
    // ondblclick.
    ondblclick : function( value ) {
        this.add( "ondblclick",value ) ;
        return "" ;
    },
    // onkeydown.
    onkeydown : function( value ) {
        this.add( "onkeydown",value ) ;
        return "" ;
    },
    // onkeypress.
    onkeypress : function( value ) {
        this.add( "onkeypress",value ) ;
        return "" ;
    },
    // onkeyup.
    onkeyup : function( value ) {
        this.add( "onkeyup",value ) ;
        return "" ;
    },
    // onmousedown.
    onmousedown : function( value ) {
        this.add( "onmousedown",value ) ;
        return "" ;
    },
    // onmouseup.
    onmouseup : function( value ) {
        this.add( "onmouseup",value ) ;
        return "" ;
    },
    // onmouseover.
    onmouseover : function( value ) {
        this.add( "onmouseover",value ) ;
        return "" ;
    },
    // onmouseout.
    onmouseout : function( value ) {
        this.add( "onmouseout",value ) ;
        return "" ;
    },
    // onmousemove.
    onmousemove : function( value ) {
        this.add( "onmousemove",value ) ;
        return "" ;
    },
    // onload.
    onload : function( value ) {
        this.add( "onload",value ) ;
        return "" ;
    },
    // onunload.
    onunload : function( value ) {
        this.add( "onunload",value ) ;
        return "" ;
    },
    // onbeforeunload.
    onbeforeunload : function( value ) {
        this.add( "onbeforeunload",value ) ;
        return "" ;
    },
    // onfocus.
    onfocus : function( value ) {
        this.add( "onfocus",value ) ;
        return "" ;
    },
    // onblur.
    onblur : function( value ) {
        this.add( "onblur",value ) ;
        return "" ;
    },
    // onsubmit.
    onsubmit : function( value ) {
        this.add( "onsubmit",value ) ;
        return "" ;
    },
    // onreset.
    onreset : function( value ) {
        this.add( "onreset",value ) ;
        return "" ;
    },
    // onchange.
    onchange : function( value ) {
        this.add( "onchange",value ) ;
        return "" ;
    },
    // onresize.
    onresize : function( value ) {
        this.add( "onresize",value ) ;
        return "" ;
    },
    // onmove.
    onmove : function( value ) {
        this.add( "onmove",value ) ;
        return "" ;
    },
    // ondragdrop.
    ondragdrop : function( value ) {
        this.add( "ondragdrop",value ) ;
        return "" ;
    },
    // onabort.
    onabort : function( value ) {
        this.add( "onabort",value ) ;
        return "" ;
    },
    // onerror.
    onerror : function( value ) {
        this.add( "onerror",value ) ;
        return "" ;
    },
    // onselect.
    onselect : function( value ) {
        this.add( "onselect",value ) ;
        return "" ;
    }
} ;

////////////////////////////////////////////////////////////////////////////////
// キャッシュ関係.
////////////////////////////////////////////////////////////////////////////////

// inputタグ名保存情報を取得.
InputNameList = {
    // 内容をクリア.
    exit : function() {
        lst = this.getList() ;
        if( lst != null ) {
            lst.clear() ;
        }
    },
    // リストに追加.
    add : function( name ) {
        lst = this.getList() ;
        lst.add( convertString( name ) ) ;
    },
    // データ存在チェック.
    contains : function( name ) {
        lst = this.getList() ;
        return lst.contains( name ) ;
    },
    // リストを取得.
    getList : function() {
        var ret = context.get( "_$tagInputNames" ) ;
        if( ret == null ) {
            ret = new gnu.trove.THashSet() ;
            context.put( "_$tagInputNames",ret ) ;
        }
        return ret ;
    }
} ;

// 入力枠カラーキャッシュ.
InputColorCache = {
    // 入力カラークリア.
    exit : function() {
        context.remove( "_$cache$_inputColor" ) ;
    },
    // 入力カラー生成.
    create : function( inColor,outColor ) {
        if( inColor == null || (inColor instanceof java.lang.String) == false ) {
            inColor = "#ccccff" ;
        }
        if( outColor == null || (outColor instanceof java.lang.String) == false ) {
            outColor = "#ffffff" ;
        }
        context.put( "_$cache$_inputColor",[ inColor,outColor ] ) ;
        return createStrBuf().ad( "\n<script><!--\n" ).
            ad( "_$_$active_$changeColor = \""+inColor+"\" ;\n" ).
            ad( "_$_$noActive_$changeColor = \""+outColor+"\" ;\n" ).
            ad( "--></script>\n" ).ts() ;
    },
    // 入力カラーが設定されているかチェック.
    use : function() {
        return context.containsKey( "_$cache$_inputColor" ) ;
    },
    // 入力カラー値を取得.
    get : function() {
        return context.get( "_$cache$_inputColor" ) ;
    }
} ;

// フォーム名キャッシュ.
FormNameCache = {
    // 内容をクリア.
    exit : function() {
        context.remove( "_$cache$_formName" )
    },
    // フォーム名を設定.
    set : function( value ) {
        context.put( "_$cache$_formName",value )
    },
    // 現在のフォーム名を取得.
    get : function() {
        return context.get( "_$cache$_formName" )
    }
} ;

// 無名フォーム項番キャッシュ.
UnknownFormCache = {
    // 内容をクリア.
    exit : function() {
        context.remove( "_$cache$_uform" ) ;
    },
    // 無名フォーム項番を追加.
    add : function() {
        var v = context.get( "_$cache$_uform" ) ;
        if( v == null ) {
            v = 0 ;
        }
        else {
            v ++ ;
        }
        context.put( "_$cache$_uform",v ) ;
    },
    // 現在の無名フォーム項番を取得.
    get : function() {
        var v = context.get( "_$cache$_uform" ) ;
        if( v == null ) {
            v = 0 ;
        }
        return v ;
    }
} ;


// ページバック用キャッシュ.
PageBackCache = {
    // 内容をクリア.
    exit : function() {
        context.remove( "_$cache$_pageBack" )
    },
    // ページバックフラグをONに設定.
    flagOn : function() {
        context.put( "_$cache$_pageBack",true )
    },
    // ページバックフラグをOFFに設定.
    flagOff : function() {
        context.put( "_$cache$_pageBack",false )
    },
    // ページバックフラグを取得.
    flag : function() {
        return context.get( "_$cache$_pageBack" )
    }
} ;

// 重複IDキャッシュ.
IdCache = {
    // 内容をクリア.
    exit : function() {
        context.remove( "_$cache$_id" )
    },
    // idキャッシュマップを取得.
    _map : function() {
        var map = context.get( "_$cache$_id" ) ;
        if( map == null ) {
            map = {} ;
            context.put( "_$cache$_id",map ) ;
        }
        return map ;
    },
    // ID名を設定.
    set : function( name ) {
        var map = this._map() ;
        var v = map[name] ;
        if( v == null ) {
            v = 0 ;
        }
        else {
            v ++ ;
        }
        map.put( name,v ) ;
        return v ;
    },
    // 現在のID項番を取得.
    get : function( name ) {
        var map = this._map() ;
        var v = map[name] ;
        if( v == null ) {
            return "" ;
        }
        return v ;
    }
} ;

// デフォルトパラメータ定義.
DefaultParams = {
    // 内容をクリア.
    exit : function() {
        context.remove( "_$default$params" ) ;
    },
    // 存在確認.
    empty : function() {
        var map = context.get( "_$default$params" ) ;
        if( map == null || typeof( map ) != "map" ) {
            return false ;
        }
        return map.length > 0  ;
    },
    // 一斉定義.
    create : function( map ) {
        if( map == null || typeof( map ) != "map" ) {
            return false ;
        }
        context.put( "_$default$params",map ) ;
        return true ;
    },
    // 指定追加.
    add : function( key,value ) {
        if( typeof( key ) != "string" ) {
            return false ;
        }
        var map = context.get( "_$default$params" ) ;
        if( map == null || typeof( map ) != "map" ) {
            return false ;
        }
        map.put( key,value ) ;
        return true ;
    },
    // hidden定義.
    hidden : function() {
        var map = context.get( "_$default$params" ) ;
        if( map == null || typeof( map ) != "map" || map.length <= 0 ) {
            return "" ;
        }
        var ret = new StrBuf() ;
        for( var k in  map ) {
            ret.ad( hiddenTag( k,map[k] ) ) ;
        }
        return ret.ts() ;
    },
    // Mapオブジェクトを取得.
    map : function( map ) {
        if( typeof( map ) != "map" ) {
            return copy( context.get( "_$default$params" ) ) ;
        }
        var ret = copy( context.get( "_$default$params" ) ) ;
        for( k in map ) {
            ret[k] = map[k] ;
        }
        return ret ;
    },
    // Mapオブジェクトを表示.
    toString : function( map ) {
        return encodeJSON( this.map( map ) ) ;
    },
    // 部分削除.
    remove : function( key ) {
        if( typeof( key ) != "string" ) {
            return false ;
        }
        var map = context.get( "_$default$params" ) ;
        if( map == null || typeof( map ) != "map" ) {
            return false ;
        }
        map.remove( key ) ;
        return true ;
    },
    // 取得.
    get : function( key ) {
        if( typeof( key ) != "string" ) {
            return null ;
        }
        var map = context.get( "_$default$params" ) ;
        if( map == null || typeof( map ) != "map" ) {
            return null ;
        }
        return map.get( key ) ;
    },
    // 存在確認.
    containsKey : function( key ) {
        if( typeof( key ) != "string" ) {
            return false ;
        }
        var map = context.get( "_$default$params" ) ;
        if( map == null || typeof( map ) != "map" ) {
            return false ;
        }
        return map.containsKey( key ) ;
    }
}

// MHTML終了後のキャッシュクリア処理.
exitMHTMLCache = function() {
    Event.exit() ;
    InputNameList.exit() ;
    InputColorCache.exit() ;
    FormNameCache.exit() ;
    UnknownFormCache.exit() ;
    PageBackCache.exit() ;
    IdCache.exit() ;
    BaseVTag.exit() ;
    BaseVLTag.exit() ;
    validate_errorFlag.exit() ;
    DefaultParams.exit() ;
} ;

////////////////////////////////////////////////////////////////////////////////
// メッセージタグ.
////////////////////////////////////////////////////////////////////////////////

// Validateエラーメッセージ表示用タグ.
errorTag = function(id) {
    if( super.__$type$script == "script" ) {
        if( isEmpty( id ) ) {
            id = "main" ;
        }
        if( useString( super._$script$query.get("_validateError"+id) ) == true ) {
            return createStrBuf().ad("<span id=\"emsgId").ad(id).ad("\" class=\"emsg\" style=\"color:red;\">").
                ad(super._$script$query.get("_validateError"+id)).
                ad("</span>").ts() ;
        }
        else {
            return createStrBuf().ad("<span id=\"emsgId" ).ad(id).ad("\" class=\"emsg\" style=\"color:red;\"></span>").ts() ;
        }
    }
    return "" ;
} ;

// 正常メッセージ表示用タグ.
successTag = function(id) {
    if( super.__$type$script == "script" ) {
        if( isEmpty( id ) ) {
            id = "main" ;
        }
        if( useString( super._$script$query.get("_validateSuccess"+id) ) == true ) {
            return createStrBuf().ad("<span id=\"smsgId").ad(id).
                ad("\" class=\"smsg\" style=\"color:blue;\">").
                ad(super._$script$query.get("_validateSuccess"+id)).
                ad("</span>").ts() ;
        }
        else {
            return createStrBuf().ad("<span id=\"smsgId").ad(id).
            ad("\" class=\"smsg\" style=\"color:blue;\">&nbsp;</span>").ts() ;
        }
    }
    return "" ;
} ;

// successエラーメッセージを登録.
editSuccessMessage = function( name,no,message ) {
    setSuccessMessage( message,getId( name,no ) ) ;
}

// Validateエラーメッセージを登録.
editErrorMessage = function( name,no,message ) {
    setErrorMessage( message,getId( name,no ) ) ;
}

////////////////////////////////////////////////////////////////////////////////
// HTMLタグ関連.
////////////////////////////////////////////////////////////////////////////////

// 現在のパラメータをhiddenタグに付加.
outputHiddenQuery = function() {
    var buf = createStrBuf() ;
    var it = super._$script$query.keySet().iterator() ;
    while( it.hasNext() ) {
        var one = it.next() ;
        if( isNull( one ) || startsWith( one,"_" ) || startsWith( one,"$" ) ) {
            continue ;
        }
        buf.append( hiddenTag( one ) ) ;
    }
    return buf.ts() ;
}

// ID名を生成.
createId = function( mode,name ) {
    if( !useString( name ) ) {
        return null ;
    }
    var n = "" ;
    if( mode ) {
        n = IdCache.set( name ) ;
    }
    else {
        n = IdCache.get( name ) ;
    }
    if( useString( n ) ) {
        return createStrBuf().ad( name ).ad( "_" ).ad( n ).ad( "_Id" ).ts() ;
    }
    return name + "_0_Id" ;
}

// ID名を項番指定で取得.
getId = function( name,num ) {
    if( useString( num ) ) {
        return createStrBuf().ad( name ).ad( "_" ).ad( num ).ad( "_Id" ).ts() ;
    }
    return name + "_0_Id" ;
}

// ID項番を取得.
getIdNum = function( name ) {
    var n = IdCache.get( name ) ;
    if( !useString( n ) ) {
        return 0 ;
    }
    return n ;
}

// その他情報を展開.
etcTag = function( etc,buf ) {
    if( isNull( etc ) ) {
        Event.flush( buf ) ;
        return "" ;
    }
    var noBuf = false ;
    if( isNull( buf ) ) {
        noBuf = true ;
        buf = createStrBuf() ;
    }
    var t = typeof( etc ) ;
    if( t == "string" ) {
        buf.append( " " ).append( etc ).append( " " ) ;
        Event.flush( buf ) ;
        if(noBuf == true ) {
            return buf.ts() ;
        }
        else {
            return "" ;
        }
    }
    else if( t == "map" ) {
        buf.ad( " " ) ;
        for( var k : etc ) {
            if( isNull( etc[k] ) == false && isEmpty( etc[k] ) ) {
                buf.ad( k ).ad( "=" ).ad( "\"" ).ad( etc[k] ).ad( "\" " ) ;
            }
        }
        Event.flush( buf ) ;
        if(noBuf == true ) {
            return buf.ts() ;
        }
        else {
            return "" ;
        }
    }
    else if( t == "array" ) {
        buf.ad( " " ) ;
        var len = etc.length ;
        for( var i = 0 ; i < len ; i ++ ) {
            var s = etc[ i ] ;
            if( useString( s ) ) {
                buf.ad( s ).ad( " " ) ;
            }
        }
        Event.flush( buf ) ;
        if(noBuf == true ) {
            return buf.ts() ;
        }
        else {
            return "" ;
        }
    }
} ;

// 入力カラー条件が付加されている場合の入力枠処理.
toInputColor = function( id ) {
    if( useString( id ) ) {
        var color = InputColorCache.get() ;
        if( color != null ) {
            Event.onfocus( createStrBuf().ad("document.getElementById(\"").ad(id).
                ad("\").style.backgroundColor=\"").ad(color[0]).ad( "\";" ).ts() ) ;
            Event.onblur( createStrBuf().ad("document.getElementById(\"").ad(id).
                ad("\").style.backgroundColor=\"").ad(color[1]).ad( "\";" ).ts() ) ;
        }
    }
}

// デフォルトパラメータを設定.
setDefaultParams = function( params ) {
    if( typeof( params ) == "map" ) {
        DefaultParams.create( params ) ;
    }
    return "" ;
}

// デフォルトパラメータをJavascriptなどで利用する場合の処理.
viewDefaultParams = function( addParams ) {
    if( DefaultParams.empty() ) {
        return encodeJSONP( DefaultParams.map( addParams ) ) ;
    }
    if( typeof( addParams ) == "map" ) {
        return encodeJSONP( addParams ) ;
    }
    return "{}" ;
}

// リンク指定時に利用.
viewHref = function(href,params,mode) {
    var buf = createStrBuf() ;
    var p = -1 ;
    if( ( p = href.indexOf( "?" ) ) == -1 ) {
        if( isSessionLink() == false && getSessionId() != null ) {
            buf.ad( href ) ;
            if( mode != false ) {
                buf.ad( "?t=" ).ad( currentTime() ).ad( "&" ) ;
            }
            else {
                buf.ad( "?" ) ;
            }
            buf.ad( sessionParam() ).ad( "=" ).ad( getSessionId() ) ;
        }
        else {
            if( mode != false ) {
                buf.ad( href ).ad( "?t=" ).ad( currentTime() ) ;
            }
            else {
                buf.ad( href ) ;
            }
        }
        href = buf.ts() ;
        buf.clear() ;
    }
    else {
        var a = href.substring( 0,p ) ;
        var b = href.substring( p+1 ) ;
        // パラメータが存在して、URLEncodeされていない場合は、変換処理.
        if( useString( b ) && b.indexOf( "%" ) == -1 ) {
            var paramBuf = createStrBuf() ;
            var v = split( false,false, b,"&" ) ;
            var len = v.length ;
            for( var i = 0 ; i < len ; i ++ ) {
                if( i != 0 ) {
                    paramBuf.ad( "&" ) ;
                }
                s = v[ i ] ;
                if( ( x = s.indexOf( "=" ) ) != -1 ) {
                    paramBuf.ad( s.substring( 0,x+1 ) ).ad( encodeURL( s.substring( x+1 ),"UTF8" ) ) ;
                }
                else {
                    paramBuf.ad( s ) ;
                }
            }
            s = null ;
            v = null ;
            b = paramBuf.ts() ;
        }
        if( isSessionLink() == false && getSessionId() != null ) {
            buf.ad( a ).ad( "?t=" ).ad( currentTime() ).ad( "&" ).
            ad( sessionParam() ).ad( "=" ).ad( getSessionId() ).ad( "&" ).ad( b ) ;
        }
        else {
            buf.ad( a ).ad( "?t=" ).ad( currentTime() ).ad( "&" ).ad( b ) ;
        }
        a = null ;
        b = null ;
        href = buf.ts() ;
        buf.clear() ;
    }
    p = null ;
    if( !startsWith( href,"http://" ) && !startsWith( href,"https://" ) ) {
        href = margePathName(href) ;
    }
    if( !isNull( params ) && params instanceof Map && params.size > 0 ) {
        // デフォルトパラメータが存在する場合は、その内容とマージした処理を実行.
        var pms = params ;
        if( DefaultParams.empty() ) {
            pms = DefaultParams.map( params ) ;
        }
        if( href.indexOf( "?" ) != -1 ) {
            href += "&" + convertMapToGetParams( pms ) ;
        }
        else {
            href += "?" + convertMapToGetParams( pms ) ;
        }
    }
    // パラメータが存在せず、デフォルトパラメータのみが存在.
    else if( DefaultParams.empty() ) {
        var pms = DefaultParams.map() ;
        if( href.indexOf( "?" ) != -1 ) {
            href += "&" + convertMapToGetParams( pms ) ;
        }
        else {
            href += "?" + convertMapToGetParams( pms ) ;
        }
    }
    return href ;
}

// hiddenセット時のコンバート.
hiddenConvert = function( value ) {
    if( value instanceof java.util.Date ) {
        return "__$formatter@date@=" + value.getTime() ;
    }
    return parseValue( pkg("org.maachang.seabass.httpd.engine.script.js.JsDef").convertByViewHtml( false,convertString(value) ) ) ;
}

// イメージキャッシュ時間を取得.
imageCacheTime = function( mode ) {
    if( mode == false ) {
        return currentTime() ;
    }
    if( pkg( "org.maachang.seabass.httpd.HttpdMode" ).imageCache ) {
        return null ;
    }
    return currentTime() ;
}

// 基本ヘッダ定義.
baseHeaderTag = function( script,css ) {
    if( super.__$type$script == "script" ) {
        if( !useString( script ) ) {
            script = "text/javascript; charset=utf-8" ;
        }
        if( !useString( css ) ) {
            css = "text/css; charset=utf-8" ;
        }
        return createStrBuf().ad( "<meta http-equiv=\"content-style-type\" content=\"" ).ad( css ).ad( "\" " ).ad( endTag() ).ad( "\n" ).
            ad( "<meta http-equiv=\"content-script-type\" content=\"" ).ad( script ).ad( "\" " ).ad( endTag() ).ts() ;
    }
    return "" ;
}

// charset定義.
charsetTag = function(charset,mime) {
    if( super.__$type$script == "script" ) {
        if( useString( charset ) == false ) {
            charset = "utf-8" ;
        }
        charset = trim( charset ) ;
        if( useString( mime ) == false ) {
            if( isXhtml() ) {
                mime = "application/xhtml+xml" ;
            }
            else {
                mime = "text/html" ;
            }
        }
        if( endsWith( mime,";" ) == false ) {
            mime += ";" ;
        }
        return createStrBuf().ad( "<meta http-equiv=\"content-type\" content=\"" ).ad( mime ).
            ad( " charset=" ).ad( charset ).ad( "\"" ).ad( endTag() ).ts() ;
    }
    return "" ;
} ;

// favicon.ico表示設定用.
iconTag = function(path,cmode) {
    if( super.__$type$script == "script" ) {
        path = trim( path ) ;
        if( !useString( path ) ) {
            path = "/favicon.ico" ;
        }
        else {
            if( !path.startsWith( "/" ) ) {
                path = toFullUrl( path ) ;
            }
            if( path.length > 0 && !path.endsWith( ".ico" ) ) {
                if( endsWith( path,"/" ) ) {
                    path += "favicon.ico" ;
                }
            }
        }
        var tm = imageCacheTime( cmode ) ;
        if( isNull( tm ) ) {
            return createStrBuf().ad( "<link rel=\"shortcut icon\" type=\"image/x-icon\" href=\"" ).
                ad( path ).ad( "\"" ).ad( endTag() ).
                ad( "<link rel=\"icon\" type=\"image/x-icon\"" ).
                ad( endTag() ).ts() ;
        }
        else {
            return createStrBuf().ad( "<link rel=\"shortcut icon\" type=\"image/x-icon\" href=\"" ).
                ad( path ).ad( "" ).ad( "?" ).ad( tm ).ad( "\"" ).ad( endTag() ).
                ad( "<link rel=\"icon\" type=\"image/x-icon\"" ).
                ad( endTag() ).ts() ;
        }
    }
    return "" ;
} ;

// JavaScript読み込み用タグ.
scriptTag = function(name) {
    if( useString( name ) == true && super.__$type$script == "script" ) {
        name = trim( name ) ;
        var buf = createStrBuf().ad( name ) ;
        var x = toLowerCase( name ) ;
        if( endsWith( name,".js" ) == false ) {
            buf.ad( ".js" ) ;
        }
        if( isSessionLink() == false && getSessionId() != null ) {
            buf.ad( "?t=" ).ad( currentTime() ).ad( "&" ).
                ad( sessionParam() ).ad( "=" ).ad( getSessionId() ) ;
        }
        else {
            buf.ad( "?t=" ).ad( currentTime() ) ;
        }
        name = buf.ts() ;
        buf.clear() ;
        if( startsWith( x,"http://" ) || startsWith( x,"https://" ) ) {
            return buf.ad( "<script language=\"javascript\" type=\"text/javascript\" charset=\"utf-8\" src=\"" ).
                ad( name ).ad( "\"></script>" ).ts() ;
        }
        else {
            if( startsWith( name,"/" ) ) {
                name = name.substring( 1 ) ;
            }
            return buf.ad( "<script language=\"javascript\" type=\"text/javascript\" charset=\"utf-8\" src=\"/js/" ).
                ad( name ).ad( "\"></script>" ).ts() ;
        }
    }
    return "" ;
} ;

// 可変長スクリプトタグ.
serverScriptTag = function( name ) {
    if( useString( name ) == true && super.__$type$script == "script" ) {
        name = trim( name ) ;
        if( !name.startsWith( "/" ) ) {
            name = toFullUrl( name ) ;
        }
        var buf = createStrBuf().ad( name ) ;
        var x = toLowerCase( name ) ;
        if( endsWith( name,".js" ) == false && endsWith( name,".ijs" ) == false ) {
            buf.ad( ".js" ) ;
        }
        if( isSessionLink() == false && getSessionId() != null ) {
            buf.ad( "?t=" ).ad( currentTime() ).ad( "&" ).
                ad( sessionParam() ).ad( "=" ).ad( getSessionId() ) ;
        }
        else {
            buf.ad( "?t=" ).ad( currentTime() ) ;
        }
        name = buf.ts() ;
        buf.clear() ;
        return buf.ad( "<script language=\"javascript\" type=\"text/javascript\" charset=\"utf-8\" src=\"" ).
            ad( name ).ad( "\"></script>" ).ts() ;
    }
    return "" ;
}

// seabass.jsスクリプト読み込み用タグ.
seabassJS = function() {
    return "<script language=\"javascript\" type=\"text/javascript\" charset=\"utf-8\" src=\"/js/seabass-min.js\"></script>" ;
}

// CSS読み込み用タグ.
styleTag = function(name) {
    if( useString( name ) == true && super.__$type$script == "script" ) {
        name = trim( name ) ;
        var x = toLowerCase( name ) ;
        if( startsWith( x,"http://" ) || startsWith( x,"https://" ) ) {
            return createStrBuf().ad( "<link rel=\"stylesheet\" href=\"" ).ad( name ).ad( "?" ).
                ad( currentTime() ).ad( "\" type=\"text/css\"" ).ad( endTag() ).ts() ;
        }
        else {
            if( startsWith( name,"/" ) ) {
                name = name.substring( 1 ) ;
            }
            return createStrBuf().ad( "<link rel=\"stylesheet\" href=\"/css/" ).ad( name ).ad( "?t=" ).
                ad( currentTime() ).ad( "\" type=\"text/css\"" ).ad( endTag() ).ts() ;
        }
    }
    return "" ;
} ;

// 可変長CSSタグ.
serverCssTag = function(name) {
    if( useString( name ) == true && super.__$type$script == "script" ) {
        name = trim( name ) ;
        if( !name.startsWith( "/" ) ) {
            name = toFullUrl( name ) ;
        }
        return createStrBuf().ad( "<link rel=\"stylesheet\" href=\"" ).ad( name ).ad( "?t=" ).
            ad( currentTime() ).ad( "\" type=\"text/css\"" ).ad( endTag() ).ts() ;
    }
    return "" ;
} ;

// Javascript初期化タグ.
initScriptTag = function() {
    if( super.__$type$script == "script" ) {
        var buf = createStrBuf() ;
        buf.ad( "<script>\n" ) ;
        buf.ad( "var $scriptParams = {\n" ) ;
        if( isSession() ) {
            buf.ad( "    sessionId :" ).ad( "\'" ).ad( getSessionId() ).ad( "\'" ) ;
        }
        if( isRequestParam() ) {
            var it = super._$script$query.keySet().iterator() ;
            var flag = false ;
            while( it.hasNext() ) {
                var key = it.next() ;
                if( startsWith( key,"_" ) || key.indexOf( "." ) >= 0 ) {
                    continue ;
                }
                if( flag == true ) {
                    buf.ad( ",\n" ) ;
                }
                flag = false ;
                var val = super._$script$query.get( key ) ;
                if( val instanceof java.util.List ) {
                    buf.ad( "    " ).ad( key ).ad( " : [" ) ;
                    var lenJ = val.size() ;
                    for( var j = 0 ; j < lenJ ; j ++ ) {
                        if( j != 0 ) {
                            buf.ad( "," ) ;
                        }
                        buf.ad( "\'" ).ad( val.get( j ) ).ad( "\'" ) ;
                    }
                    buf.ad( "]" ) ;
                }
                else {
                    buf.ad( "    " ).ad( key ).ad( " : \'" ).ad( val ).ad( "\'" ) ;
                }
                flag = true ;
            }
        }
        return buf.ad( "\n} ;\n" ).ad( "</script>\n" ).ts() ;
    }
    return "" ;
} ;

// Webアプリケーション用処理を展開.
webAppTag = function() {
    // F5禁止及び、BackSpace禁止処理.
    var buf = new StrBuf() ;
    buf.ad( "<script><!--\n(function(){" ) ;
    //buf.ad( "history.forward();" ) ;
    buf.ad( "window.document.onkeydown=function(F){if(F==undefined||F==null){F=window.event;};var E=null;var G=-1;if(document.all||document.getElementById){G=(F.keyCode!=undefined&&F.keyCode!=null)?F.keyCode:F.charCode}else{if(document.layers){G=F.which}}switch(G){case 8:if(F.srcElement!=undefined&&F.srcElement!=null){E=F.srcElement}else{if(F.target!=undefined&&F.target!=null){E=F.target}}if(E!=undefined&&E!=null){var C=E.tagName.toLowerCase();var D=null;if(E.type!=undefined&&E.type!=null){D=E.type.toLowerCase()}if((C==\"input\"&&(D==\"text\"||D==\"password\"))||C==\"textarea\"){if(E.value.length>0){return true}if(F.preventDefault){F.preventDefault()}F.cancelBubble=true;F.returnValue=false;try{F.keyCode=0}catch(B){}return false}if((C==\"input\"||C==\"textarea\")&&(D!=null&&!(D==\"button\"||D==\"submit\"||D==\"reset\"||D==\"image\"))){return true}}if(F.preventDefault){F.preventDefault()}F.cancelBubble=true;F.returnValue=false;try{F.keyCode=0}catch(B){}return false;case 116:case 117:case 118:if(F.preventDefault){F.preventDefault()}F.cancelBubble=true;F.returnValue=false;try{F.keyCode=0}catch(B){}return false}return true};" ) ;
    // 緊急メッセージが存在する場合は、アラート表示.
    if( useString( params[ '$emergency_msg' ] ) ) {
        buf.ad( "var A=\"" ).
            ad( params[ '$emergency_msg' ] ).
            ad( "\";if(A!=\"\"){alert(A)};" ) ;
    }
    buf.ad( "})();\n--></script>" ) ;
    return buf.ts() ;
}

// ダミーフレーム.
dummyFrame = function( name ) {
    if( useString( name ) == true && super.__$type$script == "script" ) {
        var buf = createStrBuf() ;
        buf.ad( "<iframe id='" ).ad( name ).ad( "Id' name='" ).ad( name ).ad( "' " ) ;
        if( isBrowser() == "msie" ) {
            // IEの場合だけ、srcダミーを入れる.
            buf.ad( "src='/@js/ref?ref=&mime=text/html' " ) ;
        }
        return buf.ad( "width=0 height=0 border=0 " ).
            ad( "marginheight=0 marginwidth=0 frameborder=0 hspace=0></iframe>" ).ts() ;
    }
    return "" ;
} ;

// bodyタグ.
startBodyTag = function( text,link,vlink,alink,bgcolor,background,webAppKey,etc ) {
    if( super.__$type$script == "script" ) {
        var buf = createStrBuf() ;
        buf.ad( "<body" ) ;
        if( useString( text ) ) {
            buf.ad( " text='" ).ad( text ).ad( "'" ) ;
        }
        if( useString( link ) ) {
            buf.ad( " link='" ).ad( link ).ad( "'" ) ;
        }
        if( useString( vlink ) ) {
            buf.ad( " vlink='" ).ad( vlink ).ad( "'" ) ;
        }
        if( useString( alink ) ) {
            buf.ad( " alink='" ).ad( alink ).ad( "'" ) ;
        }
        if( useString( bgcolor ) ) {
            buf.ad( " bgcolor='" ).ad( bgcolor ).ad( "'" ) ;
        }
        if( useString( background ) ) {
            buf.ad( " background='" ).ad( background ).ad( "'" ) ;
        }
        etcTag( etc,buf ) ;
        buf.ad( " >" ) ;
        if( webAppKey == true || webAppKey == "true" ) {
            buf.ad( "\n" ).ad( webAppTag() ) ;
        }
        return buf.ts() ;
    }
    return "" ;
} ;

// body閉じタグ.
endBodyTag = function() {
    if( super.__$type$script == "script" ) {
        return "</body>" ;
    }
    return "" ;
}

// 通常のimage読み込み用タグ.
imageTag = function(name,alt,border,width,height,etc,cmode) {
    if( useString( name ) == true && super.__$type$script == "script" ) {
        var buf = createStrBuf() ;
        name = trim( name ) ;
        var tm = imageCacheTime( cmode ) ;
        if( name.startsWith( "http://" ) || name.startsWith( "https://" ) ||
            name.startsWith( "ftp://" ) || name.startsWith( "/" ) ) {
            if( isNull( tm ) ) {
                buf.ad( "<img src=\"" ).ad( name ).ad( "\"" ) ;
            }
            else {
                if( name.indexOf( "?" ) >= 0 ) {
                    buf.ad( "<img src=\"" ).ad( name ).ad( "&t=" ).ad( tm ).ad( "\"" ) ;
                }
                else {
                    buf.ad( "<img src=\"" ).ad( name ).ad( "?t=" ).ad( tm ).ad( "\"" ) ;
                }
            }
        }
        else {
            if( !startsWith( name,"/" ) ) {
                name = viewHref(name,"",false) ;
            }
            if( isNull( tm ) ) {
                buf.ad( "<img src=\"" ).ad( name ).ad( "\"" ) ;
            }
            else {
                if( name.indexOf( "?" ) >= 0 ) {
                    buf.ad( "<img src=\"" ).ad( name ).ad( "&t=" ).ad( tm ).ad( "\"" ) ;
                }
                else {
                    buf.ad( "<img src=\"" ).ad( name ).ad( "?t=" ).ad( tm ).ad( "\"" ) ;
                }
            }
        }
        if( useString( alt ) ) {
            buf.ad( " alt=\"" ).ad( alt ).ad( "\"" ) ;
        }
        if( useString( border ) ) {
            buf.ad( " border=\"" ).ad( border ).ad( "\"" ) ;
        }
        if( isNull( width ) == false ) {
            buf.ad( " width=\"" ).ad( width ).ad( "\"" ) ;
        }
        if( isNull( height ) == false ) {
            buf.ad( " height=\"" ).ad( height ).ad( "\"" ) ;
        }
        etcTag( etc,buf ) ;
        return buf.ad( endTag() ).ts() ;
    }
    return "" ;
} ;

// 画像サーバ側生成用img読み込みタグ.
serverImgTag = function(name,alt,border,width,height,etc,id,params) {
    if( super.__$type$script == "script" ) {
        if( useString( name ) == false ) {
            name = "/img/~seabass/clear.gif" ;
        }
        else {
            name = trim( name ) ;
            name = viewHref(name,params) ;
        }
        var buf = createStrBuf().ad( "<img src=\"" ).ad( name ).ad( "\"" ) ;
        if( useString( alt ) ) {
            buf.ad( " alt=\"" ).ad( alt ).ad( "\"" ) ;
        }
        if( useString( border ) ) {
            buf.ad( " border=\"" ).ad( border ).ad( "\"" ) ;
        }
        if( isNull( width ) == false ) {
            buf.ad( " width=\"" ).ad( width ).ad( "\"" ) ;
        }
        if( isNull( height ) == false ) {
            buf.ad( " height=\"" ).ad( height ).ad( "\"" ) ;
        }
        if( isNull( id ) == false ) {
            buf.ad( " id=\"_img_" ).ad( id ).ad( "Id\"" ) ;
        }
        etcTag( etc,buf ) ;
        return buf.ad( endTag() ).ts() ;
    }
    return "" ;
} ;

// DIVタグ[start].
startDiv = function( id,etc ) {
    if( useString( id ) && super.__$type$script == "script" ) {
        var buf = createStrBuf().ad( "<div id=\"" ).ad( id ).ad( "\" " ).ad( etcTag( etc ) ) ;
        return buf.ad( ">" ).ts() ;
    }
    return "" ;
} ;

// DIVタグ[end].
endDiv = function() {
    if( super.__$type$script == "script" ) {
        return "</div>" ;
    }
    return "" ;
}

// spanタグ[start].
startSpan = function( id,etc ) {
    if( useString( id ) && super.__$type$script == "script" ) {
        var buf = createStrBuf().ad( "<span id=\"" ).ad( id ).ad( "\" " ).ad( etcTag( etc ) ) ;
        return buf.ad( ">" ).ts() ;
    }
    return "" ;
} ;

// spanタグ[end].
endSpan = function() {
    if( super.__$type$script == "script" ) {
        return "</span>" ;
    }
    return "" ;
}

// カラー開始タグ.
colorTag = function( color,size,view ) {
    if( super.__$type$script == "script" ) {
        c = useString( color ) ;
        n = isNumeric( size ) ;
        if( ( c || n ) && useString( view ) ) {
            var buf = createStrBuf().ad( "<font" ) ;
            if( c ) {
                buf.ad( " color=\"" ).ad( color ).ad( "\"" ) ;
            }
            if( n ) {
                buf.ad( " size=\"" ).ad( size ).ad( "\"" ) ;
            }
            return buf.ad( ">" ).ad( $html(view) ).ad( "</font>" ).ts() ;
        }
    }
    return "" ;
} ;

// リンクタグ.
linkTag = function( href,view,etc,mode,params ) {
    if( useString( href ) && useString( view ) && super.__$type$script == "script" ) {
        if( !href.startsWith( "javascript:" ) ) {
            if( !href.startsWith( "http://" ) && !href.startsWith( "https://" ) &&
                !href.startsWith( "ftp://" ) && !href.startsWith( "/" ) ) {
                href = toFullUrl( href ) ;
            }
            href = viewHref(href,params) ;
        }
        var buf = createStrBuf() ;
        buf.ad( "<a href=\"" ).ad( href ).ad( "\" " ) ;
        etcTag( etc,buf ) ;
        if( isNull( mode ) == false && parseValue( mode ) == true ) {
            buf.ad( " target=\"_blank\" " ) ;
        }
        buf.ad( ">" ) ;
        buf.ad( view ) ;
        return buf.ad( "</a>" ).ts() ;
    }
    return "" ;
} ;

// Topリンクタグ.
topLinkTag = function( view,etc ) {
    if( !useString( view ) && super.__$type$script == "script" ) {
        var buf = createStrBuf() ;
        buf.ad( "<a href=\"#\" " ) ;
        Event.onclick( createStrBuf().ad( "javascript:window.scrollTo(0,0);return false;" ).ts() ) ;
        etcTag( etc,buf ) ;
        buf.ad( ">" ) ;
        buf.ad( view ) ;
        return buf.ad( "</a>" ).ts() ;
    }
    return "" ;
} ;

// 開始リンクタグ.
startLinkTag = function( href,etc,mode,params ) {
    if( useString( href ) && super.__$type$script == "script" ) {
        if( !href.startsWith( "javascript:" ) ) {
            if( !href.startsWith( "http://" ) && !href.startsWith( "https://" ) &&
                !href.startsWith( "ftp://" ) && !href.startsWith( "/" ) ) {
                href = toFullUrl( href ) ;
            }
            href = viewHref(href,params) ;
        }
        var buf = createStrBuf() ;
        buf.ad( "<a href=\"" ).ad( href ).ad( "\" " ) ;
        etcTag( etc,buf ) ;
        if( isNull( mode ) == false && parseValue( mode ) == true ) {
            buf.ad( " target=\"_blank\" " ) ;
        }
        buf.ad( ">" ) ;
        return buf.ts() ;
    }
    return "" ;
} ;

// 開始Topリンクタグ.
startTopLinkTag = function( etc ) {
    if( super.__$type$script == "script" ) {
        var buf = createStrBuf() ;
        buf.ad( "<a href=\"#\" " ) ;
        Event.onclick( createStrBuf().ad( "javascript:window.scrollTo(0,0);return false;" ).ts() ) ;
        etcTag( etc,buf ) ;
        buf.ad( ">" ) ;
        return buf.ts() ;
    }
    return "" ;
} ;

// 終了リンクタグ.
endLinkTag = function() {
    if( super.__$type$script == "script" ) {
        return "</a>" ;
    }
    return "" ;
}

// form開始タグ.
startForm = function( action,name,method,target,etc ) {
    if( useString( action ) && super.__$type$script == "script" ) {
        if( !useString( name ) ) {
            v = UnknownFormCache.get() ;
            UnknownFormCache.add() ;
            name = "uform_name_" + v ;
        }
        // inputタグ系の情報を初期化.
        InputNameList.exit() ;
        var buf = createStrBuf() ;
        if( useString( method ) == false ) {
            method = "POST" ;
        }
        buf.ad( "<form " + "method=\"" ).ad( method ).ad( "\" action=\"" ).ad( margePathName(action) ).ad( "\" " ) ;
        buf.ad( " name=\"" ).ad( name ).ad( "\" " ) ;
        if( useString( target ) ) {
            buf.ad( " target=\"" ).ad( target ).ad( "\" " ) ;
        }
        etcTag( etc,buf ) ;
        if( isSessionLink() == false && getSessionId() != null ) {
            buf.ad( " >\n" ).ad( "<input type=\"hidden\" name=\"" ).ad( sessionParam() ).
                ad( "\" value=\"" ).ad( getSessionId() ).ad( "\"" ).ad( endTag() ) ;
        }
        else {
            buf.ad( " >" ) ;
        }
        buf.ad( "<input type=\"hidden\" name=\"_submit_form_name\" value=\"" ).
            ad( name ).ad( "\"" ).ad( endTag() ) ;
        FormNameCache.set( name ) ;
        return buf.ts() ;
    }
    return "" ;
} ;

// MultiPartForm開始タグ.
multiForm = function( action,name,target,etc ) {
    if( useString( action ) && super.__$type$script == "script" ) {
        if( !useString( name ) ) {
            v = UnknownFormCache.get() ;
            UnknownFormCache.add() ;
            name = "uform_name_" + v ;
        }
        // inputタグ系の情報を初期化.
        InputNameList.exit() ;
        var buf = createStrBuf() ;
        buf.ad( "<form " + "method=\"POST\" action=\"" ).ad( margePathName(action) ).ad( "\" enctype=\"multipart/form-data\" " ) ;
        buf.ad( "name=\""+name+"\" " ) ;
        if( useString( target ) ) {
            buf.ad( "target=\"" ).ad( target ).ad( "\" " ) ;
        }
        etcTag( etc,buf ) ;
        if( isSessionLink() == false && getSessionId() != null ) {
            buf.ad( ">\n" ).ad( "<input type=\"hidden\" name=\"" ).ad( sessionParam() ).ad( "\" value=\"" ).ad( getSessionId() ).ad( "\">" ) ;
        }
        else {
            buf.ad( " >" ) ;
        }
        buf.ad( "<input type=\"hidden\" name=\"_submit_form_name\" value=\"" ).ad( name ).ad( "\">" ) ;
        FormNameCache.set( name ) ;
        return buf.ts() ;
    }
    return "" ;
} ;

// 終了タグ.
endForm = function(mode) {
    if( super.__$type$script == "script" ) {
        if( isNull( mode ) == false && mode == true ) {
            tagInputNames = InputNameList.getList() ;
            var buf = createStrBuf() ;
            var it = super._$script$query.keySet().iterator() ;
            while( it.hasNext() ) {
                var one = it.next() ;
                if( isNull( one ) || startsWith( one,"_" ) ||
                    startsWith( one,"$" ) ||
                    startsWith( one,"submitButton." ) ) {
                    continue ;
                }
                else if( tagInputNames.contains( one ) ) {
                    continue ;
                }
                buf.ad( hiddenTag( one ) ) ;
            }
            if( PageBackCache.flag() ) {
                buf.ad( PageBack.pushTag() ).buf.ad( "\n" ) ;
            }
            buf.ad( "</form>" ) ;
            InputNameList.exit() ;
            FormNameCache.exit() ;
            PageBackCache.exit() ;
            return buf.ts() ;
        }
        else {
            var buf = createStrBuf() ;
            if( PageBackCache.flag() ) {
                buf.ad( PageBack.pushTag() ).buf.ad( "\n" ) ;
            }
            buf.ad( "</form>" ) ;
            InputNameList.exit() ;
            FormNameCache.exit() ;
            PageBackCache.exit() ;
            return buf.ts() ;
        }
    }
    return "" ;
} ;

// 画像ボタン.
imgButton = function(name,src,alt,border,width,height,etc,cmode,id,clazz ) {
    if( useString( src ) == true && super.__$type$script == "script" ) {
        if( !useString( id ) ) {
            id = createId( true,name ) ;
        }
        src = trim( src ) ;
        var tm = imageCacheTime( cmode ) ;
        var buf = createStrBuf().ad( "<input type=\"image\" src=\"" ) ;
        if( src.startsWith( "http://" ) || src.startsWith( "https://" ) ||
            src.startsWith( "ftp://" ) || src.startsWith( "/" ) ) {
            if( isNull( tm ) ) {
                buf.ad( src ).ad( "\"" ) ;
            }
            else {
                buf.ad( src ).ad( "?t=" ).ad( tm ).ad( "\"" ) ;
            }
        }
        else {
            if( !startsWith( src,"/" ) ) {
                src = viewHref(src,"",false) ;
            }
            if( isNull( tm ) ) {
                buf.ad( src ).ad( "\"" ) ;
            }
            else {
                buf.ad( src ).ad( "?t=" ).ad( tm ).ad( "\"" ) ;
            }
        }
        if( useString( name ) ) {
            buf.ad( " name=\"" ).ad( name ).ad( "\"" ) ;
        }
        if( useString( id ) ) {
            buf.ad( " id=\"" ).ad( id ).ad( "\"" ) ;
        }
        if( useString( alt ) ) {
            buf.ad( " alt=\"" ).ad( alt ).ad( "\"" ) ;
        }
        if( useString( border ) ) {
            buf.ad( " border=\"" ).ad( border ).ad( "\"" ) ;
        }
        if( isNull( width ) == false ) {
            buf.ad( " width=\"" ).ad( width ).ad( "\"" ) ;
        }
        if( isNull( height ) == false ) {
            buf.ad( " height=\"" ).ad( height ).ad( "\"" ) ;
        }
        if( useString( id ) == true ) {
            buf.ad( "id=\"" ).ad( id ).ad( "\" " ) ;
        }
        if( useString( clazz ) == true ) {
            buf.ad( "class=\"" ).ad( clazz ).ad( "\" " ) ;
        }
        etcTag( etc,buf ) ;
        return buf.ad( endTag() ).ts() ;
    }
    return "" ;
} ;

// 画像リンクボタン.
imgLinkButton = function(name,src,href,alt,border,width,height,etc,cmode,params,id,clazz,mode,message ) {
    if( useString( src ) == true && super.__$type$script == "script" ) {
        if( !useString( id ) ) {
            id = createId( true,name ) ;
        }
        src = trim( src ) ;
        var tm = imageCacheTime( cmode ) ;
        var buf = createStrBuf().ad( "<input type=\"image\" src=\"" ) ;
        if( src.startsWith( "http://" ) || src.startsWith( "https://" ) ||
            src.startsWith( "ftp://" ) || src.startsWith( "/" ) ) {
            if( isNull( tm ) ) {
                buf.ad( src ).ad( "\"" ) ;
            }
            else {
                buf.ad( src ).ad( "?t=" ).ad( tm ).ad( "\"" ) ;
            }
        }
        else {
            if( !startsWith( src,"/" ) ) {
                src = viewHref(src,"",false) ;
            }
            if( isNull( tm ) ) {
                buf.ad( src ).ad( "\"" ) ;
            }
            else {
                buf.ad( src ).ad( "?t=" ).ad( tm ).ad( "\"" ) ;
            }
        }
        if( useString( name ) ) {
            buf.ad( " name=\"" ).ad( name ).ad( "\"" ) ;
        }
        if( useString( id ) ) {
            buf.ad( " id=\"" ).ad( id ).ad( "\"" ) ;
        }
        if( useString( alt ) ) {
            buf.ad( " alt=\"" ).ad( alt ).ad( "\"" ) ;
        }
        if( useString( border ) ) {
            buf.ad( " border=\"" ).ad( border ).ad( "\"" ) ;
        }
        if( isNull( width ) == false ) {
            buf.ad( " width=\"" ).ad( width ).ad( "\"" ) ;
        }
        if( isNull( height ) == false ) {
            buf.ad( " height=\"" ).ad( height ).ad( "\"" ) ;
        }
        if( useString( href ) ) {
            if( !href.startsWith( "http://" ) && !href.startsWith( "https://" ) &&
                !href.startsWith( "ftp://" ) && !href.startsWith( "/" ) ) {
                href = toFullUrl( href ) ;
            }
            if( mode == true || useString( mode ) ) {
                if( mode == true ) {
                    mode = "null" ;
                }
                else {
                    mode = "\""+mode+"\"" ;
                }
                if( useString( message ) ) {
                    Event.onclick( createStrBuf().ad( "if(confirm(\"").ad( message ).ad( "\")){createMaxWindow(\"" ).
                        ad( viewHref(href,params) ).ad( "\"," ).ad( mode ).ad( ");};return false;" ).ts() ) ;
                }
                else {
                    Event.onclick( createStrBuf().ad( "createMaxWindow(\"").
                        ad( viewHref(href,params) ).ad( "\"," ).ad( mode ).ad( ");return false;" ).ts() ) ;
                }
            }
            else {
                if( useString( message ) ) {
                    Event.onclick( createStrBuf().ad( "if(confirm(\"").ad( message ).ad( "\")){location.href=\"" ).
                        ad( viewHref(href,params) ).ad( "\";};return false;" ).ts() ) ;
                }
                else {
                    Event.onclick( createStrBuf().ad( "location.href=\"" ).
                        ad( viewHref(href,params) ).ad( "\";return false;" ).ts() ) ;
                }
            }
        }
        if( useString( id ) == true ) {
            buf.ad( "id=\"" ).ad( id ).ad( "\" " ) ;
        }
        if( useString( clazz ) == true ) {
            buf.ad( "class=\"" ).ad( clazz ).ad( "\" " ) ;
        }
        etcTag( etc,buf ) ;
        return buf.ad( endTag() ).ts() ;
    }
    return "" ;
} ;

// 画像Submitボタン.
imgSubmitButton = function(name,src,formName,alt,border,width,height,etc,cmode,id,clazz,message) {
    if( useString( src ) == true && super.__$type$script == "script" ) {
        if( !useString( id ) ) {
            id = createId( true,name ) ;
        }
        if( !useString( formName ) ) {
            formName = FormNameCache.get() ;
        }
        var tm = imageCacheTime( cmode ) ;
        src = trim( src ) ;
        var buf = createStrBuf().ad( "<input type=\"image\" src=\"" ) ;
        if( src.startsWith( "http://" ) || src.startsWith( "https://" ) ||
            src.startsWith( "ftp://" ) || src.startsWith( "/" ) ) {
            if( isNull( tm ) ) {
                buf.ad( src ).ad( "\"" ) ;
            }
            else {
                buf.ad( src ).ad( "?t=" ).ad( tm ).ad( "\"" ) ;
            }
        }
        else {
            if( !startsWith( src,"/" ) ) {
                src = viewHref(src,"",false) ;
            }
            if( isNull( tm ) ) {
                buf.ad( src ).ad( "\"" ) ;
            }
            else {
                buf.ad( src ).ad( "?t=" ).ad( tm ).ad( "\"" ) ;
            }
        }
        if( useString( name ) ) {
            buf.ad( " name=\"" ).ad( name ).ad( "\"" ) ;
        }
        if( useString( id ) ) {
            buf.ad( " id=\"" ).ad( id ).ad( "\"" ) ;
        }
        if( useString( alt ) ) {
            buf.ad( " alt=\"" ).ad( alt ).ad( "\"" ) ;
        }
        if( useString( border ) ) {
            buf.ad( " border=\"" ).ad( border ).ad( "\"" ) ;
        }
        if( isNull( width ) == false ) {
            buf.ad( " width=\"" ).ad( width ).ad( "\"" ) ;
        }
        if( isNull( height ) == false ) {
            buf.ad( " height=\"" ).ad( height ).ad( "\"" ) ;
        }
        if( useString( id ) == true ) {
            buf.ad( "id=\"" ).ad( id ).ad( "\" " ) ;
        }
        if( useString( clazz ) == true ) {
            buf.ad( "class=\"" ).ad( clazz ).ad( "\" " ) ;
        }
        if( useString( message ) ) {
            Event.onclick( createStrBuf().ad( "if(confirm(\"").ad( message ).ad( "\")){document." ).ad( formName ).
                ad( ".submit();return true;};return false;" ).ts() ) ;
        }
        else {
            Event.onclick( createStrBuf().ad( "document." ).ad( formName ).
                ad( ".submit();return true;" ).ts() ) ;
        }
        etcTag( etc,buf ) ;
        return buf.ad( endTag() ).ts() ;
    }
    return "" ;
} ;

// 画像リセットボタン.
imgResetButton = function(name,src,formName,alt,border,width,height,etc,cmode,id,clazz ) {
    if( useString( src ) == true && super.__$type$script == "script" ) {
        if( !useString( id ) ) {
            id = createId( true,name ) ;
        }
        if( !useString( formName ) ) {
            formName = FormNameCache.get() ;
        }
        var tm = imageCacheTime( cmode ) ;
        src = trim( src ) ;
        var x = toLowerCase( src ) ;
        var buf = createStrBuf().ad( "<input type=\"image\" src=\"" ) ;
        if( startsWith( x,"http://" ) || startsWith( x,"https://" ) ) {
            if( isNull( tm ) ) {
                buf.ad( src ).ad( "\"" ) ;
            }
            else {
                buf.ad( src ).ad( "?t=" ).ad( tm ).ad( "\"" ) ;
            }
        }
        else {
            if( !startsWith( src,"/" ) ) {
                src = viewHref(src,"",false) ;
            }
            if( isNull( tm ) ) {
                buf.ad( src ).ad( "\"" ) ;
            }
            else {
                buf.ad( src ).ad( "?t=" ).ad( tm ).ad( "\"" ) ;
            }
        }
        if( useString( name ) ) {
            buf.ad( " name=\"" ).ad( name ).ad( "\"" ) ;
        }
        if( useString( id ) ) {
            buf.ad( " id=\"" ).ad( id ).ad( "\"" ) ;
        }
        if( useString( alt ) ) {
            buf.ad( " alt=\"" ).ad( alt ).ad( "\"" ) ;
        }
        if( useString( border ) ) {
            buf.ad( " border=\"" ).ad( border ).ad( "\"" ) ;
        }
        if( isNull( width ) == false ) {
            buf.ad( " width=\"" ).ad( width ).ad( "\"" ) ;
        }
        if( isNull( height ) == false ) {
            buf.ad( " height=\"" ).ad( height ).ad( "\"" ) ;
        }
        if( useString( id ) == true ) {
            buf.ad( "id=\"" ).ad( id ).ad( "\" " ) ;
        }
        if( useString( clazz ) == true ) {
            buf.ad( "class=\"" ).ad( clazz ).ad( "\" " ) ;
        }
        if( useString( formName ) ) {
            Event.onclick( createStrBuf().ad( "document." ).
                ad( formName ).ad( ".reset();return false;" ).ts() ) ;
        }
        etcTag( etc,buf ) ;
        return buf.ad( endTag() ).ts() ;
    }
    return "" ;
} ;

// 画像Top
imgTopButton = function(name,src,alt,border,width,height,etc,cmode,id,clazz ) {
    if( useString( src ) == true && super.__$type$script == "script" ) {
        if( !useString( id ) ) {
            id = createId( true,name ) ;
        }
        var tm = imageCacheTime( cmode ) ;
        src = trim( src ) ;
        var x = toLowerCase( src ) ;
        var buf = createStrBuf().ad( "<input type=\"image\" src=\"" ) ;
        if( startsWith( x,"http://" ) || startsWith( x,"https://" ) ) {
            if( isNull( tm ) ) {
                buf.ad( src ).ad( "\"" ) ;
            }
            else {
                buf.ad( src ).ad( "?t=" ).ad( tm ).ad( "\"" ) ;
            }
        }
        else {
            if( !startsWith( src,"/" ) ) {
                src = viewHref(src,"",false) ;
            }
            if( isNull( tm ) ) {
                buf.ad( src ).ad( "\"" ) ;
            }
            else {
                buf.ad( src ).ad( "?t=" ).ad( tm ).ad( "\"" ) ;
            }
        }
        if( useString( name ) ) {
            buf.ad( " name=\"" ).ad( name ).ad( "\"" ) ;
        }
        if( useString( id ) ) {
            buf.ad( " id=\"" ).ad( id ).ad( "\"" ) ;
        }
        if( useString( alt ) ) {
            buf.ad( " alt=\"" ).ad( alt ).ad( "\"" ) ;
        }
        if( useString( border ) ) {
            buf.ad( " border=\"" ).ad( border ).ad( "\"" ) ;
        }
        if( isNull( width ) == false ) {
            buf.ad( " width=\"" ).ad( width ).ad( "\"" ) ;
        }
        if( isNull( height ) == false ) {
            buf.ad( " height=\"" ).ad( height ).ad( "\"" ) ;
        }
        if( useString( id ) == true ) {
            buf.ad( "id=\"" ).ad( id ).ad( "\" " ) ;
        }
        if( useString( clazz ) == true ) {
            buf.ad( "class=\"" ).ad( clazz ).ad( "\" " ) ;
        }
        Event.onclick( createStrBuf().ad( "window.scrollTo(0,0);return false;" ).ts() ) ;
        etcTag( etc,buf ) ;
        return buf.ad( endTag() ).ts() ;
    }
    return "" ;
} ;

// ボタン.
button = function( value,etc,name,id,clazz,disabled ) {
    if( super.__$type$script == "script" ) {
        if( !useString( clazz ) ) {
            clazz = "button" ;
        }
        if( !useString( id ) ) {
            id = createId( true,name ) ;
        }
        var buf = createStrBuf() ;
        if( useString( name ) == false ) {
            buf.ad( "<input type=\"button\" class=\"" ).ad( clazz ).ad( "\" " ) ;
        }
        else {
            buf.ad( "<input type=\"button\" class=\"" ).ad( clazz ).ad( "\" name=\"" ).
                ad( name ).ad( "\" " ) ;
        }
        if( useString( value ) == true ) {
            buf.ad( "value=\"" ).ad( value ).ad( "\" " ) ;
        }
        if( useString( id ) == true ) {
            buf.ad( "id=\"" ).ad( id ).ad( "\" " ) ;
        }
        if( disabled == true || disabled == "true" ) {
            buf.ad( " disabled " ) ;
        }
        etcTag( etc,buf ) ;
        return buf.ad( endTag() ).ts() ;
    }
    return "" ;
} ;

// リンクボタン.
linkButton = function( value,href,etc,name,params,id,clazz,disabled,mode,message ) {
    if( super.__$type$script == "script" ) {
        if( !useString( clazz ) ) {
            clazz = "button" ;
        }
        var buf = createStrBuf() ;
        if( useString( name ) == false ) {
            buf.ad( "<input type=\"button\" class=\"" ).ad( clazz ).ad( "\" " ) ;
        }
        else {
            buf.ad( "<input type=\"button\" class=\"" ).ad( clazz ).ad( "\" name=\"" ).
                ad( name ).ad( "\" id=\"" ).ad( name ).ad( "Id\" " ) ;
        }
        if( useString( value ) == true ) {
            buf.ad( "value=\"" ).ad( value ).ad( "\" " ) ;
        }
        if( useString( href ) ) {
            if( !href.startsWith( "http://" ) && !href.startsWith( "https://" ) &&
                !href.startsWith( "ftp://" ) && !href.startsWith( "/" ) ) {
                href = toFullUrl( href ) ;
            }
            if( mode == true || useString( mode ) ) {
                if( mode == true ) {
                    mode = "null" ;
                }
                else {
                    mode = "\""+mode+"\"" ;
                }
                if( useString( message ) ) {
                    Event.onclick( createStrBuf().ad( "if(confirm(\"").ad( message ).ad( "\")){" ).
                        ad( "createMaxWindow(\"").ad( viewHref(href,params) ).ad( "\"," ).ad( mode ).ad( ");};return false;" ).ts() ) ;
                }
                else {
                    Event.onclick( createStrBuf().ad( "createMaxWindow(\"").
                        ad( viewHref(href,params) ).ad( "\"," ).ad( mode ).ad( ");return false;" ).ts() ) ;

                }
            }
            else {
                if( useString( message ) ) {
                    Event.onclick( createStrBuf().ad( "if(confirm(\"").ad( message ).ad( "\")){location.href=\"" ).
                        ad( viewHref(href,params) ).ad( "\";};return false;" ).ts() ) ;
                }
                else {
                    Event.onclick( createStrBuf().ad( "location.href=\"" ).
                        ad( viewHref(href,params) ).ad( "\";return false;" ).ts() ) ;
                }
            }
        }
        if( useString( id ) == true ) {
            buf.ad( "id=\"" ).ad( id ).ad( "\" " ) ;
        }
        if( disabled == true || disabled == "true" ) {
            buf.ad( " disabled " ) ;
        }
        etcTag( etc,buf ) ;
        return buf.ad( endTag() ).ts() ;
    }
    return "" ;
} ;

// submitボタン.
submitButton = function( value,name,id,clazz,formName,disabled,message ) {
    if( super.__$type$script == "script" ) {
        if( !useString( clazz ) ) {
            clazz = "button" ;
        }
        if( !useString( id ) ) {
            id = createId( true,name ) ;
        }
        var buf = createStrBuf() ;
        if( useString( name ) == false ) {
            buf.ad( "<input type=\"button\" class=\"" ).ad( clazz ).ad( "\" " ) ;
        }
        else {
            buf.ad( "<input type=\"button\" class=\"" ).ad( clazz ).ad( "\" name=\"" ).
                ad( name ).ad( "\" id=\"" ).ad( id ).ad( "\" " ) ;
        }
        if( useString( value ) == true ) {
            buf.ad( "value=\"" ).ad( value ).ad( "\" " ) ;
        }
        if( useString( id ) == true ) {
            buf.ad( "id=\"" ).ad( id ).ad( "\" " ) ;
        }
        if( disabled == true || disabled == "true" ) {
            buf.ad( " disabled " ) ;
        }
        if( !useString( formName ) ) {
            formName = FormNameCache.get() ;
        }
        if( useString( message ) ) {
            Event.onclick( createStrBuf().ad( "if(confirm(\"").ad( message ).ad( "\")){document." ).ad( formName ).
                ad( ".submit();return true;};return false;" ).ts() ) ;
        }
        else {
            Event.onclick( createStrBuf().ad( "document." ).ad( formName ).
                ad( ".submit();return true;" ).ts() ) ;
        }
        return buf.ad( endTag() ).ts() ;
    }
    return "" ;
} ;

// resetボタン.
resetButton = function( value,name,id,clazz,disabled ) {
    if( super.__$type$script == "script" ) {
        if( !useString( clazz ) ) {
            clazz = "button" ;
        }
        if( !useString( id ) ) {
            id = createId( true,name ) ;
        }
        var buf = createStrBuf() ;
        if( useString( name ) == false ) {
            buf.ad( "<input type=\"reset\" class=\"" ).ad( clazz ).ad( "\" " ) ;
        }
        else {
            buf.ad( "<input type=\"reset\" class=\"" ).ad( clazz ).ad( "\" name=\"" ).
                ad( name ).ad( "\" id=\"" ).ad( id ).ad( "\" " ) ;
        }
        if( useString( value ) == true ) {
            buf.ad( "value=\"" ).ad( value ).ad( "\" " ) ;
        }
        if( useString( id ) == true ) {
            buf.ad( "id=\"" ).ad( id ).ad( "\" " ) ;
        }
        if( disabled == true || disabled == "true" ) {
            buf.ad( " disabled " ) ;
        }
        return buf.ad( endTag() ).ts() ;
    }
    return "" ;
} ;

// Topボタン.
topButton = function( value,etc,name,id,clazz,disabled ) {
    if( super.__$type$script == "script" ) {
        if( !useString( clazz ) ) {
            clazz = "button" ;
        }
        var buf = createStrBuf() ;
        if( useString( name ) == false ) {
            buf.ad( "<input type=\"button\" class=\"" ).ad( clazz ).ad( "\" " ) ;
        }
        else {
            buf.ad( "<input type=\"button\" class=\"" ).ad( clazz ).ad( "\" name=\"" ).
                ad( name ).ad( "\" id=\"" ).ad( name ).ad( "Id\" " ) ;
        }
        if( useString( value ) == true ) {
            buf.ad( "value=\"" ).ad( value ).ad( "\" " ) ;
        }
        if( useString( id ) == true ) {
            buf.ad( "id=\"" ).ad( id ).ad( "\" " ) ;
        }
        if( disabled == true || disabled == "true" ) {
            buf.ad( " disabled " ) ;
        }
        Event.onclick( createStrBuf().ad( "window.scrollTo(0,0);return false;" ).ts() ) ;
        etcTag( etc,buf ) ;
        return buf.ad( endTag() ).ts() ;
    }
    return "" ;
} ;


// Hiddenタグ.
hiddenTag = function(name,value,id,etc) {
    if( useString( name ) == true && super.__$type$script == "script" ) {
        var buf = createStrBuf() ;
        buf.ad( "<input type=\"hidden\" name=\"" ).ad( name ).ad( "\" " ) ;
        etcTag( etc,buf ) ;
        if( useString( value ) == true ) {
            if( useString( id ) == false ) {
                id = createId( true,name ) ;
            }
            if( useString( id ) ) {
                buf.ad( "id=\"" ).ad( id ).ad( "\" " ) ;
            }
            buf.ad( "value=\"" ).ad( hiddenConvert( value ) ).ad( "\"" ).ad( endTag() ).ad( "\n" ) ;
        }
        else {
            var addFlag = false ;
            var val = super._$script$query.get( name ) ;
            if( isNull( val ) == false ) {
                if( ( val instanceof java.util.List ) == false ) {
                    if( useString( id ) == false ) {
                        id = createId( true,name ) ;
                    }
                    if( useString( id ) ) {
                        buf.ad( "id=\"" ).ad( id ).ad( "\" " ) ;
                    }
                    buf.ad( "value=\"" ).ad( hiddenConvert( val ) ).ad( "\"" ).ad( endTag() ).ad( "\n" ) ;
                    addFlag = true ;
                }
                else {
                    var tmp = buf.ts() ;
                    buf.clear() ;
                    var len = val.size() ;
                    for( var i = 0 ; i < len ; i ++ ) {
                        var pid = null ;
                        if( useString( id ) == false ) {
                            pid = createId( true,name ) ;
                        }
                        else {
                            pid = id + "_" + i ;
                        }
                        buf.ad( tmp ) ;
                        if( useString( pid ) ) {
                            buf.ad( "id=\"" ).ad( pid ).ad( "\" " ) ;
                        }
                        buf.ad( "value=\"" ).ad( hiddenConvert( val.get( i ) ) ).ad( "\"" ).ad( endTag() ).ad( "\n" ) ;
                        addFlag = true ;
                    }
                }
            }
            if( addFlag == false ) {
                buf.ad( endTag() ).ad( "\n" ) ;
            }
        }
        InputNameList.add( name ) ;
        return buf.ts() ;
    }
    return "" ;
} ;

// テキスト入力モード.
TextMode = {
    NUMBER : 0,   // 数値のみ.
    ALPHA : 1,    // 英数.
    HIRA : 2,     // 平仮名.
    KATA : 3      // カタカナ.
}

// タブレットモード強制OFF設定.
setTabletOffMode = function( mode ) {
    mode = ( mode == true || mode == "true" ) ? true : false ;
    context.put( "_$tablet$off$mode",mode ) ;
}

// タブレットモード強制OFF条件を取得.
isTabletOffMode = function() {
    var ret = context.get( "_$tablet$off$mode" ) ;
    return ( ret == true || ret == "true" ) ? true : false ;
}

// テキストエリアタグ.
textAreaTag = function(name,id,clazz,cols,rows,style,defaultIme,etc,readOnly) {
    if( useString( name ) == true && super.__$type$script == "script" ) {
        if( !useString( clazz ) ) {
            clazz = "textarea" ;
        }
        if( useString( id ) == false ) {
            id = createId( true,name ) ;
        }
        var buf = createStrBuf().ad( "<textarea name=\"" ).ad( name ).ad( "\" " ) ;
        if( useString( id ) ) {
            buf.ad( "id=\"" ).ad( id ).ad( "\" " ) ;
        }
        if( useString( clazz ) ) {
            buf.ad( "class=\"" ).ad( clazz ).ad( "\" " ) ;
        }
        if( isNumeric( cols ) ) {
            buf.ad( "cols=\"" ).ad( cols ).ad( "\" " ) ;
        }
        if( isNumeric( rows ) ) {
            buf.ad( "rows=\"" ).ad( rows ).ad( "\" " ) ;
        }
        if( readOnly == true || readOnly == "true" ) {
            readOnly = true ;
        }
        else {
            readOnly = false ;
        }
        toInputColor( id ) ;
        // タブレットモードの場合は、アルファベットpopupWindowを表示.
        if( !isTabletOffMode() && getCookie( "seabass_tablet_mode" ) == "true" && !readOnly ) {
            readOnly = true ; // タブレットモードの場合は、入力枠はreadonly.
            switch( defaultIme ) {
                case TextMode.HIRA :   // 平仮名.
                    Event.onclick( "TouchPanel.hiraKana.window( \"" + id + "\",4096 )" ) ;
                    break ;
                case TextMode.KATA :   // カタカナ.
                    Event.onclick( "TouchPanel.kataKana.window( \"" + id + "\",4096 )" ) ;
                    break ;
                default :              // 英数.
                    Event.onclick( "TouchPanel.alpha.window( \"" + id + "\",4096 )" ) ;
                    break ;
            }
        }
        if( useString( style ) ) {
            style = trim( style ) ;
            if( style.endsWith( ";" ) ) {
                style = trim( style.substring( 0,style.length-1 ) ) ;
            }
            switch( defaultIme ) {
                case TextMode.NUMBER :
                    style = style + " ; ime-mode:disabled ;" ;
                    break ;
                case TextMode.ALPHA :
                    style = style + " ; ime-mode:inactive ;" ;
                    break ;
                case TextMode.HIRA :
                case TextMode.KATA :
                    style = style + " ; ime-mode:active ;" ;
                    break ;
            }
        }
        else {
            switch( defaultIme ) {
                case TextMode.NUMBER :
                    style = "ime-mode:disabled ;" ;
                    break ;
                case TextMode.ALPHA :
                    style = "ime-mode:inactive ;" ;
                    break ;
                case TextMode.HIRA :
                case TextMode.KATA :
                    style = "ime-mode:active ;" ;
                    break ;
            }
        }
        if( useString( style ) ) {
            buf.ad( " style=\"" ).ad( style ).ad( "\" " ) ;
        }
        etcTag( etc,buf ) ;
        if( readOnly == true ) {
            buf.ad( " readonly " ) ;
        }
        buf.ad( ">" ) ;
        var bef = getRequestParam( name,getIdNum( name ) ) ;
        if( useString( bef ) ) {
            buf.ad( $html( bef,false ) ) ;
        }
        InputNameList.add( name ) ;
        return buf.ad( "</textarea>" ).ts() ;
    }
    return "" ;
} ;

// テキストエリアタグ(英数入力).
textAreaAlphaTag = function(name,id,clazz,cols,rows,style,etc,readOnly) {
    return textAreaTag( name,id,clazz,cols,rows,style,TextMode.ALPHA,etc,readOnly ) ;
}

// テキストエリアタグ(平仮名入力).
textAreaHiraTag = function(name,id,clazz,cols,rows,style,etc,readOnly) {
    return textAreaTag( name,id,clazz,cols,rows,style,TextMode.HIRA,etc,readOnly ) ;
}

// テキストエリアタグ(カタカナ入力).
textAreaKataTag = function(name,id,clazz,cols,rows,style,etc,readOnly) {
    return textAreaTag( name,id,clazz,cols,rows,style,TextMode.KATA,etc,readOnly ) ;
}

// テキストタグ.
textTag = function(name,id,clazz,size,max,style,defaultIme,etc,readOnly ) {
    if( useString( name ) == true && super.__$type$script == "script" ) {
        if( !useString( clazz ) ) {
            clazz = "text" ;
        }
        if( useString( id ) == false ) {
            id = createId( true,name ) ;
        }
        var buf = createStrBuf().ad( "<input type=\"text\" name=\"" ).ad( name ).ad( "\" " ) ;
        if( useString( id ) ) {
            buf.ad( "id=\"" ).ad( id ).ad( "\" " ) ;
        }
        if( useString( clazz ) ) {
            buf.ad( "class=\"" ).ad( clazz ).ad( "\" " ) ;
        }
        if( isNumeric( size ) ) {
            buf.ad( "size=\"" ).ad( size ).ad( "\" " ) ;
        }
        if( isNumeric( max ) ) {
            buf.ad( "maxlength=\"" ).ad( max ).ad( "\" " ) ;
        }
        var bef = getRequestParam( name,getIdNum( name ) ) ;
        if( useString( bef ) ) {
            buf.ad( "value=\"" ).ad( bef ).ad( "\" " ) ;
        }
        if( readOnly == true || readOnly == "true" ) {
            readOnly = true ;
        }
        else {
            readOnly = false ;
        }
        toInputColor( id ) ;
        // タブレットモードの場合は、アルファベットpopupWindowを表示.
        if( !isTabletOffMode() && getCookie( "seabass_tablet_mode" ) == "true" && !readOnly ) {
            readOnly = true ; // タブレットモードの場合は、入力枠はreadonly.
            switch( defaultIme ) {
                case TextMode.NUMBER :   // 数値.
                    if( isNumeric( max ) ) {
                        Event.onclick( "TouchPanel.number.window( \"" + id + "\","+max+" )" ) ;
                    }
                    else {
                        Event.onclick( "TouchPanel.number.window( \"" + id + "\",4096 )" ) ;
                    }
                    break ;
                case TextMode.HIRA :   // 平仮名.
                    if( isNumeric( max ) ) {
                        Event.onclick( "TouchPanel.hiraKana.window( \"" + id + "\","+max+" )" ) ;
                    }
                    else {
                        Event.onclick( "TouchPanel.hiraKana.window( \"" + id + "\",4096 )" ) ;
                    }
                    break ;
                case TextMode.KATA :   // カタカナ.
                    if( isNumeric( max ) ) {
                        Event.onclick( "TouchPanel.kataKana.window( \"" + id + "\","+max+" )" ) ;
                    }
                    else {
                        Event.onclick( "TouchPanel.kataKana.window( \"" + id + "\",4096 )" ) ;
                    }
                    break ;
                default :              // 英数.
                    if( isNumeric( max ) ) {
                        Event.onclick( "TouchPanel.alpha.window( \"" + id + "\","+max+" )" ) ;
                    }
                    else {
                        Event.onclick( "TouchPanel.alpha.window( \"" + id + "\",4096 )" ) ;
                    }
                    break ;
            }
        }
        if( useString( style ) ) {
            style = trim( style ) ;
            if( style.endsWith( ";" ) ) {
                style = trim( style.substring( 0,style.length-1 ) ) ;
            }
            switch( defaultIme ) {
                case TextMode.NUMBER :
                    style = style + " ; ime-mode:disabled ;" ;
                    break ;
                case TextMode.ALPHA :
                    style = style + " ; ime-mode:inactive ;" ;
                    break ;
                case TextMode.HIRA :
                case TextMode.KATA :
                    style = style + " ; ime-mode:active ;" ;
                    break ;
            }
        }
        else {
            switch( defaultIme ) {
                case TextMode.NUMBER :
                    style = "ime-mode:disabled ;" ;
                    break ;
                case TextMode.ALPHA :
                    style = "ime-mode:inactive ;" ;
                    break ;
                case TextMode.HIRA :
                case TextMode.KATA :
                    style = "ime-mode:active ;" ;
                    break ;
            }
        }
        if( useString( style ) ) {
            buf.ad( " style=\"" ).ad( style ).ad( "\" " ) ;
        }
        etcTag( etc,buf ) ;
        InputNameList.add( name ) ;
        if( readOnly == true ) {
            buf.ad( " readonly " ) ;
        }
        return buf.ad( endTag() ).ts() ;
    }
    return "" ;
} ;

// テキストタグ(数値).
textNumTag = function(name,id,clazz,size,max,style,etc,readOnly) {
    return textTag( name,id,clazz,size,max,style,TextMode.NUMBER,etc,readOnly ) ;
}

// テキストタグ(英数).
textAlphaTag = function(name,id,clazz,size,max,style,etc,readOnly) {
    return textTag( name,id,clazz,size,max,style,TextMode.ALPHA,etc,readOnly ) ;
}

// テキストタグ(平仮名).
textHiraTag = function(name,id,clazz,size,max,style,etc,readOnly) {
    return textTag( name,id,clazz,size,max,style,TextMode.HIRA,etc,readOnly ) ;
}

// テキストタグ(カタカナ).
textKataTag = function(name,id,clazz,size,max,style,etc,readOnly) {
    return textTag( name,id,clazz,size,max,style,TextMode.KATA,etc,readOnly ) ;
}

// パスワードタグ.
passwordTag = function(name,id,clazz,size,max,style,defaultIme,etc) {
    if( useString( name ) == true && super.__$type$script == "script" ) {
        if( !useString( clazz ) ) {
            clazz = "text" ;
        }
        if( useString( id ) == false ) {
            id = createId( true,name ) ;
        }
        var buf = createStrBuf().ad( "<input type=\"password\" name=\"" ).ad( name ).ad( "\" " ) ;
        if( useString( id ) ) {
            buf.ad( "id=\"" ).ad( id ).ad( "\" " ) ;
        }
        if( useString( clazz ) ) {
            buf.ad( "class=\"" ).ad( clazz ).ad( "\" " ) ;
        }
        if( isNumeric( size ) ) {
            buf.ad( "size=\"" ).ad( size ).ad( "\" " ) ;
        }
        if( isNumeric( max ) ) {
            buf.ad( "maxlength=\"" ).ad( max ).ad( "\" " ) ;
        }
        //var bef = getRequestParam( name,getIdNum( name ) ) ;
        //if( useString( bef ) ) {
        //    buf.ad( "value=\"" ).ad( bef ).ad( "\" " ) ;
        //}
        toInputColor( id ) ;
        var readOnly = false ;
        // タブレットモードの場合は、アルファベットpopupWindowを表示.
        if( !isTabletOffMode() && getCookie( "seabass_tablet_mode" ) == "true" ) {
            readOnly = true ; // タブレットモードの場合は、入力枠はreadonly.
            switch( defaultIme ) {
                case TextMode.NUMBER :   // 数値.
                    if( isNumeric( max ) ) {
                        Event.onclick( "TouchPanel.number.window( \"" + id + "\","+max+" )" ) ;
                    }
                    else {
                        Event.onclick( "TouchPanel.number.window( \"" + id + "\",4096 )" ) ;
                    }
                    break ;
                case TextMode.HIRA :   // 平仮名.
                    if( isNumeric( max ) ) {
                        Event.onclick( "TouchPanel.hiraKana.window( \"" + id + "\","+max+" )" ) ;
                    }
                    else {
                        Event.onclick( "TouchPanel.hiraKana.window( \"" + id + "\",4096 )" ) ;
                    }
                    break ;
                case TextMode.KATA :   // カタカナ.
                    if( isNumeric( max ) ) {
                        Event.onclick( "TouchPanel.kataKana.window( \"" + id + "\","+max+" )" ) ;
                    }
                    else {
                        Event.onclick( "TouchPanel.kataKana.window( \"" + id + "\",4096 )" ) ;
                    }
                    break ;
                default :              // 英数.
                    if( isNumeric( max ) ) {
                        Event.onclick( "TouchPanel.alpha.window( \"" + id + "\","+max+" )" ) ;
                    }
                    else {
                        Event.onclick( "TouchPanel.alpha.window( \"" + id + "\",4096 )" ) ;
                    }
                    break ;
            }
        }
        if( useString( style ) ) {
            style = trim( style ) ;
            if( style.endsWith( ";" ) ) {
                style = trim( style.substring( 0,style.length-1 ) ) ;
            }
            switch( defaultIme ) {
                case TextMode.NUMBER :
                    style = style + " ; ime-mode:disabled ;" ;
                    break ;
                case TextMode.ALPHA :
                    style = style + " ; ime-mode:inactive ;" ;
                    break ;
                case TextMode.HIRA :
                case TextMode.KATA :
                    style = style + " ; ime-mode:active ;" ;
                    break ;
            }
        }
        else {
            switch( defaultIme ) {
                case TextMode.NUMBER :
                    style = "ime-mode:disabled ;" ;
                    break ;
                case TextMode.ALPHA :
                    style = "ime-mode:inactive ;" ;
                    break ;
                case TextMode.HIRA :
                case TextMode.KATA :
                    style = "ime-mode:active ;" ;
                    break ;
            }
        }
        if( useString( style ) ) {
            buf.ad( " style=\"" ).ad( style ).ad( "\" " ) ;
        }
        etcTag( etc,buf ) ;
        if( readOnly == true ) {
            buf.ad( " readonly " ) ;
        }
        InputNameList.add( name ) ;
        return buf.ad( endTag() ).ts() ;
    }
    return "" ;
} ;

// パスワードタグ(数値).
passwordNumTag = function(name,id,clazz,size,max,style,defaultIme,etc) {
    return passwordTag(name,id,clazz,size,max,style,TextMode.NUMBER,etc) ;
}

// パスワードタグ(英数).
passwordAlphaTag = function(name,id,clazz,size,max,style,defaultIme,etc) {
    return passwordTag(name,id,clazz,size,max,style,TextMode.ALPHA,etc) ;
}

// パスワードタグ(平仮名).
passwordHiraTag = function(name,id,clazz,size,max,style,defaultIme,etc) {
    return passwordTag(name,id,clazz,size,max,style,TextMode.HIRA,etc) ;
}

// パスワードタグ(カタカナ).
passwordKataTag = function(name,id,clazz,size,max,style,defaultIme,etc) {
    return passwordTag(name,id,clazz,size,max,style,TextMode.KATA,etc) ;
}

// ファイルタグ.
fileTag = function(name,id,clazz,size,max,etc) {
    if( useString( name ) == true && super.__$type$script == "script" ) {
        if( !useString( clazz ) ) {
            clazz = "text" ;
        }
        if( useString( id ) == false ) {
            id = createId( true,name ) ;
        }
        var buf = createStrBuf().ad( "<input type=\"file\" name=\"" ).ad( name ).ad( "\" " ) ;
        if( useString( id ) ) {
            buf.ad( "id=\"" ).ad( id ).ad( "\" " ) ;
        }
        if( useString( clazz ) ) {
            buf.ad( "class=\"" ).ad( clazz ).ad( "\" " ) ;
        }
        if( isNumeric( size ) ) {
            buf.ad( "size=\"" ).ad( size ).ad( "\" " ) ;
        }
        if( isNumeric( max ) ) {
            buf.ad( "maxlength=\"" ).ad( max ).ad( "\" " ) ;
        }
        toInputColor( id ) ;
        etcTag( etc,buf ) ;
        InputNameList.add( name ) ;
        return buf.ad( endTag() ).ts() ;
    }
    return "" ;
} ;

// チェックボックスタグ.
checkBoxTag = function(name,value,id,clazz,etc,checkd ) {
    if( useString( name ) == true && useString( value ) == true && super.__$type$script == "script" ) {
        if( !useString( clazz ) ) {
            clazz = "checkbox" ;
        }
        if( useString( id ) == false ) {
            id = createId( true,name ) ;
        }
        var buf = createStrBuf().ad( "<input type=\"checkbox\" name=\"" ).ad( name ).
            ad( "\" value=\"" ).ad( value ).ad( "\" " ) ;
        if( useString( id ) ) {
            buf.ad( "id=\"" ).ad( id ).ad( "\" " ) ;
        }
        if( useString( clazz ) ) {
            buf.ad( "class=\"" ).ad( clazz ).ad( "\" " ) ;
        }
        if( checkd == true || checkd == "true" ) {
            buf.ad( "checked " ) ;
        }
        else {
            if( isNull( super._$script$query.get(name) ) == false ) {
                var lst = super._$script$query.get(name) ;
                if( ( lst instanceof java.util.List ) == false ) {
                    lst = parseValue( lst ) ;
                    if( lst == value ) {
                        buf.ad( "checked " ) ;
                    }
                }
                else {
                    var len = lst.size() ;
                    for( var i = 0 ; i < len ; i ++ ) {
                        var s = parseValue( lst.get( i ) ) ;
                        if( isNull( s ) == false && useString( s ) == true && s == value ) {
                            buf.ad( "checked " ) ;
                            break ;
                        }
                    }
                }
            }
        }
        toInputColor( id ) ;
        etcTag( etc,buf ) ;
        InputNameList.add( name ) ;
        return buf.ad( endTag() ).ts() ;
    }
    return "" ;
} ;

// 複数チェックボックスタグ.
gCheckBoxTag = function( name,values,parse,line,clazz,etc ) {
    if( useString( name ) == true &&
        typeof( values ) == "array" && values.length > 0 &&
        super.__$type$script == "script" ) {
        if( !useString( parse ) ) {
            parse = "&nbsp;" ;
        }
        if( !isNumeric( line ) || line <= 0 ) {
            line = 0 ;
        }
        var buf = createStrBuf() ;
        var len = values.length ;
        for( var i = 0,j = 0 ; i < len ; i += 2,j ++ ) {
            if( line != 0 && j >= line ) {
                buf.ad( "<br" ).ad( endTag() ) ;
                j = 0 ;
            }
            else if( i != 0 ) {
                buf.ad( parse ) ;
            }
            buf.ad( checkBoxTag( name,values[ i ],null,clazz,etc ) ).ad( values[ i+1 ] ) ;
        }
        return buf.ts() ;
    }
}

// ラジオボタンタグ.
radioTag = function(name,value,id,clazz,etc,checkd ) {
    if( useString( name ) == true && useString( value ) == true && super.__$type$script == "script" ) {
        if( !useString( clazz ) ) {
            clazz = "radioTag" ;
        }
        if( useString( id ) == false ) {
            id = createId( true,name ) ;
        }
        var buf = createStrBuf().ad( "<input type=\"radio\" name=\"" ).ad( name ).
            ad( "\" value=\"" ).ad( value ).ad( "\" " ) ;
        if( useString( id ) ) {
            buf.ad( "id=\"" ).ad( id ).ad( "\" " ) ;
        }
        if( useString( clazz ) ) {
            buf.ad( "class=\"" ).ad( clazz ).ad( "\" " ) ;
        }
        if( checkd == true || checkd == "true" ) {
            buf.ad( "checked " ) ;
        }
        else {
            if( isNull( super._$script$query.get(name) ) == false ) {
                var lst = super._$script$query.get(name) ;
                if( ( lst instanceof java.util.List ) == false ) {
                    lst = parseValue( lst ) ;
                    if( lst == value ) {
                        buf.ad( "checked " ) ;
                    }
                }
                else {
                    var len = lst.size() ;
                    for( var i = 0 ; i < len ; i ++ ) {
                        var s = parseValue( lst.get( i ) ) ;
                        if( isNull( s ) == false && useString( s ) == true && s == value ) {
                            buf.ad( "checked " ) ;
                            break ;
                        }
                    }
                }
            }
        }
        InputNameList.add( name ) ;
        toInputColor( id ) ;
        etcTag( etc,buf ) ;
        return buf.ad( endTag() ).ts() ;
    }
    return "" ;
} ;

// 複数ラジオボタンタグ.
gRadioTag = function( name,values,parse,line,clazz,etc ) {
    if( useString( name ) == true &&
        typeof( values ) == "array" && values.length > 0 &&
        super.__$type$script == "script" ) {
        if( !useString( parse ) ) {
            parse = "&nbsp;" ;
        }
        if( !isNumeric( line ) || line <= 0 ) {
            line = 0 ;
        }
        var buf = createStrBuf() ;
        var len = values.length ;
        for( var i = 0,j = 0 ; i < len ; i += 2,j ++ ) {
            if( line != 0 && j >= line ) {
                buf.ad( "<br" ).ad( endTag() ) ;
                j = 0 ;
            }
            else if( i != 0 ) {
                buf.ad( parse ) ;
            }
            buf.ad( radioTag( name,values[ i ],null,clazz,etc ) ).ad( values[ i+1 ] ) ;
        }
        return buf.ts() ;
    }
} ;

// セレクトタグ.
selectTag = function(name,view,size,multiple,id,clazz,etc,blankFlag) {
    if( useString( name ) == true && ( typeof( view ) == "map" || typeof( view ) == "array" ) &&
        super.__$type$script == "script" ) {
        if( useString( id ) == false ) {
            id = createId( true,name ) ;
        }
        buf = createStrBuf().ad( "<select name=\"" ).ad( name ).ad( "\" id=\"" ).ad( id ).ad( "\" " ) ;
        if( isNumeric( size ) ) {
            buf.ad( "size=\"" ).ad( size ).ad( "\" " ) ;
            if( size == 1 ) {
                size = null ;
            }
        }
        else {
            size = null ;
        }
        if( useString( clazz ) ) {
            buf.ad( "class=\"" ).ad( clazz ).ad( "\" " ) ;
        }
        if( size != null && isNull( multiple ) == false && multiple == true ) {
            buf.ad( "multiple " ) ;
        }
        toInputColor( id ) ;
        etcTag( etc,buf ) ;
        buf.ad( ">\n" ) ;
        var t = typeof( view ) ;
        if( t == "map" ) {
            var lst = super._$script$query.get(name) ;
            if( blankFlag ) {
                buf.ad( "    <option value=\"\">選択してください</option>\n" ) ;
            }
            if( isNull( lst ) ) {
                for( var k : view ) {
                    buf.ad( "    <option value=\"" ).ad( k ).ad( "\">" ).ad( view[k] ).ad( "</option>\n" ) ;
                }
            }
            else {
                if( ( lst instanceof java.util.List ) == false ) {
                    lst = parseValue( lst ) ;
                    for( var k : view ) {
                        buf.ad( "    <option value=\"" ).ad( k ).ad( "\" " ) ;
                        if( lst == parseValue( k ) ) {
                            buf.ad( "selected " ) ;
                        }
                        buf.ad( ">" ).ad( view[k] ).ad( "</option>\n" ) ;
                    }
                }
                else {
                    for( var k : view ) {
                        var key = parseValue( k ) ;
                        buf.ad( "    <option value=\"" ).ad( k ).ad( "\" " ) ;
                        for( var i = 0 ; i < len ; i ++ ) {
                            var s = parseValue( lst.get( i ) ) ;
                            if( isNull( s ) == false && s == k ) {
                                buf.ad( "selected " ) ;
                                break ;
                            }
                        }
                        buf.ad( ">" ).ad( view[k] ).ad( "</option>\n" ) ;
                    }
                }
            }
        }
        else if( t == "array" ) {
            if( blankFlag ) {
                buf.ad( "    <option value=\"\">選択してください</option>\n" ) ;
            }
            var lst = super._$script$query.get(name) ;
            var len = view.size() ;
            if( isNull( lst ) ) {
                // 未選択の場合.
                for( var i = 0 ; i < len ; i += 2 ) {
                    var k = view[ i ] ;
                    var v = view[ i + 1 ] ;
                    buf.ad( "    <option value=\"" ).ad( k ).ad( "\">" ).ad( v ).ad( "</option>\n" ) ;
                }
            }
            else {
                // 単一選択の場合.
                if( ( lst instanceof java.util.List ) == false ) {
                    lst = parseValue( lst ) ;
                    for( var i = 0 ; i < len ; i += 2 ) {
                        var k = view[ i ] ;
                        var v = view[ i + 1 ] ;
                        buf.ad( "    <option value=\"" ).ad( k ).ad( "\" " ) ;
                        if( lst == parseValue( k ) ) {
                            buf.ad( "selected " ) ;
                        }
                        buf.ad( ">" ).ad( v ).ad( "</option>\n" ) ;
                    }
                }
                else {
                    // 複数選択の場合.
                    var listLen = lst.size() ;
                    for( var i = 0 ; i < len ; i += 2 ) {
                        var k = view[ i ] ;
                        var v = view[ i + 1 ] ;
                        buf.ad( "    <option value=\"" ).ad( k ).ad( "\" " ) ;
                        var key = parseValue( k ) ;
                        for( var j = 0 ; j < listLen ; j ++ ) {
                            var s = lst.get( j ) ;
                            if( isNull( s ) == false && parseValue( s ) == key ) {
                                buf.ad( "selected " ) ;
                                break ;
                            }
                        }
                        buf.ad( ">" ).ad( v ).ad( "</option>\n" ) ;
                    }
                }
            }
        }
        InputNameList.add( name ) ;
        return buf.ad( "</select>" ).ts() ;
    }
    return "" ;
}

// checkbox,radio,select系の表示支援.
inputView = function( name,value,parse,line,num ) {
    if( !useString( name ) &&
        ( !(value instanceof java.util.Map) && !(value instanceof java.util.List) ) ) {
        return "" ;
    }
    if( !isNumeric( line ) || line <= 0 ) {
        line = 0 ;
    }
    if( !isNumeric( num ) ) {
        num = -1 ;
    }
    var b = super._$script$query.get(name) ;
    if( isNull( b ) ) {
        return "" ;
    }
    if( b instanceof java.util.List ) {
        if( num != -1 && ( num >= 0 || num < b.length ) ) {
            b = b[ num ] ;
        }
    }
    // Listでの処理.
    if( value instanceof java.util.List ) {
        if( b instanceof java.util.List ) {
            if( !useString( parse ) ) {
                parse = "&nbsp;" ;
            }
            var len = b.length ;
            var buf = new StrBuf() ;
            for( var i = 0,j = 0 ; i < len ; i ++,j ++) {
                if( line != 0 && j >= line ) {
                    buf.ad( "<br" ).ad( endTag() ) ;
                    j = 0 ;
                }
                else if( i != 0 ) {
                    buf.ad( parse ) ;
                }
                buf.ad( searchViewList( value,b[i] ) ) ;
            }
            return buf.ts() ;
        }
        else {
            return ""+searchViewList( value,b ) ;
        }
    }
    // Mapでの処理.
    else {
        if( b instanceof java.util.List ) {
            if( !useString( parse ) ) {
                parse = "&nbsp;" ;
            }
            var len = b.length ;
            var buf = new StrBuf() ;
            for( var i = 0,j = 0 ; i < len ; i ++,j ++) {
                if( line != 0 && j >= line ) {
                    buf.ad( "<br" ).ad( endTag() ) ;
                    j = 0 ;
                }
                else if( i != 0 ) {
                    buf.ad( parse ) ;
                }
                buf.ad( value[ b[i] ] ) ;
            }
            return buf.ts() ;
        }
        else {
            return ""+value[ b ] ;
        }
    }
}

// リスト(表示系)検索.
searchViewList = function( list,key ) {
    var len = list.length ;
    for( var i = 0 ; i < len ; i += 2 ) {
        if( list[ i ] == key ) {
            return list[ i+1 ] ;
        }
    }
    return "" ;
}

// ページング内容を生成.
paging = function( url,pos,max,params,space,targetClazz,etcClazz,viewSize,vpage ) {
    if( !useString( url ) || max <= 0 ) {
        return "" ;
    }
    max = parseInt( max ) ;
    if( useString( targetClazz ) == false ) {
        targetClazz = "page_target_view" ;
    }
    if( useString( etcClazz ) == false ) {
        etcClazz = "page_link_view" ;
    }
    if( isNull( viewSize ) ) {
        viewSize = 10 ;
    }
    if( isNull( vpage ) ) {
        vpage = 13 ;
    }
    else if( ( vpage & 0x00000001 ) == 0 ) {
        vpage ++ ;
    }
    if( max <= viewSize ) {
        return "" ;
    }
    if( isNull( space ) ) {
        space = 1 ;
    }
    var targetPos = parseInt( pos / viewSize ) ;
    var len = parseInt( vpage ) ;
    var maxPos = parseInt( ( max / viewSize ) + ( ( max % viewSize != 0 ) ? 1 : 0 ) ) ;
    var startPos = 0 ;
    if( len < maxPos ) {
        var half = parseInt( vpage / 2 ) ;
        startPos = targetPos - half ;
        if( startPos <= 0 ) {
            startPos = 0 ;
        }
        if( startPos + len > maxPos ) {
            startPos = maxPos - len ;
        }
    }
    else {
        len = maxPos ;
    }
    var spaceStr = "" ;
    if( isNumeric( space ) ) {
        for( var i = 0 ; i < space ; i ++ ) {
            spaceStr += "&nbsp;" ;
        }
    }
    else {
        spaceStr = space ;
    }
    var buf = createStrBuf() ;
    startPos = parseInt( startPos ) ;
    var defParams = convertMapToGetParams( params ) ;
    if( !useString( defParams ) ) {
        defParams = null ;
    }
    if( targetPos > 0 ) {
        var pms = ( defParams == null ) ? "?off="+(targetPos-1)+"&t="+(new Date().getTime()) :
            createStrBuf().ad( "?" ).ad(defParams).ad("&").ad("off=").ad(targetPos-1).ad( "&t=" ).ad(new Date().getTime()).ts() ;
        buf.ad( "<span class=\"" ).ad( etcClazz ).ad( "\">" ) ;
        buf.ad( "<a href='" ).ad( url ).ad( pms ).ad( "'>" ) ;
        buf.ad( "＜＜" ).ad( "</a></span>&nbsp;&nbsp;" ) ;
    }
    else {
        buf.ad( "<span class=\"" ).ad( etcClazz ).ad( "\">" ) ;
        buf.ad( "<a href='javascript:void(0)'>＜＜" ).ad( "</a></span>&nbsp;&nbsp;" ) ;
    }
    for( var i = 0 ; i < len ; i ++ ) {
        if( i != 0 ) {
            buf.ad( spaceStr ) ;
        }
        var pageNo = ( startPos + i ) ;
        var pg = pageNo+1 ;
        pg = ( pg <= 9 ) ? createStrBuf().ad("0").ad(pg).ts() : ""+pg ;
        if( pageNo == targetPos ) {
            buf.ad( "<span class=\"" ).ad( targetClazz ).ad( "\">" ).ad(pg).ad( "</span>" ) ;
        }
        else {
            buf.ad( "<span class=\"" ).ad( etcClazz ).ad( "\">" ) ;
            var pms = ( defParams == null ) ? "?off="+pageNo+"&t="+(new Date().getTime()) :
                createStrBuf().ad( "?" ).ad(defParams).ad("&").ad("off=").ad(pageNo).ad( "&t=" ).ad(new Date().getTime()).ts() ;
            buf.ad( "<a href='" ).ad( url ).ad( pms ).ad( "'>" ) ;
            buf.ad(pg).ad( "</a>" ).ad( "</span>" ) ;
        }
    }
    if( (targetPos+1) < maxPos ) {
        var pms = ( defParams == null ) ? "?off="+(targetPos+1)+"&t="+(new Date().getTime()) :
            createStrBuf().ad( "?" ).ad(defParams).ad("&").ad("off=").ad(targetPos+1).ad( "&t=" ).ad(new Date().getTime()).ts() ;
        buf.ad( "<span class=\"" ).ad( etcClazz ).ad( "\">" ) ;
        buf.ad( "&nbsp;&nbsp;<a href='" ).ad( url ).ad( pms ).ad( "'>" ) ;
        buf.ad( "＞＞" ).ad( "</a></span>" ) ;
    }
    else {
        buf.ad( "&nbsp;&nbsp;<a href='javascript:void(0)'>＞＞" ).ad( "</a></span>" ) ;
    }
    var ret = buf.ts() ;
    buf = null ;
    return ret ;
}

// ページング内容を生成(Ajax版).
pagingAjax = function( url,pos,max,params,space,targetClazz,etcClazz,viewSize,vpage,func,checkFunc ) {
    if( !useString( url ) || max <= 0 ) {
        return "" ;
    }
    if( !useString( func ) ) {
        func = "null" ;
    }
    if( !useString( checkFunc ) ) {
        checkFunc = null ;
    }
    max = parseInt( max ) ;
    if( useString( targetClazz ) == false ) {
        targetClazz = "page_target_view" ;
    }
    if( useString( etcClazz ) == false ) {
        etcClazz = "page_link_view" ;
    }
    if( isNull( viewSize ) ) {
        viewSize = 10 ;
    }
    if( isNull( vpage ) ) {
        vpage = 13 ;
    }
    else if( ( vpage & 0x00000001 ) == 0 ) {
        vpage ++ ;
    }
    if( max <= viewSize ) {
        return "" ;
    }
    if( isNull( space ) ) {
        space = 1 ;
    }
    var targetPos = parseInt( pos / viewSize ) ;
    var len = parseInt( vpage ) ;
    var maxPos = parseInt( ( max / viewSize ) + ( ( max % viewSize != 0 ) ? 1 : 0 ) ) ;
    var startPos = 0 ;
    if( len < maxPos ) {
        var half = parseInt( vpage / 2 ) ;
        startPos = targetPos - half ;
        if( startPos <= 0 ) {
            startPos = 0 ;
        }
        if( startPos + len > maxPos ) {
            startPos = maxPos - len ;
        }
    }
    else {
        len = maxPos ;
    }
    var spaceStr = "" ;
    if( isNumeric( space ) ) {
        for( var i = 0 ; i < space ; i ++ ) {
            spaceStr += "&nbsp;" ;
        }
    }
    else {
        spaceStr = space ;
    }
    var buf = createStrBuf() ;
    startPos = parseInt( startPos ) ;
    var defParams = convertMapToGetParams( params ) ;
    if( !useString( defParams ) ) {
        defParams = null ;
    }
    if( targetPos > 0 ) {
        var pms = ( defParams == null ) ? "ajxOff="+(targetPos-1) : createStrBuf().ad(defParams).ad("&").ad("ajxOff=").ad(targetPos-1).ts() ;
        buf.ad( "<span class=\"" ).ad( etcClazz ).ad( "\">" ) ;
        buf.ad( "<a href='javascript:void(0)' onclick='javascript:" ) ;
        if( checkFunc != null ) {
            buf.ad( "if( !" ).ad( checkFunc ).ad( "() ) { return false ; };" ) ;
        }
        buf.ad( "accessAjaxToJsExecution(null,\"").
            ad(url).ad("\",\"").ad(pms).ad("\",null,null,").ad(func).ad(");return false;'>" ) ;
        buf.ad( "＜＜" ).ad( "</a></span>&nbsp;&nbsp;" ) ;
    }
    else {
        buf.ad( "<span class=\"" ).ad( etcClazz ).ad( "\">" ) ;
        buf.ad( "<a href='javascript:void(0)'>＜＜" ).ad( "</a></span>&nbsp;&nbsp;" ) ;
    }
    for( var i = 0 ; i < len ; i ++ ) {
        if( i != 0 ) {
            buf.ad( spaceStr ) ;
        }
        var pageNo = ( startPos + i ) ;
        var pg = pageNo+1 ;
        pg = ( pg <= 9 ) ? createStrBuf().ad("0").ad(pg).ts() : ""+pg ;
        if( pageNo == targetPos ) {
            buf.ad( "<span class=\"" ).ad( targetClazz ).ad( "\">" ).ad(pg).ad( "</span>" ) ;
        }
        else {
            buf.ad( "<span class=\"" ).ad( etcClazz ).ad( "\">" ) ;
            var pms = ( defParams == null ) ? "ajxOff="+pageNo : createStrBuf().ad(defParams).ad("&").ad("ajxOff=").ad(pageNo).ts() ;
            buf.ad( "<a href='javascript:void(0)' onclick='javascript:" ) ;
            if( checkFunc != null ) {
                buf.ad( "if( !" ).ad( checkFunc ).ad( "() ) { return false ; };" ) ;
            }
            buf.ad( "accessAjaxToJsExecution(null,\"").
                ad(url).ad("\",\"").ad(pms).ad("\",null,null,").ad(func).ad(");return false;'>" ) ;
            buf.ad(pg).ad( "</a>" ).ad( "</span>" ) ;
        }
    }
    if( (targetPos+1) < maxPos ) {
        var pms = ( defParams == null ) ? "ajxOff="+(targetPos+1) : createStrBuf().ad(defParams).ad("&").ad("ajxOff=").ad(targetPos+1).ts() ;
        buf.ad( "<span class=\"" ).ad( etcClazz ).ad( "\">" ) ;
        buf.ad( "&nbsp;&nbsp;<a href='javascript:void(0)' onclick='javascript:" ) ;
        if( checkFunc != null ) {
            buf.ad( "if( !" ).ad( checkFunc ).ad( "() ) { return false ; };" ) ;
        }
        buf.ad( "accessAjaxToJsExecution(null,\"").
            ad(url).ad("\",\"").ad(pms).ad("\",null,null,").ad(func).ad(");return false;'>" ) ;
        buf.ad( "＞＞" ).ad( "</a></span>" ) ;
    }
    else {
        buf.ad( "&nbsp;&nbsp;<a href='javascript:void(0)'>＞＞" ).ad( "</a></span>" ) ;
    }
    var ret = buf.ts() ;
    buf = null ;
    return ret ;
}

// 日付入力用Selectタグを生成.
selectYMD = function( name,yearOut,mode,view,minYear,etc ) {
    if( useString( name ) == false ) {
        return "" ;
    }
    if( minYear == null || !isNumeric( minYear ) ) {
        minYear = 0 ;
    }
    var year = null ;
    var month = null ;
    var day = null ;
    if( isNull( view ) || typeof( view ) != "array" || view.length != 3 ) {
        year = "年" ;
        month = "月" ;
        day = "日" ;
    }
    else {
        year = view[ 0 ] ;
        month = view[ 1 ] ;
        day = view[ 2 ] ;
        if( year == null ) {
            year = "年" ;
        }
        if( month == null ) {
            month = "月" ;
        }
        if( day == null ) {
            day = "日" ;
        }
    }
    if( !isNull( mode ) || mode == "true" || mode == true ) {
        mode = true ;
    }
    else {
        mode = false ;
    }
    var buf = createStrBuf() ;
    
    // 年を生成.
    var yId = createId( true,name+"Year" ) ;
    var yNo = getIdNum( name+"Year" ) ;
    var ev = Event.copy() ;// イベントコピー.
    Event.onchange( "$base.changeSelectYMD( \""+name+"\","+yNo+");" ) ;// 年設定用イベント.
    buf.ad( "\n<select name=\"" ).ad( name ).ad( "Year\" id=\"" ).ad( yId ).ad( "\" " ) ;
    toInputColor( yId ) ;
    Event.flush( buf ) ;
    buf.ad( ">\n" ) ;
    
    var n = new JDate().getFullYear() ;
    var nowYear = n ;
    n = n - minYear ;
    var tg = getRequestParam(name+"Year",yNo) ;
    if( !useString( tg ) ) {
        var dt = getRequestParam(name ) ;
        if( typeof( dt ) == "date" ) {
            tg = convertString(dt.getYear() + 1900) ;
        }
    }
    if( yearOut == null ) {
        yearOut = 0 ;
    }
    yearOut = parseInt( yearOut ) ;
    var len = yearOut + nowYear - minYear ;
    var y = 0 ;
    if( mode == false ) {
        buf.ad( "    <option value=\"\">選択</option>\n" ) ;
    }
    if( yearOut <= 0 ) {
        if( useString( tg ) == false ) {
            y = n ;
            for( var i = n ; i >= len ; i -- ) {
                buf.ad( "    <option value=\"" ).ad( i ).ad( "\" " ) ;
                if( mode == true && i == nowYear ) {
                    buf.ad( "selected " ) ;
                }
                buf.ad( ">" ).ad( i ).ad( "</option>\n" ) ;
            }
        }
        else {
            y = tg ;
            for( var i = n ; i >= len ; i -- ) {
                buf.ad( "    <option value=\"" ).ad( i ).ad( "\" " ) ;
                if( i == tg ) {
                    buf.ad( "selected " ) ;
                }
                buf.ad( ">" ).ad( i ).ad( "</option>\n" ) ;
            }
        }
        buf.ad( "\n</select>\n" ) ;
    }
    else {
        if( useString( tg ) == false ) {
            y = n ;
            for( var i = n ; i < len ; i ++ ) {
                buf.ad( "    <option value=\"" ).ad( i ).ad( "\" " ) ;
                if( mode == true && i == nowYear ) {
                    buf.ad( "selected " ) ;
                }
                buf.ad( ">" ).ad( i ).ad( "</option>\n" ) ;
            }
        }
        else {
            y = tg ;
            for( var i = n ; i < len ; i ++ ) {
                buf.ad( "    <option value=\"" ).ad( i ).ad( "\" " ) ;
                if( i == tg ) {
                    buf.ad( "selected " ) ;
                }
                buf.ad( ">" ).ad( i ).ad( "</option>\n" ) ;
            }
        }
        buf.ad( "\n</select>\n" ) ;
    }
    buf.ad( year ).ad( "\n" ) ;
    
    // 月を生成.
    var mId = createId( true,name+"Month" ) ;
    var mNo = getIdNum( name+"Month" ) ;
    if( ev != null ) {
        Event.write( ev ) ;// イベントが存在する場合は、子要素にもコピー処理.
    }
    Event.onchange( "$base.changeSelectYMD( \""+name+"\","+yNo+");" ) ;// 年設定用イベント.
    buf.ad( "\n<select name=\"" ).ad( name ).ad( "Month\" id=\"" ).ad( mId ).ad( "\" " ) ;
    toInputColor( mId ) ;
    Event.flush( buf ) ;
    
    buf.ad( ">\n" ) ;
    n = new JDate().getMonth() + 1 ;
    tg = getRequestParam(name+"Month",mNo) ;
    if( !useString( tg ) ) {
        var dt = getRequestParam(name ) ;
        if( typeof( dt ) == "date" ) {
            tg = convertString(dt.getMonth() + 1) ;
        }
    }
    var m = 0 ;
    if( mode == false ) {
        buf.ad( "    <option value=\"\">選択</option>\n" ) ;
    }
    if( useString( tg ) == false ) {
        m = n ;
        for( var i = 1 ; i <= 12 ; i ++ ) {
            c = convertString( i ) ;
            var c = "00".substring( c.length ) + c ;
            if( mode == true && i == n ) {
                buf.ad( "    <option value=\"" ).ad( i ).ad( "\" selected>" ).ad( c ).ad( "</option>\n" ) ;
            }
            else {
                buf.ad( "    <option value=\"" ).ad( i ).ad( "\">" ).ad( c ).ad( "</option>\n" ) ;
            }
        }
    }
    else {
        m = tg ;
        for( var i = 1 ; i <= 12 ; i ++ ) {
            c = convertString( i ) ;
            var c = "00".substring( c.length ) + c ;
            buf.ad( "    <option value=\"" ).ad( i ).ad( "\" " ) ;
            if( i == tg ) {
                buf.ad( "selected " ) ;
            }
            buf.ad( ">" ).ad( c ).ad( "</option>\n" ) ;
        }
    }
    buf.ad( "\n</select>\n" ) ;
    buf.ad( month ).ad( "\n" ) ;
    
    // 日を生成.
    var sId = createId( true,name+"SYMD" ) ;
    var dId = createId( true,name+"Day" ) ;
    var dNo = getIdNum( name+"Day" ) ;
    if( ev != null ) {
        Event.write( ev ) ;// イベントが存在する場合は、子要素にもコピー処理.
    }
    buf.ad( "\n<span id=\"" ).ad( sId ).ad( "\">" ) ;
    buf.ad( "\n<select name=\"" ).ad( name ).ad( "Day\" id=\"" ).ad( dId ).ad( "\"" ) ;
    toInputColor( dId ) ;
    Event.flush( buf ) ;
    buf.ad( ">\n" ) ;
    tg = getRequestParam(name+"Day",dNo) ;
    if( !useString( tg ) ) {
        var dt = getRequestParam(name ) ;
        if( typeof( dt ) == "date" ) {
            tg = convertString( dt.getDate() ) ;
        }
    }
    if( mode == false && useString( tg ) == false ) {
        buf.ad( "    <option value=\"\">選択</option>\n" ) ;
    }
    else {
        y = parseInt( y ) ;
        m = parseInt( m ) ;
        var ymKey = createStrBuf().ad( y ).ad( "_" ).ad( m ).ts() ;
        len = null ;
        var st = new JDate( y,m-1,1,0,0,0 ).getTime() ;
        m ++ ;
        if( m > 12 ) {
            m = 1 ;
            y ++ ;
        }
        var ed = new JDate( y,m-1,1,0,0,0 ).getTime() ;
        len = parseInt( ( ed - st ) / 86400000 ) ;
        if( useString( tg ) == false ) {
            n = new JDate().getDate() ;
            for( var i = 1 ; i <= len ; i ++ ) {
                var c = convertString(i)
                var c = "00".substring( c.length ) + c ;
                if( mode == true && i == n ) {
                    buf.ad( "    <option value=\"" ).ad( i ).ad( "\" selected>" ).ad( c ).ad( "</option>\n" ) ;
                }
                else {
                    buf.ad( "    <option value=\"" ).ad( i ).ad( "\">" ).ad( c ).ad( "</option>\n" ) ;
                }
            }
        }
        else {
            for( var i = 1 ; i <= len ; i ++ ) {
                var c = convertString(i)
                var c = "00".substring( c.length ) + c ;
                buf.ad( "    <option value=\"" ).ad( i ).ad( "\" " ) ;
                if( i == tg ) {
                    buf.ad( "selected " ) ;
                }
                buf.ad( ">" ).ad( c ).ad( "</option>\n" ) ;
            }
        }
    }
    buf.ad( "\n</select></span>\n" ) ;
    buf.ad( day ).ad( "\n" ) ;
    
    return buf.ts() ;
}

// selectYMD内容を取得.
getYMD = function( name ) {
    if( useString( name ) == false ||
        isNumeric( params[name+"Year"] ) == false ||
        isNumeric( params[name+"Month"] ) == false ||
        isNumeric( params[name+"Day"] ) == false ) {
        return null ;
    }
    return new JDate( parseInt( params[name+"Year"] ),
        parseInt( params[name+"Month"] )-1,
        parseInt( params[name+"Day"] ) ) ;
}

// selectYMDパラメータに表示させるパラメータセット.
paramsYMD = function( name,date,no ) {
    if( !useString( name ) || typeof( date ) != "date" ) {
        return ;
    }
    if( !isNumeric( no ) ) {
        no = 0 ;
    }
    setRequestParam(name+"Year",no,date.getYear()+1900) ;
    setRequestParam(name+"Month",no,date.getMonth()+1) ;
    setRequestParam(name+"Day",no,date.getDate()) ;
}

// selectYMD内容を表示.
viewYMD = function( name,view ) {
    if( isNull( view ) || typeof( view ) != "array" || view.length != 3 ) {
        view = ["年","月","日"] ;
    }
    if( useString( name ) == false ||
        isNumeric( params[name+"Year"] ) == false ||
        isNumeric( params[name+"Month"] ) == false ||
        isNumeric( params[name+"Day"] ) == false ) {
        return "" ;
    }
    var buf = createStrBuf() ;
    buf.ad( params[name+"Year"] ).ad( view[ 0 ] ) ;
    buf.ad( "00".substring( (""+params[name+"Month"]).length ) ).ad( params[name+"Month"] ).ad( view[ 1 ] ) ;
    buf.ad( "00".substring( (""+params[name+"Day"]).length ) ).ad( params[name+"Day"] ).ad( view[ 2 ] ) ;
    return buf.ts() ;
}

// 時間入力用Selectタグを生成.
selectTime = function( name,mode,view ) {
    if( useString( name ) == false ) {
        return "" ;
    }
    var hour = null ;
    var minute = null ;
    var second = null ;
    if( isNull( view ) || typeof( view ) != "array" || view.length != 3 ) {
        hour = "&nbsp;時&nbsp;" ;
        minute = "&nbsp;分&nbsp;" ;
        second = "&nbsp;秒" ;
    }
    else {
        hour = view[ 0 ] ;
        minute = view[ 1 ] ;
        second = view[ 2 ] ;
        if( useString( hour ) == false ) {
            hour = "&nbsp;時&nbsp;" ;
        }
        if( useString( minute ) == false ) {
            minute = "&nbsp;分&nbsp;" ;
        }
        if( useString( second ) == false ) {
            second = "&nbsp;秒" ;
        }
    }
    if( isNull( mode ) || mode != true ) {
        mode = false ;
    }
    var buf = createStrBuf() ;
    var date = new JDate() ;
    
    // 時間を生成.
    var hId = createId( true,name+"Hour" ) ;
    var hNo = getIdNum( name+"Hour" ) ;
    buf.ad( "<select name=\"" ).ad( name ).ad( "Hour\" id=\"" ).ad( hId ).ad( "\" " ) ;
    toInputColor( hId ) ;
    Event.flush( buf ) ;
    buf.ad( ">\n" ) ;
    n = date.getHours() ;
    tg = getRequestParam(name+"Hour",hNo) ;
    if( !useString( tg ) ) {
        var dt = getRequestParam(name ) ;
        if( typeof( dt ) == "date" ) {
            tg = convertString(dt.getHours()) ;
        }
    }
    var m = 0 ;
    if( mode == false ) {
        buf.ad( "    <option value=\"\">選択</option>\n" ) ;
    }
    if( useString( tg ) == false ) {
        m = n ;
        for( var i = 0 ; i < 24 ; i ++ ) {
            c = convertString( i ) ;
            var c = "00".substring( c.length ) + c ;
            if( mode == true && i == n ) {
                buf.ad( "    <option value=\"" ).ad( i ).ad( "\" selected>" ).ad( c ).ad( "</option>\n" ) ;
            }
            else {
                buf.ad( "    <option value=\"" ).ad( i ).ad( "\">" ).ad( c ).ad( "</option>\n" ) ;
            }
        }
    }
    else {
        m = tg ;
        for( var i = 0 ; i < 24 ; i ++ ) {
            c = convertString( i ) ;
            var c = "00".substring( c.length ) + c ;
            buf.ad( "    <option value=\"" ).ad( i ).ad( "\" " ) ;
            if( i == tg ) {
                buf.ad( "selected " ) ;
            }
            buf.ad( ">" ).ad( c ).ad( "</option>\n" ) ;
        }
    }
    buf.ad( "\n</select>\n" ) ;
    buf.ad( hour ).ad( "\n" ) ;
    
    // 分を生成.
    var mId = createId( true,name+"Minute" ) ;
    var mNo = getIdNum( name+"Minute" ) ;
    buf.ad( "<select name=\"" ).ad( name ).ad( "Minute\" id=\"" ).ad( mId ).ad( "\" " ) ;
    toInputColor( mId ) ;
    Event.flush( buf ) ;
    buf.ad( ">\n" ) ;
    n = date.getMinutes() ;
    tg = getRequestParam(name+"Minute",mNo) ;
    if( !useString( tg ) ) {
        var dt = getRequestParam(name ) ;
        if( typeof( dt ) == "date" ) {
            tg = convertString(dt.getMinutes()) ;
        }
    }
    var m = 0 ;
    if( mode == false ) {
        buf.ad( "    <option value=\"\">選択</option>\n" ) ;
    }
    if( useString( tg ) == false ) {
        m = n ;
        for( var i = 0 ; i < 60 ; i ++ ) {
            c = convertString( i ) ;
            var c = "00".substring( c.length ) + c ;
            if( mode == true && i == n ) {
                buf.ad( "    <option value=\"" ).ad( i ).ad( "\" selected>" ).ad( c ).ad( "</option>\n" ) ;
            }
            else {
                buf.ad( "    <option value=\"" ).ad( i ).ad( "\">" ).ad( c ).ad( "</option>\n" ) ;
            }
        }
    }
    else {
        m = tg ;
        for( var i = 0 ; i < 60 ; i ++ ) {
            c = convertString( i ) ;
            var c = "00".substring( c.length ) + c ;
            buf.ad( "    <option value=\"" ).ad( i ).ad( "\" " ) ;
            if( i == tg ) {
                buf.ad( "selected " ) ;
            }
            buf.ad( ">" ).ad( c ).ad( "</option>\n" ) ;
        }
    }
    buf.ad( "\n</select>\n" ) ;
    buf.ad( minute ).ad( "\n" ) ;
    
    // 秒を生成.
    var sId = createId( true,name+"Second" ) ;
    var sNo = getIdNum( name+"Second" ) ;
    buf.ad( "<select name=\"" ).ad( name ).ad( "Second\" id=\"" ).ad( sId ).ad( "\" " ) ;
    toInputColor( sId ) ;
    Event.flush( buf ) ;
    buf.ad( ">\n" ) ;
    n = date.getSeconds() ;
    tg = getRequestParam(name+"Second",sNo) ;
    if( !useString( tg ) ) {
        var dt = getRequestParam(name ) ;
        if( typeof( dt ) == "date" ) {
            tg = convertString(dt.getSeconds()) ;
        }
    }
    var m = 0 ;
    if( mode == false ) {
        buf.ad( "    <option value=\"\">選択</option>\n" ) ;
    }
    if( useString( tg ) == false ) {
        m = n ;
        for( var i = 0 ; i < 60 ; i ++ ) {
            c = convertString( i ) ;
            var c = "00".substring( c.length ) + c ;
            if( mode == true && i == n ) {
                buf.ad( "    <option value=\"" ).ad( i ).ad( "\" selected>" ).ad( c ).ad( "</option>\n" ) ;
            }
            else {
                buf.ad( "    <option value=\"" ).ad( i ).ad( "\">" ).ad( c ).ad( "</option>\n" ) ;
            }
        }
    }
    else {
        m = tg ;
        for( var i = 0 ; i < 60 ; i ++ ) {
            c = convertString( i ) ;
            var c = "00".substring( c.length ) + c ;
            buf.ad( "    <option value=\"" ).ad( i ).ad( "\" " ) ;
            if( i == tg ) {
                buf.ad( "selected " ) ;
            }
            buf.ad( ">" ).ad( c ).ad( "</option>\n" ) ;
        }
    }
    buf.ad( "\n</select>\n" ) ;
    buf.ad( second ).ad( "\n" ) ;
    
    return buf.ts() ;
}

// selectTime内容を表示.
viewTime = function( name,view ) {
    if( isNull( view ) || typeof( view ) != "array" || view.length != 3 ) {
        view = ["時","分","秒"] ;
    }
    if( useString( name ) == false ||
        isNumeric( params[name+"Hour"] ) == false ||
        isNumeric( params[name+"Minute"] ) == false ||
        isNumeric( params[name+"Second"] ) == false ) {
        return "" ;
    }
    var buf = createStrBuf() ;
    buf.ad( "00".substring( (""+params[name+"Hour"]).length ) ).ad( params[name+"Hour"] ).ad( view[ 1 ] ) ;
    buf.ad( "00".substring( (""+params[name+"Minute"]).length ) ).ad( params[name+"Minute"] ).ad( view[ 1 ] ) ;
    buf.ad( "00".substring( (""+params[name+"Second"]).length ) ).ad( params[name+"Second"] ).ad( view[ 2 ] ) ;
    return buf.ts() ;
}

// 都道府県配列.
prefArray = [
"北海道",
"青森県",
"岩手県",
"秋田県",
"宮城県",
"山形県",
"福島県",
"茨城県",
"栃木県",
"群馬県",
"千葉県",
"埼玉県",
"東京都",
"神奈川県",
"山梨県",
"静岡県",
"長野県",
"岐阜県",
"愛知県",
"新潟県",
"富山県",
"石川県",
"福井県",
"三重県",
"滋賀県",
"京都府",
"大阪府",
"奈良県",
"和歌山県",
"兵庫県",
"岡山県",
"広島県",
"鳥取県",
"島根県",
"山口県",
"香川県",
"徳島県",
"高知県",
"愛媛県",
"福岡県",
"佐賀県",
"長崎県",
"大分県",
"熊本県",
"宮崎県",
"鹿児島県",
"沖縄県" ] ;

// 都道府県Selectボックス用配列.
prefSelectArray = [
-1,"選択してください",
0,"北海道",
1,"青森県",
2,"岩手県",
3,"秋田県",
4,"宮城県",
5,"山形県",
6,"福島県",
7,"茨城県",
8,"栃木県",
9,"群馬県",
10,"千葉県",
11,"埼玉県",
12,"東京都",
13,"神奈川県",
14,"山梨県",
15,"静岡県",
16,"長野県",
17,"岐阜県",
18,"愛知県",
19,"新潟県",
20,"富山県",
21,"石川県",
22,"福井県",
23,"三重県",
24,"滋賀県",
25,"京都府",
26,"大阪府",
27,"奈良県",
28,"和歌山県",
29,"兵庫県",
30,"岡山県",
31,"広島県",
32,"鳥取県",
33,"島根県",
34,"山口県",
35,"香川県",
36,"徳島県",
37,"高知県",
38,"愛媛県",
39,"福岡県",
40,"佐賀県",
41,"長崎県",
42,"大分県",
43,"熊本県",
44,"宮崎県",
45,"鹿児島県",
46,"沖縄県" ] ;

// 都道府県セレクトボックスを表示.
selectPref = function( name,size,multiple,id,clazz,etc ) {
    return selectTag( name,prefSelectArray,multiple,id,clazz,etc ) ;
}

// 都道府県表示用.
viewPref = function( name,num ) {
    if( !isNumeric( num ) ) {
        num = -1 ;
    }
    id = super._$script$query.get(name) ;
    if( isNull( id ) ) {
        return "" ;
    }
    if( id instanceof java.util.List ) {
        if( num <= 0 || num >= id.length ) {
            return "" ;
        }
        id = id[ num ] ;
    }
    if( isNull( id ) || !isNumeric( id ) ||
        id <= -1 || id >= prefArray.length ) {
        return "" ;
    }
    return prefArray[ parseInt(id) ] ;
}

// 指定パラメータの英文字をカナ変換.
britishNumberToKanaByParam = function( name ) {
    if( useString( name ) == false ) {
        return "" ;
    }
    var v = super._$script$query.get(name) ;
    return britishNumberToKana( v ) ;
}

// 指定Map情報をHTTP[GET]パラメータ情報に変換.
$mp = function( map,mode ) {
    return convertMapToGetParams( map,mode ) ;
}

// 指定Map情報をHTTP[GET]パラメータ情報に変換.
convertMapToGetParams = function( map,mode ) {
    if( super.__$type$script != "script" ) {
        return "" ;
    }
    if( typeof( map ) != "map" ) {
        return map ;
    }
    var cnt = 0 ;
    var buf = new StrBuf() ;
    if( isNull( mode ) ) {
        mode = false ;
    }
    if( mode == true ) {
        buf.ad( "?" ) ;
    }
    for( var k : map ) {
        // パラメータに $_ が付くモノに対しては、パラメータとして処理する.
        if( !k.startsWith( "_$" ) ) {
            if( startsWith( k,"submitButton." ) ||
                ( startsWith( k,"_" ) && startsWith( k,"_validate" ) == false ) ||
                k == "t" ) {
                continue ;
            }
        }
        if( cnt != 0 ) {
            buf.ad( "&" ) ;
        }
        var val = map[k] ;
        if( isNull( val ) || isEmpty( val ) ) {
            buf.ad( k ).ad( "=" ) ;
        }
        else if( typeof( val ) == "array" ) {
            var len = val.length ;
            for( var i = 0 ; i < len ; i ++ ) {
                if( i != 0 ) {
                    buf.ad( "&" ) ;
                }
                if( isNull( val[ i ] ) || isEmpty( val[ i ] ) ) {
                    buf.ad( k ).ad( "=" ) ;
                }
                else {
                    buf.ad( k ).ad( "=" ).ad( encodeURL( val[ i ] ) ) ;
                }
            }
        }
        else {
            buf.ad( k ).ad( "=" ).ad( encodeURL( val ) ) ;
        }
        cnt ++ ;
    }
    return buf.ts() ;
}

// Ｄａｔｅ内容から、日付情報で取得.
viewYyyyMmDd = function( date ) {
    if( isNull( date ) || typeof( date ) != "date" ) {
        return "" ;
    }
    var buf = createStrBuf().ad( (date.getYear()+1900) ) ;
    var x = ""+(date.getMonth()+1) ;
    buf.ad( "/" + "00".substring( x.length,2 ) ).ad( x ) ;
    x = ""+date.getDate() ;
    buf.ad( "/" + "00".substring( x.length,2 ) ).ad( x ) ;
    return buf.ts() ;
}

// 指定Mapの日付情報を、Date型に変換.
convertMapByDate = function( name,map ) {
    if( useString( name ) == false || isNull( map ) ||
        isNumeric( map[name+"Year"] ) == false ||
        isNumeric( map[name+"Month"] ) == false ||
        isNumeric( map[name+"Day"] ) == false ) {
        return null ;
    }
    var year = map[name+"Year"] ;
    var month = map[name+"Month"] ;
    var day = map[name+"Day"] ;
    return new JDate( year,month-1,day ) ;
}

// 指定パラメータの日付情報を、Date型に変換.
convertParamByDate = function( name ) {
    if( useString( name ) == false ||
        isNumeric( params[name+"Year"] ) == false ||
        isNumeric( params[name+"Month"] ) == false ||
        isNumeric( params[name+"Day"] ) == false ) {
        return null ;
    }
    var year = params[name+"Year"] ;
    var month = params[name+"Month"] ;
    var day = params[name+"Day"] ;
    return new JDate( year,month-1,day ) ;
}

// 指定日付情報を、各パラメータに付加.
convertDateByMap = function( map,name,date ) {
    if( isNull( map ) || useString( name ) == false ||
        isNull( date ) || typeof( date ) != "date" ) {
        return false ;
    }
    map[name+"Year"] = date.getYear()+1900 ;
    map[name+"Month"] = date.getMonth()+1 ;
    map[name+"Day"] = date.getDate() ;
    return true ;
}


// 指定日付情報を、各パラメータに付加.
convertDateByParam = function( name,date ) {
    if( useString( name ) == false || isNull( date ) || typeof( date ) != "date" ) {
        return false ;
    }
    params[name+"Year"] = date.getYear()+1900;
    params[name+"Month"] = date.getMonth()+1 ;
    params[name+"Day"] = date.getDate() ;
    return true ;
}

// 開始フォーカスを指定します.
initFocus = function( name ) {
    if( useString( name ) ) {
        if( !(name instanceof java.lang.String) ) {
            name = convertString( name ) ;
        }
        if( !name.endsWith( "Id" ) ) {
            name = createId( false,name ) ;
        }
        Event.onload( createStrBuf().ad( "document.getElementById(\"" ).ad( name ).ad( "\").focus()" ).ts() ) ;
    }
    return "" ;
}

// フォーカス制御.
moveFocus = function( before,next,max ) {
    var buf = createStrBuf() ;
    buf.ad( "MoveFocus.move( event,this.id," ) ;
    if( useString( before ) ) {
        if( !(before instanceof java.lang.String) ) {
            before = convertString( before ) ;
        }
        if( before.toLowerCase() == "null" ) {
            buf.ad( "null" ) ;
        }
        else {
            if( !before.endsWith( "Id" ) ) {
                before = createId( false,before ) ;
            }
            buf.ad( "\"" ).ad( before ).ad( "\"" ) ;
        }
    }
    else {
        buf.ad( "null" ) ;
    }
    buf.ad( "," ) ;
    if( useString( next ) ) {
        if( !(next instanceof java.lang.String) ) {
            next = convertString( next ) ;
        }
        if( next.toLowerCase() == "null" ) {
            buf.ad( "null" ) ;
        }
        else {
            if( !next.endsWith( "Id" ) ) {
                next = createId( false,next ) ;
            }
            buf.ad( "\"" ).ad( next ).ad( "\"" ) ;
        }
    }
    else {
        buf.ad( "null" ) ;
    }
    if( isNumeric( max ) ) {
        buf.ad( "," ).ad( max ) ;
    }
    buf.ad( " )" ) ;
    if( isBrowser() == "opera" ) {
        Event.onkeypress( buf.ts() ) ;
    }
    else {
        Event.onkeydown( buf.ts() ) ;
    }
    return "" ;
}

// 休日を表示させる、カレンダー.
restCalenderTag = function( year,month,restClass,restYearMap,restMonthMap ) {
    month = month-1 ;
    var targetDate = new JDate( year,month,1 ) ;
    var buf = new StrBuf() ;
    buf.ad( "<table class='calender'><tbody>" ).
        ad( "<tr>" ).
        ad( "<td class='week_sun'>日</td>" ).
        ad( "<td class='week'>月</td>" ).
        ad( "<td class='week'>火</td>" ).
        ad( "<td class='week'>水</td>" ).
        ad( "<td class='week'>木</td>" ).
        ad( "<td class='week'>金</td>" ).
        ad( "<td class='week_std'>土</td>" ).
        ad( "</tr><tr>" ) ;
    var day = targetDate.getDay() ;
    for( var i = 0 ; i < day ; i ++ ) {
        buf.ad( "<td>&nbsp;</td>" ) ;
    }
    var time = targetDate.getTime() ;
    var restMap = null ;
    if( useString( restClass ) ) {
        if( restYearMap != null ) {
            restMap = restYearMap[ convertString( month+1 ) ] ;
        }
        else if( restMonthMap != null ) {
            restMap = restMonthMap ;
        }
    }
    var flg = false ;
    var dateCnt = 0 ;
    var dayCnt = 1 ;
    if( useString( restClass ) && restMap != null && typeof( restMap ) == 'map' ) {
        while( true ) {
            targetDate.setTime( time ) ;
            day = targetDate.getDay() ;
            if( flg && day == 0 ) {
                dateCnt = 0 ;
                dayCnt ++ ;
                buf.ad( "</tr>" ) ;
            }
            if( targetDate.getMonth() != month ) {
                break ;
            }
            if( flg && day == 0 ) {
                buf.ad( "<tr>" ) ;
            }
            if( restMap[ convertString( targetDate.getDate() ) ] ) {
                buf.ad( "<td class='" ).ad( restClass ).ad( "'>" ).ad( targetDate.getDate() ).ad( "</td>" ) ;
            }
            else {
                buf.ad( "<td>" ).ad( targetDate.getDate() ).ad( "</td>" ) ;
            }
            time += 86400000 ;
            flg = true ;
            dateCnt ++ ;
        }
    }
    else {
        while( true ) {
            targetDate.setTime( time ) ;
            day = targetDate.getDay() ;
            if( flg && day == 0 ) {
                dateCnt = 0 ;
                dayCnt ++ ;
                buf.ad( "</tr>" ) ;
            }
            if( targetDate.getMonth() != month ) {
                break ;
            }
            if( flg && day == 0 ) {
                buf.ad( "<tr>" ) ;
            }
            buf.ad( "<td>" ).ad( targetDate.getDate() ).ad( "</td>" ) ;
            time += 86400000 ;
            flg = true ;
            dateCnt ++ ;
        }
    }
    if( dayCnt != 6 ) {
        for( var i = dateCnt ; i < 7 ; i ++ ) {
            buf.ad( "<td>&nbsp;</td>" ) ;
        }
        buf.ad( "</tr>" ) ;
        var len = 6 - dayCnt ;
        for( var i = 0 ; i < len ; i ++ ) {
            buf.ad( "<tr><td>&nbsp;</td><td>&nbsp;</td><td>&nbsp;</td>" ).
                ad( "<td>&nbsp;</td><td>&nbsp;</td><td>&nbsp;</td><td>&nbsp;</td>" ).
                ad( "</tr>" ) ;
        }
    }
    else {
        for( var i = dateCnt ; i < 7 ; i ++ ) {
            buf.ad( "<td>&nbsp;</td>" ) ;
        }
        buf.ad( "</tr>" ) ;
    }
    return buf.ad( "</tbody></table></td>" ).ts() ;
}

// 休日を設定するカレンダー.
setRestCalender = function( year,month,restYearMap,restMonthMap ) {
    var restMap = null ;
    if( restYearMap != null ) {
        restMap = restYearMap[ convertString( month ) ] ;
    }
    else if( restMonthMap != null ) {
        restMap = restMonthMap ;
    }
    else {
        return ;
    }
    month = month-1 ;
    var targetDate = new JDate( year,month,1 ) ;
    var buf = new StrBuf() ;
    buf.ad( "<table class='calender'><tbody>" ).
        ad( "<tr>" ).
        ad( "<td class='week_sun'>日</td>" ).
        ad( "<td class='week'>月</td>" ).
        ad( "<td class='week'>火</td>" ).
        ad( "<td class='week'>水</td>" ).
        ad( "<td class='week'>木</td>" ).
        ad( "<td class='week'>金</td>" ).
        ad( "<td class='week_std'>土</td>" ).
        ad( "</tr><tr>" ) ;
    var day = targetDate.getDay() ;
    for( var i = 0 ; i < day ; i ++ ) {
        buf.ad( "<td>&nbsp;</td>" ) ;
    }
    var time = targetDate.getTime() ;
    var flg = false ;
    var dateCnt = 0 ;
    var dayCnt = 1 ;
    var chkname = null ;
    while( true ) {
        targetDate.setTime( time ) ;
        var date = targetDate.getDate() ;
        chkname = convertString(year)+"_"+convertString(month+1)+"_"+convertString(date) ;
        day = targetDate.getDay() ;
        if( flg && day == 0 ) {
            dateCnt = 0 ;
            dayCnt ++ ;
            buf.ad( "</tr>" ) ;
        }
        if( targetDate.getMonth() != month ) {
            break ;
        }
        if( flg && day == 0 ) {
            buf.ad( "<tr>" ) ;
        }
        if( date >= 1 && date <= 9 ) {
            var viewDate = "&nbsp;"+date ;
        }
        else {
            viewDate = date ;
        }
        if( restMap[ convertString( date ) ] ) {
            buf.ad( "<td class='restCalendar'>" ).
                ad( viewDate ).
                ad( checkBoxTag( "restCalender",chkname,chkname+"Id",null,null,true ) ).
                ad( "</td>" ) ;
        }
        else {
            buf.ad( "<td class='restCalendar'>" ).
                ad( viewDate).
                ad( checkBoxTag( "restCalender",chkname,chkname+"Id",null,null,false ) ).
                ad( "</td>" ) ;
        }
        time += 86400000 ;
        flg = true ;
        dateCnt ++ ;
    }
    if( dayCnt != 6 ) {
        for( var i = dateCnt ; i < 7 ; i ++ ) {
            buf.ad( "<td>&nbsp;</td>" ) ;
        }
        buf.ad( "</tr>" ) ;
        var len = 6 - dayCnt ;
        for( var i = 0 ; i < len ; i ++ ) {
            buf.ad( "<tr><td>&nbsp;</td><td>&nbsp;</td><td>&nbsp;</td>" ).
                ad( "<td>&nbsp;</td><td>&nbsp;</td><td>&nbsp;</td><td>&nbsp;</td>" ).
                ad( "</tr>" ) ;
        }
    }
    else {
        for( var i = dateCnt ; i < 7 ; i ++ ) {
            buf.ad( "<td>&nbsp;</td>" ) ;
        }
        buf.ad( "</tr>" ) ;
    }
    return buf.ad( "</tbody></table></td>" ).ts() ;
}

////////////////////////////////////////////////////////////////////////////////
// Form内でのページバック機能.
////////////////////////////////////////////////////////////////////////////////
PageBack = {
    // backPage用パラメータをセット.
    pushTag : function() {
        if( super.__$type$script == "script" ) {
            if( PageBackCache.flag() == null ) {
                PageBackCache.flagOff() ;
            }
            return hiddenTag("_pageBackMode","next","_pageBackModeId") ;
        }
        return "" ;
    },
    // backPage条件であるかチェック.
    isPageBack : function() {
        if( params[ "_pageBackMode" ] == "back" ) {
            return true ;
        }
        return false ;
    },
    // backPage条件の場合、指定URLにフォワード.
    forward : function(url) {
        if( useString( url ) == true ) {
            if( params[ "_pageBackMode" ] == "back" ) {
                forwardMHTML( url ) ;
            }
        }
    },
    // ページバックJavascriptを生成.
    _createPageBackScript : function(formName) {
        if( !useString( formName ) ) {
            formName = FormNameCache.get() ;
        }
        if( PageBackCache.flag() == null ) {
            PageBackCache.flagOn() ;
        }
        return new StrBuf().ad( "document.getElementById(\"_pageBackModeId\").value=\"back\";document." ).
            ad( formName ).ad( ".submit();return true;" ).ts() ;
    },
    // ページバックリンクタグ.
    linkTag : function(view,formName) {
        if( useString( view ) == true && super.__$type$script == "script" ) {
            if( !useString( formName ) ) {
                formName = FormNameCache.get() ;
            }
            return createStrBuf().ad( "<a href=\"javascript:" ).ad( PageBack._createPageBackScript(formName) ).ad( "\">" ).
                ad( view ).ad( "</a>" ).ts() ;
        }
        return "" ;
    },
    // ページバック開始リンクタグ.
    startLinkTag : function(formName) {
        if( super.__$type$script == "script" ) {
            if( !useString( formName ) ) {
                formName = FormNameCache.get() ;
            }
            return createStrBuf().ad( "<a href=\"javascript:" ).ad( PageBack._createPageBackScript(formName) ).ad( "\">" ).ts() ;
        }
        return "" ;
    },
    // ページバックボタンタグ.
    button : function(value,formName,id,clazz,disabled ) {
        if( useString( value ) == true && super.__$type$script == "script" ) {
            if( !useString( formName ) ) {
                formName = FormNameCache.get() ;
            }
            Event.onclick( createStrBuf().ad( PageBack._createPageBackScript( formName ) ).ts() ) ;
            return button( value,null,null,id,clazz,disabled ) ;
        }
        return "" ;
    },
    // ページバックイメージボタンタグ.
    imgButton : function(name,src,formName,alt,border,width,height,etc,cmode,id,clazz ) {
        if( useString( src ) == true && super.__$type$script == "script" ) {
            if( !useString( formName ) ) {
                formName = FormNameCache.get() ;
            }
            if( !useString( id ) ) {
                id = createId( true,name ) ;
            }
            var tm = imageCacheTime( cmode ) ;
            src = trim( src ) ;
            var x = toLowerCase( src ) ;
            var buf = createStrBuf().ad( "<input type=\"image\" src=\"" ) ;
            if( startsWith( x,"http://" ) || startsWith( x,"https://" ) ) {
                if( isNull( tm ) ) {
                    buf.ad( src ).ad( "\"" ) ;
                }
                else {
                    buf.ad( src ).ad( "?t=" ).ad( tm ).ad( "\"" ) ;
                }
            }
            else {
                if( !startsWith( src,"/" ) ) {
                    src = viewHref(src,"",false) ;
                }
                if( isNull( tm ) ) {
                    buf.ad( src ).ad( "\"" ) ;
                }
                else {
                    buf.ad( src ).ad( "?t=" ).ad( tm ).ad( "\"" ) ;
                }
            }
            if( useString( name ) ) {
                buf.ad( " name=\"" ).ad( name ).ad( "\"" ) ;
            }
            if( useString( alt ) ) {
                buf.ad( " alt=\"" ).ad( alt ).ad( "\"" ) ;
            }
            if( useString( border ) ) {
                buf.ad( " border=\"" ).ad( border ).ad( "\"" ) ;
            }
            if( isNull( width ) == false ) {
                buf.ad( " width=\"" ).ad( width ).ad( "\"" ) ;
            }
            if( isNull( height ) == false ) {
                buf.ad( " height=\"" ).ad( height ).ad( "\"" ) ;
            }
            if( useString( id ) == true ) {
                buf.ad( "id=\"" ).ad( id ).ad( "\" " ) ;
            }
            if( useString( clazz ) == true ) {
                buf.ad( "class=\"" ).ad( clazz ).ad( "\" " ) ;
            }
            Event.onclick( createStrBuf().ad( PageBack._createPageBackScript( formName ) ).ts() ) ;
            etcTag( etc,buf ) ;
            return buf.ad( endTag() ).ts() ;
        }
        return "" ;
    }
} ;

////////////////////////////////////////////////////////////////////////////////
// 2重押しを回避する機能.
////////////////////////////////////////////////////////////////////////////////
DoubleSend = {
    sessionKey : "_double_send",
    valueSize : 56,
    // ２重押しパラメータを設定.
    pushTag : function() {
        if( getConfig( "server","debug" ) != true ) {
            if( isSession() ) {
                var value = pkg("org.maachang.util.RandomUtil").randomString( DoubleSend.valueSize,true,true,true ) ;
                return hiddenTag( DoubleSend.sessionKey,value ) ;
            }
        }
        return "" ;
    },
    // ２重押しされたかチェック.
    isDoubleSend : function() {
        if( getConfig( "server","debug" ) != true ) {
            if( isSession() ) {
                var value = getSession( DoubleSend.sessionKey ) ;
                if( useString( params[DoubleSend.sessionKey] ) == true ) {
                    if( params[DoubleSend.sessionKey] == value ) {
                        return true ;
                    }
                    putSession( DoubleSend.sessionKey,params[DoubleSend.sessionKey] ) ;
                    return false ;
                }
                else {
                    return false ;
                }
            }
        }
        return false ;
    }
} ;

////////////////////////////////////////////////////////////////////////////////
// Yes/Noタグ.
////////////////////////////////////////////////////////////////////////////////

YesNoTag = {
    // Yes,No表示.
    view : function( id,yes,no ) {
        if( isNull( id ) || isNumeric( id ) == false ) {
            return "" ;
        }
        if( useString( yes ) == false || useString( no ) == false ) {
            yes = "Yes" ;
            no = "No" ;
        }
        if( id == "1" ) {
            return no ;
        }
        else if( id == "2" ) {
            return yes ;
        }
        return "" ;
    },
    // Yes,NoのParam表示.
    viewParam : function( name,yes,no ) {
        if( useString( name ) == false ) {
            return "" ;
        }
        if( useString( yes ) == false || useString( no ) == false ) {
            yes = "Yes" ;
            no = "No" ;
        }
        var v = super._$script$query.get(name) ;
        if( v == "1" ) {
            return no ;
        }
        else if( v == "2" ) {
            return yes ;
        }
        return "" ;
    },
    // 有効・無効selectタグを生成.
    selectTag : function(name,yes,no) {
        if( isNull( name ) ) {
            return "" ;
        }
        if( useString( yes ) == false || useString( no ) == false ) {
            yes = "Yes" ;
            no = "No" ;
        }
        return selectTag( name,["","選択してください","2",yes,"1",no] ) ;
    },
    // Yes,Noラジオボタン.
    radioTag : function( name,yes,no,endPos ) {
        if( isNull( name ) ) {
            return "" ;
        }
        if( isEmpty( endPos ) ) {
            endPos = "" ;
        }
        if( useString( yes ) == false || useString( no ) == false ) {
            yes = "Yes" ;
            no = "No" ;
        }
        return createStrBuf().ad( radioTag( name,"2",name+"_yes_Id" ) ).
            ad( yes ).ad( endPos ).
            ad( radioTag( name,"1",name+"_no_Id" ) ).
            ad( no ).ad( endPos ).ts() ;
    }
} ;

////////////////////////////////////////////////////////////////////////////////
// 汎用Validateタグ(VTag-Frameworkで利用).
////////////////////////////////////////////////////////////////////////////////

BaseVTag = {
    // バッファクリア.
    exit : function() {
        context.remove( "_$validate_script" ) ;
    },
    // 汎用Validateタグを追加.
    addValidate : function( funcName,params,name,message,id,no ) {
        flg = false ;
        var buf = this._buf() ;
        buf.ad( funcName ).ad( "(" ) ;
        if( params != null ) {
            if( params instanceof java.util.List ) {
                len = params.length ;
                if( len > 0 ) {
                    for( i = 0 ; i < len ; i ++ ) {
                        if( flg ) {
                            buf.ad( "," ) ;
                        }
                        if( params[ i ] instanceof String ) {
                            buf.ad( "\"" ).ad( params[ i ] ).ad( "\"" ) ;
                        }
                        else {
                            buf.ad( encodeJSON( params[ i ] ) ) ;
                        }
                        flg = true ;
                    }
                }
                else {
                    buf.ad( "null" ) ;
                    flg = true ;
                }
            }
            else {
                if( params instanceof String ) {
                    buf.ad( "\"" ).ad( params ).ad( "\"" ) ;
                }
                else {
                    buf.ad( encodeJSON( params ) ) ;
                }
                flg = true ;
            }
        }
        if( !useString( no ) ) {
            no = 0 ;
        }
        if( flg ) {
            buf.ad( "," ) ;
        }
        if( !useString( id ) ) {
            buf.ad( "\"" ).ad( name ).ad( "\",\"" ).ad( message ).ad( "\",null," ).ad( no ).ad( ");\n" ) ;
        }
        else {
            buf.ad( "\"" ).ad( name ).ad( "\",\"" ).ad( message ).ad( "\",\"" ).ad( id ).ad( "\"," ).ad( no ).ad( ");\n" ) ;
        }
    },
    // 判別開始処理を追加.
    startIf : function( src,dest,mode ) {
        if( !useString( mode ) ) {
            mode = "==" ;
        }
        var buf = this._buf() ;
        buf.ad( "if ( " ).ad( src ).ad( " " ).ad( mode ).ad( " " ).ad( dest ).ad( " ) {\n" ) ;
    },
    // 判別終了処理を追加.
    endIf : function() {
        var buf = this._buf() ;
        buf.ad( "}\n" ) ;
    },
    // その他内容を追加.
    etcAdd : function( value ) {
        var buf = this._buf() ;
        buf.ad( value ) ;
        return buf ;
    },
    // 汎用Validateタグ群を取得.
    output : function() {
        var buf = context.get( "_$validate_script" ) ;
        if( buf == null ) {
            return null ;
        }
        context.remove( "_$validate_script" ) ;
        return buf.ts() ;
    },
    // バッファ取得.
    _buf : function() {
        var buf = context.get( "_$validate_script" ) ;
        if( buf == null ) {
            buf = new StrBuf() ;
            context.put( "_$validate_script",buf ) ;
        }
        return buf ;
    },
    // フォーム開始処理.
    _startForm : function( name ) {
        var buf = this._buf() ;
        buf.ad( "\ncase \"" ).ad( name ).ad( "\" : \n" ) ;
    },
    // フォーム終了処理.
    _endForm : function() {
        var buf = this._buf() ;
        buf.ad( "\nbreak;\n" ) ;
    }
}

////////////////////////////////////////////////////////////////////////////////
// 汎用Validateタグ(VLTag-Frameworkで利用).
////////////////////////////////////////////////////////////////////////////////

BaseVLTag = {
    // バッファ取得.
    _buf : function() {
        var buf = context.get( "_$validate_lite_script" ) ;
        if( buf == null ) {
            buf = new StrBuf() ;
            context.put( "_$validate_lite_script",buf ) ;
        }
        return buf ;
    },
    // バッファクリア.
    exit : function() {
        context.remove( "_$validate_lite_script" ) ;
    },
    // 汎用Validateタグ(BaseVTag継承)
    addValidate : BaseVTag.addValidate,
    // フォーム開始処理.
    _startForm : BaseVTag._startForm,
    // フォーム終了処理.
    _endForm : BaseVTag._endForm,
    // 汎用Validateタグ群を取得.
    output : function() {
        var buf = context.get( "_$validate_lite_script" ) ;
        if( buf == null ) {
            return null ;
        }
        context.remove( "_$validate_lite_script" ) ;
        return buf.ts() ;
    }
}
