// ユーティリティ関連.
//

Utils = {
    // 指定日付情報から、年齢を計算.
    calcAge : function( birthDate ) {
        if( isNull( date ) || typeof( date ) != "date" ) {
            return "" ;
        }
        var now = new Date() ;
        var ret = (now.getYear() - birthDate.getYear())+1900 ;
        if( now.getMonth() < birthDate.getMonth() ) {
            ret -- ;
        }
        else if( now.getMonth() == birthDate.getMonth() ) {
            if( now.getDate() < birthDate.getDate() ) {
                ret -- ;
            }
            else if( now.getDate() == birthDate.getDate() ) {
                if( now.getHours() < birthDate.getHours() ) {
                    ret -- ;
                }
                else if( now.getHours() == birthDate.getHours() ) {
                    if( now.getMinutes() < birthDate.getMinutes() ) {
                        ret -- ;
                    }
                    else if( now.getMinutes() == birthDate.getMinutes() ) {
                        if( now.getSeconds() < birthDate.getSeconds() ) {
                            ret -- ;
                        }
                    }
                }
            }
        }
        return ret ;
    },
    // 指定日から、対象日までの日数を計算.
    bitweenDate : function( src,dest ) {
        if( typeof( src ) != "date" || typeof( dest ) != "date" ) {
            return "" ;
        }
        var res = dest.getTime() - src.getTime() ;
        return parseInt( ( ( res / ( 24*60*60*1000) ) + 0.5 ) ) ;
    }
}

// 画像系処理.
Image = {
    // 画像情報を取得.
    _binary : function( data ) {
        if( isNull( data ) ) {
            return null ;
        }
        var bin = null ;
        if( data instanceof java.lang.String ) {
            var file = _$script$query.getOriginal( data ) ;
            if( isNull( file ) == false && file instanceof org.maachang.seabass.httpd.HttpdBinary ) {
                bin = paramBinary( data ) ;
            }
            else {
                return null ;
            }
        }
        else if( data instanceof byte[] ) {
            bin = data ;
        }
        else {
            return null ;
        }
    },
    // 指定画像に対するフォーマットを取得.
    getFormat : function( data ) {
        var bin = this._binary( data ) ;
        if( bin == null ) {
            return null ;
        }
        var ret = pkg( "org.maachang.seabass.httpd.engine.script.image.ImageUtil" ).getImageCodec( bin ) ;
        if( isNull( ret ) ) {
            return null ;
        }
        return convertString( ret ) ;
    },
    // 指定画像に対する解像度を取得.
    getSize : function( data ) {
        var bin = this._binary( data ) ;
        if( bin == null ) {
            return null ;
        }
        var res = pkg( "org.maachang.seabass.httpd.engine.script.image.ImageUtil" ).getImageWidthHeight( bin ) ;
        if( isNull( res ) ) {
            return null ;
        }
        return [ res[ 0 ],res[ 1 ] ] ;
    }
}

