// Validateスクリプト.
//

// 文字列判別.
var STR_NUMBER = 0x00000001 ;       // 数値判別.
var STR_ALPHABET = 0x00000002 ;     // アルファベット判別.
var STR_ASCII = 0x00000003 ;        // アスキー判別.
var STR_KANA = 0x00000004 ;         // カタカナ判別.
var STR_HIRA = 0x00000008 ;         // ひらがな判別.

// validateエラーフラグ管理.
validate_errorFlag = {
    // 内容をクリア.
    exit : function() {
        context.remove( "_$cache$validate$errorFlag" )
    },
    // エラーフラグを設定.
    on : function() {
        context.put( "_$cache$validate$errorFlag",true )
    },
    // エラーフラグを取得.
    get : function() {
        var ret = context.get( "_$cache$validate$errorFlag" ) ;
        if( ret == null ) {
            return false ;
        }
        return ret ;
    }
}

// validateエラー設定.
validate_errorMessage = function( message,id ) {
    setErrorMessage( message,id ) ;
    validate_errorFlag.on() ;
}

// validateエラー出力処理.
validate_error_out = function( message,name,no ) {
    var id = getId( name,no ) ;
    validate_errorMessage( message,id ) ;
}

// 正常メッセージ設定.
validate_successMessage = function( message,id ) {
    setSuccessMessage( message,id ) ;
}

// validate正常メッセージ出力処理.
validate_success_out = function( message,name,no ) {
    var id = getId( name,no ) ;
    validate_successMessage( message,id ) ;
}

// validateが利用可能かチェック.
useValidate = function() {
    return ( super.__$type$script == "script" && isNull( super._$script$query ) == false ) ;
} ;

// validate検知されたか取得.
is_validate = function() {
    if( useValidate() == true ) {
        return validate_errorFlag.get() ;
        //return isErrorMessage() ;
    }
    return false ;
} ;

// validate検知の場合のフォワード処理.
validate_forward = function( url ) {
    if( useValidate() == true && isErrorMessage() == true ) {
        forwardController( url ) ;
        return true ;
    }
    return false ;
} ;

// validate検知の場合のリダイレクト処理.
validate_redirect = function( url ) {
    if( useValidate() == true && isErrorMessage() == true ) {
        if( url.indexOf( "?" ) != -1 ) {
            redirect( url + "&" + convertMapToGetParams( params ) ) ;
        }
        else {
            redirect( url + "?" + convertMapToGetParams( params ) ) ;
        }
        return true ;
    }
    return false ;
} ;

// validate対象のパラメータを取得.
_validate_get_params = function( name,no ) {
    var src = getRequestParam( name,no ) ;
    if( src instanceof org.maachang.seabass.httpd.HttpdBinary ) {
        return src ;
    }
    else if( !useString( src ) ) {
        return "" ;
    }
    return src ;
}

// 文字列判別.
validate_string = function( type,name,message,id,no ) {
    if( !useString( name ) ) {
        return false ;
    }
    if( !isNumeric( type ) ) {
        type = 0 ;
    }
    if( useValidate() == true ) {
        if( !useString( id ) ) {
            id = getId( name,no ) ;
        }
        var src = _validate_get_params( name,no ) ;
        if( !useString( src ) ||
            src instanceof java.util.Map ||
            src instanceof java.util.List ||
            src instanceof org.maachang.seabass.httpd.HttpdBinary ) {
            setRequestParam( name,no,"" ) ;
            validate_errorMessage( message,id ) ;
            return true ;
        }
        var ret = pkg("org.maachang.seabass.httpd.engine.script.validate.BaseValidate").isString(
            type,src ) ;
        if( ret == true ) {
            setRequestParam( name,no,"" ) ;
            validate_errorMessage( message,id ) ;
        }
        return ret ;
    }
    return false ;
} ;

// 正規表現判別.
validate_match = function( match,name,message,id,no ) {
    if( !useString( match ) || !useString( name ) ) {
        return false ;
    }
    if( useValidate() == true ) {
        if( !useString( id ) ) {
            id = getId( name,no ) ;
        }
        var src = _validate_get_params( name,no ) ;
        if( !useString( src ) ||
            src instanceof java.util.Map ||
            src instanceof java.util.List ||
            src instanceof org.maachang.seabass.httpd.HttpdBinary ) {
            setRequestParam( name,no,"" ) ;
            validate_errorMessage( message,id ) ;
            return true ;
        }
        var ret = pkg("org.maachang.seabass.httpd.engine.script.validate.BaseValidate").isMatch( match,src ) ;
        if( ret == true ) {
            setRequestParam( name,no,"" ) ;
            validate_errorMessage( message,id ) ;
        }
        return ret ;
    }
    return false ;
} ;

// 日付判別.
validate_date = function( name,message,id,no ) {
    if( !useString( name ) ) {
        return false ;
    }
    if( useValidate() == true ) {
        if( !useString( id ) ) {
            id = getId( name,no ) ;
        }
        var src = _validate_get_params( name,no ) ;
        if( !useString( src ) ||
            src instanceof java.util.Map ||
            src instanceof java.util.List ||
            src instanceof org.maachang.seabass.httpd.HttpdBinary ) {
            setRequestParam( name,no,"" ) ;
            validate_errorMessage( message,id ) ;
            return true ;
        }
        src = convertString( src ) ;
        if( pkg("org.maachang.seabass.httpd.engine.script.validate.BaseValidate").isDate( src ) == true ) {
            setRequestParam( name,no,"" ) ;
            validate_errorMessage( message,id ) ;
            return true ;
        }
        // 正規表現チェック後、日付変換して、ずれがないかチェック.
        var dt = null ;
        var y = null ;
        var m = null ;
        var d = null ;
        try {
            if( useString( src ) == false ) {
                setRequestParam( name,no,"" ) ;
                validate_errorMessage( message,id ) ;
                return true ;
            }
            var b = 0 ;
            var p = src.indexOf( "/",b ) ;
            y = parseInt( src.substring( b,p ) ) ;
            b = p + 1 ;
            var p = src.indexOf( "/",b ) ;
            m = parseInt( src.substring( b,p ) ) ;
            b = p + 1 ;
            d = parseInt( src.substring( b ) ) ;
            dt = new JDate( y,m-1,d ) ;
        } catch( Exception e ) {
            setRequestParam( name,no,"" ) ;
            validate_errorMessage( message,id ) ;
            return true ;
        }
        if( dt.getFullYear() != y || (dt.getMonth()+1) != m || dt.getDate() != d ) {
            setRequestParam( name,no,"" ) ;
            validate_errorMessage( message,id ) ;
            return true ;
        }
    }
    return false ;
} ;

// 時間判別.
validate_time = function( name,message,id,no ) {
    if( !useString( name ) ) {
        return false ;
    }
    if( useValidate() == true ) {
        if( !useString( id ) ) {
            id = getId( name,no ) ;
        }
        var src = _validate_get_params( name,no ) ;
        if( !useString( src ) ||
            src instanceof java.util.Map ||
            src instanceof java.util.List ||
            src instanceof org.maachang.seabass.httpd.HttpdBinary ) {
            setRequestParam( name,no,"" ) ;
            validate_errorMessage( message,id ) ;
            return true ;
        }
        if( pkg("org.maachang.seabass.httpd.engine.script.validate.BaseValidate").isTime( src ) == true ) {
            setRequestParam( name,no,"" ) ;
            validate_errorMessage( message,id ) ;
            return true ;
        }
    }
    return false ;
} ;

// 郵便番号判別.
validate_zip = function( name,message,id,no ) {
    if( !useString( name ) ) {
        return false ;
    }
    if( useValidate() == true ) {
        if( !useString( id ) ) {
            id = getId( name,no ) ;
        }
        var src = _validate_get_params( name,no ) ;
        if( !useString( src ) ||
            src instanceof java.util.Map ||
            src instanceof java.util.List ||
            src instanceof org.maachang.seabass.httpd.HttpdBinary ) {
            setRequestParam( name,no,"" ) ;
            validate_errorMessage( message,id ) ;
            return true ;
        }
        var ret = pkg("org.maachang.seabass.httpd.engine.script.validate.BaseValidate").isZip( src ) ;
        if( ret == true ) {
            setRequestParam( name,no,"" ) ;
            validate_errorMessage( message,id ) ;
        }
        return ret ;
    }
    return false ;
} ;

// 電話番号判別.
validate_tel = function( name,message,id,no ) {
    if( !useString( name ) ) {
        return false ;
    }
    if( useValidate() == true ) {
        if( !useString( id ) ) {
            id = getId( name,no ) ;
        }
        var src = _validate_get_params( name,no ) ;
        if( !useString( src ) ||
            src instanceof java.util.Map ||
            src instanceof java.util.List ||
            src instanceof org.maachang.seabass.httpd.HttpdBinary ) {
            setRequestParam( name,no,"" ) ;
            validate_errorMessage( message,id ) ;
            return true ;
        }
        var ret = pkg("org.maachang.seabass.httpd.engine.script.validate.BaseValidate").isTel( src ) ;
        if( ret == true ) {
            setRequestParam( name,no,"" ) ;
            validate_errorMessage( message,id ) ;
        }
        return ret ;
    }
    return false ;
} ;

// ISBN番号判別.
validate_isbn = function( name,message,id,no ) {
    if( !useString( name ) ) {
        return false ;
    }
    if( useValidate() == true ) {
        if( !useString( id ) ) {
            id = getId( name,no ) ;
        }
        var src = _validate_get_params( name,no ) ;
        if( !useString( src ) ||
            src instanceof java.util.Map ||
            src instanceof java.util.List ||
            src instanceof org.maachang.seabass.httpd.HttpdBinary ) {
            setRequestParam( name,no,"" ) ;
            validate_errorMessage( message,id ) ;
            return true ;
        }
        var ret = pkg("org.maachang.seabass.httpd.engine.script.validate.BaseValidate").isIsbn( src ) ;
        if( ret == true ) {
            setRequestParam( name,no,"" ) ;
            validate_errorMessage( message,id ) ;
        }
        return ret ;
    }
    return false ;
} ;

// IPアドレス判別.
validate_ip = function( name,message,id,no ) {
    if( !useString( name ) ) {
        return false ;
    }
    if( useValidate() == true ) {
        if( !useString( id ) ) {
            id = getId( name,no ) ;
        }
        var src = _validate_get_params( name,no ) ;
        if( !useString( src ) ||
            src instanceof java.util.Map ||
            src instanceof java.util.List ||
            src instanceof org.maachang.seabass.httpd.HttpdBinary ) {
            setRequestParam( name,no,"" ) ;
            validate_errorMessage( message,id ) ;
            return true ;
        }
        var ret = pkg("org.maachang.seabass.httpd.engine.script.validate.BaseValidate").isIpAddress( src ) ;
        if( ret == true ) {
            setRequestParam( name,no,"" ) ;
            validate_errorMessage( message,id ) ;
        }
        return ret ;
    }
    return false ;
} ;

// URL判別.
validate_url = function( name,message,id,no ) {
    if( !useString( name ) ) {
        return false ;
    }
    if( useValidate() == true ) {
        if( !useString( id ) ) {
            id = getId( name,no ) ;
        }
        var src = _validate_get_params( name,no ) ;
        if( !useString( src ) ||
            src instanceof java.util.Map ||
            src instanceof java.util.List ||
            src instanceof org.maachang.seabass.httpd.HttpdBinary ) {
            setRequestParam( name,no,"" ) ;
            validate_errorMessage( message,id ) ;
            return true ;
        }
        var ret = pkg("org.maachang.seabass.httpd.engine.script.validate.BaseValidate").isUrl( src ) ;
        if( ret == true ) {
            setRequestParam( name,no,"" ) ;
            validate_errorMessage( message,id ) ;
        }
        return ret ;
    }
    return false ;
} ;

// E-MAIL判別.
validate_email = function( name,message,id,no ) {
    if( !useString( name ) ) {
        return false ;
    }
    if( useValidate() == true ) {
        if( !useString( id ) ) {
            id = getId( name,no ) ;
        }
        var src = _validate_get_params( name,no ) ;
        if( !useString( src ) ||
            src instanceof java.util.Map ||
            src instanceof java.util.List ||
            src instanceof org.maachang.seabass.httpd.HttpdBinary ) {
            setRequestParam( name,no,"" ) ;
            validate_errorMessage( message,id ) ;
            return true ;
        }
        var ret = pkg("org.maachang.seabass.httpd.engine.script.validate.BaseValidate").isEmail( src ) ;
        if( ret == true ) {
            setRequestParam( name,no,"" ) ;
            validate_errorMessage( message,id ) ;
        }
        return ret ;
    }
    return false ;
} ;

// 指定日付が現在時間より前かチェック.
validagte_nowDate = function( name,message,id,no ) {
    if( useString( name ) == false ) {
        return false ;
    }
    if( useValidate() == true ) {
        if( useString( id ) == false ) {
            id = getId( name,no ) ;
        }
        var y = _validate_get_params( name+"Year",no ) ;
        var m = _validate_get_params( name+"Month",no ) ;
        var d = _validate_get_params( name+"Day",no ) ;
        if( isNumeric( y ) == false ||
            isNumeric( m ) == false ||
            isNumeric( d ) == false ) {
            setRequestParam( name+"Year",no,"" ) ;
            setRequestParam( name+"Month",no,"" ) ;
            setRequestParam( name+"Day",no,"" ) ;
            validate_errorMessage( message,id ) ;
            return true ;
        }
        var check = new JDate( parseInt( y ),parseInt( m )-1,parseInt( d ) ) ;
        if( currentTime() >= check.getTime() ) {
            setRequestParam( name+"Year",no,"" ) ;
            setRequestParam( name+"Month",no,"" ) ;
            setRequestParam( name+"Day",no,"" ) ;
            validate_errorMessage( message,id ) ;
            return true ;
        }
    }
    return false ;
}

// 指定日付が、対象名の内容より前かチェック.
validate_dateBySrcDest = function( src,dest,message,id,no ) {
    if( useString( src ) == false || useString( dest ) == false ) {
        return false ;
    }
    if( useValidate() == true ) {
        if( useString( id ) == false ) {
            id = getId( name,no ) ;
        }
        var sy = _validate_get_params( src+"Year",no ) ;
        var sm = _validate_get_params( src+"Month",no ) ;
        var sd = _validate_get_params( src+"Day",no ) ;
        var dy = _validate_get_params( dest+"Year",no ) ;
        var dm = _validate_get_params( dest+"Month",no ) ;
        var dd = _validate_get_params( dest+"Day",no ) ;
        if( isNumeric( sy ) == false || isNumeric( sm ) == false || isNumeric( sd ) == false ||
            isNumeric( dy ) == false || isNumeric( dm ) == false || isNumeric( dd ) == false ) {
            setRequestParam( src+"Year",no,"" ) ;
            setRequestParam( src+"Month",no,"" ) ;
            setRequestParam( src+"Day",no,"" ) ;
            validate_errorMessage( message,id ) ;
            return true ;
        }
        var srcTime = new JDate( parseInt( sy ),parseInt( sm )-1,parseInt( sd ) ) ;
        var destTime = new JDate( parseInt( dy ),parseInt( dm )-1,parseInt( dd ) ) ;
        if( srcTime.getTime() >= destTime.getTime() ) {
            setRequestParam( src+"Year",no,"" ) ;
            setRequestParam( src+"Month",no,"" ) ;
            setRequestParam( src+"Day",no,"" ) ;
            validate_errorMessage( message,id ) ;
            return true ;
        }
    }
    return false ;
}

// 画像ファイル拡張子判別.
validate_image = function( name,message,id,no ) {
    if( useString( name ) == false ) {
        return false ;
    }
    if( useValidate() == true ) {
        if( useString( id ) == false ) {
            id = getId( name,no ) ;
        }
        var src = _validate_get_params( name,no ) ;
        if( isNull( file ) == false && file instanceof org.maachang.seabass.httpd.HttpdBinary ) {
            file = file.getOriginalName() ;
        }
        else {
            file = parseValue( file ) ;
        }
        // 拡張子チェック.
        if( endsWith( file,".jpeg" ) == false &&
            endsWith( file,".jpg" ) == false &&
            endsWith( file,".jpe" ) == false &&
            endsWith( file,".jfif" ) == false &&
            endsWith( file,".jfi" ) == false &&
            endsWith( file,".gif" ) == false &&
            endsWith( file,".png" ) == false ) {
            setRequestParam( name,no,"" ) ;
            validate_errorMessage( message,id ) ;
            return true ;
        }
        // バイナリデータとしての処理かチェック.
        var binPlus = Image.getFormat( name ) ;
        if( isNull( binPlus ) ) {
            return false ;
        }
        // 実際のバイナリ内容と比較して、拡張子と一致する内容かチェック.
        if( binPlus == "jpeg" || binPlus == "gif" || binPlus == "png" ) {
            if( binPlus == "jpeg" &&
                endsWith( file,".jpeg" ) == false &&
                endsWith( file,".jpg" ) == false &&
                endsWith( file,".jpe" ) == false &&
                endsWith( file,".jfif" ) == false &&
                endsWith( file,".jfi" ) == false ) {
                setRequestParam( name,no,"" ) ;
                validate_errorMessage( message,id ) ;
                return true ;
            }
            else if( binPlus == "gif" &&
                endsWith( file,".gif" ) == false ) {
                setRequestParam( name,no,"" ) ;
                validate_errorMessage( message,id ) ;
                return true ;
            }
            else if( binPlus == "png" &&
                endsWith( file,".png" ) == false ) {
                setRequestParam( name,no,"" ) ;
                validate_errorMessage( message,id ) ;
                return true ;
            }
        }
        else {
            setRequestParam( name,no,"" ) ;
            validate_errorMessage( message,id ) ;
            return true ;
        }
    }
    return false ;
}

// 画像サイズ上限チェック.
validate_iamgeSize = function( width,height,name,message,id,no ) {
    if( useString( name ) == false ) {
        return false ;
    }
    if( useValidate() == true ) {
        if( useString( id ) == false ) {
            id = getId( name,no ) ;
        }
        var bin = paramBinary( name,no ) ;
        var ret = pkg("org.maachang.seabass.httpd.engine.script.validate.BaseValidate").isImageWidthHeight( bin,width,height ) ;
        if( ret ) {
            setRequestParam( name,no,"" ) ;
            validate_errorMessage( message,id ) ;
        }
        return ret ;
    }
    return false ;
}

// 指定アップロードファイルサイズ上限チェック.
validate_uploadSize = function( size,name,message,id,no ) {
    if( isNumeric( size ) == false || useString( name ) == false ) {
        return false ;
    }
    if( useValidate() == true ) {
        if( useString( id ) == false ) {
            id = getId( name,no ) ;
        }
        size = parseValue( size ) ;
        var len = parseInt( paramBinaryLength( name,no ) ) ;
        if( size < len ) {
            setRequestParam( name,no,"" ) ;
            validate_errorMessage( message,id ) ;
            return true ;
        }
    }
    return false ;
}

// 指定拡張子判別.
validate_fileNamePlus = function( plus,name,message,id,no ) {
    if( useString( name ) == false ) {
        return false ;
    }
    if( useValidate() == true ) {
        if( useString( id ) == false ) {
            id = getId( name,no ) ;
        }
        var file = _validate_get_params( name,no ) ;
        if( isNull( file ) == false && file instanceof org.maachang.seabass.httpd.HttpdBinary ) {
            file = file.getOriginalName() ;
        }
        else {
            file = parseValue( file ) ;
        }
        if( useString( file ) == false ) {
            setRequestParam( name,no,"" ) ;
            validate_errorMessage( message,id ) ;
            return true ;
        }
        if( plus.indexOf( "," ) != -1 ) {
            var t = plus.split( "," ) ;
            var len = t.length ;
            var errFlag = true ;
            for( var i = 0 ; i < len ; i ++ ) {
                var x = t[ i ] ;
                if( startsWith( x,"." ) == false ) {
                    x = "." + x ;
                }
                if( endsWith( file,x ) == true ) {
                    errFlag = false ;
                    break ;
                }
            }
            if( errFlag ) {
                setRequestParam( name,no,"" ) ;
                validate_errorMessage( message,id ) ;
                return true ;
            }
        }
        else {
            if( startsWith( plus,"." ) == false ) {
                plus = "." + plus ;
            }
            if( endsWith( file,plus ) == false ) {
                setRequestParam( name,no,"" ) ;
                validate_errorMessage( message,id ) ;
                return true ;
            }
        }
    }
    return false ;
}

// 開始判別.
validate_startsWith = function( src,name,message,id,no ) {
    if( useString( src ) == false || useString( name ) == false ) {
        return false ;
    }
    if( useValidate() == true ) {
        if( useString( id ) == false ) {
            id = getId( name,no ) ;
        }
        var d = _validate_get_params( name,no ) ;
        if( startsWith( d,src ) == false ) {
            setRequestParam( name,no,"" ) ;
            setErrorMessage( message,id ) ;
            return true ;
        }
    }
    return false ;
}

// 終了判別.
validate_endsWith = function( src,name,message,id,no ) {
    if( useString( src ) == false || useString( name ) == false ) {
        return false ;
    }
    if( useValidate() == true ) {
        if( useString( id ) == false ) {
            id = getId( name,no ) ;
        }
        var d = _validate_get_params( name,no ) ;
        if( endsWith( d,src ) == false ) {
            setRequestParam( name,no,"" ) ;
            setErrorMessage( message,id ) ;
            return true ;
        }
    }
    return false ;
}

// Binary判別(最大値).
validate_binary = function( size,name,message,id,no ) {
    if( useString( name ) == false ) {
        return false ;
    }
    if( useValidate() == true ) {
        if( useString( id ) == false ) {
            id = getId( name,no ) ;
        }
        var src = paramBinary( name,no ) ;
        if( isNumeric( size ) == true ) {
            if( binaryLength( src ) >= size ) {
                setRequestParam( name,no,"" ) ;
                setErrorMessage( message,id ) ;
                return true ;
            }
        }
        else {
            if( isNull( src ) ) {
                setRequestParam( name,no,"" ) ;
                setErrorMessage( message,id ) ;
                return true ;
            }
        }
    }
    return false ;
} ;

// Binary判別(最小値).
validate_min_binary = function( size,name,message,id,no ) {
    if( useString( name ) == false ) {
        return false ;
    }
    if( useValidate() == true ) {
        if( useString( id ) == false ) {
            id = getId( name,no ) ;
        }
        var src = paramBinary( name,no ) ;
        if( isNumeric( size ) == true ) {
            if( binaryLength( src ) < size ) {
                setRequestParam( name,no,"" ) ;
                setErrorMessage( message,id ) ;
                return true ;
            }
        }
        else {
            if( isNull( src ) ) {
                setRequestParam( name,no,"" ) ;
                setErrorMessage( message,id ) ;
                return true ;
            }
        }
    }
    return false ;
} ;

// 指定条件非存在チェック.
validate_no_use = function( name,message,id,no ) {
    if( useString( name ) == false ) {
        return false ;
    }
    if( useValidate() == true ) {
        if( useString( id ) == false ) {
            id = getId( name,no ) ;
        }
        var src = _validate_get_params( name,no ) ;
        if( useEmpty( src ) == false ) {
            setRequestParam( name,no,"" ) ;
            setErrorMessage( message,id ) ;
            return true ;
        }
    }
    return false ;
} ;

// 指定条件存在チェック.
validate_use = function( name,message,id,no ) {
    if( useString( name ) == false ) {
        return false ;
    }
    if( useValidate() == true ) {
        if( useString( id ) == false ) {
            id = getId( name,no ) ;
        }
        var src = _validate_get_params( name,no ) ;
        if( useEmpty( src ) ) {
            setRequestParam( name,no,"" ) ;
            setErrorMessage( message,id ) ;
            return true ;
        }
    }
    return false ;
} ;

// 指定条件が、指定数より少ないかチェック.
validate_min = function( size,name,message,id,no ) {
    if( isNumeric( size ) == false || useString( name ) == false ) {
        return false ;
    }
    if( useValidate() == true ) {
        if( useString( id ) == false ) {
            id = getId( name,no ) ;
        }
        var len = 0 ;
        var src = _validate_get_params( name,no ) ;
        if( !useString( src ) ) {
            len = 0 ;
        }
        else {
            len = src.length ;
        }
        if( size > len ) {
            setRequestParam( name,no,"" ) ;
            setErrorMessage( message,id ) ;
            return true ;
        }
    }
    return false ;
} ;

// 指定条件が、指定数より多いかチェック.
validate_max = function( size,name,message,id,no ) {
    if( isNumeric( size ) == false || !useString( name ) ) {
        return false ;
    }
    if( useValidate() == true ) {
        if( useString( id ) == false ) {
            id = getId( name,no ) ;
        }
        var len = 0 ;
        var src = _validate_get_params( name,no ) ;
        if( !useString( src ) ) {
            len = 0 ;
        }
        else {
            len = src.length ;
        }
        if( size < len ) {
            setRequestParam( name,no,"" ) ;
            setErrorMessage( message,id ) ;
            return true ;
        }
    }
    return false ;
} ;

// 指定条件が、指定数より多い／少ないかチェック.
validate_minMax = function( min,max,name,message,id,no ) {
    if( isNumeric( min ) == false || isNumeric( max ) == false|| useString( name ) == false ) {
        return false ;
    }
    if( useValidate() == true ) {
        if( useString( id ) == false ) {
            id = getId( name,no ) ;
        }
        var len = 0 ;
        var src = _validate_get_params( name,no ) ;
        if( !useString( src ) ) {
            len = 0 ;
        }
        else {
            len = src.length ;
        }
        if( min >len || max < len ) {
            setRequestParam( name,no,"" ) ;
            setErrorMessage( message,id ) ;
            return true ;
        }
    }
    return false ;
}

