// Validateタグ関連.
// (VTag-Framework).
// 

// Validateタグオブジェクト.
VTag = {
    // 出力判別.
    _outputValidateBuffer : function() {
        return _$$seabass_manager.get( "VALIDATE_CACHE_MANAGER" ).contains( getMTHMLPath() ) ;
    },
    // Validate存在確認.
    isValidate : function( path ) {
        if( path instanceof String ) {
            if( !path.startsWith( "/" ) ) {
                path = toFullUrl( path ) ;
            }
            if( path.endsWith( ".mhtml" ) == false ) {
                path += ".mhtml" ;
            }
            return _$$seabass_manager.get( "VALIDATE_CACHE_MANAGER" ).contains( getMTHMLPath() ) ;
        }
        return false ;
    },
    // Validateスクリプト実行.
    validate : function( path ) {
        if( path instanceof String ) {
            if( !path.startsWith( "/" ) ) {
                path = toFullUrl( path ) ;
            }
            if( path.endsWith( ".mhtml" ) == false ) {
                path += ".mhtml" ;
            }
            if( _$$seabass_manager.get( "VALIDATE_CACHE_MANAGER" ).validate( path,context ) == false ) {
                if( path.endsWith( ".mhtml" ) ) {
                    path = path.substring( 0,path.length - ".mhtml".length ) ;
                }
                //redirect( path ) ;
                forwardController( path ) ;
            }
            return super.is_validate() ;
        }
        return false ;
    },
    // Validateスクリプト変換.
    flush : function() {
        var mhtmlPath = getMTHMLPath() ;
        script = BaseVTag.output() ;
        if( useString( script ) ) {
            _$$seabass_manager.get( "VALIDATE_CACHE_MANAGER" ).add( mhtmlPath,script ) ;
        }
        return "" ;
    },
    // validateJavascript呼び出し.
    loadValidate : function() {
        //return "<script language='javascript' type='text/javascript' charset='utf-8' src='/js/seabass-min.js?t="+currentTime()+"'></script>\n" +
        //    "<script language='javascript' type='text/javascript' charset='utf-8' src='/@js/validate" +
        //    getMTHMLPath() + ".js?t="+currentTime()+"'></script>\n" ;
        return "<script language='javascript' type='text/javascript' charset='utf-8' src='/@js/validate" +
            getMTHMLPath() + ".js?t="+currentTime()+"'></script>\n" ;
    },
    // 開始フォーム.
    startForm : function( action,name,method,target,etc ) {
        var ret = startForm( action,name,method,target,etc ) ;
        if( !VTag._outputValidateBuffer() ) {
            if( !useString( name ) ) {
                v = UnknownFormCache.get() ;
                name = "uform_name_" + v ;
            }
            BaseVTag._startForm( name ) ;
        }
        return ret ;
    },
    // 開始MultiPartフォーム.
    multiForm : function( action,name,target,etc ) {
        var ret = multiForm( action,name,target,etc ) ;
        if( !VTag._outputValidateBuffer() ) {
            if( !useString( name ) ) {
                v = UnknownFormCache.get() ;
                name = "uform_name_" + v ;
            }
            BaseVTag._startForm( name ) ;
        }
        return ret ;
    },
    // 終了フォーム.
    endForm : function( mode ) {
        var ret = endForm( mode ) ;
        if( !VTag._outputValidateBuffer() ) {
            BaseVTag._endForm() ;
        }
        return ret ;
    },
    // submitボタン.
    submit : function( formName,buttonName,id,clazz,message ) {
        if( !useString( formName ) ) {
            formName = FormNameCache.get() ;
        }
        if( useString( message ) ) {
            Event.onclick( "validate_submit_conf(\""+formName+"\",\""+message+"\");" ) ;
        }
        else {
            Event.onclick( "validate_submit(\""+formName+"\");" ) ;
        }
        return button( buttonName,null,null,id,clazz ) ;
    },
    // submitボタン.
    submitByConfirmation : function( formName,message,buttonName,id,clazz ) {
        if( !useString( formName ) ) {
            formName = FormNameCache.get() ;
        }
        Event.onclick( "validate_submit_conf(\""+formName+"\",\""+message+"\");" ) ;
        return button( buttonName,null,null,id,clazz ) ;
    },
    // 画像submitボタン.
    imgSubmit : function( formName,name,src,alt,border,width,height,cmode,id,clazz,message ) {
        if( !useString( formName ) ) {
            formName = FormNameCache.get() ;
        }
        if( useString( message ) ) {
            Event.onclick( "validate_submit_conf(\""+formName+"\",\""+message+"\");" ) ;
        }
        else {
            Event.onclick( "validate_submit(\""+formName+"\");" ) ;
        }
        return imgButton( name,src,alt,border,width,height,null,cmode,id,clazz ) ;
    },
    // 画像submitボタン.
    imgSubmitByConfirmation : function( formName,message,name,src,alt,border,width,height,cmode,id,clazz ) {
        if( !useString( formName ) ) {
            formName = FormNameCache.get() ;
        }
        Event.onclick( "validate_submit_conf(\""+formName+"\",\""+message+"\");" ) ;
        return imgButton( name,src,alt,border,width,height,null,cmode,id,clazz ) ;
    },
    // 必須入力チェック.
    requiredTag : function( message,name,id,clazz,size,max,style,defaultIme,etc ) {
        if( useString( name ) ) {
            ret = textTag( name,id,clazz,size,max,style,defaultIme,etc ) ;
            if( !VTag._outputValidateBuffer() ) {
                BaseVTag.addValidate( "validate_no_use",null,name,message,id,getIdNum( name ) ) ;
            }
            return ret ;
        }
        return "" ;
    },
    // 必須入力(password)チェック.
    requiredPasswdTag : function( message,name,id,clazz,size,max,style,defaultIme,etc ) {
        if( useString( name ) ) {
            ret = passwordTag( name,id,clazz,size,max,style,defaultIme,etc ) ;
            if( !VTag._outputValidateBuffer() ) {
                BaseVTag.addValidate( "validate_no_use",null,name,message,id,getIdNum( name ) ) ;
            }
            return ret ;
        }
        return "" ;
    },
    // 必須入力(TextArea)チェック.
    requiredAreaTag : function( message,name,id,clazz,cols,rows,style,defaultIme,etc ) {
        if( useString( name ) ) {
            ret = textAreaTag( name,id,clazz,cols,rows,style,defaultIme,etc ) ;
            if( !VTag._outputValidateBuffer() ) {
                BaseVTag.addValidate( "validate_no_use",null,name,message,id,getIdNum( name ) ) ;
            }
            return ret ;
        }
        return "" ;
    },
    // 汎用文字列判別.
    stringTag : function( message,args,name,id,clazz,size,max,style,defaultIme,etc ) {
        if( useString( name ) ) {
            ret = textTag( name,id,clazz,size,max,style,defaultIme,etc ) ;
            if( !VTag._outputValidateBuffer() ) {
                BaseVTag.addValidate( "validate_string",args,name,message,id,getIdNum( name ) ) ;
            }
            return ret ;
        }
        return "" ;
    },
    // 数値判別.
    numberTag : function( message,name,id,clazz,size,max,style,defaultIme,etc ) {
        if( useString( name ) ) {
            ret = textTag( name,id,clazz,size,max,style,defaultIme,etc ) ;
            if( !VTag._outputValidateBuffer() ) {
                BaseVTag.addValidate( "validate_string",STR_NUMBER,name,message,id,getIdNum( name ) ) ;
            }
            return ret ;
        }
        return "" ;
    },
    // アルファベット判別.
    alphabetTag : function( message,name,id,clazz,size,max,style,defaultIme,etc ) {
        if( useString( name ) ) {
            ret = textTag( name,id,clazz,size,max,style,defaultIme,etc ) ;
            if( !VTag._outputValidateBuffer() ) {
                BaseVTag.addValidate( "validate_string",STR_ALPHABET,name,message,id,getIdNum( name ) ) ;
            }
            return ret ;
        }
        return "" ;
    },
    // ASCII判別.
    asciiTag : function( message,name,id,clazz,size,max,style,defaultIme,etc ) {
        if( useString( name ) ) {
            ret = textTag( name,id,clazz,size,max,style,defaultIme,etc ) ;
            if( !VTag._outputValidateBuffer() ) {
                BaseVTag.addValidate( "validate_string",STR_ASCII,name,message,id,getIdNum( name ) ) ;
            }
            return ret ;
        }
        return "" ;
    },
    // カナ判別.
    kanaTag : function( message,name,id,clazz,size,max,style,defaultIme,etc ) {
        if( useString( name ) ) {
            ret = textTag( name,id,clazz,size,max,style,defaultIme,etc ) ;
            if( !VTag._outputValidateBuffer() ) {
                BaseVTag.addValidate( "validate_string",STR_KANA,name,message,id,getIdNum( name ) ) ;
            }
            return ret ;
        }
        return "" ;
    },
    // ひらがな判別.
    hiraTag : function( message,name,id,clazz,size,max,style,defaultIme,etc ) {
        if( useString( name ) ) {
            ret = textTag( name,id,clazz,size,max,style,defaultIme,etc ) ;
            if( !VTag._outputValidateBuffer() ) {
                BaseVTag.addValidate( "validate_string",STR_HIRA,name,message,id,getIdNum( name ) ) ;
            }
            return ret ;
        }
        return "" ;
    },
    // 正規表現判別.
    matchTag : function( message,match,name,id,clazz,size,max,style,defaultIme,etc ) {
        if( useString( name ) ) {
            ret = textTag( name,id,clazz,size,max,style,defaultIme,etc ) ;
            if( !VTag._outputValidateBuffer() ) {
                BaseVTag.addValidate( "validate_match",match,name,message,id,getIdNum( name ) ) ;
            }
            return ret ;
        }
        return "" ;
    },
    // 日付フォーマット判別.
    dateTag : function( message,name,id,clazz,size,max,style,defaultIme,etc ) {
        if( useString( name ) ) {
            ret = textTag( name,id,clazz,size,max,style,defaultIme,etc ) ;
            if( !VTag._outputValidateBuffer() ) {
                BaseVTag.addValidate( "validate_date",null,name,message,id,getIdNum( name ) ) ;
            }
            return ret ;
        }
        return "" ;
    },
    // 時間フォーマット判別.
    timeTag : function( message,name,id,clazz,size,max,style,defaultIme,etc ) {
        if( useString( name ) ) {
            ret = textTag( name,id,clazz,size,max,style,defaultIme,etc ) ;
            if( !VTag._outputValidateBuffer() ) {
                BaseVTag.addValidate( "validate_time",null,name,message,id,getIdNum( name ) ) ;
            }
            return ret ;
        }
        return "" ;
    },
    // 郵便番号判別.
    zipTag : function( message,name,id,clazz,size,max,style,defaultIme,etc ) {
        if( useString( name ) ) {
            ret = textTag( name,id,clazz,size,max,style,defaultIme,etc ) ;
            if( !VTag._outputValidateBuffer() ) {
                BaseVTag.addValidate( "validate_zip",null,name,message,id,getIdNum( name ) ) ;
            }
            return ret ;
        }
        return "" ;
    },
    // 電話番号判別.
    telTag : function( message,name,id,clazz,size,max,style,defaultIme,etc ) {
        if( useString( name ) ) {
            ret = textTag( name,id,clazz,size,max,style,defaultIme,etc ) ;
            if( !VTag._outputValidateBuffer() ) {
                BaseVTag.addValidate( "validate_tel",null,name,message,id,getIdNum( name ) ) ;
            }
            return ret ;
        }
        return "" ;
    },
    // ISBN番号判別.
    isbnTag : function( message,name,id,clazz,size,max,style,defaultIme,etc ) {
        if( useString( name ) ) {
            ret = textTag( name,id,clazz,size,max,style,defaultIme,etc ) ;
            if( !VTag._outputValidateBuffer() ) {
                BaseVTag.addValidate( "validate_isbn",null,name,message,id,getIdNum( name ) ) ;
            }
            return ret ;
        }
        return "" ;
    },
    // IPアドレス判別.
    ipTag : function( message,name,id,clazz,size,max,style,defaultIme,etc ) {
        if( useString( name ) ) {
            ret = textTag( name,id,clazz,size,max,style,defaultIme,etc ) ;
            if( !VTag._outputValidateBuffer() ) {
                BaseVTag.addValidate( "validate_ip",null,name,message,id,getIdNum( name ) ) ;
            }
            return ret ;
        }
        return "" ;
    },
    // URL判別.
    urlTag : function( message,name,id,clazz,size,max,style,defaultIme,etc ) {
        if( useString( name ) ) {
            ret = textTag( name,id,clazz,size,max,style,defaultIme,etc ) ;
            if( !VTag._outputValidateBuffer() ) {
                BaseVTag.addValidate( "validate_url",null,name,message,id,getIdNum( name ) ) ;
            }
            return ret ;
        }
        return "" ;
    },
    // EMail判別.
    emailTag : function( message,name,id,clazz,size,max,style,defaultIme,etc ) {
        if( useString( name ) ) {
            ret = textTag( name,id,clazz,size,max,style,defaultIme,etc ) ;
            if( !VTag._outputValidateBuffer() ) {
                BaseVTag.addValidate( "validate_email",null,name,message,id,getIdNum( name ) ) ;
            }
            return ret ;
        }
        return "" ;
    },
    // 情報判別開始処理.
    startIf : function( src,dest,mode,value ) {
        if( !VTag._outputValidateBuffer() ) {
            if( useString( value ) ) {
                BaseVTag.etcAdd( "if ( " + value + " ) {\n" ) ;
            }
            else {
                BaseVTag.startIf( src,dest,mode ) ;
            }
        }
        return "" ;
    },
    // 情報判別終了処理.
    endIf : function() {
        if( !VTag._outputValidateBuffer() ) {
            BaseVTag.endIf() ;
        }
        return "" ;
    },
    // パラメータ判別開始処理.
    startParamIf : function( name,value,mode ) {
        BaseVTag.startIf( "$$(\""+name+"Id\")",value,mode ) ;
    },
    // パラメータ判別終了処理.
    endParamIf : function() {
        if( !VTag._outputValidateBuffer() ) {
            BaseVTag.endIf() ;
        }
        return "" ;
    },
    // TOP出力.
    topError : function( message ) {
        if( useString( message ) ) {
            if( !VTag._outputValidateBuffer() ) {
                BaseVTag.etcAdd( "\nif( is_validate() ) { setErrorMessage(\"" ).
                    ad( message ).ad( "\",\"top\") ; }\n" ) ;
            }
            return "" ;
        }
        else {
            return errorTag( "top" ) ;
        }
    },
    // エラーメッセージ出力先.
    outError : function( name,id,no ) {
        if( useString( name ) ) {
            if( !useString( id ) ) {
                id = getId( name,no ) ;
            }
            return errorTag( id ) ;
        }
        return "" ;
    },
    // 必須入力チェック.
    toRequired : function( message,name,id,no ) {
        if( useString( name ) && !VTag._outputValidateBuffer() ) {
            BaseVTag.addValidate( "validate_no_use",null,name,message,id,no ) ;
        }
        return "" ;
    },
    // 汎用文字列チェック.
    toStringTag : function( message,args,name,id,no ) {
        if( useString( name ) && !VTag._outputValidateBuffer() ) {
            BaseVTag.addValidate( "validate_string",args,name,message,id,no ) ;
        }
        return "" ;
    },
    // 数値チェック.
    toNumberTag : function( message,name,id,no ) {
        if( useString( name ) && !VTag._outputValidateBuffer() ) {
            BaseVTag.addValidate( "validate_string",STR_NUMBER,name,message,id,no ) ;
        }
        return "" ;
    },
    // アルファベットチェック.
    toAlphabetTag : function( message,name,id,no ) {
        if( useString( name ) && !VTag._outputValidateBuffer() ) {
            BaseVTag.addValidate( "validate_string",STR_ALPHABET,name,message,id,no ) ;
        }
        return "" ;
    },
    // ASCIIチェック.
    toAsciiTag : function( message,name,id,no ) {
        if( useString( name ) && !VTag._outputValidateBuffer() ) {
            BaseVTag.addValidate( "validate_string",STR_ASCII,name,message,id,no ) ;
        }
        return "" ;
    },
    // カナチェック.
    toKanaTag : function( message,name,id,no ) {
        if( useString( name ) && !VTag._outputValidateBuffer() ) {
            BaseVTag.addValidate( "validate_string",STR_KANA,name,message,id,no ) ;
        }
        return "" ;
    },
    // ひらがなチェック.
    toHiraTag : function( message,name,id,no ) {
        if( useString( name ) && !VTag._outputValidateBuffer() ) {
            BaseVTag.addValidate( "validate_string",STR_HIRA,name,message,id,no ) ;
        }
        return "" ;
    },
    // 正規表現チェック.
    toMatchTag : function( message,match,name,id,no ) {
        if( useString( name ) && !VTag._outputValidateBuffer() ) {
            BaseVTag.addValidate( "validate_match",match,name,message,id,no ) ;
        }
        return "" ;
    },
    // 日付フォーマットチェック.
    toDateTag : function( message,name,id,no ) {
        if( useString( name ) && !VTag._outputValidateBuffer() ) {
            BaseVTag.addValidate( "validate_date",null,name,message,id,no ) ;
        }
        return "" ;
    },
    // 時間フォーマットチェック.
    toTimeTag : function( message,name,id,no ) {
        if( useString( name ) && !VTag._outputValidateBuffer() ) {
            BaseVTag.addValidate( "validate_time",null,name,message,id,no ) ;
        }
        return "" ;
    },
    // 郵便番号チェック.
    toZipTag : function( message,name,id,no ) {
        if( useString( name ) && !VTag._outputValidateBuffer() ) {
            BaseVTag.addValidate( "validate_zip",null,name,message,id,no ) ;
        }
        return "" ;
    },
    // 電話番号チェック.
    toTelTag : function( message,name,id,no ) {
        if( useString( name ) && !VTag._outputValidateBuffer() ) {
            BaseVTag.addValidate( "validate_tel",null,name,message,id,no ) ;
        }
        return "" ;
    },
    // ISBN番号チェック.
    toIsbnTag : function( message,name,id,no ) {
        if( useString( name ) && !VTag._outputValidateBuffer() ) {
            BaseVTag.addValidate( "validate_isbn",null,name,message,id,no ) ;
        }
        return "" ;
    },
    // IPアドレスチェック.
    toIpTag : function( message,name,id,no ) {
        if( useString( name ) && !VTag._outputValidateBuffer() ) {
            BaseVTag.addValidate( "validate_ip",null,name,message,id,no ) ;
        }
        return "" ;
    },
    // URLチェック.
    toUrlTag : function( message,name,id,no ) {
        if( useString( name ) && !VTag._outputValidateBuffer() ) {
            BaseVTag.addValidate( "validate_url",null,name,message,id,no ) ;
        }
        return "" ;
    },
    // EMailチェック.
    toEmailTag : function( message,name,id,no ) {
        if( useString( name ) && !VTag._outputValidateBuffer() ) {
            BaseVTag.addValidate( "validate_email",null,name,message,id,no ) ;
        }
        return "" ;
    },
    // 文字列長最小値判別.
    toMinString : function( message,size,name,id,no ) {
        if( useString( name ) && !VTag._outputValidateBuffer() ) {
            BaseVTag.addValidate( "validate_min",size,name,message,id,no ) ;
        }
        return "" ;
    },
    // 文字列長最大値判別.
    toMaxString : function( message,size,name,id,no ) {
        if( useString( name ) && !VTag._outputValidateBuffer() ) {
            BaseVTag.addValidate( "validate_max",size,name,message,id,no ) ;
        }
        return "" ;
    },
    // 文字列長範囲判別.
    toMinMaxString : function( message,min,max,name,id,no ) {
        if( useString( name ) && !VTag._outputValidateBuffer() ) {
            BaseVTag.addValidate( "validate_minMax",[min,max],name,message,id,no ) ;
        }
        return "" ;
    },
    // 指定日付が現在時間より前かチェック.
    toNowDate : function( message,name,id,no ) {
        if( useString( name ) && !VTag._outputValidateBuffer() ) {
            BaseVTag.addValidate( "validagte_nowDate",null,name,message,id,no ) ;
        }
        return "" ;
    },
    // 指定日付が、対象名の内容より前かチェック.
    toTagetDate : function( message,target,name,id,no ) {
        if( useString( name ) && !VTag._outputValidateBuffer() ) {
            BaseVTag.addValidate( "validate_dateBySrcDest",name,target,message,id,no ) ;
        }
        return "" ;
    },
    // 画像拡張子判別.
    toImage : function( message,name,id,no ) {
        if( useString( name ) && !VTag._outputValidateBuffer() ) {
            BaseVTag.addValidate( "validate_image",null,name,message,id,no ) ;
        }
        return "" ;
    },
    // 画像サイズチェック.
    toRectImage : function( message,width,height,name,id,no ) {
        if( useString( name ) && !VTag._outputValidateBuffer() ) {
            BaseVTag.addValidate( "validate_iamgeSize",[width,height],name,message,id,no ) ;
        }
        return "" ;
    },
    // アップロード画像サイズチェック.
    toUploadLength : function( message,size,name,id,no ) {
        if( useString( name ) && !VTag._outputValidateBuffer() ) {
            BaseVTag.addValidate( "validate_uploadSize",size,name,message,id,no ) ;
        }
        return "" ;
    },
    // 拡張子判別.
    toPlus : function( message,plus,name,id,no ) {
        if( useString( name ) && !VTag._outputValidateBuffer() ) {
            BaseVTag.addValidate( "validate_fileNamePlus",plus,name,message,id,no ) ;
        }
        return "" ;
    },
    // 最小バイナリ長判別.
    toMinBinary : function( message,size,name,id,no ) {
        if( useString( name ) && !VTag._outputValidateBuffer() ) {
            BaseVTag.addValidate( "validate_min_binary",size,name,message,id,no ) ;
        }
        return "" ;
    },
    // 最大バイナリ長判別.
    toMaxBinary : function( message,size,name,id,no ) {
        if( useString( name ) && !VTag._outputValidateBuffer() ) {
            BaseVTag.addValidate( "validate_binary",size,name,message,id,no ) ;
        }
        return "" ;
    }
} ;
