// (テーブル定義)表示部品.
//

// (テーブル定義)表示タグ.
ViewTag = {
    // 表示一覧を取得.
    viewList : function( master ) {
        if( typeof( master ) == "string" ) {
            master = Models[master] ;
        }
        if( master == null ||  master._$detail$ == null ) {
            return [] ;
        }
        var nms = master._$detail$.maintenanceDef ;
        var em = master._$detail$.element ;
        var len = em.length ;
        var ret = [] ;
        for( var i = 0 ; i < len ; i ++ ) {
            if( em[ i ].list == true || em[ i ].list == "true" ||
                isNumeric( em[ i ].no ) ) {
                ret.add( i ) ;
            }
        }
        return ret ;
    },
    // 指定Masterのカラム名に対する名前を取得.
    getColumnName : function( master,column ) {
        if( typeof( master ) == "string" ) {
            master = Models[master] ;
        }
        var def = null ;
        if( master == null || ( def = master._$detail$ ) == null ) {
            return column ;
        }
        var no = def.colsMap[ column ] ;
        if( no == null ) {
            return column ;
        }
        var name = def.element[no].name ;
        if( name == null ) {
            return column ;
        }
        return name ;
    },
    // 対象カラム内容の表示内容を取得.
    getColumnValueByView : function( value,master,no ) {
        if( typeof( master ) == "string" ) {
            master = Models[master] ;
        }
        var def = null ;
        if( master == null || ( def = master._$detail$ ) == null ) {
            return "" ;
        }
        var val = value[def.maintenanceDef[no]] ;
        var em = def.element[no] ;
        if( typeof( em.type ) == "string" ) {
            var type = em.type.toLowerCase() ;
            if( type == "check" ) {
                if( val == "true" || val == true ) {
                    return "○" ;
                }
                else {
                    return "×" ;
                }
            }
            else if( type == "passwd" ) {
                return "******" ;
            }
            else if( type == "date" ) {
                return parseFormatDate( "yyyy年MM月dd日",val ) ;
            }
            else if( type == "time" ) {
                return parseFormatDate( "HH時mm分ss秒",val ) ;
            }
            else if( type == "timestamp" ) {
                var s = parseFormatDate( "yyyy年MM月dd日@HH時mm分ss秒",val ) ;
                s = changeString( s,"@","&nbsp;" ) ;
                return s ;
            }
            return convertViewHtml( val,true ) ;
        }
        if( typeof( em.type ) == "map" ) {
            var type = em.type ;
            var tmst = null ;
            var target = null ;
            var chain = null ;
            if( type.select != null ) {
                tmst = type.select ;
                target = type.view ;
                chain = type.chain ;
            }
            else if( type.popup != null ) {
                tmst = type.master ;
                target = type.view ;
                chain = type.chain ;
            }
            if( tmst != null ) {
                var v = MasterTag.viewToId( val,tmst,target,chain,value ) ;
                if( !useString( v ) ) {
                    v = "<font color=red>"+val+"</font>" ;
                }
                return v ;
            }
        }
        return convertViewHtml( val,true ) ;
    }
}
