/**
 * ユーザ管理情報処理.
 * (server用).
 */

UserManager = {
    // 予約セッションID.
    RESERVATION_USER_NAME : pkg( "org.maachang.userManager.server.UserManager" ).RESERVATION_USER_NAME,
    // 利用オブジェクト.
    OBJECT : pkg( "org.maachang.userManager.server.UserManager" ).getInstance(),
    // セッション情報を更新.
    put : function( key,user ) {
        if( isRequest() ) {
            var kv = getRequest().getBdbKeyValue() ;
            this.OBJECT.put( kv,key,user ) ;
            return true ;
        }
        return false ;
    },
    // セッションアクセス時間を更新.
    update : function( key,user ) {
        if( isRequest() ) {
            var kv = getRequest().getBdbKeyValue() ;
            return this.OBJECT.update( kv,key,user ) ;
        }
        return false ;
    },
    // セッション情報削除.
    remove : function( key ) {
        if( isRequest() ) {
            var kv = getRequest().getBdbKeyValue() ;
            this.OBJECT.remove( kv,key ) ;
            return true ;
        }
        return false ;
    },
    // セッション情報取得.
    get : function( key ) {
        if( isRequest() ) {
            var kv = getRequest().getBdbKeyValue() ;
            return this.OBJECT.get( kv,key ) ;
        }
        return null ;
    },
    // セッションIDが存在するかチェック.
    containsKey : function( key ) {
        if( isRequest() ) {
            var kv = getRequest().getBdbKeyValue() ;
            return this.OBJECT.containsKey( kv,key ) ;
        }
        return false ;
    },
    // 現在のセッション数を取得.
    getLength : function() {
        return this.OBJECT.size() ;
    },
    // セッション群を取得するIterator.
    iterator : function( kv ) {
        return this.OBJECT.iterator( kv ) ;
    },
    // KeyValueオブジェクトから、UserBean情報を取得.
    userBean : function( kv,userBean ) {
        if( kv == null ) {
            return null ;
        }
        if( userBean != null ) {
            userBean.create( kv.getValue() ) ;
            return userBean ;
        }
        return new org.maachang.userManager.server.UserBean( kv.getValue() ) ;
    },
    // セッションタイムアウト値を取得.
    timeout : function() {
        return this.OBJECT.getTimeout() ;
    },
    // オブジェクトが利用可能かチェック.
    isUse : function() {
        return this.OBJECT.isUse() ;
    }
}
