package org.maachang.userManager ;

import org.maachang.conf.Config;
import org.maachang.seabass.startjava.StartupJava;
import org.maachang.userManager.server.UserManager;

/**
 * ユーザ管理サーバー開始処理.
 *
 * @version 2010/01/11
 * @author masahito suzuki
 * @since UserManager 1.0.0
 */
public class StartupUserManager implements StartupJava {
    
    /**
     * ユーザ管理サーババージョン.
     */
    private static final String VERSION = "1.0.0" ;
    
    /**
     * 実行サービス名.
     */
    private static final String SERVICE_NAME = "UserManager" + "(" + VERSION + ")" ;
    
    /**
     * セクション名.
     */
    private static final String SECTION = "user-manager" ;
    
    /**
     * コンストラクタ.
     */
    public StartupUserManager() {}
    
    /**
     * デストラクタ.
     */
    protected void finalize() throws Exception {
        
    }
    
    /**
     * 実行サービス名を取得.
     * @return String 実行サービス名が返されます.
     */
    public String getName() {
        return SERVICE_NAME ;
    }
    
    /**
     * 終了処理.
     * @exception Exception 例外.
     */
    public void destroy() throws Exception {
        UserManager.getInstance().destroy() ;
    }
    
    /**
     * 開始処理.
     * @exception Exception 例外.
     */
    public void startup() throws Exception {
        Config conf = Config.read( "./conf/userManager.conf" ) ;
        UserManager.getInstance().init( conf.getLong( SECTION,"timeout",0 ),
            conf.get( SECTION,"bdbName",0 ) ) ;
    }
    
}
