/**
 * 新しいセッションIDを追加.
 */

// POST以外でアクセスされている場合は、エラー.
if( getHttpMethod() != "POST" ) {
    // エラー403を返す.
    exit( "error403" ) ;
}

// セッションキー長.
#define _SESSION_LENGTH 64

while( true ) {
    // セッションキーを生成.
    var key = randomString( _SESSION_LENGTH,true,true,true ) ;
    if( UserManager.containsKey( key ) ) {
        // セッションキーが既に存在する場合は、もう一度作成.
        sleep( 50 ) ;
        continue ;
    }
    // 新規のセッションキーを予約コードで登録.
    UserManager.put( key,UserManager.RESERVATION_USER_NAME ) ;
    httpPrint( key ) ;
    break ;
}
