/**
 * リモートログイン処理.
 * 
 * パラメータ user は、ユーザ名、passwd は、パスワード、セッションIDは session.
 * この情報は必須.
 * ログインが成功した場合は、DB内容を戻す.
 */

// POST以外でアクセスされている場合は、エラー.
if( getHttpMethod() != "POST" ) {
    // エラー403を返す.
    exit( "error403" ) ;
}

setResponseHeader( "Content-Type","text/plain" ) ;
if( useString( params['user'] ) && useString( params['passwd'] ) && useString( params['session'] ) ) {
    // マスターキャッシュから問い合わせ.
    var res = MasterCache.find( "PersonMaster",{adminNumber:params['user']} ) ;
    // ユーザ名が存在しない.
    if( res == null || res.length <= 0 ) {
        httpPrint( _ERROR_ + "ログイン処理に失敗しました" ) ;
        exit() ;
    }
    // パスワードが一致しない.
    res = res[ 0 ] ;
    if( res.passwd != params['passwd'] ) {
        httpPrint( _ERROR_ + "ログイン処理に失敗しました" ) ;
        exit() ;
    }
    // ユーザ名／パスワードが存在する場合、その条件をBDBにセット.
    try {
        UserManager.put( params['session'],params['user'] ) ;
    } catch( Exception e ) {
        httpPrint( _ERROR_ + "ログイン処理に失敗しました" ) ;
        exit() ;
    }
    // DB内容を返す.
    httpPrint( encodeJSON( res ) ) ;
}
else {
    httpPrint( _ERROR_ + "ログイン処理に失敗しました" ) ;
}
