/**
 * セッションIDが存在するかチェック.
 * セッションIDは session.
 * この情報は必須.
 * また、確認セッションIDが存在しない場合は、予約書き込みを行うことができる。
 * その場合は、reservation=trueとすればよい.
 */

// POST以外でアクセスされている場合は、エラー.
if( getHttpMethod() != "POST" ) {
    // エラー403を返す.
    exit( "error403" ) ;
}

setResponseHeader( "Content-Type","text/plain" ) ;
if( useString( params['session'] ) ) {
    if( UserManager.containsKey( params['session'] ) ) {
        // セッションIDは既に存在する.
        httpPrint( "true" ) ;
    }
    else if( params['reservation'] == "true" ) {
        // 予約設定条件の場合は、予約設定ユーザ名で設定する.
        UserManager.put( params['session'],UserManager.RESERVATION_USER_NAME ) ;
        httpPrint( "false" ) ;
    }
    else {
        httpPrint( "false" ) ;
    }
}
else {
    httpPrint( _ERROR_ + "セッションIDチェックに失敗しました" ) ;
}
