/**
 * パスワード変更.
 */

// validateチェック処理.
VTag.validate( "/~seabass/fd/admin/menu/config/editPass" ) ;

// 新しいパスワードと確認用パスワードが一致しない場合.
if( params['passwd'] != params['passwd2'] ) {
    validate_error_out( "新しいパスワードと新しいパスワード(確認)は一致していません","topError" ) ;
}
else {
    // ユーザ毎に対するユーザ定義ファイルを読み込む.
    seabassDefine( "../../@user" ) ;
    if( isNull( super._adminUser ) ) {
        errorLog( "FDユーザファイルは存在しないため、リダイレクトします" ) ;
        redirect( "/~seabass/fd/admin/" ) ;
    }
    // 指定ユーザが存在しないかチェック.
    if( isNull( _adminUser[params['userName']] ) ) {
        errorLog( "ユーザ「" + params['userName'] + "」は存在しません" ) ;
        redirect( "/~seabass/fd/admin/" ) ;
    }
    // パスワードと、既存パスワードが一致するかチェック.
    if( _adminUser[params['userName']][0] != (Digest.sha1( params['oldPass'] ) + "_" + params['oldPass'].length) ) {
        validate_error_out( "既存のパスワードと、設定されているパスワードは一致しません","topError" ) ;
    }
}

// Validateが存在した場合はForwardする.
validate_forward( "/~seabass/fd/admin/menu/config/editPass" ) ;

// パスワード変更.
_adminUser[params['userName']][0] = (Digest.sha1( params['passwd'] ) + "_" + params['passwd'].length) ;

// 定義ファイルに出力.
seabassDefineW( "../../@user",{"_adminUser":_adminUser} ) ;

// リスト画面にリダイレクト.
redirect( "index" ) ;
