/**
 * 新規ユーザ登録.
 */

// validateチェック処理.
VTag.validate( "/~seabass/fd/admin/menu/config/newUser" ) ;

// パスワードと確認用パスワードが一致しない場合.
if( params['passwd'] != params['passwd2'] ) {
    validate_error_out( "パスワードとパスワード(確認)は一致していません","topError" ) ;
}
else {
    // ユーザ毎に対するユーザ定義ファイルを読み込む.
    seabassDefine( "../../@user" ) ;
    if( isNull( super._adminUser ) ) {
        errorLog( "FDユーザファイルは存在しないため、リダイレクトします" ) ;
        redirect( "/~seabass/fd/admin/" ) ;
    }
    
    // 指定ユーザが既に存在するかチェック.
    if( !isNull( _adminUser[params['userName']] ) ) {
        validate_error_out( "指定ユーザ「" + params['userName'] + "」は既に存在します","userName" ) ;
        params['userName'] = "" ;
    }
}

// Validateが存在した場合はForwardする.
validate_forward( "/~seabass/fd/admin/menu/config/newUser" ) ;

// adminフラグがＯＦＦの場合はゼロをセット.
if( isNull( params['admin'] ) ) {
    params['admin'] = 0 ;
}

var target = [
    (Digest.sha1( params['passwd'] ) + "_" + params['passwd'].length),
    params['admin'],params['app'],params['lib'],params['pub'],params['err'] ] ;
var len = target.length ;
for( var i = 2 ; i < len ; i ++ ) {
    if( !useString( target[i] ) || target[i] == "selected" ) {
        target[i] = "" ;
    }
}

// ユーザ登録.
_adminUser[params['userName']] = target ;

// 定義ファイルに出力.
seabassDefineW( "../../@user",{"_adminUser":_adminUser} ) ;

// リスト画面にリダイレクト.
redirect( "index" ) ;
