// ファイラ系処理群.
////////////////////////////////////////////////////////////////////////////////
FD = {
    // ROOTディレクトリ.
    _ROOT_DIR : "/",

    // メニューURL.
    _MENU_URL : "/~seabass/fd/admin/menu/",

    // 基本ディレクトリ名.
    _baseDir : null,

    // 現在表示メニュー値.
    _nowMenuType : -1,

    // 処理選択時のURL.
    _selectMenuByUrl : "/",

    // 表示モード.
    _viewMode : false,

    ////////////////////////////////////////////////////////////////////////////////
    // 初期化表示処理.
    ////////////////////////////////////////////////////////////////////////////////

    // ファイラ初期化処理.
    init : function( base,viewMode ) {
        if( !$base.useString( base ) ) {
            throw new IllegalArgumentException( "基本ディレクトリ名は不正です" ) ;
        }
        FD._baseDir = base ;
        if( valueof( viewMode ) == "map" ) {
            FD._viewMode = viewMode ;
        }
        else {
            FD._viewMode = {} ;
        }
        // ページ遷移時に編集中の場合のダイアログ出力登録.
        ExitToDialog.initPageMoveByDialog("controllId",
            "編集中の内容が存在します。編集中の内容を破棄しますか？") ;
        // レイアウト初期化.
        FD.initLayout() ;
    },

    // レイアウト初期処理.
    initLayout : function() {
        FD.createLayout() ;
        FD.ajaxTree(null,true) ;
    },

    // 画面遷移処理.
    changePage : function() {
        if( !ExitToDialog.isCancelEdit() ) {
            if( !$base.isNull( getGlobal('editAreaLoader') ) ) {
                getGlobal('editAreaLoader').destroy() ;
            }
            return false ;
        }
        return true ;
    },

    // 表示モード条件を取得.
    getViewMode : function( name ) {
        var r = FD._viewMode[name] ;
        if( $base.isNull( r ) ) {
            return false ;
        }
        if( r == true ) {
            return true ;
        }
        else {
            return false ;
        }
    },

    ////////////////////////////////////////////////////////////////////////////////
    // ユーティリティ系.
    ////////////////////////////////////////////////////////////////////////////////

    // メニューに戻る.
    topMenu : function() {
        location.href=FD._MENU_URL ;
    },

    // コントローラ内容をクリア.
    clearController : function( mode ) {
        var mid = null ;
        if( mode == true ) {
            if( !$base.isNull( parent ) ) {
                mid = parent.document.getElementById("controllId") ;
            }
            if( $base.isNull( mid ) && !$base.isNull( window.opener ) ) {
                mid = window.opener.document.getElementById("controllId") ;
            }
            if( $base.isNull( mid ) ) {
                mid = document.getElementById("controllId") ;
            }
        }
        else {
            mid = document.getElementById("controllId") ;
        }
        if( !$base.isNull( mid ) ) {
            mid.innerHTML = "" ;
        }
    },

    // メッセージをクリア.
    clearMessage : function( mode ) {
        var mid = null ;
        if( mode == true ) {
            if( !$base.isNull( parent ) ) {
                mid = parent.document.getElementById("messageId") ;
            }
            if( $base.isNull( mid ) && !$base.isNull( window.opener ) ) {
                mid = window.opener.document.getElementById("messageId") ;
            }
            if( $base.isNull( mid ) ) {
                mid = document.getElementById("messageId") ;
            }
        }
        else {
            mid = document.getElementById("messageId") ;
        }
        if( !$base.isNull( mid ) ) {
            mid.innerHTML = "" ;
        }
    },

    // normalMessage.
    message : function( v,mode ) {
        if( !$base.useString( v ) ) {
            return ;
        }
        FD.writeMessage( "*" + v,mode ) ;
    },

    // errorMessage.
    errorMessage : function( v,mode ) {
        if( !$base.useString( v,mode ) ) {
            return ;
        }
        FD.writeMessage( "#" + v,mode ) ;
    },

    // successMessage.
    successMessage : function( v,mode ) {
        if( !$base.useString( v ) ) {
            return ;
        }
        FD.writeMessage( "@" + v,mode ) ;
    },

    // writeMessage.
    writeMessage : function( v,mode ) {
        var mid = null ;
        if( mode == true ) {
            if( !$base.isNull( parent ) ) {
                mid = parent.document.getElementById("messageId") ;
            }
            if( $base.isNull( mid ) && !$base.isNull( window.opener ) ) {
                mid = window.opener.document.getElementById("messageId") ;
            }
            if( $base.isNull( mid ) ) {
                mid = document.getElementById("messageId") ;
            }
        }
        else {
            mid = document.getElementById("messageId") ;
        }
        if( !$base.isNull( mid ) ) {
            if( $base.startsWith( v,"#" ) ) {
                mid.innerHTML = "<span style='color:#cf0000'>"+v.substring( 1 )+"</span>" ;
                return false ;
            }
            else if( $base.startsWith( v,"@" ) ) {
                mid.innerHTML = "<span style='color:#0000cf'>"+v.substring( 1 )+"</span>" ;
                return true ;
            }
            else if( $base.startsWith( v,"*" ) ) {
                mid.innerHTML = "<span style='color:#00cf00'>"+v.substring( 1 )+"</span>" ;
                return true ;
            }
            mid.innerHTML = "<span style='color:#00cf00'>"+v+"</span>" ;
            return true ;
        }
        return false ;
    },

    // 指定IDのON／OFF.
    idToDisabled : function( id,flg,mode ) {
        if( $base.useString( id ) ) {
            id = $base.trim( id ) ;
            if( !$base.endsWith( id,"Id" ) ) {
                id = id + "Id" ;
            }
        }
        else {
            return ;
        }
        if( flg != true ) {
            flg = false ;
        }
        if( mode == true ) {
            if( !$base.isNull( parent ) ) {
                mid = parent.document.getElementById(id) ;
            }
            if( $base.isNull( mid ) && !$base.isNull( window.opener ) ) {
                mid = window.opener.document.getElementById(id) ;
            }
            if( $base.isNull( mid ) ) {
                mid = document.getElementById(id) ;
            }
        }
        else {
            mid = document.getElementById(id) ;
        }
        if( !$base.isNull( mid ) ) {
            mid.disabled = flg ;
        }
    },

    // 正しいコンテンツ名かチェック.
    isContentsName : function( name ) {
        if( !$base.useString( name ) ) {
            return false ;
        }
        name = $base.trim( name ) ;
        var len = name.length ;
        var c = null ;
        c = name.charAt( 0 ) ;
        if( !( ( c >= 'a' && c <= 'z' ) ||
            ( c >= 'A' && c <= 'Z' ) ||
            c == '_' || c == '-' ) ) {
            return false ;
        }
        for( var i = 0 ; i < len ; i ++ ) {
            c = name.charAt( i ) ;
            if( !( ( c >= 'a' && c <= 'z' ) ||
                ( c >= 'A' && c <= 'Z' ) ||
                ( c >= '0' && c <= '9' ) ||
                c == '_' || c == '-' ) ) {
                return false ;
            }
        }
        return true ;
    },

    ////////////////////////////////////////////////////////////////////////////////
    // TreeView表示系.
    ////////////////////////////////////////////////////////////////////////////////

    // TreeView表示(Ajax).
    ajaxTree : function(mode,closeMode) {
        // modeがfalse以外の場合は、Tree位置をROOTに配置させる.
        var params = null ;
        if( !FD._viewMode.seabass ) {
            params = {path:FD._baseDir,emask:"",full:"upimg"}
        }
        else {
            params = {path:FD._baseDir,emask:""}
        }
        accessAjax("/~seabass/fd/admin/menu/tools/ajax/treeAjax",
            params,
            function(v) {
                $("treeId").innerHTML=v;
                FD.flushTree();
                if( closeMode == true ) {
                    treeInfo.close() ;
                }
                if( mode != false ) {
                    // AjaxでTree表示を行った場合は、Tree位置をROOTに配置.
                    FD.selectTree( 0,FD._ROOT_DIR ) ;
                }
                // TreeAction情報を更新.
                $("treeActionId").innerHTML = "<div align='left' style='font-size:small;'>" +
                    "&nbsp;<a href='#' onclick='javascript:treeInfo.open();'>full</a>&nbsp;" +
                    "-" + 
                    "<a href='#' onclick='javascript:treeInfo.close();'>close</a>" + 
                    "-" + 
                    "<a id='refreshTreeId' href='#' onclick='javascript:FD.ajaxTree(null,true);'>reload</a>" +
                    "</div>" ;
            }
        ) ;
    },

    // TreeView更新.
    flushTree : function() {
        // 拡張子表示画像条件.
        var pFile = {
            txt:"/~seabass/fd/admin/res/img/text.png",
            gif:"/~seabass/fd/admin/res/img/image.png",
            png:"/~seabass/fd/admin/res/img/image.png",
            jpeg:"/~seabass/fd/admin/res/img/image.png",
            jpg:"/~seabass/fd/admin/res/img/image.png",
            html:"/~seabass/fd/admin/res/img/html.png",
            htm:"/~seabass/fd/admin/res/img/html.png",
            js:"/~seabass/fd/admin/res/img/js.png",
            css:"/~seabass/fd/admin/res/img/css.png",
            mhtml:"/~seabass/fd/admin/res/img/mhtml.png",
            ms:"/~seabass/fd/admin/res/img/ms.png",
            sdoc:"/~seabass/fd/admin/res/img/sdoc.png"
        } ;
        // treeを表示.
        initTree("treeId","treeInfo","FD.selectTree",pFile) ;
    },

    // ディレクトリ/ファイルツリー情報が選択された場合の処理.
    selectTree : function( type,name ) {
        if( FD.changePage() ) {
            return ;
        }
        FD._selectMenuByUrl = name ;
        // URLを表示させる.
        $("urlId").innerHTML = "<span style=\"color:#0000cf\"><b>" + name + "</b></span>" ;
        // 色々処理させる.
        // type : 0 の場合は、ディレクトリ指定.
        // type : 1 の場合は、ファイル指定.
        if( FD._nowMenuType != type ) {
            switch( type ) {
                case 0 :
                    FD.menuDirectory() ;
                    break ;
                case 1 :
                    FD.menuFile() ;
                    break ;
            }
        }
        if( FD._nowMenuType == 1 ) {
            if( name.indexOf( "/@" ) != -1 ) {
                $( "file_button_id_5" ).disabled = false ;
                $( "file_button_id_6" ).disabled = true ;
            }
            // HTML系、テキスト系、conf系、csvでない場合は、編集不可.
            else if( !( $base.endsWith( name,".htm" ) ||
                $base.endsWith( name,".html" ) ||
                $base.endsWith( name,".xml" ) ||
                $base.endsWith( name,".txt" ) ||
                $base.endsWith( name,".conf" ) ||
                $base.endsWith( name,".mhtml" ) ||
                $base.endsWith( name,".ms" ) ||
                $base.endsWith( name,".css" ) ||
                $base.endsWith( name,".js" ) ||
                $base.endsWith( name,".sdoc" ) ||
                $base.endsWith( name,".csv" ) ) ) {
                // 画像系、以外の場合は、プレビュー不可.
                if( !( $base.endsWith( name,".png" ) ||
                    $base.endsWith( name,".ico" ) ||
                    $base.endsWith( name,".gif" ) ||
                    $base.endsWith( name,".jpeg" ) ||
                    $base.endsWith( name,".jpg" ) ||
                    $base.endsWith( name,".jpe" ) ||
                    $base.endsWith( name,".jfif" ) ||
                    $base.endsWith( name,".jfi" ) ) ) {
                    $( "file_button_id_6" ).disabled = true ;
                }
                else {
                    $( "file_button_id_6" ).disabled = false ;
                }
            }
            // ms系、js系、css系の場合は、プレビュー処理をOFF.
            else if( $base.endsWith( name,".ms" ) ||
                $base.endsWith( name,".css" ) ||
                $base.endsWith( name,".js" ) ) {
                $( "file_button_id_5" ).disabled = false ;
                $( "file_button_id_6" ).disabled = true ;
            }
            // 全ての条件が一致するものに対して、編集／プレビューをONにする.
            else {
                $( "file_button_id_5" ).disabled = false ;
                $( "file_button_id_6" ).disabled = false ;
            }
            // ファイル指定の場合は、ファイルステータスを表示させる.
            FD.stateFile() ;
        }
        // ディレクトリ指定でROOTの場合は、一定の操作を不可能にする.
        else if( FD._nowMenuType == 0 ) {
            if( name == "/" ) {
                $( "dir_button_id_1" ).disabled = true ;
                $( "dir_button_id_2" ).disabled = true ;
                $( "dir_button_id_3" ).disabled = true ;
                $( "dir_button_id_4" ).disabled = true ;
            }
            else {
                $( "dir_button_id_1" ).disabled = false ;
                $( "dir_button_id_2" ).disabled = false ;
                $( "dir_button_id_3" ).disabled = false ;
                $( "dir_button_id_4" ).disabled = false ;
            }
        }
        else if( FD._nowMenuType == 2 ) {
            // コンテンツ指定の場合は、コンテンツステータスを表示させる.
            FD.stateContent() ;
        }
    },

    ////////////////////////////////////////////////////////////////////////////////
    // レイアウト整形.
    ////////////////////////////////////////////////////////////////////////////////
    LAYOUT_HEADER_H : 150,
    createLayout : function(event) {
        var w = parseInt(Math.ceil(width()* 0.985 )) ;
        var h = parseInt(Math.ceil(height()* 0.95 )) ;
        
        var css = "" ;
        
        // 全体のレイアウト.
        css += "#tTopId {" +
            " width:" + w+"px;" +
            " height:" + h+"px;" +
            " border-style:solid; border-width:1px; border-color:#707070; background:#efefef; }\r\n" ;
        
        // メニューサイズ.
        css += "#tMenuId {" +
            " width:" + w+"px;" +
            " height:76px;" +
            " position:relative;vertical-align:top;border-style:solid; border-width:1px; border-color:#707070; background:#efefef; }\r\n" ;
        
        // URL表示サイズ.
        css += "#tUrlId {" +
            " width:" + w+"px;" +
            " height:42px;" +
            " border-style:solid; border-width:1px; border-color:#707070; background:#efefef; }\r\n" ;
        
        // ディレクトリ表示サイズ.
        css += "#tTreeId {" +
            " width:" + parseInt(Math.ceil( w * 0.20 )) + "px;" +
            " height:" + (h-FD.LAYOUT_HEADER_H) + "px;" +
            " position:relative;vertical-align:top; border-style:solid; border-width:1px; border-color:#707070; background:#efefef; }\r\n" ;
        
        // ディレクトリ表示サイズ(DIV).
        css += "#treeId {" +
            " width:" + parseInt(Math.ceil( w * 0.20 )) + "px;" +
            " height:" + parseInt(Math.ceil((h-FD.LAYOUT_HEADER_H) * 0.95 )) + "px;" +
            " overflow: auto; }\r\n" ;
        
        // コントローラ表示サイズ.
        css += "#tControllId {" +
            " width:" + parseInt(Math.ceil( w * 0.80 )) + "px;" +
            " height:" + (h-FD.LAYOUT_HEADER_H) + "px;" +
            " position:relative;vertical-align:top; border-style:solid; border-width:1px; border-color:#707070; background:#efefef; }\r\n" ;
        
        // コントローラ表示サイズ(DIV).
        css += "#controllId {" +
            " width:" + parseInt(Math.ceil( w * 0.80 )) + "px;" +
            " height:" + (h-FD.LAYOUT_HEADER_H) + "px;" +
            " overflow: auto; }\r\n" ;
        
        // CSS追加処理を呼び出す.
        innerCSS( "createLayout",css ) ;
    },

    // コントローラ表示サイズを取得.
    getControllerRect : function() {
        var w = parseInt(Math.ceil(width()* 0.985 )) ;
        var h = parseInt(Math.ceil(height()* 0.965 )) ;
        return [ parseInt(Math.ceil( w * 0.80 )),(h-FD.LAYOUT_HEADER_H) ] ;
    },

    ////////////////////////////////////////////////////////////////////////////////
    // メニュー系.
    ////////////////////////////////////////////////////////////////////////////////

    // メニュー表示：ディレクトリ用メニューを表示.
    menuDirectory : function() {
        FD._nowMenuType = 0 ;
        var s = "" ;
        s += "<span style=\"color:#33cc66\"><b>【フォルダ処理】</b></span>" ;
        s += "&nbsp;&nbsp;&nbsp;&nbsp;<a href='"+FD._MENU_URL+"'>メニューに戻る</a>" ;
        s += "<br>" ;
        
        s += "<input type='button' id='dir_button_id_1' class='button' value='削除' onclick='javascript:this.blur();" +
            "if(!FD.changePage()){FD.removeDir()}'>&nbsp;" ;
        s += "<input type='button' id='dir_button_id_2' class='button' value='移動' onclick='javascript:this.blur();" +
            "if(!FD.changePage()){FD.moveDir()}'>&nbsp;" ;
        s += "<input type='button' id='dir_button_id_3' class='button' value='コピー' onclick='javascript:this.blur();" +
            "if(!FD.changePage()){FD.copyDir()}'>&nbsp;" ;
        s += "<input type='button' id='dir_button_id_4' class='button' value='名前の変更' onclick='javascript:this.blur();" +
            "if(!FD.changePage()){FD.renameDir()}'>&nbsp;" ;
        s += "<input type='button' id='dir_button_id_5' class='button' value='フォルダ作成' onclick='javascript:this.blur();" +
            "if(!FD.changePage()){FD.createDir()}'>&nbsp;" ;
        s += "<input type='button' id='dir_button_id_6' class='button' value='アップロード' onclick='javascript:this.blur();" +
            "if(!FD.changePage()){FD.uploadFile()}'>&nbsp;" ;
        s += "<input type='button' id='dir_button_id_8' class='button' value='ファイル作成' onclick='javascript:this.blur();" +
            "if(!FD.changePage()){FD.createFile()}'>&nbsp;" ;
        $("menuId").innerHTML = s ;
    },

    // メニュー表示：ファイル用メニューを表示.
    menuFile : function() {
        FD._nowMenuType = 1 ;
        var s = "" ;
        s += "<span style=\"color:#6633cc\"><b>【ファイル処理】</b></span>" ;
        s += "&nbsp;&nbsp;&nbsp;&nbsp;<a href='"+FD._MENU_URL+"'>メニューに戻る</a>" ;
        s += "<br>" ;
        
        s += "<input type='button' id='file_button_id_1' class='button' value='削除' onclick='javascript:this.blur();" +
            "if(!FD.changePage()){FD.removeFile()}'>&nbsp;" ;
        s += "<input type='button' id='file_button_id_2' class='button' value='移動' onclick='javascript:this.blur();" +
            "if(!FD.changePage()){FD.moveFile()}'>&nbsp;" ;
        s += "<input type='button' id='file_button_id_3' class='button' value='コピー' onclick='javascript:this.blur();" +
            "if(!FD.changePage()){FD.copyFile()}'>&nbsp;" ;
        s += "<input type='button' id='file_button_id_4' class='button' value='名前の変更' onclick='javascript:this.blur();" +
            "if(!FD.changePage()){FD.renameFile()}'>&nbsp;" ;
        s += "<input type='button' id='file_button_id_5' class='button' value='編集' onclick='javascript:this.blur();" +
            "if(!FD.changePage()){FD.editFile()}'>&nbsp;" ;
        s += "<input type='button' id='file_button_id_6' class='button' value='プレビュー' onclick='javascript:this.blur();" +
            "FD.previewFile();'>&nbsp;" ;
        s += "<input type='button' id='file_button_id_7' class='button' value='ダウンロード' onclick='javascript:this.blur();" +
            "FD.downloadFile();'>&nbsp;" ;
        s += "<input type='button' id='file_button_id_8' class='button' value='詳細' onclick='javascript:this.blur();" +
            "if(!FD.changePage()){FD.stateFile()}'>&nbsp;" ;
        $("menuId").innerHTML = s ;
    },

    // コントロールページ表示処理.
    viewControllPage : function( url ) {
        accessAjaxToJsExecution( "controllId",url,{base:FD._baseDir,path:FD._selectMenuByUrl} ) ;
    },

    // 通常画面プレビュー処理.
    previewInfo : function( url,params,width,height ) {
        if( !$base.useString( url ) ) {
            return false ;
        }
        if( $base.isNull( width ) ) {
            width = 800 ;
        }
        if( $base.isNull( height ) ) {
            height = 600 ;
        }
        var basePath = FD._baseDir ;
        if( $base.startsWith( basePath,"application" ) ) {
            basePath = basePath.substring( "application".length ) ;
        }
        if( $base.startsWith( basePath,"public" ) ) {
            basePath = basePath.substring( "public".length ) ;
        }
        params = convertParams( params ) ;
        if( $base.useString( params ) ) {
            if( url.indexOf( "?" ) != -1 ) {
                url += "&" + params + "&t="+(new Date()).getTime() ;
            }
            else {
                url += "?" + params + "&t="+(new Date()).getTime() ;
            }
        }
        else {
            if( url.indexOf( "?" ) != -1 ) {
                url += "&t="+(new Date()).getTime() ;
            }
            else {
                url += "?t="+(new Date()).getTime() ;
            }
        }
        url = basePath + url ;
        if( $base.startsWith( url,"//" ) ) {
            url = url.substring( 1 ) ;
        }
        window.open(url,'preview', "width="+width+",height="+height+",scrollbars=yes" ) ;
    },

    ////////////////////////////////////////////////////////////////////////////////
    // 実行処理系.
    ////////////////////////////////////////////////////////////////////////////////

    // ディレクトリを削除.
    removeDir : function() {
        FD.clearMessage() ;
        if( confirm( "フォルダ " + FD._selectMenuByUrl + " は１度削除すると復元できません。よろしいですか？" ) ) {
            accessAjax("/~seabass/fd/admin/menu/tools/ajax/dir/removeDirAjax",
                {base:FD._baseDir,path:FD._selectMenuByUrl},
                function(v) {
                    if( !$base.isNull( v ) && typeof( v ) == "string" ) {
                        // 画面初期化.
                        FD.initLayout() ;
                        // メッセージ出力.
                        FD.writeMessage( v );
                    }
                }
            ) ;
        }
    },

    // ディレクトリを移動.
    moveDir : function() {
        FD.clearMessage() ;
        FD.viewControllPage( "/~seabass/fd/admin/menu/tools/dir/viewMoveDirAjax.mhtml" ) ;
    },

    // ディレクトリをコピー.
    copyDir : function() {
        FD.clearMessage() ;
        FD.viewControllPage( "/~seabass/fd/admin/menu/tools/dir/viewCopyDirAjax.mhtml" ) ;
    },

    // ディレクトリ名を変更.
    renameDir : function() {
        FD.clearMessage() ;
        FD.viewControllPage( "/~seabass/fd/admin/menu/tools/dir/viewRenameDirAjax.mhtml" ) ;
    },

    // ディレクトリを作成.
    createDir : function() {
        FD.clearMessage() ;
        FD.viewControllPage( "/~seabass/fd/admin/menu/tools/dir/viewCreateDirAjax.mhtml" ) ;
    },

    // ファイルをアップロード.
    uploadFile : function() {
        FD.clearMessage() ;
        //if( !isFlash || isMSIE ) {
        //    FD.viewControllPage( "/~seabass/fd/admin/menu/tools/dir/viewFileUploadAjax.mhtml" ) ;
        //}
        //else {
        //    FD.viewControllPage( "/~seabass/fd/admin/menu/tools/dir/viewSwfUploadAjax.mhtml" ) ;
        //}
        FD.viewControllPage( "/~seabass/fd/admin/menu/tools/dir/viewFileUploadAjax.mhtml" ) ;
    },

    // 新しいファイルを作成.
    createFile : function() {
        FD.clearMessage() ;
        FD.viewControllPage( "/~seabass/fd/admin/menu/tools/dir/viewCreateFileAjax.mhtml" ) ;
    },

    // ファイルを削除.
    removeFile : function() {
        FD.clearMessage() ;
        if( confirm( "ファイル " + FD._selectMenuByUrl + " は１度削除すると復元できません。よろしいですか？" ) ) {
            accessAjax("/~seabass/fd/admin/menu/tools/ajax/file/removeFileAjax",
                {base:FD._baseDir,path:FD._selectMenuByUrl},
                function(v) {
                    if( !$base.isNull( v ) && typeof( v ) == "string" ) {
                        // 画面初期化.
                        FD.initLayout() ;
                        // メッセージ出力.
                        FD.writeMessage( v );
                    }
                }
            ) ;
        }
    },

    // ファイルを移動.
    moveFile : function() {
        FD.clearMessage() ;
        FD.viewControllPage( "/~seabass/fd/admin/menu/tools/file/viewMoveFileAjax.mhtml" ) ;
    },

    // ファイルをコピー.
    copyFile : function() {
        FD.clearMessage() ;
        FD.viewControllPage( "/~seabass/fd/admin/menu/tools/file/viewCopyFileAjax.mhtml" ) ;
    },

    // ファイル名を変更.
    renameFile : function() {
        FD.clearMessage() ;
        FD.viewControllPage( "/~seabass/fd/admin/menu/tools/file/viewRenameFileAjax.mhtml" ) ;
    },

    // ファイル編集.
    editFile : function() {
        FD.clearMessage() ;
        FD.viewControllPage( "/~seabass/fd/admin/menu/tools/file/viewEditFileByEditAreaAjax.mhtml" ) ;
    },

    // ファイルをプレビュー.
    previewFile : function() {
        var name = FD._selectMenuByUrl ;
        if( !$base.useString( name ) ) {
            return false ;
        }
        FD.previewInfo( name ) ;
        return true ;
    },

    // ファイルダウンロード.
    downloadFile : function() {
        forwardURL( "/~seabass/fd/admin/menu/tools/ajax/file/downloadFileAjax",
            {base:FD._baseDir,path:FD._selectMenuByUrl} ) ;
    },

    // ファイル詳細
    stateFile : function() {
        FD.clearMessage() ;
        FD.viewControllPage( "/~seabass/fd/admin/menu/tools/file/viewStateFileAjax.mhtml" ) ;
    }

}

