// 指定ファイルのエディタオープン処理.
////////////////////////////////////////////////////////////////////////////////
// id: textareaのＩＤ.
// name: 読み込み対象ファイル名.
// charset: 読み込み対象のキャラクタセット.
// width: 表示サイズWidth.
// height: 表示サイズheight.

if( !useString( params["id"] ) ||
    !useString( params["name"] ) ) {
    exit( "error403" ) ;
}

// パラメータ調整.
var width = "640" ;
var height = "400" ;
var charset = "UTF8" ;
var type = "html" ;
var lang = "ja" ;
if( useString( params['charset'] ) ) {
    charset = params['charset'] ;
}
if( useString( params['width'] ) ) {
    width = params['width'] ;
}
if( useString( params['height'] ) ) {
    height = params['height'] ;
}
if( useString( params['lang'] ) ) {
    lang = params['lang'] ;
}
// 拡張子でパターン判別.
var name = params["name"] ;
var endsName = toLast( name,"." ).toLowerCase() ;
if( endsName == ".htm" || endsName == ".html" ) {
    type = "html" ;
}
else if( endsName == ".mhtml" ) {
    type = "html" ;
}
else if( endsName == ".ms" ) {
    type = "js" ;
}
else if( endsName == ".css" ) {
    type = "css" ;
}
else if( endsName == ".js" ) {
    type = "js" ;
}
else if( name.startsWith( "@" ) ) {
    type = "js" ;
}

// 画面作成.
var buf = createStrBuf() ;
buf.ad( "<textarea id=\"" ).ad( params["id"] ).ad( "\" style=\"width:" ).ad( width ).
    ad( "px;height:" ).ad( height ).ad( "\"  wrap=\"off\" name=\"" ).
    ad( params["id"] ).ad( "_name" ).ad( "\">" ) ;
if( Io.isFileExists( name ) ) {
    var fInfo = Io.readFileByString( name,charset ) ;
    fInfo = changeByNoCote( fInfo,"    ","\t" ) ;
    fInfo = changeString( fInfo,"&","&amp;" ) ;
    fInfo = changeString( fInfo,"<","&lt;" ) ;
    fInfo = changeString( fInfo,">","&gt;" ) ;
    fInfo = changeByNoCote( fInfo,"\r\n","\n" ) ;
    buf.ad( fInfo ) ;
    fInfo = null ;
}

buf.ad( "</textarea>" ) ;
buf.ad( "<script>" ).
    ad( "editAreaLoader.init({id:\"" ).ad( params["id"] ).ad( "\"," ).
        ad( "start_highlight:true," ).
        ad( "allow_resize:\"no\"," ).
        ad( "allow_toggle:false," ).
        ad( "language: \"" ).ad( lang ).ad( "\"," ).
        ad( "syntax: \"" ).ad( type ).ad( "\"," ) ;
// アクセスブラウザがIEかOperaの場合は、拡大ボタンを表示させない.
if( isBrowser() == "msie" || isBrowser() == "opera" ) {
    if( isBrowser() == "msie" ) {
        buf.ad( "toolbar: \"" ).ad( "search,go_to_line,help" ).ad( "\"" ) ;
    }
    else {
        buf.ad( "toolbar: \"" ).ad( "select_font,search,go_to_line,help" ).ad( "\"" ) ;
    }
}
// 上記以外のブラウザの場合は、拡大ボタンを表示させる.
else {
    buf.ad( "toolbar: \"" ).ad( "fullscreen,select_font,search,go_to_line,help" ).ad( "\"" ) ;
}
buf.ad( "});" ).
    ad( "editAreaLoader.setSelectionRange(" ).ad( "\"" ).ad( params["id"] ).ad( "\", 0, 0);" ).
    ad( "</script>" ) ;
// 画面出力.
httpPrint( buf.ts() ) ;
