///////////////////////////////////////////////////////////////////////////////
// 簡易HTMLパーサー関連.
///////////////////////////////////////////////////////////////////////////////

// HTMLユーティリティ.
HtmlUtil = {
    // タグ位置を取得.
    startTagPos : function( out,s,pos ) {
        if( pos <= 0 ) {
            pos = 0 ;
        }
        var len = s.length ;
        var p,pp,e ;
        while( true ) {
            if( (p = ParserUtil.indexOfCote( s,"<",pos )) == -1 ) {
                return false ;
            }
            if( p + 3 < len ) {
                if( s.charAt( p+1 ) == '!' &&
                    s.charAt( p+2 ) == '-' &&
                    s.charAt( p+3 ) == '-' ) {
                    var e = ParserUtil.indexOfCote( s,"-->",p+1 ) ;
                    if( e != -1 ) {
                        out[ 0 ] = p ;
                        out[ 1 ] = e+2 ;
                        return true ;
                    }
                    out[ 0 ] = p ;
                    out[ 1 ] = s.length ;
                    return true ;
                }
            }
            pp = ParserUtil.indexOfCote( s,"<",p+1 ) ;
            e = ParserUtil.indexOfCote( s,">",p+1 ) ;
            if( e == -1 ) {
                return false ;
            }
            else if( pp != -1 && pp < e ) {
                pos = pp ;
            }
            else {
                out[ 0 ] = p ;
                out[ 1 ] = e ;
                return true ;
            }
        }
    }
}

// タグ要素オブジェクト.
TagElement = function( string ) {
    if( !$base.useString( string ) ) {
        return ;
    }
    // 初期化.
    this.name = "" ;
    this.value = "" ;
    
    var p = string.indexOf( "=" ) ;
    if( p == -1 ) {
        this.name = string ;
        this.value = null ;
    }
    else {
        this.name = ParserUtil.trim( string.substring( 0,p ) ) ;
        this.value = ParserUtil.trim( string.substring( p+1 ) ) ;
        if( ( $base.startsWith( this.value,"\"" ) || $base.startsWith( this.value,"'" ) ) &&
            ( $base.endsWith( this.value,"\"" ) || $base.endsWith( this.value,"'" ) ) ) {
            this.value = this.value.substring( 1,this.value.length-1 ) ;
        }
    }
}
TagElement.prototype = {
    // 要素名.
    name : "",
    // 要素内容.
    value : "",
    // 文字列に変換.
    toString : function() {
        if( $base.isNull( this.value ) ) {
            return this.name ;
        }
        var c = "\"" ;
        if( this.value.indexOf( "\'" ) == -1 ) {
            c = "\'" ;
        }
        return this.name+"="+c+this.value+c ;
    }
}
// タグオブジェクト.
Tag = function( string ) {
    if( $base.isNull( string ) ) {
        throw "not tag" ;
    }
    // 初期化.
    this.name = "" ;
    this.values = [] ;
    this.endFlag = false ;
    this.startEndFlag = false ;
    
    var p ;
    var cote = -1 ;
    var s = -1 ;
    var bf = -1 ;
    var eq = 0 ;
    var key = null ;
    var yenFlag = false ;
    var c = null ;
    string = $base.changeString( string,"\r\n","\n" ) ;
    string = ParserUtil.trim( string.substring( 1,string.length-1 ) ) ;
    string = ParserUtil.cutEnter( string ) ;
    if( $base.startsWith( string,"/" ) ) {
        this.endFlag = true ;
        string = ParserUtil.trim( string.substring( 1,string.length ) ) ;
        p = ParserUtil.indexOfCote( string," " ) ;
        if( p == -1 ) {
            this.name = ParserUtil.trim( string ).toLowerCase() ;
        }
        else {
            this.name = ParserUtil.trim( string.substring( 0,p ) ).toLowerCase() ;
        }
    }
    else {
        if( $base.endsWith( string,"/" ) ) {
            this.startEndFlag = true ;
            string = ParserUtil.trim( string.substring( 0,string.length-1 ) ) ;
        }
        p = ParserUtil.indexOfCote( string," " ) ;
        if( p == -1 ) {
            this.name = ParserUtil.trim( string ).toLowerCase() ;
            return ;
        }
        this.name = ParserUtil.trim( string.substring( 0,p ) ).toLowerCase() ;
        string = ParserUtil.trim( string.substring( p ) ) ;
        var len = string.length ;
        for( var i = 0 ; i < len ; i ++ ) {
            c = string.charAt( i ) ;
            if( cote != -1 ) {
                if( c == cote && bf != '\\' ) {
                    yenFlag = false ;
                    cote = -1 ;
                    if( key != null ) {
                        this.addElement( key,string.substring( s+1,i ) ) ;
                        key = null ;
                        eq = 0 ;
                        s = -1 ;
                    }
                    else {
                        throw "error element[" + string + "]...pos:" + i ;
                    }
                }
                else if( c == '\\' && bf == '\\' ) {
                    yenFlag = true ;
                }
                else {
                    yenFlag = false ;
                }
            }
            else {
                if( c == '\'' || c == '\"' ) {
                    if( s != -1 ) {
                        throw "error element[" + string + "]...pos:" + i ;
                    }
                    else if( key == null ) {
                        throw "error element[" + string + "]...pos:" + i ;
                    }
                    else if( bf == '\\' ) {
                        throw "An illegal content of cote exists. [" + string + "]...pos:" + i ;
                    }
                    cote = c ;
                    s = i ;
                    continue ;
                }
                else if( c == '\r' || c == '\n' || c == ' ' || c == '　' || c == '\t' ) {
                    if( eq == 0 ) {
                        if( s != -1 ) {
                            if( key != null ) {
                                this.addElement( key,null ) ;
                                key = null ;
                                eq = 0 ;
                            }
                            key = string.substring( s,i ) ;
                            eq = 0 ;
                            s = -1 ;
                        }
                    }
                    else if( eq == 1 ) {
                        if( key == null ) {
                            throw "error element[" + string + "]...pos:" + i ;
                        }
                        this.addElement( key,string.substring( s,i ) ) ;
                        key = null ;
                        eq = 0 ;
                        s = -1 ;
                    }
                }
                else if( c == '=' ) {
                    if( eq == 0 ) {
                        if( s != -1 ) {
                            if( key != null ) {
                                this.addElement( key,null ) ;
                                key = null ;
                                eq = 0 ;
                            }
                            key = string.substring( s,i ) ;
                            eq = 1 ;
                            s = -1 ;
                        }
                        else {
                            throw "error element[" + string + "]...pos:" + i ;
                        }
                    }
                    else {
                        throw "error element[" + string + "]...pos:" + i ;
                    }
                }
                else if( s == -1 ) {
                    s = i ;
                }
            }
            if( yenFlag ) {
                yenFlag = false ;
                bf = -1 ;
            }
            else {
                bf = c ;
            }
        }
        if( s != -1 ) {
            if( eq == 0 ) {
                if( s != -1 ) {
                    if( key != null ) {
                        this.addElement( key,null ) ;
                        key = null ;
                    }
                    this.addElement( string.substring( s ),null ) ;
                }
            }
            else if( eq == 1 ) {
                if( key == null ) {
                    throw "error element[" + string + "]" ;
                }
                this.addElement( key,string.substring( s ) ) ;
            }
        }
    }
}
Tag.prototype = {
    // タグ名.
    name : "",
    // 要素群.
    values : [],
    // 終了フラグ.
    endFlag : false,
    // 開始終了フラグ.
    startEndFlag : false,
    // タグ名を取得.
    getName : function() {
        return this.name ;
    },
    // 要素を直接追加.
    addInner : function( string ) {
        if( this.endFlag ) {
            return false ;
        }
        var t = new TagElement( string ) ;
        this.values[ this.values.length ] = t ;
        return true ;
    },
    // TagElementオブジェクトをを直接追加.
    addTagElement : function( te ) {
        if( this.endFlag ) {
            return false ;
        }
        this.values[ this.values.length ] = te ;
        return true ;
    },
    // 要素を追加.
    addElement : function( name,value ) {
        if( this.endFlag ) {
            return false ;
        }
        var t = new TagElement() ;
        t.name = name.toLowerCase() ;
        t.value = value ;
        this.values[ this.values.length ] = t ;
        return true ;
    },
    // 指定項番の要素を設定.
    setElement : function( no,name,value ) {
        if( this.endFlag ) {
            return false ;
        }
        if( no >= 0 && this.values.length > no ) {
            var t = this.values[no] ;
            t.name = name.toLowerCase() ;
            t.value = value ;
            return true ;
        }
        return false ;
    },
    // 指定項番の要素を取得.
    getElement : function( no ) {
        if( this.endFlag ) {
            return null ;
        }
        if( no >= 0 && this.values.length > no ) {
            var ret = this.values[no] ;
            if( !$base.isNull( ret ) ) {
                return ret ;
            }
        }
        return null ;
    },
    // 要素内容を直接取得.
    get : function( no ) {
        if( this.endFlag ) {
            return null ;
        }
        if( no >= 0 && this.values.length > no ) {
            var ret = this.values[no] ;
            if( !$base.isNull( ret ) ) {
                if( !$base.isNull( ret.value ) ) {
                    return ret.value
                }
            }
        }
        return null ;
    },
    // 指定項番の要素を削除.
    removeElement : function( no ) {
        if( this.endFlag ) {
            return false ;
        }
        if( no >= 0 && this.values.length > no ) {
            this.values[no] = null ;
            return true ;
        }
        return false ;
    },
    // 指定名の要素を検索.
    search : function( name,off ) {
        if( this.endFlag ) {
            return false ;
        }
        if( $base.isNull( off ) ) {
            off = 0 ;
        }
        if( $base.useString( name ) ) {
            name = ParserUtil.trim( name ).toLowerCase() ;
            var len = this.values.length ;
            for( var i = off ; i < len ; i ++ ) {
                if( !$base.isNull( this.values[ i ] ) &&
                    name == this.values[ i ].name ) {
                    return i ;
                }
            }
        }
        return -1 ;
    },
    // タグ要素数を取得.
    length : function() {
        if( this.endFlag ) {
            return 0 ;
        }
        return this.values.length ;
    },
    // 文字列に変換.
    toString : function() {
        if( this.endFlag ) {
            return "</" + this.name + ">" ;
        }
        var len = this.values.length ;
        var buf = new StrBuf( "<" ).ad( this.name ) ;
        for( var i = 0 ; i < len ; i ++ ) {
            var t = this.values[ i ] ;
            if( $base.isNull( t ) ) {
                continue ;
            }
            buf.ad( " " ).ad( t.toString() ) ;
        }
        if( this.startEndFlag ) {
            buf.ad( " / " ) ;
        }
        buf.ad( ">" ) ;
        return buf.ts() ;
    }
}
// Htmlコメントオブジェクト.
HtmlComment = function() {
    this.value = "" ;
}
HtmlComment.prototype = {
    // 要素.
    value : "",
    // 要素を設定.
    set : function( string ) {
        this.value = string ;
    },
    // 要素を取得.
    get : function() {
        return this.value ;
    },
    // 文字列に変換.
    toString : function() {
        return "<!-- " + this.value + " -->" ;
    }
}
// htmlオブジェクト.
Html = function( string ) {
    if( $base.isNull( string ) ) {
        throw "not html" ;
    }
    // 初期化.
    this.values = [] ;
    
    // タグ範囲.
    var tagPos = [-1,-1] ;
    
    var b = 0 ;
    if( !HtmlUtil.startTagPos( tagPos,string,b ) ) {
        string = ParserUtil.trim( string ) ;
        if( string.length > 0 ) {
            this.values[ this.values.length ] = string ;
        }
        return ;
    }
    var p = tagPos[ 0 ] ;
    var e = tagPos[ 1 ] ;
    if( p > 0 ) {
        var s = ParserUtil.trim( string.substring( b,p ) ) ;
        if( s.length > 0 ) {
            this.values[ this.values.length ] = s ;
        }
    }
    while( true ) {
        var t = string.substring( p,e+1 ) ;
        if( t.charAt( 1 ) == '!' && t.charAt( 2 ) == '-' &&
            t.charAt( 3 ) == '-' ) {
            var c = new HtmlComment() ;
            c.set( ParserUtil.trim( t.substring( "<!--".length,( t.length - (parseInt("-->".length)+1) ) ) ) ) ;
            this.values[ this.values.length ] = c ;
        }
        else {
            t = ParserUtil.trim( t ) ;
            var s = ParserUtil.trim( t.substring( 1,t.length-1 ) ) ;
            if( s.length <= 0 || $base.startsWith( ( s = s.toLowerCase() ),"!doctype" ) ) {
                this.values[ this.values.length ] = t ;
            }
            else {
                var tg = new Tag( t ) ;
                this.values[ this.values.length ] = tg ;
            }
        }
        b = e+1 ;
        if( !HtmlUtil.startTagPos( tagPos,string,b ) ) {
            var s = ParserUtil.trim( string.substring( b ) ) ;
            if( s.length > 0 ) {
                this.values[ this.values.length ] = s ;
            }
            return ;
        }
        p = tagPos[ 0 ] ;
        e = tagPos[ 1 ] ;
        if( b != p ) {
            var s = ParserUtil.trim( string.substring( b,p ) ) ;
            if( s.length > 0 ) {
                this.values[ this.values.length ] = s ;
            }
        }
    }
}
Html.prototype = {
    // 要素群.
    values : [],
    // パース数を取得.
    length : function() {
        return this.values.length ;
    },
    // 削除条件を除く.
    trim : function() {
        var len = this.values.length ;
        var tmp = [] ;
        for( var i = 0 ; i < len ; i ++ ) {
            if( !$base.isNull( this.values[ i  ] ) ) {
                tmp[tmp.length] = this.values[ i  ] ;
            }
        }
        this.values = tmp ;
    },
    // 指定項番の要素を取得.
    get : function( no ) {
        if( no >= 0 && this.values.length > no ) {
            var ret = this.values[ no ] ;
            if( !$base.isNull( ret ) ) {
                return ret ;
            }
        }
        return null ;
    },
    // 指定項番の要素を削除して取得.
    remove : function( no ) {
        if( no >= 0 && this.values.length > no ) {
            var ret = this.values[ no ] ;
            if( !$base.isNull( ret ) ) {
                this.values[ no ] = null ;
                return ret ;
            }
        }
        return null ;
    },
    // 指定タグ郡を検索.
    getTagNames : function( name,endTag ) {
        if( !$base.useString( name ) ) {
            return null ;
        }
        if( endTag != true ) {
            endTag = false ;
        }
        name = ParserUtil.trim( name ).toLowerCase() ;
        var len = this.values.length ;
        var ret = [] ;
        if( endTag ) {
            for( var i = 0 ; i < len ; i ++ ) {
                var t = this.values[ i ] ;
                if( !$base.isNull( t ) && t instanceof Tag && t.name == name ) {
                    ret[ ret.length ] = t ;
                }
            }
        }
        else {
            for( var i = 0 ; i < len ; i ++ ) {
                var t = this.values[ i ] ;
                if( !$base.isNull( t ) && t instanceof Tag && t.name == name && t.endFlag == false ) {
                    ret[ ret.length ] = t ;
                }
            }
        }
        return ret ;
    },
    // 指定条件のタグを検索.
    search : function( endFlag,name,off ) {
        if( !$base.useString( name ) ) {
            return -1 ;
        }
        if( endFlag != true ) {
            endFlag = false ;
        }
        if( $base.isNull( off ) ) {
            off = 0 ;
        }
        name = ParserUtil.trim( name ).toLowerCase() ;
        var len = this.values.length ;
        for( var i = off ; i < len ; i ++ ) {
            var t = this.values[ i ] ;
            if( !$base.isNull( t ) && t instanceof Tag && t.name == name && endFlag == t.endFlag ) {
                return i ;
            }
        }
        return -1 ;
    },
    // 指定タグ位置の閉じタグ位置を取得.
    searchEnd : function( no ) {
        if( $base.isNull( no ) ) {
            return -1 ;
        }
        if( no >= 0 && this.values.length > no ) {
            var t = this.values[ no ] ;
            if( !( !$base.isNull( t ) && t instanceof Tag && t.endFlag == false && t.startEndFlag == false ) ) {
                return -1 ;
            }
            var ind = 1 ;
            var len = this.values.length ;
            for( var i = no+1 ; i < len ; i ++ ) {
                var x = this.values[ i ] ;
                if( !$base.isNull( x ) && x instanceof Tag && x.name == t.name ) {
                    if( x.endFlag == true ) {
                        ind -- ;
                    }
                    else if( x.startEndFlag == false ) {
                        ind ++ ;
                    }
                    if( ind <= 0 ) {
                        return i ;
                    }
                }
            }
        }
        return -1 ;
    },
    // 文字列に変換.
    toString : function() {
        var buf = new StrBuf() ;
        var len = this.values.length ;
        for( var i = 0 ; i < len ; i ++ ) {
            var t = this.values[ i ] ;
            if( !$base.isNull( t ) ) {
                if( t instanceof Tag ) {
                    buf.ad( t.toString() ) ;
                }
                else if( t instanceof HtmlComment ) {
                    buf.ad( t.toString() ) ;
                }
                else {
                    buf.ad( t ) ;
                }
            }
        }
        return buf.ts() ;
    }
}

///////////////////////////////////////////////////////////////////////////////
// HTMLパーサー応用.
///////////////////////////////////////////////////////////////////////////////

// 指定タグ内容を抽出.
// 指定タグを除外する.
getInnerTag = function( mode,s,tgName ) {
    var ret = new StrBuf() ;
    var html = null ;
    if( s instanceof Html ) {
        html = s ;
    }
    else {
        if( !$base.useString( s ) ) {
            return "" ;
        }
        html = new Html( s ) ;
        retFlag = true ;
    }
    s = null ;
    var b = 0 ;
    while( true ) {
        var sn = html.search( false,tgName,b ) ;
        if( sn == -1 ) {
            break ;
        }
        var en = html.searchEnd( sn ) ;
        if( en == -1 ) {
            break ;
        }
        b = en + 1 ;
        var o = null ;
        if( !mode ) {
            html.remove( sn ) ;
            html.remove( en ) ;
        }
        sn ++ ;
        en -- ;
        for( var i = sn ; i <= en ; i ++ ) {
            if( mode ) {
                o = html.get( i ) ;
            }
            else {
                o = html.remove( i ) ;
            }
            if( o instanceof HtmlComment ) {
                ret.ad( o.get() ) ;
            }
            else {
                ret.ad( o ) ;
            }
        }
    }
    return ret.ts() ;
} ;

// 指定タグだけを除外する.
cutTargetTag = function( s,tgName ) {
    var retFlag = false ;
    var html = null ;
    if( s instanceof Html ) {
        html = s ;
    }
    else {
        if( !$base.useString( s ) ) {
            return "" ;
        }
        html = new Html( s ) ;
        retFlag = true ;
    }
    s = null ;
    var b = 0 ;
    while( true ) {
        var sn = html.search( false,tgName,b ) ;
        if( sn == -1 ) {
            break ;
        }
        html.remove( sn ) ;
    }
    if( retFlag ) {
        return html.toString() ;
    }
    else {
        return html ;
    }
} ;

// 指定タグ内容を除外する.
cutInnerTag = function( s,tgName ) {
    var retFlag = false ;
    var html = null ;
    if( s instanceof Html ) {
        html = s ;
    }
    else {
        if( !$base.useString( s ) ) {
            return "" ;
        }
        html = new Html( s ) ;
        retFlag = true ;
    }
    s = null ;
    var b = 0 ;
    while( true ) {
        var sn = html.search( false,tgName,b ) ;
        if( sn == -1 ) {
            break ;
        }
        var en = html.searchEnd( sn ) ;
        if( en == -1 ) {
            break ;
        }
        b = en + 1 ;
        var o = null ;
        for( var i = sn ; i <= en ; i ++ ) {
            o = html.remove( i ) ;
            if( o instanceof Tag ) {
                continue ;
            }
        }
    }
    if( retFlag ) {
        return html.toString() ;
    }
    else {
        return html ;
    }
} ;

//innerHTML実行処理.
innerHTML = function( node,value ) {
    if( typeof( node ) == "string" ) {
        node = $( node ) ;
    }
    // ExitToDialogが利用されていて、ブラウザがIEの場合.
    if( ExitToDialog.isUse() && isMSIE ) {
        if( !(value instanceof Html) ) {
            value = new Html( value ) ;
        }
        ExitToDialog.ieToConvertLink( value ) ;
        value = value.toString() ;
        fastInnerHTML( node,value ) ;
        return value ;
    }
    // HTMLパーサ解析済みの条件.
    else if( value instanceof Html ) {
        value = value.toString() ;
        fastInnerHTML( node,value ) ;
        return value ;
    }
    // 通常の文字列.
    else if( valueof( value ) == "string" ) {
        fastInnerHTML( node,value ) ;
        return value ;
    }
}

////////////////////////////////////////////////////////////////////////////////
// edit終了ダイアログ系.
////////////////////////////////////////////////////////////////////////////////

ExitToDialog = {
    // Edit終了ダイアログ利用フラグ.
    initFlag : false,
    // 更新フラグ.
    updateEditFlag : false,
    // IE用非遷移フラグ.
    toIeByNoLink : false,
    // クリアーID.
    clearId : null,
    // 出力メッセージ.
    msg : null,
    // ページ遷移時に、編集中フラグがONの場合の確認処理.
    initPageMoveByDialog : function(clId,msg) {
        ExitToDialog.initFlag = true ;
        if( $base.useString( msg ) ) {
            ExitToDialog.msg = msg ;
            // 終了前のハンドリング処理を定義.
            window.onbeforeunload = function(event) {
                event = getEvent( event ) ;
                if( !ExitToDialog.toIeByNoLink ) {
                    if( ExitToDialog.updateEditFlag ) {
                        if( isMSIE ) {
                            ExitToDialog.toIeByNoLink = false ;
                            return "『" + ExitToDialog.msg + "』" ;
                        }
                        else {
                            ExitToDialog.toIeByNoLink = false ;
                            event.returnValue = "『" + ExitToDialog.msg + "』" ;
                            return true ;
                        }
                    }
                    else if( !isMSIE ) {
                        event.returnValue = null;
                    }
                }
                ExitToDialog.toIeByNoLink = false ;
            }
            if( $base.useString( clId ) ) {
                ExitToDialog.clearId = clId ;
            }
            else {
                ExitToDialog.clearId = null ;
            }
            // IEの場合は、Javascriptリンク(href="javascript:・・・")に対して、
            // onclickイベント追加処理に変換して処理する.
            ExitToDialog.ieToAddLink() ;
        }
    },
    // 更新フラグをONにセット.
    editOn : function() {
        ExitToDialog.updateEditFlag = true ;
    },
    // 更新フラグをOFFにセット.
    editOff : function() {
        ExitToDialog.updateEditFlag = false ;
    },
    // 編集中の編集内容破棄確認.
    isCancelEdit : function() {
        var ret = false ;
        if( ExitToDialog.updateEditFlag ) {
            ret = confirm( ExitToDialog.msg ) ;
            if( ret ) {
                if( ExitToDialog.clearId != null ) {
                    //$(ExitToDialog.clearId).innerHTML = "&nbsp;" ;
                    fastInnerHTML( ExitToDialog.clearId,"&nbsp;" ) ;
                }
                ExitToDialog.editOff() ;
            }
            else {
                ExitToDialog.editOn() ;
            }
            ret = !ret ;
        }
        else {
            if( ExitToDialog.clearId != null ) {
                //$(ExitToDialog.clearId).innerHTML = "&nbsp;" ;
                fastInnerHTML( ExitToDialog.clearId,"&nbsp;" ) ;
            }
            ExitToDialog.editOff() ;
        }
        return ret ;
    },
    // IEでの、リンク実行開始処理.
    ieToScriptLink : function() {
        if( isMSIE ) {
            ExitToDialog.toIeByNoLink = true ;
        }
    },
    // IEでの、リンク実行付加処理.
    ieToAddLink : function() {
        if( isMSIE ) {
            var allTags = ( document.getElementsByTagName('*') || document.all );
            if( allTags != null ) {
                var tag ;
                var len = allTags.length ;
                for (var i=0; i<len; i++) {
                    tag = allTags[i] ;
                    if( tag.tagName.toUpperCase() == "A" && $base.useString( tag.href ) &&
                        $base.startsWith( tag.href.toLowerCase(),"javascript:" ) ) {
                        var s = tag.href ;
                        //tag.href = "#" ;
                        tag.href = "javascript:void(0);" ;
                        $base.addEvent( tag,"click",new Function( s.substring( 11 ) ) ) ;
                    }
                }
            }
        }
    },
    // IEでの、リンク実行付加処理(Htmlパーサー版).
    ieToConvertLink : function( html ) {
        if( !$base.useString( html ) ) {
            return html ;
        }
        if( isMSIE ) {
            var linkTags = html.getTagNames( "a" ) ;
            if( $base.isNull( linkTags ) ) {
                return html ;
            }
            var len = linkTags.length ;
            for( var i = 0 ; i < len ; i ++ ) {
                var lnk = linkTags[ i ] ;
                var p = lnk.search( "href" ) ;
                if( p == -1 ) {
                    continue ;
                }
                var s = lnk.get( p ) ;
                if( !$base.isNull( s ) && $base.startsWith( s.toLowerCase(),"javascript:" ) ) {
                    //lnk.setElement( p,"href","#" ) ;
                    lnk.setElement( p,"href","javascript:void(0);" ) ;
                    p = lnk.search( "onclick" ) ;
                    if( p == -1 ) {
                        lnk.addElement( "onclick",s ) ;
                    }
                    else {
                        s = s.substring( 11 ) ;
                        var x = lnk.get( p ) ;
                        if( !$base.isNull( x ) ) {
                            lnk.setElement( p,"onclick",x+s ) ;
                        }
                        else {
                            lnk.addElement( "onclick",s ) ;
                        }
                    }
                }
            }
        }
        return html ;
    },
    // ExitToDialog利用チェック.
    isUse : function() {
        return ExitToDialog.initFlag ;
    }
}

