///////////////////////////////////////////////////////////////////////////////
// seabass JSONP系処理.
// Copyright (c) 2009 masahito suzuki, Inc. All Rights Reserved.
///////////////////////////////////////////////////////////////////////////////
//
// ※JSONP処理、RPC処理、COMMET処理を行う場合は、
//   このJavascriptを呼び出してください

///////////////////////////////////////////////////////////////////////////////
// jsonpオブジェクト.
///////////////////////////////////////////////////////////////////////////////

$jsonp = {
    // jsonp実行処理.
    execution : function(url,cb,arg,jmap) {
        if( $base.useString( url ) == false ) {
            throw "urlが指定されていません" ;
        }
        // パラメータ引数をJSON形式に変換.
        if( $base.isNull( arg ) || valueof( arg ) != "array" ) {
            arg = null ;
        }
        var params = new StrBuf() ;
        // JSONP引数.
        if( $base.isNull( arg ) == false && arg.length > 0 ) {
            params.ad( "jargs=" ).ad( encodeURIComponent( $json.encode( arg ) ) ) ;
        }
        else {
            params.ad( "jargs=" ) ;
        }
        // コールバックメソッドが存在する場合、その内容をパラメータとしてセット.
        if( $base.useString( cb ) ) {
            params.ad( "&callback=" ).ad( encodeURIComponent(cb) ) ;
        }
        if( $base.isNull( jmap ) == false && valueof( jmap ) == 'map' ) {
            params.ad( convertParams( jmap ) ) ;
        }
        return this.send( url,md5(url),null,params.ts() ) ;
    },
    // jsonp.
    send : function( url,id,name,params ) {
        if( $base.useString( url ) == false ) {
            throw "接続先(url)を指定してください" ;
        }
        // url名に整形.
        if( $base.startsWith( url,"http://" ) == false &&
            $base.startsWith( url,"https://" ) == false ) {
            if( url.startsWith( "/" ) == false ) {
                url = "/" + url ;
            }
            if( $base.useString( __VAL_GLOVAL__['_$HTTP_URL'] ) &&
                $base.useString( __VAL_GLOVAL__['_$HTTPS_URL'] ) ) {
                // 現在の接続プロトコルに合った通信を行う.
                if( document.location.protocol == "http:" ) {
                    url = __VAL_GLOVAL__['_$HTTP_URL'] + url ;
                }
                else {
                    url = __VAL_GLOVAL__['_$HTTPS_URL'] + url ;
                }
            }
            else {
                var s = document.URL ;
                var p = s.indexOf( "//" ) ;
                p = s.indexOf( "/",p+2 ) ;
                s = s.substring( 0,p+1 ) ;
                url = s + url ;
            }
        }
        if( url.indexOf( "?" ) == -1 ) {
            url += "?t=" + new Date().getTime() ;
        }
        else {
            url += "&t=" + new Date().getTime() ;
        }
        if( url.indexOf( "://"+$base.getDomain() ) != -1 ) {
            url = $base.addNoCookieBySession( url ) ;
        }
        includeJS( url,params,name ) ;
        
        return url ;
    }
} ;

// 通常のＪＳＯＮＰ.
accessJSONP = function( url,params ) {
    includeJS( url,params,"_"+md5( url )+"Id" ) ;
} ;

///////////////////////////////////////////////////////////////////////////////
// RPCオブジェクト.
///////////////////////////////////////////////////////////////////////////////

$rpc = {
    _methodCounter : 0,
    // jsonpサーバリソースにアクセスするメソッド生成.
    createFunction : function( url,callFunc ) {
        if( $base.useString( url ) == false || typeof( url ) != "string" ||
            url.endsWith( ".mhtml" ) || url.endsWith( "mttml" ) ) {
            throw "urlは不正です" ;
        }
        if( $base.isNull( callFunc ) || typeof( callFunc ) != "function" ) {
            throw "callFuncは不正です" ;
        }
        if( url.endsWith( ".ms" ) ) {
            url = url.substring( 0,url.length-".ms".length ) ;
        }
        if( url.endsWith( "/" ) ) {
            url += "index" ;
        }
        if( url.endsWith( "Rpc" ) == false ) {
            url += "Rpc" ;
        }
        // コールバックメソッドをセット.
        var callbackName = "_rs_rpc"+this._methodCounter+"_"+new Date().getTime() ;
        this._methodCounter ++ ;
        eval( callbackName + "=" + callFunc.toString() ) ;
        callFunc = null ;
        // 実行メソッドを生成して戻す.
        return (function() {
            // パラメータ引数をJSON形式に変換.
            var jargs = [] ;
            for( var i = 0 ; i < arguments.length ; i ++ ) {
                jargs[ jargs.length ] = encodeURIComponent(arguments[ i ]) ;
            }
            $jsonp.execution( url,callbackName,jargs,null ) ;
        }) ;
    }
} ;

///////////////////////////////////////////////////////////////////////////////
// Cometオブジェクト.
///////////////////////////////////////////////////////////////////////////////

$comet = {
    _methodCounter : 0,
    // comet開始処理.
    startComet : function( url,gid,callFunc ) {
        if( $base.useString( url ) == false || typeof( url ) != "string" ||
            url.endsWith( ".mhtml" ) || url.endsWith( "mttml" ) ) {
            throw "urlは不正です" ;
        }
        if( $base.isNull( callFunc ) || typeof( callFunc ) != "function" ) {
            throw "callFuncは不正です" ;
        }
        if( url.endsWith( ".ms" ) ) {
            url = url.substring( 0,url.length-".ms".length ) ;
        }
        if( url.endsWith( "/" ) ) {
            url += "index" ;
        }
        if( url.endsWith( "Comet" ) == false ) {
            url += "Comet" ;
        }
        if( $base.useString( gid ) == false ) {
            gid = md5( url.substring( 0,url.length-"Comet".length ) ) ;
        }
        if( gid.startsWith( "gid_" ) == false ) {
            gid = "gid_" + gid ;
        }
        // コールバックメソッド名を生成.
        var callbackName = "_rs_cmt"+this._methodCounter+"_"+new Date().getTime() ;
        this._methodCounter ++ ;
        // コールバックメソッドを改竄.
        var funcStr = callFunc.toString() ;
        callFunc = null ;
        var p = funcStr.lastIndexOf( "}" ) ;
        // 改竄コールバックメソッドをセット.
        funcStr = new StrBuf().ad( callbackName ).ad( " = " ).ad( funcStr.substring( 0,p ) ).
            ad( "\n    $jsonp.execution(\"" ).ad( url ).ad( "\",\"" ).
            ad( callbackName ).ad( "\",null,{groupId:\"" ).
            ad( gid ).ad( "\"});\n}" ).ts() ;
        eval( funcStr ) ;
        funcStr = null ;
        $jsonp.execution( url,callbackName,null,{groupId:gid} ) ;
    },
    // cometトリガー実行用メソッドを生成.
    triggerFunction : function( url,gid ) {
        if( $base.useString( url ) == false || typeof( url ) != "string" ||
            url.endsWith( ".mhtml" ) || url.endsWith( "mttml" ) ) {
            throw "urlは不正です" ;
        }
        if( url.endsWith( ".ms" ) ) {
            url = url.substring( 0,url.length-".ms".length ) ;
        }
        if( url.endsWith( "/" ) ) {
            url += "index" ;
        }
        if( url.endsWith( "Trigger" ) == false ) {
            url += "Trigger" ;
        }
        if( $base.useString( gid ) == false ) {
            gid = md5( url.substring( 0,url.length-"Trigger".length ) ) ;
        }
        if( gid.startsWith( "gid_" ) == false ) {
            gid = "gid_" + gid ;
        }
        // 実行メソッドを生成して戻す.
        return (function() {
            // パラメータ引数をJSON形式に変換.
            var jargs = [] ;
            for( var i = 0 ; i < arguments.length ; i ++ ) {
                jargs[ jargs.length ] = arguments[ i ] ;
            }
            $jsonp.execution( url,null,jargs,{"groupId":gid} ) ;
        }) ;
    }
}

