////////////////////////////////////////////////////////////////////////////////
// キー入力系.
////////////////////////////////////////////////////////////////////////////////

InKey = {
    _ALPHA_CD : [ 'A', 'B', 'C', 'D', 'E', 'F', 'G',
    'H', 'I', 'J', 'K', 'L', 'M', 'N', 'O', 'P', 'Q', 'R', 'S', 'T',
    'U', 'V', 'W', 'X', 'Y', 'Z' ],
    // 数値キー入力チェック.
    getNumber : function( event ) {
        switch( getKeyCode( event ) ) {
            case 48 :// 通常キー.
            case 96 :// (テンキー).
                return '0' ;
            case 49 :// 通常キー.
            case 97 :// (テンキー).
                return '1' ;
            case 50 :// 通常キー.
            case 98 :// (テンキー).
                return '2' ;
            case 51 :// 通常キー.
            case 99 :// (テンキー).
                return '3' ;
            case 52 :// 通常キー.
            case 100 :// (テンキー).
                return '4' ;
            case 53 :// 通常キー.
            case 101 :// (テンキー).
                return '5' ;
            case 54 :// 通常キー.
            case 102 :// (テンキー).
                return '6' ;
            case 55 :// 通常キー.
            case 103 :// (テンキー).
                return '7' ;
            case 56 :// 通常キー.
            case 104 :// (テンキー).
                return '8' ;
            case 57 :// 通常キー.
            case 105 :// (テンキー).
                return '9' ;
        }
        return null ;
    },
    // アルファベット入力チェック.
    getAlphabet : function( event ) {
        var key = getKeyCode( event ) ;
        if( key >= 65 && key <= 90 ) {
            return InKey._ALPHA_CD[ key - 65 ] ;
        }
        return null ;
    },
    // コントロールキーが押されているかチェック.
    isCtrl : function( event ) {
        event = getEvent( event ) ;
        if( isMSIE ) {
            return event.ctrlKey ;
        }
        else {
            return ( event.modifiers == undefined ) ? event.ctrlKey :
                event.modifiers & Event.CONTROL_MASK ;
        }
    },
    // シフトキーが押されているかチェック.
    isShift : function( event ) {
        event = getEvent( event ) ;
        if( isMSIE ) {
            return event.shiftKey ;
        }
        else {
            return ( event.modifiers == undefined ) ? event.shiftKey :
                event.modifiers & Event.SHIFT_MASK ;
        }
    },
    // 改行入力チェック.
    isEnter : function( event ) {
        return ( getKeyCode( event ) == 13 ) ;
    },
    // バックスペース入力チェック.
    isBackSpace : function( event ) {
        return ( getKeyCode( event ) == 8 ) ;
    },
    // Delete入力チェック.
    isDelete : function( event ) {
        return ( getKeyCode( event ) == 46 ) ;
    },
    // スペース入力チェック.
    isSpace : function( event ) {
        return ( getKeyCode( event ) == 32 ) ;
    },
    // タブ入力チェック.
    isTab : function( event ) {
        return ( getKeyCode( event ) == 9 ) ;
    },
    // ESC入力チェック.
    isESC : function( event ) {
        return ( getKeyCode( event ) == 27 ) ;
    },
    // PageUp入力チェック.
    isPgUp : function( event ) {
        return ( getKeyCode( event ) == 33 ) ;
    },
    // PageDown入力チェック.
    isPgDn : function( event ) {
        return ( getKeyCode( event ) == 34 ) ;
    }
}
