///////////////////////////////////////////////////////////////////////////////
// Javascript描画部品関連.
///////////////////////////////////////////////////////////////////////////////

// テキストモード.
TextMode = {
    NUMBER : 0,   // 数値のみ.
    ALPHA : 1,    // 英数.
    HIRA : 2,     // 平仮名.
    KATA : 3      // カタカナ.
} ;

// 金額表示(円).
viewYen = function( val ) {
    if( $base.isNull( val ) || $base.isNumeric( val ) == false ) {
        return val ;
    }
    val = ""+ val ;
    var len = val.length ;
    var cnt = 0 ;
    var ret = "" ;
    for( var i = len-1 ; i >= 0 ; i -- ) {
        if( cnt >= 3 ) {
            ret = "," + ret ;
            cnt = 0 ;
        }
        ret = val.substring( i,i+1 ) + ret ;
        cnt ++ ;
    }
    return ret ;
}

// 日付情報を表示.
viewDate = function( value,view ) {
    if( valueof( value ) != "date" ) {
        return "" ;
    }
    if( $base.isNull( view ) || typeof( view ) != "array" || view.length != 3 ) {
        view = ["年","月","日"] ;
    }
    var y = ""+value.getFullYear() ;
    var m = ""+(value.getMonth()+1) ;
    var d = ""+value.getDate() ;
    var buf = new StrBuf() ;
    buf.ad( y ).ad( view[ 0 ] ) ;
    buf.ad( "00".substring( m.length ) ).ad( m ).ad( view[ 1 ] ) ;
    buf.ad( "00".substring( d.length ) ).ad( d ).ad( view[ 2 ] ) ;
    return buf.ts() ;
}

// 内容表示.
viewList = function(value,view) {
    var t = valueof( view ) ;
    if( t == "array" ) {
        var len = view.length ;
        for( var i = 0 ; i < len ; i += 2 ) {
            if( view[ i ] == value ) {
                return view[ i+1 ] ;
            }
        }
        return value ;
    }
    else if( t == "map" ) {
        if( $base.isNull( view[ value ] ) ) {
            return value ;
        }
        return view[ value ] ;
    }
    return value ;
}

// チェンジカラー値を設定.
setChangeColor = function( a,n ) {
    _$setChangeColor( a,n ) ;
}

// チェンジカラー値をクリア.
clearChangeColor = function() {
    setGlobal( "_$_$active_$changeColor",null ) ;
    setGlobal( "_$_$noActive_$changeColor",null ) ;
}

// select表示.
selectTag = function(name,no,value,view,size,multiple,id,clazz,blankFlag) {
    var changeColor = getGlobal( "_$_$active_$changeColor" ) ;
    var changeNColor = getGlobal( "_$_$noActive_$changeColor" ) ;
    if( $base.useString( name ) == false ) {
        return "" ;
    }
    if( !$base.isNumeric( no ) ) {
        no = 0 ;
    }
    else {
        no = parseInt( no ) ;
    }
    if( $base.useString( id ) == false ) {
        id = name+"_"+no+"_Id" ;
    }
    var buf = new StrBuf().ad( "<select name=\"" ).ad( name ).ad( "\" id=\"" ).ad( id ).ad( "\" " ) ;
    if( $base.isNumeric( size ) ) {
        buf.ad( "size=\"" ).ad( size ).ad( "\" " ) ;
        if( size == 1 ) {
            size = null ;
        }
    }
    else {
        size = null ;
    }
    if( $base.useString( clazz ) ) {
        buf.ad( "class=\"" ).ad( clazz ).ad( "\" " ) ;
    }
    if( size != null && isNull( multiple ) == false && multiple == true ) {
        buf.ad( "multiple " ) ;
    }
    if( $base.useString( changeColor ) ) {
        buf.ad( " onblur='javascript:document.getElementById(\""+id+"\").style.backgroundColor=\"").ad(changeNColor).ad("\";'" ).
            ad( " onfocus='javascript:document.getElementById(\""+id+"\").style.backgroundColor=\"").ad(changeColor).ad("\";'" ) ;
    }
    buf.ad( ">\n" ) ;
    var t = valueof( view ) ;
    if( t == "map" ) {
        var lst = value ;
        if( blankFlag ) {
            buf.ad( "    <option value=\"\">未選択</option>\n" ) ;
        }
        if( $base.isNull( lst ) ) {
            for( var k in view ) {
                buf.ad( "    <option value=\"" ).ad( k ).ad( "\">" ).ad( view[k] ).ad( "</option>\n" ) ;
            }
        }
        else {
            if( valueof( lst ) != "array" ) {
                lst = ""+lst ;
                for( var k in view ) {
                    buf.ad( "    <option value=\"" ).ad( k ).ad( "\" " ) ;
                    if( lst == ""+k ) {
                        buf.ad( "selected " ) ;
                    }
                    buf.ad( ">" ).ad( view[k] ).ad( "</option>\n" ) ;
                }
            }
            else {
                for( var k in view ) {
                    var key = ""+k ;
                    buf.ad( "    <option value=\"" ).ad( k ).ad( "\" " ) ;
                    for( var i = 0 ; i < len ; i ++ ) {
                        var s = ""+lst.get( i ) ;
                        if( $base.isNull( s ) == false && s == k ) {
                            buf.ad( "selected " ) ;
                            break ;
                        }
                    }
                    buf.ad( ">" ).ad( view[k] ).ad( "</option>\n" ) ;
                }
            }
        }
    }
    else if( t == "array" ) {
        if( blankFlag ) {
            buf.ad( "    <option value=\"\">未選択</option>\n" ) ;
        }
        var lst = value ;
        var len = view.length ;
        if( $base.isNull( lst ) ) {
            // 未選択の場合.
            for( var i = 0 ; i < len ; i += 2 ) {
                var k = view[ i ] ;
                var v = view[ i + 1 ] ;
                buf.ad( "    <option value=\"" ).ad( k ).ad( "\">" ).ad( v ).ad( "</option>\n" ) ;
            }
        }
        else {
            // 単一選択の場合.
            if( valueof( lst ) != "array" ) {
                lst = ""+ lst ;
                for( var i = 0 ; i < len ; i += 2 ) {
                    var k = view[ i ] ;
                    var v = view[ i + 1 ] ;
                    buf.ad( "    <option value=\"" ).ad( k ).ad( "\" " ) ;
                    if( lst == ""+ k ) {
                        buf.ad( "selected " ) ;
                    }
                    buf.ad( ">" ).ad( v ).ad( "</option>\n" ) ;
                }
            }
            else {
                // 複数選択の場合.
                var listLen = lst.length ;
                for( var i = 0 ; i < len ; i += 2 ) {
                    var k = view[ i ] ;
                    var v = view[ i + 1 ] ;
                    buf.ad( "    <option value=\"" ).ad( k ).ad( "\" " ) ;
                    var key = ""+ k ;
                    for( var j = 0 ; j < listLen ; j ++ ) {
                        var s = lst.get( j ) ;
                        if( $base.isNull( s ) == false && ""+ s == key ) {
                            buf.ad( "selected " ) ;
                            break ;
                        }
                    }
                    buf.ad( ">" ).ad( v ).ad( "</option>\n" ) ;
                }
            }
        }
    }
    return buf.ad( "</select>" ).ts() ;
}

// 日付情報を表示.
selectYMD = function( name,no,value,yearOut,mode,view,minYear ) {
    var changeColor = getGlobal( "_$_$active_$changeColor" ) ;
    var changeNColor = getGlobal( "_$_$noActive_$changeColor" ) ;
    if( $base.useString( name ) == false ) {
        return "" ;
    }
    if( !$base.isNumeric( no ) ) {
        no = 0 ;
    }
    else {
        no = parseInt( no ) ;
    }
    if( minYear == null || !$base.isNumeric( minYear ) ) {
        minYear = 0 ;
    }
    var year = null ;
    var month = null ;
    var day = null ;
    var c = null ;
    if( $base.isNull( view ) || valueof( view ) != "array" || view.length != 3 ) {
        year = "年" ;
        month = "月" ;
        day = "日" ;
    }
    else {
        year = view[ 0 ] ;
        month = view[ 1 ] ;
        day = view[ 2 ] ;
        if( !$base.useString( year ) ) {
            year = "年" ;
        }
        if( !$base.useString( month ) ) {
            month = "月" ;
        }
        if( !$base.useString( day ) ) {
            day = "日" ;
        }
    }
    if( !$base.isNull( mode ) || mode == "true" || mode == true ) {
        mode = true ;
    }
    else {
        mode = false ;
    }
    var buf = new StrBuf() ;
    
    // 年を生成.
    var yId = name+"Year_"+no+"_Id" ;
    buf.ad( "\n<select name=\"" ).ad( name ).ad( "Year\" id=\"" ).ad( yId ).ad( "\" " ) ;
    buf.ad( " onchange='$base.changeSelectYMD( \"" ).ad( name ).ad( "\"," ).ad( no ).ad( ");'" ) ;
    if( $base.useString( changeColor ) ) {
        buf.ad( " onblur='javascript:document.getElementById(\""+yId+"\").style.backgroundColor=\"").ad(changeNColor).ad("\";'" ).
            ad( " onfocus='javascript:document.getElementById(\""+yId+"\").style.backgroundColor=\"").ad(changeColor).ad("\";'" ) ;
    }
    buf.ad( ">\n" ) ;
    var n = new Date().getFullYear() ;
    var nowYear = n ;
    n = n - minYear ;
    var tg = null ;
    if( valueof( value ) == "date" ) {
        tg = value.getFullYear() ;
    }
    if( yearOut == null ) {
        yearOut = 0 ;
    }
    yearOut = parseInt( yearOut ) ;
    var len = yearOut + nowYear - minYear ;
    var y = 0 ;
    if( mode == false ) {
        buf.ad( "    <option value=\"\">未選択</option>\n" ) ;
    }
    if( yearOut <= 0 ) {
        if( !$base.useString( tg ) ) {
            y = n ;
            for( var i = n ; i >= len ; i -- ) {
                buf.ad( "    <option value=\"" ).ad( i ).ad( "\" " ) ;
                if( mode == true && i == nowYear ) {
                    buf.ad( "selected " ) ;
                }
                buf.ad( ">" ).ad( i ).ad( "</option>\n" ) ;
            }
        }
        else {
            y = tg ;
            for( var i = n ; i >= len ; i -- ) {
                buf.ad( "    <option value=\"" ).ad( i ).ad( "\" " ) ;
                if( i == tg ) {
                    buf.ad( "selected " ) ;
                }
                buf.ad( ">" ).ad( i ).ad( "</option>\n" ) ;
            }
        }
        buf.ad( "\n</select>\n" ) ;
    }
    else {
        if( !$base.useString( tg ) ) {
            y = n ;
            for( var i = n ; i < len ; i ++ ) {
                buf.ad( "    <option value=\"" ).ad( i ).ad( "\" " ) ;
                if( mode == true && i == nowYear ) {
                    buf.ad( "selected " ) ;
                }
                buf.ad( ">" ).ad( i ).ad( "</option>\n" ) ;
            }
        }
        else {
            y = tg ;
            for( var i = n ; i < len ; i ++ ) {
                buf.ad( "    <option value=\"" ).ad( i ).ad( "\" " ) ;
                if( i == tg ) {
                    buf.ad( "selected " ) ;
                }
                buf.ad( ">" ).ad( i ).ad( "</option>\n" ) ;
            }
        }
        buf.ad( "\n</select>\n" ) ;
    }
    buf.ad( year ).ad( "\n" ) ;
    
    // 月を生成.
    var mId = name+"Month_"+no+"_Id" ;
    buf.ad( "\n<select name=\"" ).ad( name ).ad( "Month\" id=\"" ).ad( mId ).ad( "\" " ) ;
    buf.ad( " onchange='$base.changeSelectYMD( \"" ).ad( name ).ad( "\"," ).ad( no ).ad( ");'" ) ;
    if( $base.useString( changeColor ) ) {
        buf.ad( " onblur='javascript:document.getElementById(\""+mId+"\").style.backgroundColor=\"").ad(changeNColor).ad("\";'" ).
            ad( " onfocus='javascript:document.getElementById(\""+mId+"\").style.backgroundColor=\"").ad(changeColor).ad("\";'" ) ;
    }
    buf.ad( ">\n" ) ;
    n = new Date().getMonth() + 1 ;
    var tg = null ;
    if( valueof( value ) == "date" ) {
        tg = value.getMonth()+1 ;
    }
    var m = 0 ;
    if( mode == false ) {
        buf.ad( "    <option value=\"\">未選択</option>\n" ) ;
    }
    if( !$base.useString( tg ) ) {
        m = n ;
        for( var i = 1 ; i <= 12 ; i ++ ) {
            c = ""+i ;
            var c = "00".substring( c.length ) + c ;
            if( mode == true && i == n ) {
                buf.ad( "    <option value=\"" ).ad( i ).ad( "\" selected>" ).ad( c ).ad( "</option>\n" ) ;
            }
            else {
                buf.ad( "    <option value=\"" ).ad( i ).ad( "\">" ).ad( c ).ad( "</option>\n" ) ;
            }
        }
    }
    else {
        m = tg ;
        for( var i = 1 ; i <= 12 ; i ++ ) {
            c = ""+i ;
            var c = "00".substring( c.length ) + c ;
            buf.ad( "    <option value=\"" ).ad( i ).ad( "\" " ) ;
            if( i == tg ) {
                buf.ad( "selected " ) ;
            }
            buf.ad( ">" ).ad( c ).ad( "</option>\n" ) ;
        }
    }
    buf.ad( "\n</select>\n" ) ;
    buf.ad( month ).ad( "\n" ) ;
    
    // 日を生成.
    var sId = name+"SYMD_"+no+"_Id" ;
    var dId = name+"Day_"+no+"_Id" ;
    buf.ad( "\n<span id=\"" ).ad( sId ).ad( "\">" ) ;
    buf.ad( "\n<select name=\"" ).ad( name ).ad( "Day\" id=\"" ).ad( dId ).ad( "\"" ) ;
    if( $base.useString( changeColor ) ) {
        buf.ad( " onblur='javascript:document.getElementById(\""+dId+"\").style.backgroundColor=\"").ad(changeNColor).ad("\";'" ).
            ad( " onfocus='javascript:document.getElementById(\""+dId+"\").style.backgroundColor=\"").ad(changeColor).ad("\";'" ) ;
    }
    buf.ad( ">\n" ) ;
    var tg = null ;
    if( valueof( value ) == "date" ) {
        tg = value.getDate() ;
    }
    if( mode == false && $base.useString( tg ) == false ) {
        buf.ad( "    <option value=\"\">未選択</option>\n" ) ;
    }
    else {
        y = parseInt( y ) ;
        m = parseInt( m ) ;
        var ymKey = new StrBuf().ad( y ).ad( "_" ).ad( m ).ts() ;
        len = null ;
        var st = new Date( y,m-1,1,0,0,0 ).getTime() ;
        m ++ ;
        if( m > 12 ) {
            m = 1 ;
            y ++ ;
        }
        var ed = new Date( y,m-1,1,0,0,0 ).getTime() ;
        len = parseInt( ( ed - st ) / 86400000 ) ;
        if( !$base.useString( tg ) ) {
            n = new Date().getDate() ;
            for( var i = 1 ; i <= len ; i ++ ) {
                var c = ""+i ;
                var c = "00".substring( c.length ) + c ;
                if( mode == true && i == n ) {
                    buf.ad( "    <option value=\"" ).ad( i ).ad( "\" selected>" ).ad( c ).ad( "</option>\n" ) ;
                }
                else {
                    buf.ad( "    <option value=\"" ).ad( i ).ad( "\">" ).ad( c ).ad( "</option>\n" ) ;
                }
            }
        }
        else {
            for( var i = 1 ; i <= len ; i ++ ) {
                var c = ""+i ;
                var c = "00".substring( c.length ) + c ;
                buf.ad( "    <option value=\"" ).ad( i ).ad( "\" " ) ;
                if( i == tg ) {
                    buf.ad( "selected " ) ;
                }
                buf.ad( ">" ).ad( c ).ad( "</option>\n" ) ;
            }
        }
    }
    buf.ad( "\n</select></span>\n" ) ;
    buf.ad( day ).ad( "\n" ) ;
    return buf.ts() ;
}

// テキスト情報を表示.
textTag = function(name,id,no,clazz,size,max,style,defaultIme,readOnly,value,tabletMode ) {
    var changeColor = getGlobal( "_$_$active_$changeColor" ) ;
    var changeNColor = getGlobal( "_$_$noActive_$changeColor" ) ;
    if( !$base.useString( clazz ) ) {
        clazz = "text" ;
    }
    if( !$base.isNumeric( no ) ) {
        no = 0 ;
    }
    else {
        no = parseInt( no ) ;
    }
    if( !$base.useString( id ) ) {
        id = name+"_"+no+"_Id" ;
    }
    var buf = new StrBuf().ad( "<input type=\"text\" name=\"" ).ad( name ).ad( "\" " ) ;
    if( $base.useString( id ) ) {
        buf.ad( "id=\"" ).ad( id ).ad( "\" " ) ;
    }
    if( $base.useString( clazz ) ) {
        buf.ad( "class=\"" ).ad( clazz ).ad( "\" " ) ;
    }
    if( $base.isNumeric( size ) ) {
        buf.ad( "size=\"" ).ad( size ).ad( "\" " ) ;
    }
    if( $base.isNumeric( max ) ) {
        buf.ad( "maxlength=\"" ).ad( max ).ad( "\" " ) ;
    }
    if( $base.useString( value ) ) {
        buf.ad( "value=\"" ).ad( value ).ad( "\" " ) ;
    }
    if( readOnly == true || readOnly == "true" ) {
        readOnly = true ;
    }
    else {
        readOnly = false ;
    }
    if( tabletMode == true || tabletMode == "true" ) {
        tabletMode = true ;
    }
    else {
        tabletMode = null ;
    }
    var tabletMd = ( getCookie( "seabass_tablet_mode" ) == "true" ) ;
    if( tabletMode == false ) {
        tabletMd = false ;
    }
    // タブレットモードの場合は、アルファベットpopupWindowを表示.
    if( tabletMd ) {
        readOnly = true ; // タブレットモードの場合は、入力枠はreadonly.
        switch( defaultIme ) {
            case TextMode.NUMBER :   // 数値.
                if( $base.isNumeric( max ) ) {
                    Event.onclick( "TouchPanel.number.window( \"" + id + "\","+max+" )" ) ;
                }
                else {
                    Event.onclick( "TouchPanel.number.window( \"" + id + "\",4096 )" ) ;
                }
                break ;
            case TextMode.HIRA :   // 平仮名.
                if( $base.isNumeric( max ) ) {
                    Event.onclick( "TouchPanel.hiraKana.window( \"" + id + "\","+max+" )" ) ;
                }
                else {
                    Event.onclick( "TouchPanel.hiraKana.window( \"" + id + "\",4096 )" ) ;
                }
                break ;
            case TextMode.KATA :   // カタカナ.
                if( $base.isNumeric( max ) ) {
                    Event.onclick( "TouchPanel.kataKana.window( \"" + id + "\","+max+" )" ) ;
                }
                else {
                    Event.onclick( "TouchPanel.kataKana.window( \"" + id + "\",4096 )" ) ;
                }
                break ;
            default :              // 英数.
                if( $base.isNumeric( max ) ) {
                    Event.onclick( "TouchPanel.alpha.window( \"" + id + "\","+max+" )" ) ;
                }
                else {
                    Event.onclick( "TouchPanel.alpha.window( \"" + id + "\",4096 )" ) ;
                }
                break ;
        }
    }
    if( $base.useString( style ) ) {
        style = $base.trim( style ) ;
        if( $base.endsWith( style, ";" ) ) {
            style = $base.trim( style.substring( 0,style.length-1 ) ) ;
        }
        switch( defaultIme ) {
            case TextMode.NUMBER :
                style = style + " ; ime-mode:disabled ;" ;
                break ;
            case TextMode.ALPHA :
                style = style + " ; ime-mode:inactive ;" ;
                break ;
            case TextMode.HIRA :
            case TextMode.KATA :
                style = style + " ; ime-mode:active ;" ;
                break ;
            default :
                style += ";" ;
                break ;
        }
    }
    else {
        switch( defaultIme ) {
            case TextMode.NUMBER :
                style = "ime-mode:disabled ;" ;
                break ;
            case TextMode.ALPHA :
                style = "ime-mode:inactive ;" ;
                break ;
            case TextMode.HIRA :
            case TextMode.KATA :
                style = "ime-mode:active ;" ;
                break ;
        }
    }
    if( $base.useString( style ) ) {
        buf.ad( " style=\"" ).ad( style ).ad( "\" " ) ;
    }
    if( readOnly == true ) {
        buf.ad( " readonly " ) ;
    }
    if( $base.useString( changeColor ) ) {
        buf.ad( " onblur='javascript:document.getElementById(\""+id+"\").style.backgroundColor=\"").ad(changeNColor).ad("\";'" ).
            ad( " onfocus='javascript:document.getElementById(\""+id+"\").style.backgroundColor=\"").ad(changeColor).ad("\";'" ) ;
    }
    return buf.ad( " >" ).ts() ;
}

