////////////////////////////////////////////////////////////////////////////////
// tree表示.
////////////////////////////////////////////////////////////////////////////////

// Tree初期化処理.
initTree = function( id,varName,selectFunc,fMap,noRootLink,infoMap ) {
    var index = null ;
    var indent = null ;
    var rootFile = null ;
    var opFile = null ;
    var clFile = null ;
    var fFile = null ;
    var rootName = null ;
    var dirClazz = null ;
    var fileClazz = null ;
    if( !$base.isNull( infoMap ) && valueof( infoMap ) == "map" ) {
        index = infoMap['index'] ;
        indent = infoMap['indent'] ;
        rootFile = infoMap['root'] ;
        opFile = infoMap['open'] ;
        clFile = infoMap['close'] ;
        fFile = infoMap['list'] ;
        rootName = infoMap['rootName'] ;
        dirClazz = infoMap['dirClass'] ;
        fileClazz = infoMap['fileClass'] ;
    }
    if( $base.isNull( rootFile ) ) {
        rootFile = "/img/~seabass/tree/root.gif" ;
    }
    if( $base.isNull( opFile ) ) {
        opFile = "/img/~seabass/tree/open.gif" ;
    }
    if( $base.isNull( clFile ) ) {
        clFile = "/img/~seabass/tree/close.gif" ;
    }
    if( $base.isNull( fFile ) ) {
        fFile = "/img/~seabass/tree/list.png" ;
    }
    if( $base.isNull( rootName ) ) {
        rootName = "<root>" ;
    }
    var ret = new Tree() ;
    ret._init( id,index,indent,varName,selectFunc,
        rootFile,opFile,clFile,fFile,fMap,rootName,noRootLink,dirClazz,fileClazz ) ;
    return ret ;
}

Tree = function() {}
Tree._tree = function( object,opFile,clFile,dirId,fullPath,selectFunc ) {
    if( !$base.isNull( object ) && !$base.isNull( fullPath ) ) {
        object._lastSelectIO = fullPath ;
        object._lastSelectType = 0 ;
        if( $base.useFunction( selectFunc ) ) {
            getGlobal(selectFunc)( 0,fullPath ) ;
        }
    }
    var dir = document.getElementById( dirId ) ;
    if( $base.isNull( dir ) ) {
        return ;
    }
    var s = dir.style ;
    if( s.display == "none" ) {
        s.display = "block" ;
        if( !$base.isNull( opFile ) ) {
            document.getElementById( dirId+"dir_Id" ).src=opFile ;
        }
    }
    else {
        s.display = 'none' ;
        if( !$base.isNull( clFile ) ) {
            document.getElementById( dirId+"dir_Id" ).src=clFile ;
        }
    }
} ;
Tree._activeDir = function( object,fullPath,selectFunc ) {
    if( !$base.isNull( object ) && !$base.isNull( fullPath ) ) {
        object._lastSelectIO = fullPath ;
        object._lastSelectType = 0 ;
        if( $base.useFunction( selectFunc ) ) {
            getGlobal(selectFunc)( 0,fullPath ) ;
        }
    }
} ;
Tree._activeFile = function( object,fullPath,selectFunc ) {
    if( !$base.isNull( object ) && !$base.isNull( fullPath ) ) {
        object._lastSelectIO = fullPath ;
        object._lastSelectType = 1 ;
        if( $base.useFunction( selectFunc ) ) {
            getGlobal(selectFunc)( 1,fullPath ) ;
        }
    }
} ;
Tree._target = function( dirId ) {
    var dir = document.getElementById( dirId ) ;
    if( $base.isNull( dir ) ) {
        return false ;
    }
    var s = dir.style ;
    if( s.display == "none" ) {
        return false ;
    }
    return true ;
} ;
Tree.prototype = {
    _id : "",
    _openFile : "",
    _closeFile : "",
    _dirClazz : "",
    _fileClazz : "",
    _lastSelectIO : "",
    _lastSelectType : -1,
    // ツリーをフルオープン.
    open : function() {
        for( var i = 1 ;; i ++ ) {
            for( var j = 0 ;; j ++ ) {
                var name = "_dir_" + this._id + "_" + i + "_" + j + "_iD_" ;
                if( $base.isNull( document.getElementById( name ) ) ) {
                    if( j == 0 ) {
                        return ;
                    }
                    break ;
                }
                if( !Tree._target( name ) ) {
                    Tree._tree( null,this._openFile,this._closeFile,name,null,null ) ;
                }
            }
        }
    },
    // ツリーをクローズ.
    close : function( index ) {
        if( $base.isNull( index ) || index <= 0 ) {
            index = 1 ;
        }
        for( var i = index ;; i ++ ) {
            for( var j = 0 ;; j ++ ) {
                var name = "_dir_" + this._id + "_" + i + "_" + j + "_iD_" ;
                if( $base.isNull( document.getElementById( name ) ) ) {
                    if( j == 0 ) {
                        return ;
                    }
                    break ;
                }
                if( Tree._target( name ) ) {
                    Tree._tree( null,this._openFile,this._closeFile,name,null,null ) ;
                }
            }
        }
    },
    // ツリー初期処理.
    _init : function( id,index,indent,varName,selectFunc,rootFile,opFile,clFile,fFile,fMap,rootName,noRootLink,dirClazz,fileClazz ) {
        if( $base.isNull( varName ) ) {
            return ;
        }
        var treeInfo = document.getElementById( id ) ;
        if( $base.isNull( treeInfo ) ) {
            return ;
        }
        if( !$base.isNull( selectFunc ) && typeof( selectFunc ) == 'function' ) {
            var funcName = "_$access$Tree$Result" ;
            setGlobal(funcName,selectFunc) ;
            selectFunc = funcName ;
        }
        else if( !$base.useString( selectFunc ) ) {
            selectFunc = "" ;
        }
        if( !$base.useString( rootName ) ) {
            rootName = "<root>" ;
        }
        if( $base.isNull( indent ) ) {
            //indent = "2em" ;
            indent = "18px" ;
        }
        if( $base.isNull( index ) || index <= 0 ) {
            index = -1 ;
        }
        if( $base.isNull( dirClazz ) ) {
            dirClazz = "directory" ;
        }
        if( $base.isNull( fileClazz ) ) {
            fileClazz = "file" ;
        }
        var s = treeInfo.innerHTML ;
        treeInfo.innerHTML = "" ;
        var lst = s.split( "|" ) ;
        var len = lst.length ;
        var dirCnt = [
            0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
            0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0] ;
        var dirNames = [
            "","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","",
            "","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","",""]
        var fileCnt = 0 ;
        var ind = 0 ;
        s = "" ;
        // ディレクトリ構成生成.
        for( var i = 0 ; i < len ; i ++ ) {
            var x = $base.trim( lst[ i ] ) ;
            if( $base.startsWith( x,"?" ) ) {
                if( fileCnt > 0 ) {
                    s += "</div>" ;
                    fileCnt = 0 ;
                }
                var p = x.indexOf( "*" ) ;
                var pp = x.indexOf( "*",p+1 ) ;
                var targetDir = x.substring( 1,p ) ;
                var innerLength = x.substring( p+1,pp ) ;
                var nowDirName = "" ;
                for( var j = 1 ; j < ind ; j ++ ) {
                    nowDirName += "/" + dirNames[ j ] ;
                }
                var viewDir = targetDir ;
                nowDirName += "/" + targetDir ;
                if( dirCnt[ind] == 0 && ind == 0 ) {
                    nowDirName = "/" ;
                    viewDir = $base.changeStringByHTML( rootName ) ;
                }
                if( nowDirName != "/" ) {
                    s += "<div class=\""+dirClazz+"\" style=\"margin-left:"+indent+";\"><div>" ;
                    s += "<input type='image' src='" + opFile + "' onclick='javascript:Tree._tree("+varName+"," +
                        "\"" + opFile + "\"," +
                        "\"" + clFile + "\"," +
                        "\"_dir_" + id + "_" + ind + "_" + dirCnt[ind] + "_iD_\"," +
                        "\"" + nowDirName + "\"," +
                        "\"" + selectFunc + "\");' id=\"_dir_" + id + "_" + ind + "_" + dirCnt[ind] + "_iD_dir_Id\">" ;
                }
                else {
                    s += "<div class=\""+dirClazz+"\" style=\"margin-left:0px;\"><div>" ;
                    s += "<input type='image' src='" + rootFile + "' onclick='javascript:Tree._activeDir("+
                        varName+"," + "\"" + nowDirName + "\",\"" + selectFunc + "\");'>" ;
                }
                if( noRootLink && nowDirName == "/" ) {
                    s += viewDir ;
                }
                else {
                    s += "<a href='javascript:Tree._activeDir("+varName+"," + "\"" + nowDirName + "\",\"" + selectFunc + "\");'>" ;
                    if( nowDirName == "/" ) {
                        s += viewDir + "</a>" ;
                    }
                    else {
                        s += viewDir + "</a>" + " (" + innerLength + ")" ;
                    }
                }
                s += "</div><div id=\"_dir_" + id + "_" + ind + "_" + dirCnt[ind] + "_iD_\">" ;
                dirNames[ind] = targetDir ;
                dirCnt[ind] ++ ;
                ind ++ ;
            }
            else if( $base.startsWith( x,"\\" ) ) {
                var p = x.indexOf( "*" ) ;
                var pp = x.indexOf( "*",p+1 ) ;
                var vInfo = x.substring( 1,p ) ;
                var vLink = x.substring( p+1,pp ) ;
                if( fileCnt == 0 ) {
                    s += "<div class=\""+fileClazz+"\" style=\"margin-left:"+indent+";\">" ;
                }
                var fimg = null ;
                if( !$base.isNull( fMap ) && valueof( fMap ) == 'map' ) {
                    var pls = null ;
                    p = vInfo.lastIndexOf( "." ) ;
                    if( p != -1 ) {
                        pls = vInfo.substring( p+1 ).toLowerCase() ;
                    }
                    fimg = fMap[pls] ;
                }
                if( $base.isNull( fimg ) ) {
                    fimg = fFile ;
                }
                s += "<div id=\"_file_" + id + "_" + ind + "_" + dirCnt[ind] +"_"+ fileCnt + "_iD\">" +
                    "<img src='" + fimg + "'>" + 
                    "<a href='javascript:Tree._activeFile("+varName+"," +
                    "\"" + vLink + "\","+
                    "\"" + selectFunc + "\");'>" + vInfo + "</a></div>" ;
                fileCnt ++ ;
            }
            else if( x == "*" ) {
                if( fileCnt > 0 ) {
                    s += "</div>" ;
                    fileCnt = 0 ;
                }
                s += "</div></div>" ;
                ind -- ;
            }
        }
        this._id = id ;
        this._openFile = opFile ;
        this._closeFile = clFile ;
        this._dirClazz = dirClazz ;
        this._fileClazz = fileClazz ;
        innerHTML( treeInfo,s ) ;
        if( index >= 1 ) {
            this.close( index ) ;
        }
        setGlobal(varName,this) ;
    }
} ;
