package org.maachang.util;

import java.util.concurrent.ConcurrentLinkedQueue;

/**
 * 最速文字連結バッファ用Factory.
 *
 * @version 2009/10/14
 * @author masahito suzuki
 * @since MaachangBase 1.0B
 */
public class FastStringBufferFactory {
    private static final ConcurrentLinkedQueue<FastStringBuffer> queue =
        new ConcurrentLinkedQueue<FastStringBuffer>() ;
    
    /**
     * FastStringBufferを取得.
     * @return FastStringBuffer FastStringBufferが返されます.
     */
    public static final FastStringBuffer get() {
        FastStringBuffer ret = queue.poll() ;
        if( ret == null ) {
            ret = new FastStringBuffer() ;
        }
        return ret ;
    }
    
    /**
     * FastStringBufferをリリース.
     */
    protected static final void release( FastStringBuffer html ) {
        if( html != null && !html.isClear() ) {
            html.clear() ;
        }
        queue.offer( html ) ;
    }
}

