package org.maachang.util;

/**
 * シリアライズロール１要素オブジェクト.
 *
 * @version 2009/12/14
 * @author masahito suzuki
 * @since MaachangBase 1.0B
 */
public class SerializeRollElement {
    private byte[] binary = null ;
    private long id = -1L ;
    private int position = -1 ;
    
    /** コンストラクタ **/
    public SerializeRollElement() {
        
    }
    
    /**
     * コンストラクタ.
     * @param binary 対象のバイナリを設定します.
     * @param id 対象のIDを設定します.
     */
    public SerializeRollElement( byte[] binary,long id ) {
        this.binary = binary ;
        this.id = id ;
    }
    
    /**
     * クリア.
     */
    public void clear() {
        binary = null ;
        id = -1L ;
        position = -1 ;
    }
    
    /**
     * バイナリを設定.
     * @param binary 対象のバイナリを設定します.
     */
    public void setBinary( byte[] binary ) {
        this.binary = binary ;
    }
    
    /**
     * バイナリを取得.
     * @return byte[] バイナリが返されます.
     */
    public byte[] getBinary() {
        return binary ;
    }
    
    /**
     * IDを設定.
     * @param id 対象のIDを設定します.
     */
    public void setId( long id ) {
        this.id = id ;
    }
    
    /**
     * IDを取得.
     * @return long IDが返されます.
     */
    public long getId() {
        return id ;
    }
    
    /**
     * ポジションを設定.
     * @param pos 対象のポジションを設定します.
     */
    public void setPosition( int position ) {
        this.position = position ;
    }
    
    /**
     * ポジションを取得.
     * @return int ポジションが返されます.
     */
    public int getPosition() {
        return position ;
    }
}
