package org.maachang.util;

/**
 * Stack情報.
 * 
 * @version 2009/02/13
 * @author  masahito suzuki
 * @since   MaachangBase 1.0A
 */
public class StackInfo<T> {
    private StackInfoChild<T> cell = null ;
    private int count = 0 ;
    
    static class StackInfoChild<T> {
        T object = null ;
        StackInfoChild<T> next = null ;
    }
    
    public StackInfo() {}
    
    public void clear() {
        this.cell = null ;
    }
    
    public void push(T object) {
        StackInfoChild<T> nw = new StackInfoChild<T>();
        nw.object = object;
        nw.next = this.cell;
        this.cell = nw;
        count ++ ;
    }
    
    public T pop() {
        if( this.cell == null ) {
            return null ;
        }
        T ret = cell.object ;
        this.cell = this.cell.next ;
        count -- ;
        return ret ;
    }
    
    public T peek() {
        if( this.cell == null ) {
            return null ;
        }
        return this.cell.object ;
    }
    
    public int size() {
        return count ;
    }
}
