package org.maachang.util.atomic ;

import java.util.concurrent.atomic.AtomicInteger;

/**
 * Atomic同期.
 * 
 * @version 2009/09/13
 * @author masahito suzuki
 * @since MaachangBase 1.0B
 */
public class AtomicLock {
    private final AtomicInteger sync = new AtomicInteger( 0 ) ;
    
    /**
     * ロック処理.
     */
    public void lock() {
        while( !sync.compareAndSet( 0,1 ) ) {
            try{Thread.sleep( 1 ) ;}catch( Exception e ){}
        }
    }
    
    /**
     * アンロック処理.
     */
    public void unlock() {
        while( !sync.compareAndSet( sync.get(),0 ) ) {
        }
    }
    
}

