package org.maachang.util.atomic;

import org.maachang.util.atomic.lock.HashLock;

/**
 * ターゲットロックオブジェクト.
 * 
 * @version 2009/06/19
 * @author masahito suzuki
 * @since MaachangBase 1.0B
 */
public class TargetLock {
    private final HashLock hashLock = new HashLock() ;
    
    /**
     * コンストラクタ.
     */
    public TargetLock() {
        
    }
    
    /**
     * ロック処理.
     * @param code 対象のコードを設定します.
     */
    public void lock( String code ) {
        if( code == null ) {
            return ;
        }
        hashLock.lock( code.hashCode() ) ;
    }
    
    /**
     * アンロック処理.
     * @param code 対象のコードを設定します.
     */
    public void unlock( String code ) {
        if( code == null ) {
            return ;
        }
        hashLock.unlock( code.hashCode() ) ;
    }
}

