package org.maachang.dao.dbms ;

import gnu.trove.THashMap;

import java.util.Collection;
import java.util.Map;
import java.util.Set;

/**
 * Dao専用Map.
 * 
 * @version 2009/09/09
 * @author masahito suzuki
 * @since MaachangDao 1.00
 */
public class DaoMap implements Map<String,Object> {
    private final Map<String,Object> base = new THashMap<String,Object>() ;
    public DaoMap() {
    }
    public void clear() {
        base.clear() ;
    }
    public void putAll(Map<? extends String, ? extends Object> toMerge) {
        base.putAll( toMerge ) ;
    }
    public boolean containsValue( Object value) {
        return base.containsValue( value ) ;
    }
    public Set<Map.Entry<String,Object>> entrySet() {
        return base.entrySet() ;
    }
    public Collection<Object> values() {
        return base.values() ;
    }
    public Object put(String name, Object value) {
        return base.put( name,value ) ;
    }
    public boolean containsKey(Object key) {
        return base.containsKey( key ) ;
    }
    public Object get(Object key) {
        return base.get( key ) ;
    }
    public boolean isNull( String key ) {
        if( base.containsKey( key ) ) {
            if( base.get( key ) == null ) {
                return true ;
            }
        }
        return false ;
    }
    public Object remove(Object key) {
        return base.remove( key ) ;
    }
    public boolean isEmpty() {
        return base.isEmpty() ;
    }
    public Set<String> keySet() {
        return base.keySet() ;
    }
    public int size() {
        return base.size() ;
    }
    public String toString() {
        return base.toString() ;
    }
}
