package org.maachang.dao.dbms.kind;

/**
 * MySQL用DBMS定義.
 * 
 * @version 2007/10/18
 * @author masahito suzuki
 * @since MaachangDao 1.00
 */
public class KindByMySql extends SupportKind {
    
    /**
     * リミットSQL文を取得.
     * @param mode join/srcJoinが存在する場合は、trueを設定します.
     * @param offset オフセット値を設定します.
     * @param limit リミット値を設定します.
     * @return String リミットSQL文が返されます.
     */
    public String getLimit( boolean mode,int offset,int limit ) {
        if( mode ) {
            return new StringBuilder().
                append( " OFFSET " ).append( offset ).toString() ;
        }
        return new StringBuilder().
            append( " LIMIT " ).append( offset ).
            append( "," ).append( limit ).append( " " ).toString() ;
    }
    
    /**
     * Boolean非サポートフラグ.
     * <BR><BR>
     * Boolean非サポートフラグを取得します.
     * <BR>
     * @return boolean [true]の場合は、サポートしています.
     */
    public boolean isBoolean() {
        return false ;
    }
    
    /**
     * limitサポートフラグ.
     * @return boolean [true]の場合、limit処理はサポートしています.
     */
    public boolean isLimit() {
        return true ;
    }
    
    /**
     * アダプタ名を取得.
     * <BR><BR>
     * アダプタ名を取得します.
     * <BR>
     * @return String アダプタ名が返されます.
     */
    public String getAdapter() {
        return "mysql" ;
    }
    
    /**
     * IDを設定した後の取得SQL.
     * <BR><BR>
     * IDを設定した後の取得SQLが返されます.
     * <BR>
     * @return String SQLが返されます.
     */
    public String getInsertIdBySQL() {
        return "SELECT LAST_INSERT_ID()";
    }
    
}
