package org.maachang.dao.dbms.pool.atomic;

import java.sql.Connection;

/**
 * RDBMSConnection.
 * 
 * @version 2009/05/30
 * @author masahito suzuki
 * @since MaachangDao 1.13
 */
public interface RdbmsConnection extends Connection {
    /** オブジェクトを破棄. **/
    public void destroy() ;
    
    /** 非アクティブ時間を取得. **/
    public long noActiveTime() ;
    
    /** オブジェクトアクティブ. **/
    public void toActive() ;
    
    /** 管理元コネクションがクローズされているかチェック. **/
    public boolean isConnectionClose() ;
}
