package org.maachang.seabass ;

import org.maachang.util.FileUtil;

/**
 * SeaBassWebApplication定義.
 *
 * @version 2007/08/26
 * @author  masahito suzuki
 * @since   SeaBass 1.00
 */
public class SeaBassDef {
    
    private SeaBassDef() {}
    
    /**
     * エラー行数出力定義.
     */
    public static final int OUTPUT_ERROR_LIST = 128 ;
    
    /**
     * ディレクトリ : コンフィグ.
     */
    public static final String DIRECTORY_CONFIG = "conf/" ;
    
    /**
     * ディレクトリ : アプリケーション.
     */
    public static final String DIRECTORY_APPLICATION = "application/" ;
    
    /**
     * ディレクトリ : Modelディレクトリ.
     */
    public static final String DIRECTORY_MODEL = "model/" ;
    
    /**
     * ディレクトリ : ライブラリ用ディレクトリ.
     */
    public static final String DIRECTORY_LIB = "lib/" ;
    
    /**
     * ディレクトリ : JARファイル用ディレクトリ.
     */
    public static final String DIRECTORY_JAR = "jar/" ;
    
    /**
     * ディレクトリ : ログ出力用ディレクトリ.
     */
    public static final String DIRECTORY_LOG = "log/" ;
    
    /**
     * ディレクトリ : テーブル用ディレクトリ.
     */
    public static final String DIRECTORY_TABLE = "table/" ;
    
    /**
     * ディレクトリ : エラーページ用ディレクトリ.
     */
    public static final String DIRECTORY_ERROR_PAGE = "error/" ;
    
    /**
     * ディレクトリ : テンプレート用ディレクトリ.
     */
    public static final String DIRECTORY_TEMPLATE = "template/" ;
    
    /**
     * ディレクトリ : 公開ディレクトリ.
     */
    public static final String DIRECTORY_PUBLIC = "public/" ;
    
    /**
     * ディレクトリ : スタートアップディレクトリ.
     */
    public static final String DIRECTORY_STARTUP = "startup/" ;
    
    /**
     * ディレクトリ : クーロン(スケジューリング)ディレクトリ.
     */
    public static final String DIRECTORY_CRON = "cron/" ;
    
    /**
     * ディレクトリ : タグライブラリディレクトリ.
     */
    public static final String DIRECTORY_TAGLIB = "taglib/" ;
    
    /**
     * ディレクトリ : 帳票定義ディレクトリ.
     */
    public static final String DIRECTORY_REPORT = "report/" ;
    
    /**
     * ディレクトリ : 画像ディレクトリ[公開ディレクトリ配下に存在する].
     */
    public static final String DIRECTORY_IMAGE = "img/" ;
    
    /**
     * ディレクトリ : 外部StyleSeetディレクトリ[公開ディレクトリ配下に存在する].
     */
    public static final String DIRECTORY_CSS = "css/" ;
    
    /**
     * ディレクトリ : 外部JavaScriptディレクトリ[公開ディレクトリ配下に存在する].
     */
    public static final String DIRECTORY_JS = "js/" ;
    
    /**
     * 現在のフルパス.
     */
    public static final String NOW_FULL_PATH ;
    
    /**
     * 現在の基本パス.
     */
    public static final String NOW_BASE_PATH ;
    
    /**
     * 現在のアプリケーションパス.
     */
    public static final String NOW_APPLICATION_PATH ;
    
    /**
     * 現在のパブリックパス.
     */
    public static final String NOW_PUBLIC_PATH ;
    
    /** 初期処理 **/
    static {
        String base = null ;
        try {
            base = new StringBuilder().append( FileUtil.getFullPath( "." ) ).toString() ;
        } catch( Exception e ) {
            base = null ;
            e.printStackTrace() ;
        }
        if( base != null ) {
            NOW_FULL_PATH = base ;
            NOW_BASE_PATH = base + "/" ;
            NOW_APPLICATION_PATH = base + "/" + DIRECTORY_APPLICATION ;
            NOW_PUBLIC_PATH = base + "/" + DIRECTORY_PUBLIC ;
        }
        else {
            NOW_FULL_PATH = null ;
            NOW_BASE_PATH = null ;
            NOW_APPLICATION_PATH = null ;
            NOW_PUBLIC_PATH = null ;
        }
    }
    
}
