package org.maachang.seabass.down ;

import org.maachang.seabass.dbm.BdbService;
import org.maachang.seabass.httpd.engine.script.ExecutionStartup;
import org.maachang.seabass.startjava.StartupJavaManager;
import org.maachang.shutdown.ShutdownCallback;

/**
 * スクリプトシャットダウン.
 *
 * @version 2009/12/25
 * @author  masahito suzuki
 * @since   SeaBass 1.00
 */
public class ShutdownScript extends ShutdownCallback {
    
    /**
     * シャットダウン実行.
     * <BR><BR>
     * シャットダウンを実行するコールバックメソッド.
     */
    public void execution() {
        // 外部Javaプログラムの終了.
        StartupJavaManager.getInstance().destroy() ;
        
        // スクリプトの終了.
        ExecutionStartup.destroy() ;
        
        // BdbServiceの終了.
        try {
            BdbService.getInstance().init() ;
        } catch( Exception e ) {
        }
        
        // シャットダウン完了.
        super.exitShutdown() ;
    }
    
}
