package org.maachang.seabass.httpd ;

/**
 * HTTPD-コンテンツ入出力フィルタ.
 *
 * @version 2008/12/14
 * @author  masahito suzuki
 * @since   SeaBass 1.2B
 */
public abstract class HttpdIOFilter {
    
    /**
     * フィルタ初期化処理.
     * @exception Exception 例外.
     */
    public void init() throws Exception {
    }
    
    /**
     * フィルタ終了化処理.
     */
    public void destroy() {
    }
    
    /**
     * コンテンツ実行前処理.
     * @param request 対象のリクエストを設定します.
     * @param response 対象のレスポンスを設定します.
     * @param HttpdResponse 仮のレスポンス処理を行う場合のHttpdResponseが返されます.
     * @exception Exception 例外.
     */
    public HttpdResponse beforePointContents( HttpdRequest request,HttpdResponse response )
        throws Exception {
        return null ;
    }
    
    /**
     * コンテンツ実行後処理.
     * @param request 対象のリクエストを設定します.
     * @param baseResponse 元のレスポンス情報を設定します.
     * @param dummyResponse 仮のレスポンス処理を行った条件が渡されます.
     * @exception Exception 例外.
     */
    public void endPointContents( HttpdRequest request,HttpdResponse baseResponse,HttpdResponse dummyResponse )
        throws Exception {
    }
}

