package org.maachang.seabass.httpd ;

import org.apache.commons.logging.Log;
import org.apache.commons.logging.LogFactory;
import org.maachang.conf.ConvIniParam;
import org.maachang.manager.GlobalManager;
import org.maachang.seabass.ServiceDef;
import org.maachang.seabass.conf.IniFile;

/**
 * HTTPD-モード.
 *
 * @version 2007/08/20
 * @author  masahito suzuki
 * @since   SeaBass 1.00
 */
public class HttpdMode {
    /**
     * ログ.
     */
    private static final Log LOG = LogFactory.getLog( HttpdMode.class ) ;
    
    /**
     * イメージキャッシュモード.
     */
    public static final boolean imageCache ;
    
    /**
     * データキャッシュモード.
     */
    public static final boolean cacheMode ;
    
    /**
     * xhtmlモード.
     */
    public static final boolean xhtml ;
    
    /**
     * 非コンパイルキャッシュモード.
     */
    public static final boolean noNompileCache ;
    
    /**
     * HTML圧縮モード.
     */
    public static final boolean smartHtml ;
    
    /**
     * HTML整頓モード.
     */
    public static final boolean tidyHtml ;
    
    /**
     * コネクションクローズモード.
     */
    public static final boolean closeMode ;
    
    static {
        IniFile conf = ( IniFile )GlobalManager.getInstance().get( ServiceDef.MANAGER_BY_CONFIG ) ;
        cacheMode = ConvIniParam.getBoolean( conf.get( "server","cache",0 ) ) ;
        imageCache = ConvIniParam.getBoolean( conf.get( "server","image-cache",0 ) ) ;
        xhtml = ConvIniParam.getBoolean( conf.get( "server","xhtml",0 ) ) ;
        noNompileCache = ConvIniParam.getBoolean( conf.get( "server","no-compile-cache",0 ) ) ;
        smartHtml = ConvIniParam.getBoolean( conf.get( "server","smart",0 ) ) ;
        tidyHtml = ConvIniParam.getBoolean( conf.get( "server","tidy",0 ) ) ;
        closeMode = ConvIniParam.getBoolean( conf.get( "server","close-mode",0 ) ) ;
        if( LOG.isDebugEnabled() ) {
        LOG.debug( "## cacheMode:" + cacheMode + " imageCache:" + imageCache +
            " xhtml:" + xhtml + " noNompileCache:" + noNompileCache +
            " smartHtml:" + smartHtml + " tidyHtml:" + tidyHtml ) ;
        }
    }
}

