package org.maachang.seabass.httpd ;

/**
 * HTTPD-Version-Define.
 *
 * @version 2007/08/19
 * @author  masahito suzuki
 * @since   SeaBass 1.00
 */
public class HttpdVersionDef {
    
    private HttpdVersionDef() {
        
    }
    
    /**
     * 名前を取得.
     * <BR><BR>
     * 名前を取得します.
     * <BR>
     * @return String 名前が返されます.
     */
    public static final String getName() {
        return "SeaBass" ;
    }
    
    /**
     * バージョンを取得.
     * <BR><BR>
     * バージョン値を取得します.
     * <BR>
     * @return String バージョン値が返されます.
     */
    public static final String getVersion() {
        return "1.0.1" ;
    }
    
    /**
     * 作成日を取得.
     * <BR><BR>
     * 作成日を取得します.
     * <BR>
     * @return String 作成日が返されます.
     */
    public static final String getDate() {
        return "2010/09/29" ;
    }
    
    /**
     * copyright.
     * <BR><BR>
     * copyrightを取得します.
     * <BR>
     * @return String copyrightが返されます.
     */
    public static final String getCopyright() {
        return "Copyright (c) 2007-2010 SeaBass, Inc. All Rights Reserved." ;
    }
    
    /**
     * サーバ名を取得.
     * <BR><BR>
     * サーバ名が返されます.
     * <BR>
     * @return String サーバ名が返されます.
     */
    public static final String getServerName() {
        return SERVER_NAME ;
    }
    private static final String SERVER_NAME = getName() + "/" + getVersion() ;
    
    /**
     * 表示用サーバ名を取得.
     * <BR><BR>
     * 表示用のサーバ名を取得します.
     * <BR>
     * @return Stirng 表示用サーバ名が返されます.
     */
    public static final String getPrintServerName() {
        return PSERVER_NAME ;
    }
    private static final String PSERVER_NAME = getName() + "/" + getVersion() ;
}

