package org.maachang.seabass.httpd.engine.script.cache;

import org.maachang.util.SimpleKeyValue;
import org.maachang.util.atomic.AtomicLONG;

/**
 * Json情報をキャッシュ子要素.
 * 
 * @version 2010/01/15
 * @author masahito suzuki
 * @since SeaBass 1.0.0
 */
public class CacheJsonChild {
    /** 要素キー名. **/
    public String keyName = null ;
    /** 要素格納データ. **/
    public SimpleKeyValue[] child = null ;
    /** 最終アクセス時間. **/
    private final AtomicLONG lastAccessTime = new AtomicLONG() ;
    /** コンストラクタ **/
    public CacheJsonChild() { lastAccessTime.set( System.currentTimeMillis() ) ; }
    /** 最終アクセス時間を取得. **/
    public long getLastAccessTime() { return lastAccessTime.get() ; }
    /** この要素を更新 **/
    public void update() { lastAccessTime.set( System.currentTimeMillis() ) ; }
    /** 要素格納枠を生成. **/
    public void createChild( int len ) {
        SimpleKeyValue[] c = new SimpleKeyValue[ len ] ;
        for( int i = 0 ; i < len ; i ++ ) {
            c[ i ] = new SimpleKeyValue() ;
        }
        this.child = c ;
    }
}
