package org.maachang.seabass.httpd.engine.script.doc ;

/**
 * SeaBassドキュメント[パラメータ]Bean.
 * 
 * @version 2009/01/22
 * @author masahito suzuki
 * @since SeaBass 1.0.0
 */
public class SeaBassDocParams implements SeaBassDocBase {
    private String name = null ;
    private String info = null ;
    
    /**
     * コンストラクタ.
     */
    public SeaBassDocParams() {
        
    }
    
    protected void finalize() throws Exception {
        destroy() ;
    }
    
    /**
     * オブジェクト破棄.
     */
    public void destroy() {
        name = null ;
        info = null ;
    }
    
    /**
     * 名前を設定.
     * @param name 名前を設定します.
     */
    public void setName( String name ) {
        if( name == null || ( name = name.trim() ).length() <= 0 ) {
            throw new IllegalArgumentException( "カテゴリ名が設定されていません" ) ;
        }
        this.name = name ;
    }
    
    /**
     * 名前を取得.
     * @return String 名前が返されます.
     */
    public String getName() {
        return name ;
    }
    
    /**
     * 説明情報を設定.
     * @param info 説明情報を設定します.
     */
    public void setInfo( String info ) {
        if( info == null || ( info = info.trim() ).length() <= 0 ) {
            info = "" ;
        }
        this.info = info ;
    }
    
    /**
     * 説明情報を取得.
     * @return String 説明情報が返されます.
     */
    public String getInfo() {
        return info ;
    }
}
