package org.maachang.seabass.httpd.engine.script.scripts;

import java.util.concurrent.ConcurrentLinkedQueue;

/**
 * HTML出力用Factory.
 *
 * @version 2009/10/14
 * @author masahito suzuki
 * @since SeaBass 1.0.0
 */
public class OutputHtmlFactory {
    private static final ConcurrentLinkedQueue<OutputHTML> queue = new ConcurrentLinkedQueue<OutputHTML>() ;
    
    /**
     * OutputHtmlを取得.
     * @return OutputHTML OutputHTMLが返されます.
     */
    public static final OutputHTML get() {
        OutputHTML ret = queue.poll() ;
        if( ret == null ) {
            ret = new OutputHTML() ;
        }
        return ret ;
    }
    
    /**
     * OutputHtmlをリリース.
     */
    protected static final void release( OutputHTML html ) {
        if( html != null && !html.isClear() ) {
            html.clear() ;
        }
        queue.offer( html ) ;
    }
}

