package org.maachang.seabass.httpd.engine.script.scripts;

import org.maachang.seabass.SeaBassDef;
import org.maachang.seabass.httpd.engine.script.js.InitJS;
import org.maachang.util.StringUtil;

/**
 * 帳票用スクリプト.
 * 
 * @version 2007/08/29
 * @author masahito suzuki
 * @since SeaBass 1.0.0
 */
public class ReportScript extends AbstractScript {
    
    private ReportScript() {
    }
    
    /**
     * コンストラクタ.
     * <BR><BR>
     * 条件を指定してオブジェクトを生成します.
     * <BR>
     * @param path 対象のパスを設定します.
     * @param currentDirectory カレントディレクトリを設定します.
     * @exception Exception 例外.
     */
    public ReportScript( String path,String currentDirectory )
        throws Exception {
        this.create( "Report",SeaBassDef.DIRECTORY_APPLICATION,
            path,currentDirectory ) ;
    }
    
    /**
     * スクリプトタイプを取得.
     * <BR><BR>
     * スクリプトタイプを取得します.
     * <BR>
     * @return int スクリプトタイプが返されます.
     */
    public int getScriptType() {
        return ScriptManager.SCRIPT_TYPE_BY_REPORT ;
    }
    
    /**
     * Headerスクリプトを設定.
     */
    protected String addHeaderScript() throws Exception {
        return new StringBuilder().append( InitJS.getInstance().get() ).
            append( "\n" ).append( "var $report = new Report() ;\n" ).
            append( "try { \n" ).
            toString() ;
    }
    
    /**
     * Footerスクリプトを設定.
     */
    protected String addFooterScript() throws Exception {
        return "\n $report.flush(); \n} finally { $report.destroy(); }\n" ;
    }
}
