package org.maachang.seabass.httpd.engine.script.scripts;

import org.maachang.seabass.SeaBassDef;
import org.maachang.seabass.httpd.engine.script.js.InitJS;

/**
 * X-REPORTスクリプト.
 * 
 * @version 2009/12/31
 * @author masahito suzuki
 * @since SeaBass 1.0.0
 */
public class XReportScript extends AbstractScript {
    
    private XReportScript() {
    }
    
    /**
     * コンストラクタ.
     * <BR><BR>
     * 条件を指定してオブジェクトを生成します.
     * <BR>
     * @param path 対象のパスを設定します.
     * @param currentDirectory カレントディレクトリを設定します.
     * @exception Exception 例外.
     */
    public XReportScript( String path,String currentDirectory )
        throws Exception {
        setCloseConnect( true ) ;
        create( "XReport",SeaBassDef.DIRECTORY_APPLICATION,
            path,currentDirectory ) ;
    }
    
    /**
     * スクリプトタイプを取得.
     * <BR><BR>
     * スクリプトタイプを取得します.
     * <BR>
     * @return int スクリプトタイプが返されます.
     */
    public int getScriptType() {
        return ScriptManager.SCRIPT_TYPE_BY_XREPORT ;
    }
    
    /**
     * Headerスクリプトを設定.
     */
    protected String addHeaderScript() throws Exception {
        return InitJS.getInstance().get() ;
    }
    
    /**
     * Footerスクリプトを設定.
     */
    protected String addFooterScript() throws Exception {
        return "\nkeepAliveOff() ;" ;
    }
}
