package org.maachang.seabass.net ;

import gnu.trove.THashSet;

import java.net.InetAddress;
import java.util.Set;

/**
 * ネットワーク情報.
 * 
 * @version 2009/01/31
 * @author  masahito suzuki
 * @since   SeaBass 1.00
 */
public class NetInfo {
    /**
     * 現在のIPアドレス.
     */
    public static final Set<String> THIS_IP_LIST ;
    static {
        Set<String> ipList = null ;
        try {
            InetAddress[] all = InetAddress.getAllByName( InetAddress.getLocalHost().getHostName() ) ;
            if( all.length > 0 ) {
                ipList = new THashSet<String>() ;
                int len = all.length ;
                for( int i = 0 ; i < len ; i ++ ) {
                    ipList.add( all[ i ].getHostAddress() ) ;
                }
            }
            else {
                ipList = new THashSet<String>() ;
            }
        } catch( Exception e ) {
            //e.printStackTrace() ;
            ipList = new THashSet<String>() ;
        }
        ipList.add( "127.0.0.1" ) ;
        THIS_IP_LIST = ipList ;
    }
}
