package org.maachang.seabass.net ;

import gnu.trove.THashMap;

import java.util.Map;

import org.maachang.seabass.httpd.HttpdBinary;

/**
 * パラメータマップ.
 * 
 * @version 2009/01/31
 * @author  masahito suzuki
 * @since   SeaBass 1.00
 */
public class ParamsMap extends THashMap implements Map {
    private static final long serialVersionUID = 6368500189096985421L;
    public ParamsMap() {
        super() ;
    }
    public Object get(Object key) {
        Object ret = getOriginal( key ) ;
        if( ret instanceof HttpdBinary ) {
            return ret.toString() ;
        }
        return ret ;
    }
    public Object getOriginal(Object key) {
        if( key instanceof String ) {
            return super.get( key ) ;
        }
        else {
            return super.get( String.valueOf( key ) ) ;
        }
    }
    public Object put(Object name, Object value) {
        if( name instanceof String ) {
            return super.put( name,value ) ;
        }
        else {
            return super.put( String.valueOf( name ),value ) ;
        }
    }
    public Object remove(Object key) {
        if( key instanceof String ) {
            return super.remove( key ) ;
        }
        else {
            return super.remove( String.valueOf( key ) ) ;
        }
    }
    public boolean containsKey(Object key) {
        if( key instanceof String ) {
            return super.containsKey( key ) ;
        }
        else {
            return super.containsKey( String.valueOf( key ) ) ;
        }
    }
}
