package org.maachang.seabass.net.nio ;

import java.util.concurrent.ConcurrentLinkedQueue;

/**
 * 書き込み可能キュー.
 * 
 * @version 2008/05/28
 * @author  masahito suzuki
 * @since   SeaBass 1.0.0
 */
class IsWriteQueue {
    private final ConcurrentLinkedQueue<NioElement> queue = new ConcurrentLinkedQueue<NioElement>() ;
    
    public IsWriteQueue() {
    }
    
    protected void finalize() throws Exception {
        destroy() ;
    }
    
    public void destroy() {
        queue.clear() ;
    }
    
     public void append( final NioElement element ) {
        if( element != null ) {
            queue.offer( element ) ;
        }
    }
    
    public NioElement getQueue() {
        return queue.poll() ;
    }
    
    public int size() {
        return queue.size() ;
    }
}
