package org.maachang.seabass.net.nio ;

import java.util.concurrent.ConcurrentLinkedQueue;

/**
 * ヘッダ出力用Factory.
 *
 * @version 2009/10/14
 * @author masahito suzuki
 * @since SeaBass 1.0.0
 */
public class OutputHeaderFactory {
    private static final ConcurrentLinkedQueue<OutputHeader> queue = new ConcurrentLinkedQueue<OutputHeader>() ;
    
    /**
     * OutputHeaderを取得.
     * @return OutputHeader OutputHeaderが返されます.
     */
    public static final OutputHeader get() {
    	OutputHeader ret = queue.poll() ;
        if( ret == null ) {
            ret = new OutputHeader() ;
        }
        return ret ;
    }
    
    /**
     * OutputHeaderをリリース.
     */
    protected static final void release( OutputHeader o ) {
        if( o != null && !o.isClear() ) {
            o.clear() ;
        }
        queue.offer( o ) ;
    }
}

