package org.maachang.seabass.net.nio ;

import java.util.concurrent.LinkedBlockingQueue;

/**
 * 受信情報を保持したソケットオブジェクト管理キュー.
 * 
 * @version 2008/05/28
 * @author  masahito suzuki
 * @since   SeaBass 1.0.0
 */
class ReceiveLinkQueue {
    private final LinkedBlockingQueue<NioElement> queue = new LinkedBlockingQueue<NioElement>() ;
    //private final ConcurrentLinkedQueue<NioElement> queue = new ConcurrentLinkedQueue<NioElement>() ;
    
    public ReceiveLinkQueue() {
    }
    
    protected void finalize() throws Exception {
        destroy() ;
    }
    
    public void destroy() {
        queue.clear() ;
    }
    
    public void append( final NioElement accept ) {
        if( accept != null ) {
            queue.offer( accept ) ;
        }
    }
    
    public NioElement getQueue() throws InterruptedException {
        return queue.take() ;
        //return queue.poll() ;
    }
    
    public int size() {
        return queue.size() ;
    }
}
