package org.maachang.seabass.session.client.local ;

import org.maachang.bdb.BdbManager;
import org.maachang.seabass.session.client.PSessionManager;
import org.maachang.seabass.session.engine.PersistenceEngine;
import org.maachang.seabass.session.engine.PersistenceService;

/**
 * ローカル接続による、
 * クライアント永続化セッションドライバ.
 * 
 * @version 2008/05/25
 * @author masahito suzuki
 * @since PersistenceSession 1.00
 */
public class PSessionLocalDriver {
    
    /**
     * 永続化セッションマネージャを取得.
     * @return PSessionManager 永続化セッションマネージャが返されます.
     * @exception Exception 例外.
     */
    public static final PSessionManager getConnection() throws Exception {
        return getConnection( null ) ;
    }
    
    /**
     * 永続化セッションマネージャを取得.
     * @param io 対象のBdbManagerオブジェクトを設定します.
     * @return PSessionManager 永続化セッションマネージャが返されます.
     * @exception Exception 例外.
     */
    public static final PSessionManager getConnection( BdbManager io ) throws Exception {
        PersistenceService.getInstance().init( io ) ;
        PersistenceEngine engine = PersistenceService.getInstance().getEngine() ;
        return new PSessionLocalManagerImpl( engine ) ;
    }
}

