package org.maachang ;

import gnu.trove.*;
import java.util.*;

/**
 * 呼び出しメソッド前の位置を取得.
 * 
 * @version 2008/12/01
 * @author masahito suzuki
 * @since Maachang 1.00
 */
public abstract class LoadMethodTrace {
    private LoadMethodTrace(){}
    
    public static final String trace() {
        StackTraceElement[] em = new Throwable().getStackTrace() ;
        if( em.length >= 3 ) {
            StackTraceElement s = em[ 3 ] ;
            return new StringBuilder().
                append( "class:" ).append( s.getClassName() ).
                append( " method:" ).append( s.getMethodName() ).
                append( "(" ).append( s.getLineNumber() ).append( ")" ).
                toString() ;
        }
        return "unknown" ;
    }
}
