package org.maachang ;

import gnu.trove.*;
import java.util.*;

import org.maachang.seabass.*;

/**
 * Keyが文字列専用Map.
 * 
 * @version 2008/12/01
 * @author masahito suzuki
 * @since Maachang 1.00
 */
public class StringMap extends SeaBassMap implements Map {
    protected boolean noWriteFlag = false ;
    public StringMap() {
        super() ;
    }
    
    public void setNoSetting() {
        noWriteFlag = true ;
    }
    
    public Object put(String name, Object value) {
        if( noWriteFlag ) {
            throw new IllegalAccessError( "このMap条件は上書きが禁止されています" ) ;
        }
        return super.put( name,value ) ;
    }
    
    public Object put(Object name, Object value) {
        if( noWriteFlag ) {
            throw new IllegalAccessError( "このMap条件は上書きが禁止されています" ) ;
        }
        return super.put( String.valueOf( name ),value ) ;
    }
    
    public Object get(String key) {
        return super.get( key ) ;
    }
    
    public Object get(Object key) {
        return super.get( String.valueOf( key ) ) ;
    }
    
    public KeyValue removeElement(String key) {
        if( noWriteFlag ) {
            throw new IllegalAccessError( "このMap条件は上書きが禁止されています" ) ;
        }
        return super.removeElement( key ) ;
    }
    
    public KeyValue removeElement(Object key) {
        if( noWriteFlag ) {
            throw new IllegalAccessError( "このMap条件は上書きが禁止されています" ) ;
        }
        return super.removeElement( String.valueOf( key ) ) ;
    }
    
    public Object remove(String key) {
        if( noWriteFlag ) {
            throw new IllegalAccessError( "このMap条件は上書きが禁止されています" ) ;
        }
        return super.remove( key ) ;
    }
    
    public Object remove(Object key) {
        if( noWriteFlag ) {
            throw new IllegalAccessError( "このMap条件は上書きが禁止されています" ) ;
        }
        return super.remove( String.valueOf( key ) ) ;
    }
    
    public boolean containsKey(String key) {
        return super.containsKey( key ) ;
    }
    
    public boolean containsKey(Object key) {
        return super.containsKey( String.valueOf( key ) ) ;
    }
    
    public void putAll(Map toMerge) {
        if( noWriteFlag ) {
            throw new IllegalAccessError( "このMap条件は上書きが禁止されています" ) ;
        }
        if( toMerge != null ) {
            Iterator it = toMerge.keySet().iterator() ;
            while( it.hasNext() ) {
                Object o = it.next() ;
                this.put( o,toMerge.get( o ) ) ;
            }
        }
    }
}
