package org.maachang.seabass ;

import java.io.* ;
import java.util.* ;
import java.text.* ;

/**
 * コンソール実行用.
 * 
 * @version 2007/08/26
 * @author masahito suzuki
 * @since SeaBassScriptEngine 1.00
 */
public class ConSeaBass {
    private ConSeaBass() {}
    public static final void main( String[] args ) throws Exception {
        if( args == null || args.length <= 0 ) {
            SeaBassMode.getInstance().complie() ;// コンパイルモード.
            System.out.println( "MODE:compile" ) ;
        }
        else if( "i".equals( args[ 0 ] ) || "I".equals( args[ 0 ] ) ) {
            SeaBassMode.getInstance().interpreter() ;// インタイプリタモード.
            System.out.println( "MODE:interpreter" ) ;
        }
        else if( "c".equals( args[ 0 ] ) || "C".equals( args[ 0 ] ) ) {
            SeaBassMode.getInstance().complie() ;// コンパイルモード.
            System.out.println( "MODE:compile" ) ;
        }
        else if( "o".equals( args[ 0 ] ) || "O".equals( args[ 0 ] ) ) {
            SeaBassMode.getInstance().optimize() ;// 最適化モード.
            System.out.println( "MODE:optimize" ) ;
        }
        else {
            SeaBassMode.getInstance().complie() ;// コンパイルモード.
            System.out.println( "MODE:compile" ) ;
        }
        SimpleDateFormat fmt = new SimpleDateFormat( "yyyy/MM/dd HH:mm:ss",Locale.US ) ;
        SeaBassScriptEngine engine = new SeaBassScriptEngine() ;
        System.out.println( "SeaBass[pnuts-"+SeaBassScriptEngine.getVersion()+"] by console mode." ) ;
        SeaBassContext context = SeaBassStackContext.getInstance().getContext( null ) ;
        context.setName( "console" ) ;
        // 予約パッケージ群.
        String packageList =
            "import java.util.* ;\n" +
            "import java.lang.* ;\n" +
            "import java.io.* ;\n" +
            "import java.text.* ;\n" +
            "import java.math.* ;\n" +
            "import org.maachang.seabass.mod.object.* ;" ;
        engine.eval( packageList,context ) ;
        BufferedReader stdin = new BufferedReader( new InputStreamReader( System.in ) ) ;
        while(true){ 
            System.out.print( "$>" ) ;
            String line = stdin.readLine() ;
            if( line == null || line.length() <= 0 ) {
                continue ;
            }
            if( "exit".equals( line = line.trim() ) ) {
                System.out.println( "SeaBass-終了" ) ;
                return ;
            }
            try {
                Object res = engine.eval( line,context ) ;
                if( res instanceof ExitSeaBass ) {
                    System.out.println( "SeaBass-終了" ) ;
                    return ;
                }
                if( res instanceof java.util.Date ) {
                    System.out.println( fmt.format( ( java.util.Date )res ) ) ;
                }
                else {
                    System.out.println( res ) ;
                }
            } catch( Exception e ) {
                e.printStackTrace() ;
            } catch( Error er ) {
                er.printStackTrace() ;
            }
        }
    }
}
