package org.maachang.seabass ;

import pnuts.lang.*;

/**
 * SeaBass停止シグナル.
 * 
 * @version 2007/08/26
 * @author masahito suzuki
 * @since MaachangComet 1.00
 */
public class ExitSeaBass extends RuntimeException {
    private static final long serialVersionUID = -6855465702119811162L;
    
    /**
     * 終了コード.
     */
    private String _exitCode = "" ;
    
    /**
     * コンストラクタ.
     */
    public ExitSeaBass() {
        this("") ;
    }
    
    /**
     * コンストラクタ.
     * @param exitCode 終了コードを設定します.
     */
    public ExitSeaBass( String exitCode ) {
        super() ;
        this._exitCode = exitCode ;
        Context ctx = Context.getCurrentContext() ;
        if( ctx != null ) {
            ctx.getCurrentPackage().set( "_$exit$to",this ) ;
        }
    }
    
    /**
     * 終了コードを取得.
     * @return String 終了コードが返されます.
     */
    public String getExitCode() {
        return _exitCode ;
    }
}
