package org.maachang.seabass ;

import java.util.* ;
import gnu.trove.* ;
import org.maachang.* ;

import org.maachang.seabass.mod.* ;

/**
 * ScriptMemory.
 * 
 * @version 2008/12/21
 * @author masahito suzuki
 * @since SeaBassScriptEngine 1.00
 */
public class SeaBassMemory extends BaseMap implements Map {
    private Map topMemory = null ;
    private Map map = null ;
    private final ModSeaBass mod = ModSeaBass.getInstance() ;
    private final SeabassDI di = SeabassDI.getInstance() ;
    
    protected SeaBassMemory() {
        map = new SeaBassMap() ;
    }
    
    protected void finalize() throws Exception {
        destroy() ;
    }
    
    protected void destroy() {
        topMemory = null ;
        map = null ;
    }
    
    protected void create() {
        this.create(null) ;
    }
    
    protected void create( Map topMemory ) {
        clearMemory() ;
        this.topMemory = topMemory ;
    }
    
    public void recreate() {
        map = new SeaBassMap() ;
    }
    
    protected void clearMemory() {
        map.clear() ;
    }
    
    public void putAll(Map toMerge) {
        map.putAll( toMerge ) ;
    }
    
    public Object put(Object name, Object value) {
        return map.put( name,value ) ;
    }
    
    public boolean containsKey(Object key) {
        boolean ret ;
        if( map.containsKey( key ) ||
            mod.containsKey( key ) ||
            di.containsKey( key ) ) {
            return true ;
        }
        if( topMemory != null ) {
            return topMemory.containsKey( key ) ;
        }
        return false ;
    }
    
    public boolean currentContainsKey(Object key) {
        return map.containsKey( key ) ;
    }
    
    public boolean noCurrentContainsKey(Object key) {
        boolean ret ;
        if( mod.containsKey( key ) ||
            di.containsKey( key ) ) {
            return true ;
        }
        if( topMemory != null ) {
            return topMemory.containsKey( key ) ;
        }
        return false ;
    }
    
    public Object get(Object key) {
        Object ret = map.get( key ) ;
        if( ret == null ) {
            ret = mod.get( key ) ;
            if( ret != null ) {
                return ret ;
            }
            ret = di.get( key ) ;
            if( ret != null ) {
                return ret ;
            }
            if( topMemory != null ) {
                return topMemory.get( key ) ;
            }
        }
        return ret ;
    }
    
    public Object remove(Object key) {
        return map.remove( key ) ;
    }
    
    public boolean isEmpty() {
        return ( size() <= 0 ) ;
    }
    
    public Set keySet() {
        Set ret = new HashSet() ;
        Iterator it = map.keySet().iterator() ;
        while( it.hasNext() ) {
            ret.add( it.next() ) ;
        }
        if( topMemory != null ) {
            if( topMemory instanceof BaseMap ) {
                ((BaseMap)topMemory).getAllKey( ret ) ;
            }
            else {
                it = topMemory.keySet().iterator() ;
                while( it.hasNext() ) {
                    ret.add( it.next() ) ;
                }
            }
        }
        return ret ;
    }
    
    public Collection values() {
        Set ret = new THashSet() ;
        Iterator it = map.values().iterator() ;
        while( it.hasNext() ) {
            ret.add( map.get( it.next() ) ) ;
        }
        if( topMemory != null ) {
            if( topMemory instanceof BaseMap ) {
                ((BaseMap)topMemory).getAllValues( ret ) ;
            }
            else {
                it = topMemory.values().iterator() ;
                while( it.hasNext() ) {
                    ret.add( topMemory.get( it.next() ) ) ;
                }
            }
        }
        return ret ;
    }
    
    public int size() {
        int ret = map.size() ;
        if( topMemory != null ) {
            ret += topMemory.size() ;
        }
        return ret ;
    }
    
    public Map getMap() {
        return map ;
    }
}
