package org.maachang.seabass ;

import gnu.trove.*;
import java.util.*;

/**
 * SeaBass用DIコンテナ.
 * 
 * @version 2009/03/28
 * @author masahito suzuki
 * @since SeaBassScriptEngine 1.00
 */
public final class SeabassDI implements Map {
    private SeabassDI() {}
    private static final SeabassDI SNGL = new SeabassDI() ;
    private final Map<String,Object> map = new THashMap<String,Object>() ;
    
    /**
     * オブジェクトを取得.
     * @return SeabassDI オブジェクトが返されます.
     */
    public static final SeabassDI getInstance() {
        return SNGL ;
    }
    
    /**
     * オブジェクトチェック.
     * @param key このオブジェクトは文字列(java.lang.String)である必要があります.
     * @return boolean [true]の場合、情報が存在します.
     */
    public boolean containsKey(Object key) {
        if( key instanceof String ) {
            return map.containsKey( (String)key ) ;
        }
        return false ;
    }
    
    /**
     * オブジェクトを取得.
     * @param key このオブジェクトは文字列(java.lang.String)である必要があります.
     * @return Object 情報が返されます.
     */
    public Object get(Object key) {
        if( key instanceof String ) {
            return map.get( (String)key ) ;
        }
        return null ;
    }
    
    /**
     * 元のMapオブジェクトを取得.
     * @return String 元のオブジェクトが返されます.
     */
    public Map<String,Object> getMap() {
        return map ;
    }
    
    ////////////////////////////////////////////////////////////////////////////
    // 以下未実装.
    ////////////////////////////////////////////////////////////////////////////
    
    public void clear() {
    }
    public void putAll(Map toMerge) {
    }
    public boolean containsValue(Object value) {
        return false ;
    }
    public Set entrySet() {
        return null ;
    }
    public Collection values() {
        return null ;
    }
    public Object put(Object name, Object value) {
        return null ;
    }
    public Object remove(Object key) {
        return null ;
    }
    public boolean isEmpty() {
        return false ;
    }
    public Set keySet() {
        return new HashSet() ;
    }
    public int size() {
        return 0 ;
    }
    public void getAllKey( Set<Object> set ) {
    }
    public void getAllValues( Set<Object> set ) {
    }
    public String toString() {
        return "" ;
    }
}
