package org.maachang.seabass.mod.base ;

import java.lang.reflect.*;
import org.pnuts.util.*;
import pnuts.lang.*;
import org.maachang.*;

/*
 * instanceOf(object,object/class/string)
 */
public class instanceOf extends PnutsFunction {

    public instanceOf(){
        super("instanceOf");
    }

    public boolean defined(int narg){
        return (narg == 2);
    }

    protected Object exec(Object[] args, Context context){
        if( args == null || args.length != 2  ) {
            return Boolean.FALSE ;
        }
        if( args[ 0 ] == null || args[ 1 ] == null ) {
            return Boolean.FALSE ;
        }
        // クラスオブジェクトでチェック.
        if( args[ 1 ] instanceof Class ) {
            Class c = (Class)args[ 1 ] ;
            if( c.isArray() ) {
                return ( args[ 0 ].getClass().isArray() &&
                    c.isInstance( args[ 0 ] ) ) ? Boolean.TRUE : Boolean.FALSE ;
            }
            else {
                return ( c.isInstance( args[ 0 ] ) ) ? Boolean.TRUE : Boolean.FALSE ;
            }
        }
        // 指定文字列がクラス指定の場合にクラス変換してチェック.
        else if( args[ 1 ] instanceof String ) {
            String clz = ModUtil.trimString( ( String )args[ 1 ] ) ;
            try {
                // 配列でチェックする場合.
                if( clz.endsWith( "[]" ) ) {
                    clz = clz.substring( 0,clz.length()-2 ) ;
                    return ( args[ 0 ].getClass().isArray() &&
                        Array.newInstance( SearchJavaInfo.getClass( clz ),0 ).getClass().isInstance( args[ 0 ] ) ) ?
                            Boolean.TRUE : Boolean.FALSE ;
                }
                // 配列でチェックしない場合.
                else {
                    Class c = SearchJavaInfo.getClass( clz ) ;
                    return ( c.isInstance( args[ 0 ] ) ) ? Boolean.TRUE : Boolean.FALSE ;
                }
            } catch( Exception e ) {
            }
        }
        Class c = args[ 1 ].getClass() ;
        if( c.isArray() ) {
            return ( args[ 0 ].getClass().isArray() &&
                c.isInstance( args[ 0 ] ) ) ? Boolean.TRUE : Boolean.FALSE ;
        }
        else {
            return ( c.isInstance( args[ 0 ] ) ) ? Boolean.TRUE : Boolean.FALSE ;
        }
    }
    
    public String toString(){
        return "instanceOf(object,object/class/string)";
    }
}
