package org.maachang.seabass.mod.base ;

import java.io.* ;
import pnuts.compiler.*;
import pnuts.lang.*;
import org.maachang.*;
import org.maachang.seabass.* ;

/*
 * load(script)
 */
public class load extends PnutsFunction {
    public load(){
        super("load");
    }

    public boolean defined(int narg){
        return (narg == 1);
    }

    protected Object exec(Object[] args, Context context){
        if( args == null || args.length <= 0 ) {
            throw new PnutsException( "実行対象ファイル名は指定されていません",context ) ;
        }
        if( args[ 0 ] == null || (args[ 0 ] instanceof String) == false ) {
            throw new PnutsException( "実行対象ファイル名は指定されていません",context ) ;
        }
        String name = (String)args[ 0 ] ;
        if( name == null || name.length() <= 0 ) {
            throw new PnutsException( "実行対象ファイル名は指定されていません",context ) ;
        }
        try {
            String file = getFullPath( name ) ;
            if( isFileExists( file ) == false ) {
                throw new PnutsException( "実行対象ファイル名[" + name + "]は存在しません",context ) ;
            }
            String script = getFileByString( file,"UTF8" ) ;
            return ModUtil.eval( context,true,name,script ) ;
        } catch( Exception e ) {
            if( e instanceof SeaBassException ) {
                throw (SeaBassException)e ;
            }
            if( ( e instanceof PnutsException ) == false ) {
                e = new PnutsException( e,context ) ;
            }
            pnuts.lang.Package pkg = context.getCurrentPackage() ;
            if( pkg instanceof SeaBassBindings ) {
                ( ( SeaBassBindings )pkg ).getMemory().put( "_$lastError",e ) ;
            }
            throw (PnutsException)e ;
        }
    }

    public String toString(){
        return "function load(string)";
    }
    
    private static final String getFullPath(String path) throws IOException {
        File fp = new File(path);
        return fp.getCanonicalPath();
    }
    
    public static final boolean isFileExists(String name) {
        boolean ret;
        if (name == null || name.length() <= 0) {
            return false;
        }
        try {
            File file = new File(name);
            ret = (file.exists() == true) ? ((file.isDirectory() == false) ? file
                    .canRead()
                    : false)
                    : false;
        } catch (Exception e) {
            ret = false;
        }
        return ret;
    }

    private static final String getFileByString(String name, String charset) throws Exception {
        int len;
        char[] tmp = null;
        CharArrayWriter ca = null;
        Reader buf = null;
        String ret = null;
        try {
            tmp = new char[8192];
            ca = new CharArrayWriter();
            buf = new InputStreamReader(new BufferedInputStream( new FileInputStream( name ) ),charset) ;
            while ((len = buf.read(tmp, 0, 8192)) > 0) {
                ca.write(tmp, 0, len);
            }
            ret = ca.toString();
            ca.close();
            ca = null;
            buf.close() ;
            buf = null ;
        } finally {
            if( buf != null ) {
                try {
                    buf.close();
                } catch (Exception t) {
                }
            }
            if( ca != null ) {
                try {
                    ca.close();
                } catch (Exception t) {
                }
            }
            buf = null;
            ca = null;
            tmp = null;
        }
        return ret;
    }
}
