package org.maachang.seabass.mod.base ;

import java.text.*;
import pnuts.lang.*;
import org.maachang.*;

/*
 * numberFormat(string,number)
 */
public class numberFormat extends PnutsFunction {

    public numberFormat(){
        super("numberFormat");
    }

    public boolean defined(int narg){
        return (narg == 2);
    }

    protected Object exec(Object[] args, Context context){
        if( args == null || args.length != 2 ) {
            throw new PnutsException( "引数が足りません",context ) ;
        }
        if( args[ 0 ] == null || (args[ 0 ] instanceof String) == false ||
            args[ 1 ] == null ||
            ((args[ 1 ] instanceof String) == false &&
                (args[ 1 ] instanceof Short) == false &&
                (args[ 1 ] instanceof Integer) == false &&
                (args[ 1 ] instanceof Long) == false &&
                (args[ 1 ] instanceof Double) == false &&
                (args[ 1 ] instanceof Float) == false)) {
            throw new PnutsException( "第一引数は文字列(String)、第二引数は文字列か数値で指定してください",context ) ;
        }
        NumberFormat nf = ModUtil.getNumberFormat( (String)args[0] ) ;
        Object o = args[ 1 ] ;
        if( o instanceof String ) {
            try {
                o = ModUtil.parseNumber( o ) ;
            } catch( Exception e ) {
                throw new PnutsException( e,context ) ;
            }
        }
        if( o instanceof Float ) {
            return nf.format( ( ( Float )o ).doubleValue() ) ;
        }
        else if( o instanceof Double ) {
            return nf.format( ( ( Double )o ).doubleValue() ) ;
        }
        else if( o instanceof Short ) {
            return nf.format( (long)( ( ( Short )o ).shortValue() ) ) ;
        }
        else if( o instanceof Integer ) {
            return nf.format( (long)( ( ( Integer )o ).intValue() ) ) ;
        }
        else if( o instanceof Long ) {
            return nf.format( ( ( ( Integer )o ).longValue() ) ) ;
        }
        throw new PnutsException( "変換処理に失敗しました",context ) ;
    }

    public String toString(){
        return "function numberFormat(string,number)";
    }
}
