package org.maachang.seabass.mod.base ;

import pnuts.lang.*;
import org.maachang.*;

/*
 * parseBoolean(string)
 */
public class parseBoolean extends PnutsFunction {

    public parseBoolean(){
        super("parseBoolean");
    }

    public boolean defined(int narg){
        return (narg == 1);
    }

    protected Object exec(Object[] args, Context context){
        if( args == null || args.length <= 0 ) {
            throw new PnutsException( "指定条件が不正です",context ) ;
        }
        try {
            Object o = args[ 0 ] ;
            if( o instanceof Boolean ) {
                return o ;
            }
            else if( o instanceof String ) {
                String s = (String)o ;
                s = s.trim().toLowerCase() ;
                if( "true".equals( s ) ) {
                    return true ;
                }
            }
            return false ;
        } catch( Exception e ) {
            throw new PnutsException( e,context ) ;
        }
    }

    public String toString(){
        return "function parseBoolean(object)";
    }
}
