package org.maachang.seabass.mod.base ;

import pnuts.lang.*;
import org.maachang.*;

/*
 * useString(string)
 */
public class useString extends PnutsFunction {

    public useString(){
        super("useString");
    }

    public boolean defined(int narg){
        return (narg == 1);
    }

    protected Object exec(Object[] args, Context context){
        if( args == null || args.length <= 0 ) {
            return Boolean.FALSE ;
        }
        if( args[ 0 ] != null ) {
            Object o = args[ 0 ] ;
            // 文字列の場合は中身をチェック.
            if( o instanceof String ) {
                return ModUtil.useString( (String)o ) ? Boolean.TRUE : Boolean.FALSE ;
            }
            // キャラクタの場合は、String変換して、有効文字列かチェック.
            else if( o instanceof Character ) {
                return ModUtil.useString( new String( new char[]{ ((Character)o).charValue() } ) ) ? Boolean.TRUE : Boolean.FALSE ;
            }
            // プリミティブ型の場合は、trueを返す.
            return ( o instanceof Boolean ||
                o instanceof Short ||
                o instanceof Integer ||
                o instanceof Long ||
                o instanceof Float ||
                o instanceof Double ||
                o instanceof java.util.Date ||
                o instanceof java.math.BigInteger ||
                o instanceof java.math.BigDecimal ) ;
        }
        return Boolean.FALSE ;
    }

    public String toString(){
        return "function useString(string)";
    }
}
