package org.maachang.seabass.mod.util;

import java.util.concurrent.ConcurrentLinkedQueue;

/**
 * 最速文字連結バッファ用Factory.
 *
 * @version 2009/10/14
 * @author masahito suzuki
 * @since SeaBassScriptEngine 1.00
 */
public class FStrBufFactory {
    private static final ConcurrentLinkedQueue<FStrBuf> queue = new ConcurrentLinkedQueue<FStrBuf>() ;
    
    /**
     * FStrBufを取得.
     * @return FStrBuf FStrBufが返されます.
     */
    public static final FStrBuf get() {
        FStrBuf ret = queue.poll() ;
        if( ret == null ) {
            ret = new FStrBuf() ;
        }
        return ret ;
    }
    
    /**
     * FStrBufをリリース.
     */
    protected static final void release( FStrBuf html ) {
        if( html != null && !html.isClear() ) {
            html.clear() ;
        }
        queue.offer( html ) ;
    }
}

