package org.pnuts.util;

import java.util.ArrayList;
import java.util.List;
import java.util.concurrent.atomic.*;

import pnuts.lang.*;
import org.maachang.atomic.*;

/**
 * Stack実装.
 * 
 * @version 2008/12/11
 * @author masahito suzuki
 * @since SeaBassScriptEngine 1.00
 */
public class BaseStack {
    private static class _baseStackChild {
        Object object = null ;
        _baseStackChild next = null ;
    }
    
    private _baseStackChild cell = null ;
    private int size = 0 ;
    
    public BaseStack() {}
    
    public void clear() {
        this.cell = null ;
        this.size = 0 ;
    }
    
    public void push(Object object) {
        _baseStackChild nw = new _baseStackChild();
        nw.object = object;
        nw.next = this.cell;
        this.cell = nw;
        this.size ++ ;
    }
    
    public Object pop() {
        if( this.cell == null ) {
            return null ;
        }
        Object ret = this.cell.object ;
        this.cell = this.cell.next ;
        this.size -- ;
        return ret ;
    }
    
    public Object peek() {
        if( this.cell == null ) {
            return null ;
        }
        return this.cell.object ;
    }
    
    public int size() {
        return size ;
    }
}
