package org.pnuts.util;

/**
 * charバッファ.
 * 
 * @version 2008/12/11
 * @author masahito suzuki
 * @since SeaBassScriptEngine 1.00
 */
public class CharBuffer {
    private static final int DEF_SIZE = 512 ;
    private char[] buf = null ;
    private int pos = 0 ;
    public CharBuffer() {
        this( -1 ) ;
    }
    public CharBuffer( int len ) {
        len = ( len <= DEF_SIZE ) ? DEF_SIZE : len ;
        buf = new char[ len ] ;
    }
    public CharBuffer clear() {
        pos = 0 ;
        return this ;
    }
    public CharBuffer append( char c ) {
        buf[ pos ] = c ;
        pos ++ ;
        return this ;
    }
    public CharBuffer append( String s ) {
        if( s == null ) {
            s = null ;
        }
        int len = s.length() ;
        for( int i = 0 ; i < len ; i ++ ) {
            buf[ pos+i ] = s.charAt( i ) ;
        }
        pos += len ;
        return this ;
    }
    public String toString() {
        if( pos <= 0 ) {
            return "" ;
        }
        return new String( buf,0,pos ) ;
    }
    public int length() {
        return pos ;
    }
}
