package org.pnuts.util;

import java.util.* ;
import org.maachang.* ;

/**
 * プリミティブ型検索.
 * 
 * @version 2008/12/11
 * @author masahito suzuki
 * @since SeaBassScriptEngine 1.00
 */
public abstract class SearchPrimitive {
    private SearchPrimitive(){}
    
    /** 数値系プリミティブ **/
    public static final Set<Class> NUMBER ;
    
    /** Booleanプリミティブ **/
    public static final Set<Class> BOOLEAN ;
    
    static {
        Set<Class> y = new HashSet<Class>() ;
        y.add( Byte.TYPE ) ;
        y.add( Character.TYPE ) ;
        y.add( Short.TYPE ) ;
        y.add( Integer.TYPE ) ;
        y.add( Long.TYPE ) ;
        y.add( Float.TYPE ) ;
        y.add( Double.TYPE ) ;
        y.add( Byte.class ) ;
        y.add( Character.class ) ;
        y.add( Short.class ) ;
        y.add( Integer.class ) ;
        y.add( Long.class ) ;
        y.add( Float.class ) ;
        y.add( Double.class ) ;
        NUMBER = y ;
        
        Set<Class> b = new HashSet<Class>() ;
        b.add( java.lang.Boolean.class ) ;
        b.add( java.lang.Boolean.TYPE ) ;
        BOOLEAN = b ;
    }
    
    /**
     * 数値情報系かチェック.
     * @param c 対象のクラスを設定します.
     * @return boolean [true]の場合、数値用プリミティブです.
     */
    public static final boolean toNumberPrimitive( Class c ) {
        return NUMBER.contains( c ) ;
    }
    
    /**
     * Boolean系かチェック.
     * @param c 対象のクラスを設定します.
     * @return boolean [true]の場合、Booleanプリミティブです.
     */
    public static final boolean toBooleanPrimitive( Class c ) {
        return BOOLEAN.contains( c ) ;
    }
}
