package org.pnuts.util;

import java.util.ArrayList;
import java.util.List;
import java.util.concurrent.atomic.*;

import pnuts.lang.*;
import org.maachang.atomic.*;

/**
 * Stack実装.
 * 
 * @version 2008/12/11
 * @author masahito suzuki
 * @since SeaBassScriptEngine 1.00
 */
public class StackList {
    private static class _stackListChild {
        Object object = null ;
        _stackListChild next = null ;
    }
    
    private _stackListChild cell = null ;
    private int size = 0 ;
    
    public StackList() {}
    
    public void clear() {
        this.cell = null ;
        this.size = 0 ;
    }
    
    public boolean push(Object object) {
        if( object instanceof ThisObject ) {
            return false ;
        }
        _stackListChild nw = new _stackListChild();
        nw.object = object;
        nw.next = this.cell;
        this.cell = nw;
        this.size ++ ;
        return true ;
    }
    
    public Object pop() {
        if( this.cell == null ) {
            return null ;
        }
        Object ret = this.cell.object ;
        this.cell = this.cell.next ;
        this.size -- ;
        return ret ;
    }
    
    public Object peek() {
        if( this.cell == null ) {
            return null ;
        }
        return this.cell.object ;
    }
    
    public int size() {
        return size ;
    }
}
