package org.pnuts.util;

import java.util.* ;

public class TempMap {
    private class TempChild implements Comparable<TempChild> {
        protected String key = null ;
        protected Object value = null ;
        public TempChild(){}
        public TempChild( String key,Object value ) {
            this.key = key ;
            this.value = value ;
        }
        public int compareTo(TempChild o) {
            return key.compareTo( o.key ) ;
        }
        public int hashCode() {
            return key.hashCode() ;
        }
        public boolean equals(Object o) {
            return ( o instanceof TempChild && key.equals( ((TempChild)o).key ) ) ;
        }
        public TempChild searchKey( String key ) {
            this.key = key ;
            return this ;
        }
    }
    
    private static final int DEF_MAX = 16 ;
    private final List list = new SkipListSet<TempChild>() ;
    private int max = -1 ;
    private TempChild dummyKey = new TempChild() ;
    
    public TempMap() {
        this.max = DEF_MAX ;
    }
    
    public TempMap( int max ) {
        if( max <= 0 ) {
            max = DEF_MAX ;
        }
        this.max = max ;
    }
    
    public static final TempMap getInstance() {
        String o = System.getProperties().getProperty( "seabass.localformat.max" ) ;
        int createSize = -1 ;
        if( o != null ) {
            try {
                createSize = Integer.parseInt( (String)o ) ;
            } catch( Exception e ) {
                createSize = -1 ;
            }
        }
        if( createSize <= 0 ) {
            return new TempMap() ;
        }
        else {
            return new TempMap( createSize ) ;
        }
    }
    
    public void put( String key,Object value ) {
        int no = list.indexOf( dummyKey.searchKey( key ) ) ;
        if( no <= -1 ) {
            TempChild o = new TempChild( key,value ) ;
            list.add( o ) ;
            if( list.size() > max ) {
                list.remove( 0 ) ;
            }
        }
        else {
            TempChild o = ( TempChild )list.remove( no ) ;
            o.value = value ;
            list.add( o ) ;
        }
    }
    
    public Object get( String key ) {
        int no = list.indexOf( dummyKey.searchKey( key ) ) ;
        if( no <= -1 ) {
            return null ;
        }
        TempChild o = ( TempChild )list.remove( no ) ;
        list.add( o ) ;
        return o.value ;
    }
    
    public int size() {
        return list.size() ;
    }
    
    public int max() {
        return max ;
    }
}
