/*
 * @(#)Import.java 1.2 04/12/06
 * 
 * Copyright (c) 1997-2003 Sun Microsystems, Inc. All Rights Reserved.
 * 
 * See the file "LICENSE.txt" for information on usage and redistribution of
 * this file, and for a DISCLAIMER OF ALL WARRANTIES.
 */
package pnuts.lang;

import java.io.IOException;
import java.io.ObjectInputStream;
import java.io.Serializable;
import java.util.*;
import org.maachang.reflect.*;

class Import implements Serializable {

    static final long serialVersionUID = 5497516072354034892L;

    /**
     * @serial
     */
    private String name;
    private String pkgName ;

    public Import(String name) {
        this.name = name;
        this.pkgName = name + "." ;
    }

    public String getName() {
        return name;
    }

    public Class get(String className, Context context) {
        try {
            return (Class) FastReflect.getClass( pkgName+className ) ;
        } catch (ClassNotFoundException e) {
        }
        return null;
    }

    void reset() {
    }

    private void readObject(ObjectInputStream s)
            throws IOException, ClassNotFoundException {
        s.defaultReadObject();
    }

    public String toString() {
        return "import " + name;
    }
}
