package pnuts.lang;

import java.util.* ;

/**
 * Pnuts Error Line.
 */
public class PnutsErrorLineInfo {
    private final List<PnutsErrorLineChild> list = new ArrayList<PnutsErrorLineChild>() ;
    
    public PnutsErrorLineInfo() {
        
    }
    
    public void clear() {
        list.clear() ;
    }
    
    public void add( Object file,String contextName,String errorScriptName,int line,int column ) {
        // 行位置がゼロ以上の条件でないと、処理対象としない.
        if( line > 0 ) {
            int len = list.size() ;
            // 既に同一行が存在する場合は、追加できない.
            for( int i = 0 ; i < len ; i ++ ) {
                PnutsErrorLineChild n = list.get( i ) ;
                if( contextName == n.contextName && errorScriptName == n.errorScriptName &&
                    line == n.line ) {
                    return ;
                }
            }
            PnutsErrorLineChild n = new PnutsErrorLineChild() ;
            n.file = file ;
            n.contextName = contextName ;
            n.errorScriptName = errorScriptName ;
            n.line = line ;
            n.column = column ;
            list.add( n ) ;
        }
    }
    
    public PnutsErrorLineChild get( int no ) {
        return list.get( no ) ;
    }
    
    public int size() {
        return list.size() ;
    }
    
    public String toString() {
        StringBuilder buf = new StringBuilder();
        int len = list.size() ;
        for( int i = 0 ; i < len ; i ++ ) {
            if( i != 0 ) {
                buf.append( "\n" ) ;
            }
            PnutsErrorLineChild n = list.get( i ) ;
            buf.append('[');
            if (n.contextName != null) {
                buf.append(n.contextName).append(", ");
            }
            if (n.file != null) {
                buf.append(n.file);
            }
            if( n.errorScriptName != null ) {
                buf.append( n.errorScriptName ).append( ", ") ;
            }
            if (n.line > 0) {
                buf.append("line: " + n.line);
                if (n.column > 0){
                    buf.append(" column: " + n.column);
                }
            }
            buf.append(']');
        }
        return buf.toString() ;
    }
}
