package pnuts.lang ;

import java.util.*;
import org.maachang.*;
import org.maachang.seabass.*;

public class ThisObject extends BaseMap {
    private final static String THIS = "this".intern();
    private final static String SUPER = "super".intern();
    
    private ThisObject(){
    }
    private static final ThisObject SNGL = new ThisObject() ;
    public static final ThisObject getInstance() {
        return SNGL ;
    }
    
    public Object put(Object name, Object value) {
        if( name == null || ( name instanceof String ) == false ||
            value instanceof ThisObject ) {
            return null ;
        }
        String target = ( String )name ;
        //if( THIS.equals( target ) || SUPER.equals( target ) ) {
        if( THIS == target|| SUPER == target ) {
            return null ;
        }
        Context context = Context.getCurrentContext() ;
        Object thisObj = context.getThisStack().peek() ;
        if( thisObj == null ) {
            thisObj = ((SeaBassBindings)context.getCurrentPackage()).getMemory() ;
        }
        else if( thisObj == this ) {
            throw new PnutsException( "構成が不正なthisオブジェクト" ) ;
        }
        if( thisObj instanceof java.util.Map ) {
            return ((java.util.Map)thisObj).put( target,value ) ;
        }
        return null ;
    }
    
    public boolean containsKey(Object key) {
        if( key == null || ( key instanceof String ) == false ) {
            return false ;
        }
        String target = ( String )key ;
        //if( THIS.equals( target ) || SUPER.equals( target ) ) {
        if( THIS == target|| SUPER == target ) {
            return false ;
        }
        Context context = Context.getCurrentContext() ;
        Object thisObj = context.getThisStack().peek() ;
        if( thisObj == null ) {
            thisObj = ((SeaBassBindings)context.getCurrentPackage()).getMemory() ;
        }
        else if( thisObj == this ) {
            throw new PnutsException( "構成が不正なthisオブジェクト" ) ;
        }
        if( thisObj instanceof java.util.Map ) {
            return ((java.util.Map)thisObj).containsKey( target ) ;
        }
        return false ;
    }
    
    public Object get(Object key) {
        if( key == null || ( key instanceof String ) == false ) {
            return false ;
        }
        String target = ( String )key ;
        //if( THIS.equals( target ) || SUPER.equals( target ) ) {
        if( THIS == target|| SUPER == target ) {
            return null ;
        }
        Context context = Context.getCurrentContext() ;
        Object thisObj = context.getThisStack().peek() ;
        if( thisObj == null ) {
            thisObj = ((SeaBassBindings)context.getCurrentPackage()).getMemory() ;
        }
        else if( thisObj == this ) {
            throw new PnutsException( "構成が不正なthisオブジェクト" ) ;
        }
        if( thisObj instanceof java.util.Map ) {
            return ((java.util.Map)thisObj).get( target ) ;
        }
        return null ;
    }
    
    public Object remove(Object key) {
        if( key == null || ( key instanceof String ) == false ) {
            return false ;
        }
        String target = ( String )key ;
        //if( THIS.equals( target ) || SUPER.equals( target ) ) {
        if( THIS == target|| SUPER == target ) {
            return null ;
        }
        Context context = Context.getCurrentContext() ;
        Object thisObj = context.getThisStack().peek() ;
        if( thisObj == null ) {
            thisObj = ((SeaBassBindings)context.getCurrentPackage()).getMemory() ;
        }
        else if( thisObj == this ) {
            throw new PnutsException( "構成が不正なthisオブジェクト" ) ;
        }
        if( thisObj instanceof java.util.Map ) {
            return ((java.util.Map)thisObj).remove( target ) ;
        }
        return null ;
    }
    
    public Set keySet() {
        Context context = Context.getCurrentContext() ;
        Object thisObj = context.getThisStack().peek() ;
        if( thisObj == null ) {
            thisObj = ((SeaBassBindings)context.getCurrentPackage()).getMemory() ;
        }
        else if( thisObj == this ) {
            throw new PnutsException( "構成が不正なthisオブジェクト" ) ;
        }
        if( thisObj instanceof java.util.Map ) {
            return ((java.util.Map)thisObj).keySet() ;
        }
        return null ;
    }
    
    public int size() {
        Context context = Context.getCurrentContext() ;
        Object thisObj = context.getThisStack().peek() ;
        if( thisObj == null ) {
            thisObj = ((SeaBassBindings)context.getCurrentPackage()).getMemory() ;
        }
        else if( thisObj == this ) {
            throw new PnutsException( "構成が不正なthisオブジェクト" ) ;
        }
        if( thisObj instanceof java.util.Map ) {
            return ((java.util.Map)thisObj).size() ;
        }
        return -1 ;
    }
    
    public Object getThisObject() {
        Context context = Context.getCurrentContext() ;
        Object thisObj = context.getThisStack().peek() ;
        if( thisObj == null ) {
            thisObj = ((SeaBassBindings)context.getCurrentPackage()).getMemory() ;
        }
        else if( thisObj == this ) {
            throw new PnutsException( "構成が不正なthisオブジェクト" ) ;
        }
        return thisObj ;
    }
    
    public String toString() {
        return "this" ;
    }
}

