// Java(SeaBass)Npwb_t@C.

#ifndef _FILE_LIST_H_INCLUDE_
#define _FILE_LIST_H_INCLUDE_

#include "include/util.h"

#include <sys/types.h>
#include <sys/stat.h>

// t@CXg擾p.
typedef struct _tagFileList{
    void* next ;    // ̈.
    char path[ 260+1 ] ;  // i[t@C/fBNg.
} FILE_LIST,*LPFILE_LIST ;

// t@CXg𐶐.
inline LPFILE_LIST createFileList() {
    LPFILE_LIST ret = ( LPFILE_LIST )malloc( sizeof( FILE_LIST ) ) ;
    memset( ret->path,0,260+1 ) ;
    ret->next = NULL ;
    return ret ;
}

// t@CXgj.
inline void dropFileList( LPFILE_LIST lst ) {
    LPFILE_LIST nx ;
    for( ;; ) {
        if( lst == NULL ) {
            break ;
        }
        nx = ( LPFILE_LIST )lst->next ;
        free( lst ) ;
        lst = nx ;
        nx = NULL ;
    }
}

// wfBNg̃t@Cꗗ擾.
inline LPFILE_LIST getFileList( char* ph ) {
    char path[260+1] ;
    if( endsWith( ph,"*" ) == FALSE ) {
        if( endsWith( ph,"\\" ) == FALSE ) {
             joinString( path,ph,"\\" ) ;
        }
        else {
            sprintf( path,"%s\0",ph ) ;
        }
        joinString( path,path,"*" ) ;
    }
    else {
        sprintf( path,"%s\0",ph ) ;
    }
    WIN32_FIND_DATA FindFileData;
    HANDLE hFind;
    LPFILE_LIST ret;
    hFind = FindFirstFile(path, &FindFileData);
    if (hFind == INVALID_HANDLE_VALUE) {
        return NULL ;
    } else {
        ret = createFileList() ;
        sprintf( ret->path,"%s\0",FindFileData.cFileName ) ;
        LPFILE_LIST now = ret ;
        LPFILE_LIST nx ;
        for( ;; ) {
            if( FindNextFile( hFind,&FindFileData ) == FALSE ) {
                break ;
            }
            nx = createFileList() ;
            sprintf( nx->path,"%s\0",FindFileData.cFileName ) ;
            now->next = nx ;
            now = nx ;
        }
    }
    FindClose(hFind);
    return ret ;
}

// pX{t@CA.
inline void joinPathFile( char* out,char* path,char* name ) {
    if( endsWith( path,"\\" ) == FALSE ) {
        joinString( out,path,"\\" ) ;
    }
    else {
        sprintf( out,"%s\0",path ) ;
    }
    joinString( out,out,name ) ;
}

// pX{t@CA.
inline char* joinPathFile_s( char* path,char* name ) {
    char p[ 260+1 ] ;
    if( endsWith( path,"\\" ) == FALSE ) {
        joinString( p,path,"\\" ) ;
    }
    else {
        sprintf( p,"%s\0",path ) ;
    }
    return joinString_s( p,name ) ;
}


// weAt@CfBNg`FbN.
inline int isFileOrDir( char* path,char* name ) {
    struct stat s ;
    char file[ 260+1 ] ;
    joinPathFile( file,path,name ) ;
    stat( file,&s ) ;
    return ( s.st_mode & S_IFMT ) ;
}

// wfBNgȉ̃t@CQ[;]AŎ擾.
inline void findTargetPath( char* out,char* path ) {
    char nextPath[ 260+1 ] ;
    LPFILE_LIST lst = getFileList( path ) ;
    LPFILE_LIST pos = lst ;
    for( ;; ) {
        if( pos == NULL ) {
            break ;
        }
        if( strcmp( pos->path,"." ) == 0 || strcmp( pos->path,".." ) == 0 ) {
            pos = ( LPFILE_LIST )pos->next ;
            continue ;
        }
        joinPathFile( nextPath,path,pos->path ) ;
        if( isFileOrDir( path,pos->path ) == S_IFDIR ) {
            findTargetPath( out,nextPath ) ;
        }
        else if( endsWith( nextPath,".jar" ) ) {
            if( strlen( out ) > 0 ) {
                sprintf( out,"%s;%s\0",out,nextPath ) ;
            }
            else {
                sprintf( out,"%s\0",nextPath ) ;
            }
        }
        pos = ( LPFILE_LIST )pos->next ;
    }
    dropFileList( lst ) ;
    lst = NULL ;
    pos = NULL ;
}

#endif // _FILE_LIST_H_INCLUDE_
