///////////////////////////////////////////////////////////////////////////////
// seabass 基本Javascript.
// Copyright (c) 2009 masahito suzuki, Inc. All Rights Reserved.
///////////////////////////////////////////////////////////////////////////////

// グローバルオブジェクト.
__VAL_GLOVAL__ = this ;

// ブラウザ判別.
var isMSIE = /*@cc_on!@*/false; 
var isSAFARI = navigator.userAgent.indexOf( "Safari" ) != -1 ;
var isOPERA = navigator.userAgent.indexOf( "Opera" ) != -1 ;
var isMOZILLA = navigator.userAgent.indexOf( "Mozilla/" ) != -1 && isMSIE == false && isSAFARI == false ;
var isNETSCAPE = navigator.userAgent.indexOf( "Netscape" ) != -1 ;
var isCHROME = navigator.userAgent.indexOf( "Chrome/" ) != -1 ;

// IE6ブラウザ判定.
var isMSIE6 = ( isMSIE && typeof( document.documentElement.style.msInterpolationMode ) == "undefined" ) ;

// IE7ブラウザ判別.
var isMSIE7 = ( isMSIE && !isMSIE6 && typeof( document.documentElement.style.msInterpolationMode ) != "undefined" &&
    navigator.userAgent.indexOf("MSIE 7.") != -1 ) ;

// IE8ブラウザ判別.
var isMSIE8 = ( isMSIE && !isMSIE6 && !isMSIE7 &&
    typeof( document.documentElement.style.msInterpolationMode ) != "undefined" &&
    navigator.userAgent.indexOf("Trident/4.0") != -1 ) ;

// bind.
Function.prototype.bind = function(object) {
    var md = this;
    return (function() {
        return md.apply(object, arguments);
    }) ;
} ;

// firefox専用デバッグ出力.
dbg = function( str ) {
    if( isMOZILLA == true && console != null && console != undefined ) {
        console.debug( str ) ;
    }
} ;

///////////////////////////////////////////////////////////////////////////////
// seabass特殊定義情報のロード.
///////////////////////////////////////////////////////////////////////////////
(function() {
    var id = "_$load_seabass_special_$Id" ;
    var script = document.getElementById( id ) ;
    if( script != undefined ) {
        var pn = script.parentNode ;
        if( pn != undefined ) {
            pn.removeChild( script ) ;
        }
        pn = null ;
    }
    script = document.createElement("script");
    script.setAttribute("charset", "utf-8");
    script.setAttribute("type", "text/javascript");
    script.setAttribute("src", "/js/seabass_special-min.js?t=" + (new Date().getTime()) );
    script.setAttribute("language", "javascript");
    script.setAttribute("id", id);
    var heads = document.getElementsByTagName("head");
    if( heads != undefined && heads.length > 0 ) {
        heads[0].appendChild( script ) ;
    }
})() ;

////////////////////////////////////////////////////////////////////////////////
// Cookie系.
////////////////////////////////////////////////////////////////////////////////

// クッキー判別.
var isCookie = navigator.cookieEnabled ;

// cookie取得.
getCookie = function(key) {
    if( isCookie == false ) {
        return  ;
    }
    var xx1,xx2,xx3 ;
    var tmp2 ;
    var tmp1 = " " + document.cookie + ";";
    xx1 = xx2 = 0;
    var len = tmp1.length;
    while (xx1 < len) {
        xx2 = tmp1.indexOf(";", xx1);
        tmp2 = tmp1.substring(xx1 + 1, xx2);
        xx3 = tmp2.indexOf("=");
        if (tmp2.substring(0, xx3) == key) {
            return(unescape(tmp2.substring(xx3 + 1, xx2 - xx1 - 1)));
        }
        xx1 = xx2 + 1;
    }
    return("");
}

// cookie登録.
setCookie = function(key,val) {
    if( !isCookie || $base.isNull( key ) || $base.isNull( val ) ) {
        return ;
    }
    document.cookie = key + "=" + escape(val) + " ; path=/;" +
        " expires=Tue, 31-Dec-2030 23:59:59 GMT ; " ;
}

// 複数のcookie登録.
setCookies = function(map) {
    if( !isCookie || $base.isNull( map ) || valueof( map ) != 'map' ) {
        return ;
    }
    for( var k in map ) {
        document.cookie  = k + "=" + escape(map[k]) + " ; path=/;" +
            " expires=Tue, 31-Dec-2030 23:59:59 GMT ; " ;
    }
}

// cookie削除.
clearCookie = function(key) {
    if( isCookie == false ) {
        return  ;
    }
    document.cookie = key + "=" + "x ; path=/; expires=Tue, 1-Jan-1980 00:00:00 GMT ; ";
}

///////////////////////////////////////////////////////////////////////////////
// 文字列連結オブジェクト.
// IEの場合は、Array.joinを利用.
// それ以外のブラウザでは、文字連結で処理する.
///////////////////////////////////////////////////////////////////////////////
StrBuf = function( str ) {
    return this.create( str ) ;
}
StrBuf.prototype = {
    // buffer.
    _buf: null,
    _len: 0,
    // 生成処理.
    create: function( str ) {
        this.clear() ;
        if( str != null && typeof( str ) != "undefined" ) {
            return this.ad( str ) ;
        }
        return this ;
    },
    // クリア処理.
    clear: function() {
        this._buf = new Array() ;
        this._len = 0 ;
        return this ;
    },
    // 連結.
    ad: function(str) {
        if( str == null || typeof( str ) == "undefined" ) {
            return this ;
        }
        if( valueof( str ) != "string" ) {
            str = ""+str ;
        }
        this._len += str.length ;
        //this._buf[this._buf.length] = str ;
        this._buf.push( str ) ;
        return this ;
    },
    append: function(str) {
        if( str == null || typeof( str ) == "undefined" ) {
            return this ;
        }
        if( valueof( str ) != "string" ) {
            str = ""+str ;
        }
        this._len += str.length ;
        //this._buf[this._buf.length] = str ;
        this._buf.push( str ) ;
        return this ;
    },
    // 長さ取得.
    getLength : function() {
        if( this._buf.length <= 0 ) {
            return 0 ;
        }
        return this._len ;
    },
    // 内容表示.
    ts: function() {
        if( this._buf.length <= 0 ) {
            return "" ;
        }
        return this._buf.join('');
    },
    // 内容表示.
    toString: function() {
        if( this._buf.length <= 0 ) {
            return "" ;
        }
        return this._buf.join('');
    }
} ;

// 高速InnerHTML(FireFox用).
fastInnerHTML = function( node,html ) {
    if( typeof( node ) == "string" ) {
        node = $( node ) ;
    }
    // tbody条件の場合は、Table操作処理を行う.
    if( node.tagName.toUpperCase() == "TBODY" ) {
        Table.change( node,html ) ;
        return node ;
    }
    node.innerHTML = html ;
    return node ;
}

// innerText実行処理.
innerText = function( node,value ) {
    if( typeof( node ) == "string" ) {
        node = $( node ) ;
    }
    if( isMSIE ) {
        node.innerText = value ;
    }
    else {
        node.textContent = value ;
    }
}

// innerText情報を取得.
getInnerText = function( node ) {
    if( typeof( node ) == "string" ) {
        node = $( node ) ;
    }
    if( isMSIE ) {
        return node.innerText ;
    }
    else {
        return node.textContent ;
    }
}

// seabass検索アイテムによる、検索処理.
_$SSearch$_ = {
    _HEAD_NAME : "_$search$_$_",
    // 検索パラメータを取得.
    _$get : function() {
        if( $base.isNull( __VAL_GLOVAL__['$$_search_$$'] ) ) {
            __VAL_GLOVAL__['$$_search_$$'] = {} ;
        }
        return __VAL_GLOVAL__['$$_search_$$'] ;
    },
    // 検索内容を破棄.
    destroy : function() {
        _$SSearch$_.clear() ;
        __VAL_GLOVAL__['$$_search_$$'] = null ;
    },
    // 検索パラメータをクリア.
    clear : function() {
        // 検索タグ内容をクリア.
        var lst = (document.getElementsByTagName("*") || document.all);
        if( !$base.isNull( lst ) && lst.length > 0 ) {
            var tag ;
            var len = lst.length ;
            // 検索用タグの内容をクリア.
            for( var i = 0 ; i < len ; i ++ ) {
                tag = lst[ i ] ;
                if( $base.startsWith( tag.name,_$SSearch$_._HEAD_NAME ) ) {
                    tag.value = "" ;
                }
                if( !$base.isNull( tag.id ) &&
                    $base.startsWith( tag.id,_$SSearch$_._HEAD_NAME ) &&
                    $base.endsWith( tag.id,"_ViewId" ) ) {
                    fastInnerHTML( tag,"" ) ;
                }
            }
            // テーブルサマリーが検索、searchと付く条件の間だけのテキスト条件を削除.
            var searchTag = null ;
            for( var i = 0 ; i < len ; i ++ ) {
                var tag = lst[ i ] ;
                if( tag.tagName.toUpperCase() == "TABLE" ||
                    ( $base.startsWith( tag.summary,"検索" ) || $base.startsWith( tag.summary,"search" ) ) ) {
                    searchTag = tag ;
                    break ;
                }
            }
            // 検索された検索枠のテーブル条件が存在する場合、
            // その中のinput(text/password)/textareaをクリア.
            if( !$base.isNull( searchTag ) ) {
                var _$chk = function( tgLst ) {
                    if( $base.isNull( tgLst ) ) {
                        return ;
                    }
                    var len = tgLst.length ;
                    for( var i = 0 ; i < len ; i ++ ) {
                        var t = tgLst[ i ] ;
                        if( !$base.isNull( t ) ) {
                            _$chk( t.childNodes ) ;
                            if( !$base.isNull( t.tagName ) ) {
                                var tagName = t.tagName.toUpperCase() ;
                                if( tagName == "TEXTAREA" ) {
                                    if( !$base.isNull( t.value ) ) {
                                        t.value = "" ;
                                    }
                                }
                                else if( tagName == "INPUT" ) {
                                    var type = t.type.toLowerCase()
                                    if( type == "text" || type == "password" ) {
                                        if( !$base.isNull( t.value ) ) {
                                            t.value = "" ;
                                        }
                                    }
                                }
                            }
                        }
                    }
                }
                _$chk( searchTag.childNodes ) ;
            }
        }
        
    },
    // 検索パラメータを定義.
    define : function( searchType,column,hankaku,telMode ) {
        if( $base.isNull( searchType ) ||
            !$base.useString( column ) ) {
            return ;
        }
        var map = _$SSearch$_._$get() ;
        if( typeof( searchType ) == "function" ) {
            map[ "$"+column ] = searchType ;
        }
        else if( typeof( searchType ) == "string" ) {
            if( hankaku == true || hankaku == "true" ) {
                map[ "$"+column ] = "#"+searchType ;
            }
            else if( telMode == true || telMode == "true" ) {
                map[ "$"+column ] = "+"+searchType ;
            }
            else {
                map[ "$"+column ] = searchType ;
            }
        }
    },
    // Ajax検索処理.
    search : function( url,table,callbackId,params,func,forwardFlag ) {
        if( !$base.useString( url ) ) {
            // 検索処理が正しく行えない.
            return false ;
        }
        if( $base.isNull( params ) ) {
            params = "" ;
        }
        else if( valueof( params ) == "map" ) {
            params = convertParams( params,false ) ;
        }
        if( $base.useString( table ) ) {
            params = addParamByString( params,"_$table",table ) ;
        }
        else {
            params = addParamByString( params,"_$table","none" ) ;
        }
        var m = _$SSearch$_._$get() ;
        var name ;
        var val ;
        var val2 ;
        var type ;
        var cnt = 0 ;
        var HEAD = _$SSearch$_._HEAD_NAME ;
        // 定義されている内容から、パラメータを生成.
        for( var k in  m ) {
            if( $base.startsWith( k,"$" ) && !$base.isNull( ( type = m[k] ) ) ) {
                name = k.substring( 1 ) ;
                // 対象タイプが関数の場合.
                if( typeof( type ) == "function" ) {
                    var res = null ;
                    try {
                        res = type() ;
                    } catch( ee ) {
                        res = null ;
                    }
                    if( !$base.isNull( res ) ) {
                        params = addParamByString( params,"_$stype."+name,"function" ) ;
                        params = addParamByString( params,"_$skey."+name,res ) ;
                        cnt ++ ;
                    }
                }
                // 対象タイプが文字列の場合.
                else if( typeof( type ) == "string" ) {
                    // rangeの場合は、２つのパラメータ内容で処理する.
                    if( type == "range" ) {
                        val = $( HEAD + name + "_S" ) ;
                        val2 = $( HEAD + name + "_E" ) ;
                        if( $base.isNull( val ) || $base.isNull( val2 ) ||
                            ( !$base.useString( val.value ) && !$base.useString( val2.value ) ) ) {
                            continue ;
                        }
                        params = addParamByString( params,"_$stype."+name,type ) ;
                        params = addParamByString( params,"_$skey_S."+name,val.value ) ;
                        params = addParamByString( params,"_$skey_E."+name,val2.value ) ;
                        cnt ++ ;
                    }
                    // dateの場合は、３つのパラメータ内容で処理する.
                    else if( type == "date" ) {
                        year = $( HEAD + name + "_YMDYear" ) ;
                        month = $( HEAD + name + "_YMDMonth" ) ;
                        date = $( HEAD + name + "_YMDDay" ) ;
                        params = addParamByString( params,"_$stype."+name,type ) ;
                        params = addParamByString( params,"_$skey_Y."+name,year.value ) ;
                        params = addParamByString( params,"_$skey_M."+name,month.value ) ;
                        params = addParamByString( params,"_$skey_D."+name,date.value ) ;
                        cnt ++ ;
                    }
                    // それ以外の場合は、１つのパラメータ内容で処理する.
                    else {
                        val = $( HEAD + name ) ;
                        if( !$base.isNull( val ) && $base.useString( val.value ) ) {
                            params = addParamByString( params,"_$stype."+name,type ) ;
                            params = addParamByString( params,"_$skey."+name,val.value ) ;
                            cnt ++ ;
                        }
                    }
                }
            }
        }
        // フォワード処理の場合.
        if( forwardFlag == true || forwardFlag == "true" ) {
            forwardURL( url,params ) ;
            return true ;
        }
        var ret = false ;
        try {
            var res = accessAjaxToJsExecution( null,url,params ) ;
            if( typeof( res ) == "string" ) {
                if( $base.useString( callbackId ) ) {
                    var em = document.getElementById( callbackId ) ;
                    if( !$base.isNull( em ) ) {
                        fastInnerHTML( em,res ) ;
                        if( typeof( func ) == "function" ) {
                            func() ;
                        }
                    }
                    ret = true ;
                }
                else {
                    ret = false ;
                }
            }
            else {
                ret = false ;
            }
        } catch( e ) {
            ret = false ;
        }
        return ret ;
    },
    // 現在設定されている内容を取得.
    get : function( name ) {
        if( $base.useString( name ) ) {
            var ret = $( _$SSearch$_._HEAD_NAME + name ) ;
            if( !$base.isNull( ret ) ) {
                return ret.value ;
            }
        }
        return "" ;
    },
    // 表示データ設定.
    viewInfo : function( name,value ) {
        if( $base.useString( name ) ) {
            var em = document.getElementById( name + "_ViewId" ) ;
            if( !$base.isNull( em ) ) {
                fastInnerHTML( em,value ) ;
            }
        }
    }
}

// Seabass検索パラメータが存在するかチェック.
isSeabassSearchViewInfo = function( name ) {
    return !$base.isNull( document.getElementById( name + "_ViewId" ) ) ;
}

// Seabass検索パラメータを取得.
seabassSearchParam = function( name ) {
    return _$SSearch$_.get( name ) ;
}

// Seabass検索表示データに設定.
seabassSearchViewInfo = function( name,value ) {
    _$SSearch$_.viewInfo( name,value ) ;
}

// Seabass検索処理.
seabassSearch = function( url,table,callbackId,params ) {
    return _$SSearch$_.search( url,table,callbackId,params ) ;
}

// SeabassDao系処理.
SeabassDao = {
    id:"id",// 予約カラム(ID).
    createTime:"createTime",// 予約カラム(生成時間).
    optimisticLockVersion:"optimisticLockVersion",// 予約カラム(楽観ロックバージョン).
    // src条件を継承.
    copyRemColumns:function( src,dest ) {
        if( !$base.isNull( src[ SeabassDao.id ] ) ) {
            dest[ SeabassDao.id ] = src[ SeabassDao.id ] ;
        }
        if( !$base.isNull( src[ SeabassDao.createTime ] ) ) {
            dest[ SeabassDao.createTime ] = src[ SeabassDao.createTime ] ;
        }
        if( !$base.isNull( src[ SeabassDao.optimisticLockVersion ] ) ) {
            dest[ SeabassDao.optimisticLockVersion ] = src[ SeabassDao.optimisticLockVersion ] ;
        }
        return dest ;
    }
}

// 入力枠のカラー値を設定.
_$setChangeColor = function( a,n ) {
    if( !$base.useString( a ) ) {
        return ;
    }
    if( !$base.useString( n ) ) {
        n = "#ffffff" ;
    }
    setGlobal( "_$_$active_$changeColor",a ) ;
    setGlobal( "_$_$noActive_$changeColor",n ) ;
}

///////////////////////////////////////////////////////////////////////////////
// 基本定義.
///////////////////////////////////////////////////////////////////////////////

// getElementById.
$ = function( name,no ) {
    if( document.getElementById(name) == undefined ) {
        if( no == null || no == undefined ) {
            no = 0 ;
        }
        name = name + "_" + no + "_Id" ;
    }
    return document.getElementById( name ) ;
} ;

// getElementById.
$$ = function( name,no ) {
    if( document.getElementById(name) == undefined ) {
        if( no == null || no == undefined ) {
            no = 0 ;
        }
        name = name + "_" + no + "_Id" ;
    }
    var x = document.getElementById( name ) ;
    if( x == null || x == undefined ) {
        return null ;
    }
    return x.value ;
} ;

// 親条件の要素を取得.
_$ = function( id,mode ) {
    if( $base.useString( id ) ) {
        if( !$base.isNull( parent ) ) {
            mid = parent.document.getElementById(id) ;
        }
        if( $base.isNull( mid ) && !$base.isNull( window.opener ) ) {
            mid = window.opener.document.getElementById(id) ;
        }
        if( !$base.isNull( mid ) ) {
            return mid ;
        }
    }
    return null ;
}

// グローバルオブジェクトに設定.
setGlobal = function( key,value ) {
    if( $base.useString( key ) ) {
        if( key.indexOf( "." ) != -1 ) {
            var x = key.split( "." ) ;
            var len = x.length ;
            var o = __VAL_GLOVAL__[x[0]] ;
            if( $base.isNull( o ) ) {
                return false ;
            }
            len -- ;
            for( var i = 1 ; i < len ; i ++ ) {
                var o = o[x[i]] ;
                if( $base.isNull( o ) ) {
                    return false ;
                }
            }
            o[x[len]] = value ;
        }
        else {
            __VAL_GLOVAL__[key] = value ;
        }
    }
    return true ;
} ;

// グローバルオブジェクトを取得.
getGlobal = function( key ) {
    if( $base.useString( key ) ) {
        if( key.indexOf( "." ) != -1 ) {
            var x = key.split( "." ) ;
            var len = x.length ;
            var o = __VAL_GLOVAL__[x[0]] ;
            if( $base.isNull( o ) ) {
                return null ;
            }
            len -- ;
            for( var i = 1 ; i < len ; i ++ ) {
                var o = o[x[i]] ;
                if( $base.isNull( o ) ) {
                    return null ;
                }
            }
            return o[x[len]] ;
        }
        else {
            return __VAL_GLOVAL__[key] ;
        }
    }
    return null ;
}

// グローバルオブジェクトを削除.
removeGlobal = function( key ) {
    if( $base.useString( key ) ) {
        if( key.indexOf( "." ) != -1 ) {
            var x = key.split( "." ) ;
            var len = x.length ;
            var o = __VAL_GLOVAL__[x[0]] ;
            if( $base.isNull( o ) ) {
                return ;
            }
            len -- ;
            for( var i = 1 ; i < len ; i ++ ) {
                var o = o[x[i]] ;
                if( $base.isNull( o ) ) {
                    return ;
                }
            }
            delete o[x[len]] ;
        }
        else {
            delete __VAL_GLOVAL__[key] ;
        }
    }
}

// パラメータ変換処理.
convertParams = function( params,sessionId ) {
    // パラメータがMap形式の場合.
    if( !$base.isNull( params ) ) {
        var t = valueof( params ) ;
        if( t == "map" ) {
            var f = false ;
            var v ;
            var len ;
            var buf = new StrBuf() ;
            for( var k in params ) {
                v = params[k] ;
                if( valueof( v ) == "array" ) {
                    len = v.length ;
                    for( var i = 0 ; i < len ; i ++ ) {
                        if( f ) {
                            buf.ad( "&" ) ;
                        }
                        buf.ad( k ).ad( "=" ).ad( encodeURIComponent(v[i]) ) ;
                        f = true ;
                    }
                }
                else {
                    if( f ) {
                        buf.ad( "&" ) ;
                    }
                    buf.ad( k ).ad( "=" ).ad( encodeURIComponent(v) ) ;
                    f = true ;
                }
            }
            params = buf.ts() ;
        }
        else if( t != "string" ) {
            params = null ;
        }
        if( sessionId ) {
            return $base.trimGetParams( params ) ;
        }
        else {
            return params ;
        }
    }
    return null ;
}

// GETパラメータに指定パラメータ内容を追加.
addParamByString = function( params,key,value ) {
    var ret ;
    params = $base.trim( params ) ;
    if( $base.useString( params ) ) {
        ret = params + "&" + key + "=" + encodeURIComponent( value ) ;
    }
    else {
        ret = key + "=" + encodeURIComponent( value ) ;
    }
    return ret ;
}

// 入力要素のパラメータを取得して、MAPで取得.
inputElementParams = function( names ) {
    if( valueof( names ) != "array" ) {
        if( valueof( names ) != "string" ) {
            return {} ;
        }
        // 現在開いている全ての条件を送信.
        if( names == "*" ) {
            // 全てのinput,textarea,selectタグの名前を取得.
            var lst = (document.getElementsByTagName("*") || document.all);
            if( !$base.isNull( lst ) && lst.length > 0 ) {
                var len = lst.length ;
                var tag = null ;
                var tagName = null ;
                var ret = {} ;
                for( var i = 0 ; i < len ; i ++ ) {
                    tag = lst[ i ] ;
                    tagName = tag.tagName.toUpperCase() ;
                    if( tagName == "INPUT" || tagName == "TEXTAREA" || tagName == "SELECT" ) {
                        if( $base.isNull( ret[ tag.name ] ) ) {
                            if( $base.useString( tagValue ) ) {
                                ret[ tag.name ] = tag.value ;
                            }
                            else {
                                ret[ tag.name ] = "" ;
                            }
                        }
                        else {
                            var v = ret[ tag.name ] ;
                            if( valueof( v ) == "string" ) {
                                v = [v] ;
                            }
                            if( $base.useString( tagValue ) ) {
                                v[v.length] = tag.value ;
                            }
                            else {
                                v[v.length] = "" ;
                            }
                            ret[ tag.name ] = v ;
                        }
                    }
                }
                return ret ;
            }
            else {
                return {} ;
            }
        }
        names = [ names ] ;
    }
    var len = names.length ;
    var c ;
    var ret = {} ;
    for( var i = 0 ; i < len ; i ++ ) {
        c = $( names[ i ] ) ;
        if( $base.isNull( c ) || !$base.useString( c.value ) ) {
            c = "" ;
        }
        else {
            c = c.value ;
        }
        ret[names[ i ]] = c ;
    }
    return ret ;
}

///////////////////////////////////////////////////////////////////////////////
// baseオブジェクト.
///////////////////////////////////////////////////////////////////////////////
$base = {
    // nullチェック.
    isNull : function( value ) {
        return ( value == null || typeof( value ) == "undefined" ) ;
    },
    // trim.
    trim : function(arg_value){
        if( this.isNull( arg_value ) == true ||
            arg_value.length <= 0 ) {
            return '' ;
        }
        else if( typeof( arg_value ) != "string" ) {
            return arg_value ;
        }
        for( i = 0; i < arg_value.length ; i ++ ) {
            var old = arg_value ;
            arg_value = arg_value.replace( "&nbsp;"," " ) ;
            if( old.length == arg_value.length ) {
                break ;
            }
        }
        
        var st = 0 ;
        var ed = arg_value.length ;
        var len = arg_value.length ;
        for( i = 0 ; i < len ; i ++ ) {
            var c = arg_value.charAt( i ) ;
            var x = arg_value.charCodeAt( i ) ;
            if( c == ' ' || c == '　' || c == '\t' || c == '\r' || c == '\n' || x == 160 ) {//x==160はsafari対応.
                st = i+1 ;
            }
            else {
                break ;
            }
        }
        len = arg_value.length-1 ;
        for( i = len ; i >= 0 ; i -- ) {
            var c = arg_value.charAt( i ) ;
            var x = arg_value.charCodeAt( i ) ;
            if( c == ' ' || c == '　' || c == '\t' || c == '\r' || c == '\n' || x == 160 ) {//x==160はsafari対応.
                ed = i ;
            }
            else {
                break ;
            }
        }
        if( st >= ed ) {
            return '' ;
        }
        ret = arg_value.substring( 0,ed ) ;
        if( st > 0 ) {
            ret = ret.substring( st ) ;
        }
        return ret ;
    },
    // 文字列を置き換える.
    changeString : function( base,src,dest ) {
        if( this.isNull( base ) ) {
            return "" ;
        }
        if( this.isNull( src ) || src.length <= 0 ||
            this.isNull( dest ) ) {
            return base ;
        }
        var pnt;
        var end;
        var buf = new StrBuf();
        var srcLen = src.length ;
        pnt = base.indexOf(src);
        if (pnt == -1) {
            return base;
        } else if (pnt == 0) {
            buf.ad( dest ) ;
            end = srcLen;
        } else {
            buf.ad( base.substring(0, pnt) );
            buf.ad( dest );
            end = pnt + srcLen;
        }
        for (pnt += srcLen;;) {
            if ((pnt = base.indexOf(src, pnt)) == -1) {
                buf.ad( base.substring(end) );
                break;
            }
            if (pnt == end) {
                buf.ad( dest );
            } else {
                buf.ad( base.substring(end, pnt) );
                buf.ad( dest );
            }
            end = pnt + srcLen;
            pnt += srcLen;
        }
        return buf.ts() ;
    },
    // stringマージ.
    margeString : function( s,sp,d,dp,len ) {
        return new StrBuf().ad( d.substring( 0,dp ) ).
            ad( s.substring( sp,sp+len ) ).ad( d.substring( dp+len ) ).ts() ;
    },
    // 文字列を配列に変換.
    strToArray : function( s ) {
        if( valueof( s ) != "string" ) {
            return null ;
        }
        s = encodeURIComponent( s ) ;
        var len = s.length ;
        var ret = new Array( len ) ;
        for( var i = 0 ; i < len ; i ++ ) {
            ret[ i ] = s.charCodeAt( i ) ;
        }
        return ret ;
    },
    // 配列文字列を文字列に変換.
    aryToString : function( s ) {
        if( valueof( s ) != "array" ) {
            return s ;
        }
        var len = s.length ;
        var ret = new Array( len ) ;
        for( var i = 0 ; i < len ; i ++ ) {
            ret[ i ] = String.fromCharCode( s[ i ] ) ;
        }
        return decodeURIComponent( ret.join('') ) ;
    },
    // 配列コピー.
    arraycopy : function( s,sp,d,dp,len ) {
        len = parseInt( len ) ;
        sp = parseInt( sp ) ;
        dp = parseInt( dp ) ;
        for( var i = 0 ; i < len ; i ++ ) {
            d[(dp+i)] = s[(sp+i)] ;
        }
    },
    // 配列削除.
    removeArray : function( v,no ) {
        no = parseInt( no ) ;
        v.splice( no,1 ) ;
        return v ;
    },
    // startWith.
    startsWith : function(str,chk) {
        if( this.isNull( str ) || this.isNull( chk ) ) {
            return false ;
        }
        str = ""+str ;
        chk = ""+chk ;
        if( str == chk || str.indexOf( chk ) == 0 ) {
            return true ;
        }
        return false ;
    },
    // endsWith.
    endsWith : function(str,chk) {
        if( this.isNull( str ) || this.isNull( chk ) ) {
            return false ;
        }
        str = ""+str ;
        chk = ""+chk ;
        if( str == chk ) {
            return true ;
        }
        var last = str.lastIndexOf( chk ) ;
        if( last != -1 && last == str.length-chk.length ) {
            return true ;
        }
        return false ;
    },
    // 文字存在チェック.
    useString : function(str){
        if( this.isNull( str ) == true || this.trim(str).length <= 0 ) {
            return false ;
        }
        return true ;
    },
    // 指定文字列がFunction条件かチェック.
    useFunction : function(str) {
        return ( this.useString( str ) && typeof( getGlobal(str) ) == "function" ) ;
    },
    // 数値チェック.
    isNumeric : function(num){
        if( !this.useString( num ) ) {
            return false ;
        }
        num = ""+num ;
        if( this.startsWith( num,"-" ) ) {
            num = num.substring( 1 ) ;
        }
        if ( this.isNull(num.match) || num.match(/[^0-9.0-9]/g)) {
            return false;
        }
        return true;
    },
    // 現在日付を取得
    nowDateString : function(mode) {
        return this.formatDateByString(new Date(),mode) ;
    },
    // 日付を変換.
    formatDateByString : function( date,mode ) {
        if( this.isNull( date ) ) {
            return null ;
        }
        if( this.isNull( mode ) ) {
            mode = false ;
        }
        var ret = new StrBuf( date.getFullYear() ) ;
        var x = ""+(date.getMonth()+1) ;
        ret.ad( "/" ).ad( "00".substring( x.length,2 ) ).ad( x ) ;
        x = ""+date.getDate() ;
        ret.ad( "/" ).ad( "00".substring( x.length,2 ) ).ad( x ) ;
        if( mode == true ) {
            ret.ad( " " ) ;
        }
        else {
            ret.ad( "&nbsp;" ) ;
        }
        x = ""+date.getHours() ;
        ret.ad( "00".substring( x.length,2 ) ).ad( x ) ;
        x = ""+date.getMinutes() ;
        ret.ad( ":" ).ad( "00".substring( x.length,2 ) ).ad( x ) ;
        x = ""+date.getSeconds() ;
        ret.ad( ":" ).ad( "00".substring( x.length,2 ) ).ad( x ) ;
        return ret.ts() ;
    },
    // 文字をエンコード.
    encodeParam : function(params) {
        if( this.useString( params ) == true ) {
            var x = params.split( "&" ) ;
            var len = x.length ;
            var ret = new StrBuf() ;
            for( var i = 0 ; i < len ; i ++ ) {
                if( i != 0 ) {
                    ret.ad( "&" ) ;
                }
                var p = x[i].indexOf( "=" ) ;
                if( p != -1 ) {
                    var k = x[i].substring( 0,p ) ;
                    var v = x[i].substring( p+1,x[i].length ) ;
                    ret.ad( k ).ad( "=" ).ad( encodeURIComponent( v ) ) ;
                }
                else {
                    ret.ad( x[i] ) ;
                }
            }
        }
        return ret.ts() ;
    },
    // ＧＥＴパラメータを整形.
    trimGetParams : function( params ) {
        if( isCookie == false && $base.useString( __VAL_GLOVAL__['_$SESSION_ID'] ) ) {
            if( this.useString( params ) ) {
                params += "&_maachang-session=" + __VAL_GLOVAL__['_$SESSION_ID'] ;
            }
            else {
                params = "_maachang-session=" + __VAL_GLOVAL__['_$SESSION_ID'] ;
            }
        }
        return params ;
    },
    // セッションIDを取得.
    getSessionId : function() {
        return ( $base.useString( __VAL_GLOVAL__['_$SESSION_ID'] ) ) ? __VAL_GLOVAL__['_$SESSION_ID'] : null ;
    },
    // 現在のURLを取得.
    getURL : function() {
        return document.URL ;
    },
    // サーバが認識しているURLを取得.
    getServerURL : function() {
        var ret ;
        if( !$base.useString( __VAL_GLOVAL__['_$URL'] ) ) {
            ret = document.URL ;
        }
        else {
            ret = __VAL_GLOVAL__['_$URL'] ;
        }
        if( !$base.endsWith( ret,"/" ) ) {
            ret += "/" ;
        }
        return ret ;
    },
    // 現在のURLから、ドメイン名までを取得.
    getUrlDomain : function() {
        var url = this.getURL() ;
        var p = url.indexOf( "//" ) ;
        if( p <= -1 ) {
            return "" ;
        }
        p = url.indexOf( "/",p+"//".length ) ;
        if( p <= -1 ) {
            return url ;
        }
        return url.substring( 0,p+"/".length ) ;
    },
    // サーバが認識している現在のURLから、ドメイン名までを取得.
    getServerUrlDomain : function() {
        var url = this.getServerURL() ;
        var p = url.indexOf( "//" ) ;
        if( p <= -1 ) {
            return "" ;
        }
        p = url.indexOf( "/",p+"//".length ) ;
        if( p <= -1 ) {
            return url ;
        }
        return url.substring( 0,p+"/".length ) ;
    },
    // 現在のドメインだけを取得.
    getDomain : function() {
        var url = this.getURL() ;
        var p = url.indexOf( "//" ) ;
        if( p <= -1 ) {
            return "" ;
        }
        var p1 = url.indexOf( "/",p+"//".length ) ;
        if( p1 <= -1 ) {
            return url.substring( p+"//".length ) ;
        }
        return url.substring( p+"//".length,p1 ) ;
    },
    // サーバが認識しているドメインを取得.
    getServerDomain : function() {
        var url = $base.getServerURL() ;
        var p = url.indexOf( "//" ) ;
        if( p <= -1 ) {
            return "" ;
        }
        var p1 = url.indexOf( "/",p+"//".length ) ;
        if( p1 <= -1 ) {
            return url.substring( p+"//".length ) ;
        }
        return url.substring( p+"//".length,p1 ) ;
    },
    // URLパラメータに対して、クッキー非対応の場合のセッションID付加処理.
    addNoCookieBySession : function( params ) {
        // クッキ非対応の場合.
        if( isCookie == false && $base.useString( __VAL_GLOVAL__['_$SESSION_ID'] ) ) {
            if( $base.isNull( params ) ) {
                params = "" ;
            }
            if( $base.useString( params ) ) {
                params += "&_maachang-session=" + __VAL_GLOVAL__['_$SESSION_ID'] ;
            }
            else {
                params += "_maachang-session=" + __VAL_GLOVAL__['_$SESSION_ID'] ;
            }
        }
        return params ;
    },
    // チェック処理に対して日付計算を行ってoptionを再生成.
    changeSelectYMD : function( name,no ) {
        if( !$base.useString( no ) ) {
            no = 0 ;
        }
        var yId = name + "Year" + "_" + no + "_Id" ;
        var mId = name + "Month" + "_" + no + "_Id" ;
        var dId = name + "Day" + "_" + no + "_Id" ;
        var sId = name + "SYMD" + "_" + no + "_Id" ;
        
        if( this.useString( $( yId ).value ) == false ||
            this.useString( $( mId ).value ) == false ) {
            fastInnerHTML( dId,"<option value=\"\">選択</option>" ) ;
            return ;
        }
        var y = parseInt( $( yId ).value ) ;
        var m = parseInt( $( mId ).value ) ;
        var st = new Date( y,m-1,1,0,0,0 ).getTime() ;
        m = m + 1 ;
        if( m > 12 ) {
            m = 1 ;
            y ++ ;
        }
        var ed = new Date( y,m-1,1,0,0,0 ).getTime() ;
        var tm = ed-st ;
        var len = tm / ( new Date( 0,0,2,0,0,0 ).getTime()-new Date( 0,0,1,0,0,0 ).getTime() );
        var dayIdEm = $( dId ) ;
        var selectDay = parseInt( dayIdEm.value ) ;
        var _onFocus = dayIdEm.onfocus ;
        var _onBlur = dayIdEm.onblur ;
        var _onClick = dayIdEm.onclick ;
        var _onKeyDown = dayIdEm.onkeydown ;
        var _onKeyPress = dayIdEm.onkeypress ;
        var str = new StrBuf( "<select name=\"" + name + "Day\" id=\"" ).ad( dId ).ad( "\">\n" ) ;
        if( $base.isNull( selectDay ) ) {
            for( var i = 0 ; i < len ; i ++ ) {
                var x = ""+(i+1) ;
                x = "00".substring( x.length )+x ;
                str.ad( "<option value=\"" ).ad( (i+1) ).ad( "\">" ).ad( x ) ;
            }
        }
        else {
            str.ad( "<option value=\"\">選択</option>" ) ;
            for( var i = 0 ; i < len ; i ++ ) {
                var x = ""+(i+1) ;
                x = "00".substring( x.length )+x ;
                if( selectDay != i+1 ) {
                    str.ad( "<option value=\"" ).ad( (i+1) ).ad( "\">" ).ad( x ).ad( "</option>" ) ;
                }
                else {
                    str.ad( "<option value=\"" ).ad( (i+1) ).ad( "\" selected>" ).ad( x ).ad( "</option>" ) ;
                }
            }
        }
        str.ad( "</select>" ) ;
        fastInnerHTML( sId,str.ts() ) ;
        str = null ;
        dayIdEm = $( dId ) ;
        if( !$base.isNull( _onFocus ) ) {
            dayIdEm.onfocus = _onFocus ;
        }
        if( !$base.isNull( _onBlur ) ) {
            dayIdEm.onblur = _onBlur ;
        }
        if( !$base.isNull( _onClick ) ) {
            dayIdEm.onclick = _onClick ;
        }
        if( !$base.isNull( _onKeyDown ) ) {
            dayIdEm.onkeydown = _onKeyDown ;
        }
        if( !$base.isNull( _onKeyPress ) ) {
            dayIdEm.onkeypress = _onKeyPress ;
        }
    },
    // selectYMD内容を取得.
    getYMD : function( name ) {
        var year = $( name + "Year" ) ;
        var month = $( name + "Month" ) ;
        var date = $( name + "Day" ) ;
        if( $base.isNull( year ) ||
            $base.isNull( month ) ||
            $base.isNull( date ) ) {
            return null ;
        }
        year = year.value ;
        month = month.value ;
        date = date.value ;
        if( !$base.isNumeric( year ) ||
            !$base.isNumeric( month ) ||
            !$base.isNumeric( date ) ) {
            return null ;
        }
        return new Date( parseInt( year ),parseInt( month )-1,parseInt( date ) ) ;
    },
    // HTML表示可能な形式に変換.
    changeStringByHTML : function( string ) {
        var len = string.length ;
        var ret = new StrBuf() ;
        for( var i = 0 ; i < len ; i ++ ) {
            var c = string.charAt( i ) ;
            if( c == "&" ) {
                ret.ad( "&amp;" ) ;
            }
            else if( c == "<" ) {
                ret.ad( "&lt;" ) ;
            }
            else if( c == ">" ) {
                ret.ad( "&gt;" ) ;
            }
            else if( c == "\'" ) {
                ret.ad( "&#039;" ) ;
            }
            else if( c == "\"" ) {
                ret.ad( "&#034;" ) ;
            }
            else {
                ret.ad( c ) ;
            }
        }
        return ret.ts() ;
    },
    // イベント追加.
    addEvent : function( node,name,func ) {
        if( !$base.useString( name ) || $base.isNull( func ) ||
            typeof( func ) != "function" ) {
            return false ;
        }
        if( $base.isNull( node ) ) {
            node = window ;
        }
        name = name.toLowerCase() ;
        if( $base.startsWith( "on" ) ) {
            name = name.substring( 2 ) ;
        }
        if( !$base.isNull( node.attachEvent ) ){
            node.attachEvent("on"+name, func);
        }
        else if( !$base.isNull( node.addEventListener ) ){
            node.addEventListener(name, func, false);
        }
    },
    // イベントの削除.
    removeEvent : function( node,name,func ) {
        if( $base.isNull( node ) || !$base.useString( name ) || $base.isNull( func ) ||
            typeof( func ) != "function" ) {
            return false ;
        }
        name = name.toLowerCase() ;
        if( $base.startsWith( "on" ) ) {
            name = name.substring( 2 ) ;
        }
        if(node.removeEventListener){
            node.removeEventListener(name, func, false);
        }else if(node.detachEvent){
            node.detachEvent("on"+name, func);
        }
    },
    // リストソート.
    sort : function(list, comparer) {
        if (!comparer) comparer = function(x, y) { return y - x; };
        return (function s(l) {
            var len = l.length;
            if (len < 2) return l;
            var x = l[0], y = l[1], lt = [], gt = [];
            for (var i = 1; i < len; y = l[++i]) (comparer(x, y) < 0 ? lt : gt).push(y);
            return s(lt).concat([x], s(gt));
        })(list);
    },
    // リストから、一致する文字列を検索.
    searchList : function( list,name ) {
        if( $base.isNull( list ) ) {
            return -1 ;
        }
        var len = list.length ;
        for( var i = 0 ; i < len ; i ++ ) {
            if( list[ i ] == name ) {
                return i ;
            }
        }
        return -1 ;
    },
    // SSL通信か判別.
    isSSL : function() {
        return $base.startsWith( document.URL,"https://" ) ;
    },
    // bodyオブジェクトを取得.
    getBody : function() {
        if( $base.isNull( document.body ) ) {
            var bodys = document.getElementsByTagName("body");
            if( !$base.isNull( bodys ) && bodys.length > 0 ) {
                return bodys[ 0 ] ;
            }
        }
        else {
            return document.body ;
        }
        return null ;
    },
    // 16進数を10進数に変換.
    convert16To10 : function( value ) {
        if( $base.isNull( value ) ) {
            return 0 ;
        }
        value = value.toLowerCase() ;
        var len = value.length ;
        var ret = 0 ;
        var shift = 0 ;
        var c ;
        for( var i = len-1 ; i >= 0 ; i -- ) {
            c = value.charAt( i ) ;
            switch( c ) {
                case '0' : break ;
                case '1' :
                case '2' :
                case '3' :
                case '4' :
                case '5' :
                case '6' :
                case '7' :
                case '8' :
                case '9' :
                    ret += parseInt( c ) << shift ;
                    break ;
                case 'a' : ret += 10 << shift ; break ;
                case 'b' : ret += 11 << shift ; break ;
                case 'c' : ret += 12 << shift ; break ;
                case 'd' : ret += 13 << shift ; break ;
                case 'e' : ret += 14 << shift ; break ;
                case 'f' : ret += 15 << shift ; break ;
            }
            shift += 4 ;
        }
        return ret ;
    },
    // 10進数を16進数に変換.
    convert10To16 : function( value,len ) {
        if( $base.isNull( value ) ) {
            return "0" ;
        }
        if( typeof( value ) == "string" ) {
            value = parseInt( value ) ;
        }
        if( typeof( value ) != "number" ) {
            return "0" ;
        }
        if( !$base.isNumeric( len ) ) {
            len = -1 ;
        }
        var ret = "" ;
        var c ;
        for( var i = 0 ; i < 32 ; i += 4 ) {
            if( len != -1 && len <= ret.length ) {
                break ;
            }
            c = ( value & ( 0x0f << i ) ) >> i ;
            switch( c ) {
                case 0 :
                case 1 :
                case 2 :
                case 3 :
                case 4 :
                case 5 :
                case 6 :
                case 7 :
                case 8 :
                case 9 :
                    ret = c + ret ;
                    break ;
                case 10 : ret = "a" + ret ; break ;
                case 11 : ret = "b" + ret ; break ;
                case 12 : ret = "c" + ret ; break ;
                case 13 : ret = "d" + ret ; break ;
                case 14 : ret = "e" + ret ; break ;
                case 15 : ret = "f" + ret ; break ;
            }
        }
        return ret ;
    },
    // select選択中の表示名を取得.
    selectIndexView : function( name ) {
        var em = $(name) ;
        if( !$base.isNull( em ) ) {
            var opt = em.options ;
            if( !$base.isNull( opt ) ) {
                return opt[em.selectedIndex].text;
            }
            return em.value ;
        }
        return null ;
    }
} ;

///////////////////////////////////////////////////////////////////////////////
// パーサー関連.
///////////////////////////////////////////////////////////////////////////////

// パーサー用ユーティリティ.
ParserUtil = {
    // 改行を含むtrim処理.
    trim : function( string ) {
        var s = 0 ;
        var e = -1 ;
        var len = string.length ;
        var sFlg = false ;
        var c = null ;
        for( var i = 0 ; i < len ; i ++ ) {
            c = string.charAt( i ) ;
            if( c != ' '  && c != '　' && c != '\r' && c != '\n' && c != '\t' ) {
                s = i ;
                break ;
            }
            sFlg = true ;
        }
        e = len-1 ;
        var eFlg = false ;
        for( var i = len-1 ; i >= 0 ; i -- ) {
            c = string.charAt( i ) ;
            if( c != ' '  && c != '　' && c != '\r' && c != '\n' && c != '\t' ) {
                e = i ;
                break ;
            }
            eFlg = true ;
        }
        if( sFlg == true && eFlg == true ) {
            return string.substring( s,e+1 ) ;
        }
        else if( sFlg == true ) {
            return string.substring( s ) ;
        }
        else if( eFlg == true ) {
            return string.substring( 0,e+1 ) ;
        }
        return string ;
    },
    // コーテーションを検出しないIndexOf.
    indexOfCote : function( base,cc,off ) {
        if( off == undefined || off == null ) {
            off = 0 ;
        }
        var len = base.length ;
        var cote = -1 ;
        var cs = cc.charAt(0) ;
        var cLen = cc.length ;
        var bef = 0 ;
        var yenFlag = false ;
        var c = null ;
        var res = null ;
        for( var i = off ; i < len ; i ++ ) {
            c = base.charAt( i ) ;
            if( cote != -1 ) {
                if( bef != '\\' && c == cote ) {
                    yenFlag = false ;
                    cote = -1 ;
                }
                else if( c == '\\' && bef == '\\' ) {
                    yenFlag = true ;
                }
                else {
                    yenFlag = false ;
                }
            }
            else {
                if( bef != '\\' && ( c == '\'' || c == '\"' ) ) {
                    cote = c ;
                }
                else if( c == cs ) {
                    res = true ;
                    for( var j = 1 ; j < cLen ; j ++ ) {
                        if( i + j >= len || cc.charAt( j ) != base.charAt( i + j ) ) {
                            res = false ;
                            break ;
                        }
                    }
                    if( res == true ) {
                        return i ;
                    }
                }
            }
            if( yenFlag ) {
                yenFlag = false ;
                bef = 0 ;
            }
            else {
                bef = c ;
            }
        }
        return -1 ;
    },
    // 開始位置(st)から、終了位置(ed)を取得.
    indexParCote : function( base,st,ed,off ) {
        if( $base.isNull( off ) ) {
            off = 0 ;
        }
        var len = base.length ;
        var par = -1 ;
        var cote = -1 ;
        var idx = 0 ;
        var bef = 0 ;
        var yenFlag = false ;
        var c = null ;
        for( var i = off ; i < len ; i ++ ) {
            c = base.charAt( i ) ;
            if( par != -1 || cote != -1 ) {
                if( cote != -1 ) {
                    if( bef != '\\' && c == cote ) {
                        yenFlag = false ;
                        cote = -1 ;
                    }
                    else if( c == '\\' && bef == '\\' ) {
                        yenFlag = true ;
                    }
                    else {
                        yenFlag = false ;
                    }
                }
                else if( par != -1 ) {
                    if( c == ed ) {
                        idx -- ;
                        if( idx <= 0 ) {
                            return i ;
                        }
                    }
                    else if( c == st ) {
                        idx ++ ;
                    }
                }
            }
            else {
                if( c == '\'' || c == '\"' ) {
                    cote = c ;
                }
                else if( c == st ) {
                    idx = 1 ;
                    par = c ;
                }
                else if( c == ed ) {
                    return i ;
                }
            }
            if( yenFlag ) {
                yenFlag = false ;
                bef = 0 ;
            }
            else {
                bef = c ;
            }
        }
        return -1 ;
    },
    // 改行内容を取り除く.
    cutEnter : function( string ) {
        if( $base.isNull( string ) || ( string = ParserUtil.trim( string ) ).length <= 0 ) {
            return "" ;
        }
        var buf = new StrBuf() ;
        var len = string.length ;
        var cote = -1 ;
        var bef = 0 ;
        var yenFlag = false ;
        var c = null ;
        for( var i = 0 ; i < len ; i ++ ) {
            c = string.charAt( i ) ;
            if( cote != -1 ) {
                if( bef != '\\' && c == cote ) {
                    yenFlag = false ;
                    cote = -1 ;
                }
                else if( c == '\\' && bef == '\\' ) {
                    yenFlag = true ;
                }
                else {
                    yenFlag = false ;
                }
            }
            else if( c == '\'' || c == '\"' ) {
                cote = c ;
            }
            if( c == '\r' || c == '\n' || c == "\t" || c == "　" ) {
                if( cote == -1 ) {
                    buf.ad( " " ) ;
                }
                continue ;
            }
            buf.ad( c ) ;
            if( yenFlag ) {
                yenFlag = false ;
                bef = 0 ;
            }
            else {
                bef = c ;
            }
        }
        return buf.ts() ;
    },
    // コメント情報を除外する.
    cutComment : function( script )  {
        if( script == null || script.length <= 0 ) {
            return "" ;
        }
        var buf = new StrBuf() ;
        var len = script.length ;
        var cote = -1 ;
        var commentType = -1 ;
        var bef = -1 ;
        for( var i = 0 ; i < len ; i ++ ) {
            if( i != 0 ) {
                bef = script.charAt( i-1 ) ;
            }
            var c = script.charAt(i) ;
            // コメント内の処理.
            if( commentType != -1 ) {
                switch( commentType ) {
                    case 1 : // １行コメント.
                        if( c == '\n' ) {
                            buf.ad( c ) ;
                            commentType = -1 ;
                        }
                        break ;
                    case 2 : // 複数行コメント.
                        if( c == '\n' ) {
                            buf.ad( c ) ;
                        }
                        else if( len > i + 1 && c == '*' && script.charAt( i+1 ) == '/' ) {
                            i ++ ;
                            commentType = -1 ;
                        }
                        break ;
                }
                continue ;
            }
            // シングル／ダブルコーテーション内の処理.
            if( cote != -1 ) {
                if( c == cote && bef != '\\' ) {
                    cote = -1 ;
                }
                buf.ad( c ) ;
                continue ;
            }
            // それ以外の処理.
            if( c == '/' ) {
                if( len <= i + 1 ) {
                    buf.ad( c ) ;
                    continue ;
                }
                var c2 = script.charAt( i+1 ) ;
                if( c2 == '*' ) {
                    commentType = 2 ;
                    continue ;
                }
                else if( c2 == '/' ) {
                    commentType = 1 ;
                    continue ;
                }
            }
            // コーテーション開始.
            else if( ( c == '\'' || c == '\"' ) && bef != '\\' ) {
                cote = parseInt( c & 0x0000ffff ) ;
            }
            buf.ad( c ) ;
        }
        return buf.ts() ;
    },
    // コーテーション付加.
    indentCote : function( string,off,dc ) {
        if( string == undefined || string == null || string.length <= 0 ) {
            return "" ;
        }
        var cote = '\"' ;
        if( !dc ) {
            cote = '\'' ;
        }
        if( string.indexOf( cote ) != -1 ) {
            var yenCount = 0 ;
            var indNo = off ;
            var len = string.length ;
            var buf = new StrBuf() ;
            var stack = new StackInfo() ;
            var c,decFlag,yenLen,j ;
            for( var i = 0 ; i < len ; i ++ ) {
                c = string.charAt( i ) ;
                if( c == cote ) {
                    decFlag = false ;
                    if( stack.size() > 0 && stack.peek() >= yenCount ) {
                        if( stack.peek() > yenCount ) {
                            stack.pop() ;
                            indNo -- ;
                            decFlag = false ;
                        }
                        else {
                            stack.pop() ;
                            decFlag = true ;
                        }
                    }
                    else {
                        stack.push( yenCount ) ;
                        indNo ++ ;
                    }
                    yenLen = (2<<(indNo-1))-1 ;
                    for( j = 0 ; j < yenLen ; j ++ ) {
                        buf.ad( "\\" ) ;
                    }
                    buf.ad( cote ) ;
                    yenCount = 0 ;
                    if( decFlag ) {
                        indNo -- ;
                    }
                }
                else if( c == '\\' ) {
                    yenCount ++ ;
                }
                else {
                    if( yenCount > 0 ) {
                        for( j = 0 ; j < yenCount ; j ++ ) {
                            buf.ad( "\\" ) ;
                        }
                        yenCount = 0 ;
                    }
                    buf.ad( c ) ;
                }
            }
            return buf.ts() ;
        }
        return string ;
    },
    // 指定開始位置からの有効文字情報を取得.
    toIndexFirstString : function( string,endTagFlag,start,end ) {
        var len = string.length ;
        var c ;
        var flg = false ;
        if( end <= -1 || len <= end ) {
            end = len ;
        }
        var slCnt = 0 ;
        var buf = new StrBuf() ;
        for( var i = start+1 ; i < end ; i ++ ) {
            c = string.charAt( i ) ;
            if( !flg ) {
                if( c == '/' ) {
                    if( endTagFlag ) {
                        if( slCnt > 0 ) {
                            return null ;
                        }
                        slCnt ++ ;
                        continue ;
                    }
                    else {
                        return null ;
                    }
                }
                if( c != ' ' && c != '\t' && c != '\r' && c != '\n' &&
                    ( ( c >= 'a' && c <= 'z' ) || ( c >= 'A' && c <= 'Z' ) ) ) {
                    flg = true ;
                    buf.ad( c ) ;
                }
            }
            else {
                if( c == ' ' || c == '\t' || c == '\r' || c == '\n' || c == '>' ) {
                    return buf.ts() ;
                }
                buf.ad( c ) ;
            }
        }
        return null ;
    }
} ;

// 文字データで取得.
getStringValue = function( name ) {
    var em = $(name) ;
    if( $base.isNull( em ) ) {
        return null ;
    }
    em = em.value ;
    if( $base.useString( em ) ) {
        return $base.trim( em ) ;
    }
    return "" ;
}

// 数値データで取得.
getNumberValue = function( name ) {
    var em = $(name) ;
    if( $base.isNull( em ) ) {
        return null ;
    }
    em = em.value ;
    if( $base.isNumeric( em ) ) {
        return parseInt( em ) ;
    }
    return null ;
}

// 指定要素をクリック処理.
clickElement = function( id,mode ) {
    var em = null ;
    if( mode ) {
        em = _$( id ) ;
    }
    else {
        em = $( id ) ;
    }
    if( $base.isNull( em ) ) {
        return ;
    }
    if( !$base.isNull( em.click ) ) {
        em.click() ;
    }
    else if( !$base.isNull( em.onclick ) ) {
        em.onclick() ;
    }
}

// Flashバージョンを取得.
getFlashVersion = function() {
    var vsn = '';
    if( navigator.plugins && navigator.mimeTypes.length ) {     // not IE
        var tmp = navigator.plugins["Shockwave Flash"].description.match(/([0-9]+)/);
        vsn = tmp[0];
    } else {    // IE
        var tmp = new ActiveXObject("ShockwaveFlash.ShockwaveFlash").
            GetVariable("$version").match(/([0-9]+)/);
        vsn = tmp[0];
    }
    return vsn;
}

// プラグインチェック.
checkPlugin = function(mimeType, comNames){
    comNames = [].concat(comNames);
    if(!isMSIE){
        return !!navigator.mimeTypes[mimeType];
    }
    for(var i=comNames.length-1 ; comNames[i] ; i-- ){
        try{
          new ActiveXObject(comNames[i]);
          return true;
        }catch(e){
        }
    }
    return false;
}

// IE以外のWindowイベントを取得.
windowEvent = function(){
    if(window.event) return window.event;
    var caller = arguments.callee.caller;
    while(caller){
        var ob = caller.arguments[0];
        if(ob && ob.constructor == MouseEvent) return ob;
        caller = caller.caller;
    }
    return null;
}

// イベントを取得.
getEvent = function(e) {
    e = ( $base.isNull( e ) ) ? windowEvent() : e ;
    if( $base.isNull( e ) ) {
        return null ;
    }
    return e ;
}

// イベントキャンセル.
cencellEvent = function( event ) {
    event = getEvent( event ) ;
    if( event.preventDefault ) {
        event.preventDefault() ;
    }
    event.cancelBubble = true;
    event.returnValue = false ;
}

// キーコードを取得.
getKeyCode = function(e){
    e = getEvent( e ) ;
    if( $base.isNull( e ) ) {
        return -1 ;
    }
    if(document.all) {
        return (!$base.isNull( e.keyCode ))? e.keyCode: e.charCode;
    }
    else if(document.getElementById) {
        return (!$base.isNull( e.keyCode ))? e.keyCode: e.charCode;
    }
    else if(document.layers) {
        return  e.which;
    }
}

// キーイベントキャンセル.
cancellKey = function(event) {
    event = getEvent( event ) ;
    if( event.preventDefault ) {
        event.preventDefault() ;
    }
    event.cancelBubble = true;
    event.returnValue = false ;
    try {
        event.keyCode = 0 ;
    } catch( e ) {
    }
}

// 選択条件を除外.
clearSelect = function() {
    // 選択条件を解除.
    if( !$base.isNull( document.selection ) ) {
        if( document.selection.type != "none" ) {
            try {
                document.selection.empty() ;
            } catch( e ) {
            }
        }
    }
    else if( typeof( window.getSelection ) == "function" ) {
        window.getSelection().removeAllRanges() ;
    }
}

// アクティブなHTML要素を取得.
getActiveElement = function( e ) {
    e = getEvent( e ) ;
    var ret = null ;
    if( !$base.isNull( e.srcElement ) ) {
        ret = e.srcElement ;
    }
    else if( !$base.isNull( e.target ) ) {
        ret = e.target ;
    }
    return ret ;
}

// Webアプリケーション利用時のキーを無効設定.
webAppByNotKey = function() {
    var oldkeydown = window.document.onkeydown ;
    window.document.onkeydown = function( event ){
        event = getEvent( event ) ;
        if( !$base.isNull( oldkeydown ) ) {
            oldkeydown( event ) ;
        }
        (function( e ){
            var value = null ;
            switch( getKeyCode( e ) ) {
                case 8 :// backspace.
                    if( !$base.isNull( ( value = getActiveElement( e ) ) ) ) {
                        var tagName = value.tagName.toLowerCase() ;
                        var type = null ;
                        if( !$base.isNull( value.type ) ) {
                            type = value.type.toLowerCase() ;
                        }
                        if( ( tagName == "input" && ( type == "text" || type == "password" ) ) ||
                            tagName == "textarea" ) {
                            if( value.value.length > 0 ) {
                                return true ;
                            }
                            cancellKey( e ) ;
                            return false ;
                        }
                        if( ( tagName == "input" || tagName == "textarea" ) &&
                            ( type != null && !( type == "button" || type == "submit" ||
                                type == "reset" || type == "image" ) ) ) {
                            return true ;
                        }
                    }
                    cancellKey( e ) ;
                    return false ;
                case 116 :// f5.
                case 117 :// f6.
                case 118 :// f7.
                    cancellKey( e ) ;
                    return false ;
            }
            return true ;
        })( event ) ;
    }
}

// 緊急メッセージパラメータが存在する場合、出力.
emergencyMessage = function() {
    var params = getGetParams() ;
    if( $base.useString( params[ '$emergency_msg' ] ) ) {
        alert( params[ '$emergency_msg' ] ) ;
    }
}

// urlをMD5化.
convertUrlParamsByMD5 = function( url ) {
    if( $base.useString( url ) ) {
        var p = url.indexOf( "?" ) ;
        if( p != -1 ) {
            return md5( url.substring( 0,p ) ) ;
        }
        return md5( url ) ;
    }
    return "" ;
}

// installPluginチェック情報.
var isFlash = checkPlugin( "application/x-shockwave-flash","ShockwaveFlash.ShockwaveFlash" ) ;
//var isQTIME = checkPlugin( "video/quicktime","QuickTimeCheckObject.QuickTimeCheck" ) ;
//var isPDF = checkPlugin( "application/pdf",['AcroPDF.PDF.1', 'PDF.PdfCtrl.5'] ) ;
//var isSVG = checkPlugin( "image/svg+xml","Adobe.SVGCtl" ) ;
//var isRAUD = checkPlugin( "audio/x-pn-realaudio-plugin","rmocx.RealPlayer G2 Control" ) ;

// stringオブジェクト拡張用.
String.prototype.startsWith = function( s ) {
    return $base.startsWith( this,s ) ;
}
String.prototype.endsWith = function( s ) {
    return $base.endsWith( this,s ) ;
}
String.prototype.trim = function() {
    return $base.trim( this ) ;
}
String.prototype.change = function( src,dest ) {
    return $base.changeString( this,src,dest ) ;
}

///////////////////////////////////////////////////////////////////////////////
// 文字列変換処理系.
///////////////////////////////////////////////////////////////////////////////

// 文字列を置き換える.
change = function( base,src,dest ) {
    if( $base.isNull( base ) ) {
        return "" ;
    }
    if( $base.isNull( src ) || src.length <= 0 ||
        $base.isNull( dest ) ) {
        return base ;
    }
    var pnt;
    var end;
    var buf = new StrBuf() ;
    var srcLen = src.length ;
    pnt = base.indexOf(src);
    if (pnt == -1) {
        return base;
    } else if (pnt == 0) {
        buf.ad( dest ) ;
        end = srcLen;
    } else {
        buf.ad( base.substring(0, pnt) );
        buf.ad( dest );
        end = pnt + srcLen;
    }
    for (pnt += srcLen;;) {
        if ((pnt = base.indexOf(src, pnt)) == -1) {
            buf.ad( base.substring(end) );
            break;
        }
        if (pnt == end) {
            buf.ad( dest );
        } else {
            buf.ad( base.substring(end, pnt) );
            buf.ad( dest );
        }
        end = pnt + srcLen;
        pnt += srcLen;
    }
    return buf.ts() ;
} ;

// 文字列を置き換える.
// (コーテーション内を検知しない).
changeByNoCote = function( base,src,dest ) {
    if( $base.isNull( base ) ) {
        return "" ;
    }
    if( $base.isNull( src ) || src.length <= 0 ||
        $base.isNull( dest ) ) {
        return base ;
    }
    var pnt;
    var end;
    var buf = new StrBuf();
    var srcLen = src.length ;
    pnt = ParserUtil.indexOfCote( base,src,0 ) ;
    if (pnt == -1) {
        return base;
    } else if (pnt == 0) {
        buf.ad( dest ) ;
        end = srcLen;
    } else {
        buf.ad( base.substring(0, pnt) );
        buf.ad( dest );
        end = pnt + srcLen;
    }
    for (pnt += srcLen;;) {
        if ((pnt = ParserUtil.indexOfCote( base,src,pnt )) == -1) {
            buf.ad( base.substring(end) );
            break;
        }
        if (pnt == end) {
            buf.ad( dest );
        } else {
            buf.ad( base.substring(end, pnt) );
            buf.ad( dest );
        }
        end = pnt + srcLen;
        pnt += srcLen;
    }
    return buf.ts() ;
} ;

///////////////////////////////////////////////////////////////////////////////
// md5.
///////////////////////////////////////////////////////////////////////////////

$md5 = {
    TABLE : new Array(0x00000000, 0xd76aa478, 0xe8c7b756, 0x242070db,
                  0xc1bdceee, 0xf57c0faf, 0x4787c62a, 0xa8304613,
                  0xfd469501, 0x698098d8, 0x8b44f7af, 0xffff5bb1,
                  0x895cd7be, 0x6b901122, 0xfd987193, 0xa679438e,
                  0x49b40821, 0xf61e2562, 0xc040b340, 0x265e5a51,
                  0xe9b6c7aa, 0xd62f105d, 0x02441453, 0xd8a1e681,
                  0xe7d3fbc8, 0x21e1cde6, 0xc33707d6, 0xf4d50d87,
                  0x455a14ed, 0xa9e3e905, 0xfcefa3f8, 0x676f02d9,
                  0x8d2a4c8a, 0xfffa3942, 0x8771f681, 0x6d9d6122,
                  0xfde5380c, 0xa4beea44, 0x4bdecfa9, 0xf6bb4b60,
                  0xbebfbc70, 0x289b7ec6, 0xeaa127fa, 0xd4ef3085,
                  0x04881d05, 0xd9d4d039, 0xe6db99e5, 0x1fa27cf8,
                  0xc4ac5665, 0xf4292244, 0x432aff97, 0xab9423a7,
                  0xfc93a039, 0x655b59c3, 0x8f0ccc92, 0xffeff47d,
                  0x85845dd1, 0x6fa87e4f, 0xfe2ce6e0, 0xa3014314,
                  0x4e0811a1, 0xf7537e82, 0xbd3af235, 0x2ad7d2bb,
                  0xeb86d391),
    ROUND : [
        [function(x, y, z) { return (x & y) | (~x & z); },
        new Array(new Array( 0, 7, 1), new Array( 1,12, 2),
               new Array( 2,17, 3), new Array( 3,22, 4),
               new Array( 4, 7, 5), new Array( 5,12, 6),
               new Array( 6,17, 7), new Array( 7,22, 8),
               new Array( 8, 7, 9), new Array( 9,12,10),
               new Array(10,17,11), new Array(11,22,12),
               new Array(12, 7,13), new Array(13,12,14),
               new Array(14,17,15), new Array(15,22,16)) ],
        [function(x, y, z) { return (x & z) | (y & ~z); },
        new Array(new Array( 1, 5,17), new Array( 6, 9,18),
               new Array(11,14,19), new Array( 0,20,20),
               new Array( 5, 5,21), new Array(10, 9,22),
               new Array(15,14,23), new Array( 4,20,24),
               new Array( 9, 5,25), new Array(14, 9,26),
               new Array( 3,14,27), new Array( 8,20,28),
               new Array(13, 5,29), new Array( 2, 9,30),
               new Array( 7,14,31), new Array(12,20,32)) ],
        [function(x, y, z) { return x ^ y ^ z;          },
        new Array(new Array( 5, 4,33), new Array( 8,11,34),
               new Array(11,16,35), new Array(14,23,36),
               new Array( 1, 4,37), new Array( 4,11,38),
               new Array( 7,16,39), new Array(10,23,40),
               new Array(13, 4,41), new Array( 0,11,42),
               new Array( 3,16,43), new Array( 6,23,44),
               new Array( 9, 4,45), new Array(12,11,46),
               new Array(15,16,47), new Array( 2,23,48)) ],
        [function(x, y, z) { return y ^ (x | ~z);       },
        new Array(new Array( 0, 6,49), new Array( 7,10,50),
               new Array(14,15,51), new Array( 5,21,52),
               new Array(12, 6,53), new Array( 3,10,54),
               new Array(10,15,55), new Array( 1,21,56),
               new Array( 8, 6,57), new Array(15,10,58),
               new Array( 6,15,59), new Array(13,21,60),
               new Array( 4, 6,61), new Array(11,10,62),
               new Array( 2,15,63), new Array( 9,21,64)) ]],
    pack : function(ary,n32) {
      ary[ary.length] = ( n32 & 0x000000ff ) ;
      ary[ary.length] = ( (n32 >>> 8) & 0x000000ff ) ;
      ary[ary.length] = ( (n32 >>> 16) & 0x000000ff ) ;
      ary[ary.length] = ( (n32 >>> 24) & 0x000000ff ) ;
    },
    number : function(n) {
      while (n < 0)
        n += 4294967296;
      while (n > 4294967295)
        n -= 4294967296;
      return n;
    },
    apply_round : function(x, s, f, abcd, r) {
      var a, b, c, d;
      var kk, ss, ii;
      var t, u;
      a = abcd[0];
      b = abcd[1];
      c = abcd[2];
      d = abcd[3];
      kk = r[0];
      ss = r[1];
      ii = r[2];
      u = f(s[b], s[c], s[d]);
      t = s[a] + u + x[kk] + this.TABLE[ii];
      t = this.number(t);
      t = ((t<<ss) | (t>>>(32-ss)));
      t += s[b];
      s[a] = this.number(t);
    },
    hash : function(data) {
      if( valueof( data ) != "array" ) {
        var len = data.length ;
        var v = new Array( len ) ;
        for( var i = 0 ; i < len ; i ++ ) {
            v[ i ] = data.charCodeAt( i ) ;
        }
        data = v ;
      }
      var bin = new Array(data.length) ;
      $base.arraycopy( data,0,bin,0,data.length ) ;
      var abcd, x, state, s;
      var len, index, padLen, f, r;
      var i, j, k;
      var tmp;
      
      state = new Array(0x67452301, 0xefcdab89, 0x98badcfe, 0x10325476);
      len = bin.length;
      index = len & 0x3f;
      padLen = (index < 56) ? (56 - index) : (120 - index);
      if(padLen > 0) {
        bin[bin.length] = 0x80 ;
        for(i = 0; i < padLen - 1; i++)
          bin[bin.length] = 0x00 ;
      }
      this.pack(bin,len * 8);
      this.pack(bin,0);
      len  += (padLen + 8);
      abcd = new Array(0, 1, 2, 3);
      x    = new Array(16);
      s    = new Array(4);
      
      for(k = 0; k < len; k += 64) {
        for(i = 0, j = k; i < 16; i++, j += 4) {
          x[i] = (bin[j]&0x000000ff) |
            ((bin[j + 1]&0x000000ff) <<  8) |
            ((bin[j + 2]&0x000000ff) << 16) |
            ((bin[j + 3]&0x000000ff) << 24);
        }
        for(i = 0; i < 4; i++)
          s[i] = state[i];
        for(i = 0; i < 4; i++) {
          f = this.ROUND[i][0];
          r = this.ROUND[i][1];
          for(j = 0; j < 16; j++) {
            this.apply_round(x, s, f, abcd, r[j]);
            tmp = abcd[0];
            abcd[0] = abcd[3];
            abcd[3] = abcd[2];
            abcd[2] = abcd[1];
            abcd[1] = tmp;
          }
        }
        for(i = 0; i < 4; i++) {
          state[i] += s[i];
          state[i] = this.number(state[i]);
        }
      }
      var ret = [] ;
      this.pack(ret,state[0]) ;
      this.pack(ret,state[1]) ;
      this.pack(ret,state[2]) ;
      this.pack(ret,state[3]) ;
      return ret ;
    },
    hexhash : function(data) {
        var i, c;
        var bit128;
        
        bit128 = this.hash(data);
        var out = new StrBuf() ;
        for(i = 0; i < 16; i++) {
            c = bit128[i];
            out.ad( "0123456789abcdef".charAt((c>>4) & 0x0f) );
            out.ad( "0123456789abcdef".charAt(c & 0x0f) );
        }
        return out.ts();
    }
} ;

// md5変換内容を文字列で取得するメソッド.
md5 = function( data ) {
    return $md5.hexhash( data ) ;
} ;

////////////////////////////////////////////////////////////////////////////////
// base64.
////////////////////////////////////////////////////////////////////////////////

Base64 = {
    NOT_DEC : -1,
    REMAINDER_ENC : '=',
    ENC_CD : [ 'A', 'B', 'C', 'D', 'E', 'F', 'G',
        'H', 'I', 'J', 'K', 'L', 'M', 'N', 'O', 'P', 'Q', 'R', 'S', 'T',
        'U', 'V', 'W', 'X', 'Y', 'Z', 'a', 'b', 'c', 'd', 'e', 'f', 'g',
        'h', 'i', 'j', 'k', 'l', 'm', 'n', 'o', 'p', 'q', 'r', 's', 't',
        'u', 'v', 'w', 'x', 'y', 'z', '0', '1', '2', '3', '4', '5', '6',
        '7', '8', '9', '+', '/' ],
    DEC_CD : [ -1, -1, -1, -1, -1, -1, -1, -1,
        -1, -1, -1, -1, -1, -1, -1, -1,
        -1, -1, -1, -1, -1, -1, -1, -1, -1, -1,
        -1, -1, -1, -1, -1, -1,
        -1, -1, -1, -1, -1, -1, -1, -1, -1, -1,
        -1, 0x0000003e, -1, -1, -1,
        0x0000003f,
        0x00000034, 0x00000035, 0x00000036, 0x00000037, 0x00000038,
        0x00000039, 0x0000003a, 0x0000003b, 0x0000003c, 0x0000003d,
        -1, -1, -1, 0x00000040, -1,
        -1,
        -1, 0x00000000, 0x00000001, 0x00000002, 0x00000003,
        0x00000004, 0x00000005, 0x00000006, 0x00000007, 0x00000008,
        0x00000009, 0x0000000a, 0x0000000b, 0x0000000c, 0x0000000d,
        0x0000000e,
        0x0000000f, 0x00000010, 0x00000011, 0x00000012, 0x00000013,
        0x00000014, 0x00000015, 0x00000016, 0x00000017, 0x00000018,
        0x00000019, -1, -1, -1, -1,
        -1,
        -1, 0x0000001a, 0x0000001b, 0x0000001c, 0x0000001d,
        0x0000001e, 0x0000001f, 0x00000020, 0x00000021, 0x00000022,
        0x00000023, 0x00000024, 0x00000025, 0x00000026, 0x00000027,
        0x00000028,
        0x00000029, 0x0000002a, 0x0000002b, 0x0000002c, 0x0000002d,
        0x0000002e, 0x0000002f, 0x00000030, 0x00000031, 0x00000032,
        0x00000033, -1, -1, -1, -1, -1,
        -1, -1, -1, -1, -1, -1, -1, -1, -1, -1,
        -1, -1, -1, -1, -1, -1,
        -1, -1, -1, -1, -1, -1, -1, -1, -1, -1,
        -1, -1, -1, -1, -1, -1,
        -1, -1, -1, -1, -1, -1, -1, -1, -1, -1,
        -1, -1, -1, -1, -1, -1,
        -1, -1, -1, -1, -1, -1, -1, -1, -1, -1,
        -1, -1, -1, -1, -1, -1,
        -1, -1, -1, -1, -1, -1, -1, -1, -1, -1,
        -1, -1, -1, -1, -1, -1,
        -1, -1, -1, -1, -1, -1, -1, -1, -1, -1,
        -1, -1, -1, -1, -1, -1,
        -1, -1, -1, -1, -1, -1, -1, -1, -1, -1,
        -1, -1, -1, -1, -1, -1,
        -1, -1, -1, -1, -1, -1, -1, -1, -1, -1,
        -1, -1, -1, -1, -1, -1 ],
    encode : function(binary) {
        var bin ;
        if( valueof( binary ) == "array" ) {
            bin = binary ;
        }
        else {
            bin = $base.strToArray( binary ) ;
        }
        binary = null ;
        var i, j, k;
        var allLen = allLen = bin.length ;
        var etc = allLen % 3;
        var len = parseInt(allLen / 3);
        var ary = new Array(parseInt((len * 4) + ((etc != 0) ? 4 : 0)));
        for (i = 0, j = 0, k = 0; i < len; i++, j += 3, k += 4) {
            ary[k] = Base64.ENC_CD[((bin[j] & 0x000000fc) >> 2)];
            ary[k + 1] = Base64.ENC_CD[(((bin[j] & 0x00000003) << 4) | ((bin[j+1] & 0x000000f0) >> 4))];
            ary[k + 2] = Base64.ENC_CD[(((bin[j+1] & 0x0000000f) << 2) | ((bin[j+2] & 0x000000c0) >> 6))];
            ary[k + 3] = Base64.ENC_CD[(bin[j+2] & 0x0000003f)];
        }
        switch (etc) {
        case 1:
            j = len * 3;
            k = len * 4;
            ary[k] = Base64.ENC_CD[((bin[j] & 0x000000fc) >> 2)];
            ary[k + 1] = Base64.ENC_CD[((bin[j] & 0x00000003) << 4)];
            ary[k + 2] = Base64.REMAINDER_ENC;
            ary[k + 3] = Base64.REMAINDER_ENC;
            break;
        case 2:
            j = len * 3;
            k = len * 4;
            ary[k] = Base64.ENC_CD[((bin[j] & 0x000000fc) >> 2)];
            ary[k + 1] = Base64.ENC_CD[(((bin[j] & 0x00000003) << 4) | ((bin[j+1] & 0x000000f0) >> 4))];
            ary[k + 2] = Base64.ENC_CD[(((bin[j+1] & 0x0000000f) << 2))];
            ary[k + 3] = Base64.REMAINDER_ENC;
            break;
        }
        return ary.join('');
    },
    decode : function(base64) {
        return $base.aryToString( Base64.decodeArray( base64 ) ) ;
    },
    decodeArray : function(base64) {
        var i, j, k;
        var allLen = base64.length ;
        var etc = 0 ;
        for (i = allLen - 1; i >= 0; i--) {
            if (base64.charAt(i) == Base64.REMAINDER_ENC) {
                etc++;
            } else {
                break;
            }
        }
        var len = parseInt(allLen / 4);
        var ret = new Array(parseInt((len * 3)) - etc);
        len -= 1;
        for (i = 0, j = 0, k = 0; i < len; i++, j += 4, k += 3) {
            ret[k] = (((Base64.DEC_CD[base64.charCodeAt(j)] & 0x0000003f) << 2) | ((Base64.DEC_CD[base64.charCodeAt(j+1)] & 0x00000030) >> 4));
            ret[k + 1] = (((Base64.DEC_CD[base64.charCodeAt(j+1)] & 0x0000000f) << 4) | ((Base64.DEC_CD[base64.charCodeAt(j+2)] & 0x0000003c) >> 2));
            ret[k + 2] = (((Base64.DEC_CD[base64.charCodeAt(j+2)] & 0x00000003) << 6) | (Base64.DEC_CD[base64.charCodeAt(j+3)] & 0x0000003f));
        }
        switch (etc) {
        case 0:
            j = len * 4;
            k = len * 3;
            ret[k] = (((Base64.DEC_CD[base64.charCodeAt(j)] & 0x0000003f) << 2) | ((Base64.DEC_CD[base64.charCodeAt(j+1)] & 0x00000030) >> 4));
            ret[k + 1] = (((Base64.DEC_CD[base64.charCodeAt(j+1)] & 0x0000000f) << 4) | ((Base64.DEC_CD[base64.charCodeAt(j+2)] & 0x0000003c) >> 2));
            ret[k + 2] = (((Base64.DEC_CD[base64.charCodeAt(j+2)] & 0x00000003) << 6) | (Base64.DEC_CD[base64.charCodeAt(j+3)] & 0x0000003f));
            break;
        case 1:
            j = len * 4;
            k = len * 3;
            ret[k] = (((Base64.DEC_CD[base64.charCodeAt(j)] & 0x0000003f) << 2) | ((Base64.DEC_CD[base64.charCodeAt(j+1)] & 0x00000030) >> 4));
            ret[k + 1] = (((Base64.DEC_CD[base64.charCodeAt(j+1)] & 0x0000000f) << 4) | ((Base64.DEC_CD[base64.charCodeAt(j+2)] & 0x0000003c) >> 2));
            break;
        case 2:
            j = len * 4;
            k = len * 3;
            ret[k] = (((Base64.DEC_CD[base64.charCodeAt(j)] & 0x0000003f) << 2) | ((Base64.DEC_CD[base64.charCodeAt(j+1)] & 0x00000030) >> 4));
            break;
        }
        return ret;
    }
}

///////////////////////////////////////////////////////////////////////////////
// stack.
///////////////////////////////////////////////////////////////////////////////
StackInfo = function() {}
StackInfo.prototype = {
    cell : null,
    count : 0,
    clear : function() {
        this.cell = null ;
    },
    push : function(object) {
        var nw = new Array( 2 ) ;
        nw[ 0 ] = object;
        nw[ 1 ] = this.cell;
        this.cell = nw;
        this.count ++ ;
    },
    pop : function() {
        if( this.cell == null ) {
            return null ;
        }
        var ret = this.cell[ 0 ] ;
        this.cell = this.cell[ 1 ] ;
        this.count -- ;
        return ret ;
    },
    peek : function() {
        if( this.cell == null ) {
            return null ;
        }
        return this.cell[ 0 ] ;
    },
    size : function() {
        return this.count ;
    }
}

///////////////////////////////////////////////////////////////////////////////
// Xor128ランダム発生オブジェクト.
///////////////////////////////////////////////////////////////////////////////

Xor128 = function( time ) {
    this.setSeet( time ) ;
}
Xor128.prototype = {
    a : 123456789,
    b : 362436069,
    c : 521288629,
    d : 88675123,
    // シートセット.
    setSeet : function( time ) {
        if( time == undefined  || time == null ) {
            time = new Date().getTime() ;
        }
        else {
            try {
                time = parseInt( time ) ;
            } catch( e ) {
                time = new Date().getTime() ;
            }
        }
        
        this.d = ( this.d * time ) & 0x00000000ffffffff ;
        this.next() ;
    },
    // 乱数取得.
    next : function() {
        var t=this.a;
        var r=t;
        t = ( t << 11 ) & 0x00000000ffffffff ;
        t = ( t ^ r ) & 0x00000000ffffffff ;
        r=t;
        r = ( r >> 8 ) & 0x00000000ffffffff ;
        t = ( t ^ r ) & 0x00000000ffffffff ;
        r=this.b;
        this.a=r;
        r=this.c;
        this.b=r;
        r=this.d;
        this.c=r;
        t = ( t ^ r ) & 0x00000000ffffffff ;
        r = ( r >> 19 ) & 0x00000000ffffffff ;
        r = ( r ^ t ) & 0x00000000ffffffff ;
        this.d=r;
        return r;
    }
} ;

var baseXor128 = new Xor128() ;
// ランダムIDを生成.
randomId = function( len ) {
    var ret = new StrBuf() ;
    var map = "0123456789ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz+-" ;
    for( var i = 0 ; i < len ; i ++ ) {
        ret.ad( map[(baseXor128.next()&0x0000003f)] ) ;
    }
    return ret.ts() ;
}

// パスワード用ランダムIDを生成.
passwdRandom = function( len ) {
    var ret = new StrBuf() ;
    var map = "0123456789ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz!?" ;
    for( var i = 0 ; i < len ; i ++ ) {
        ret.ad( map[(baseXor128.next()&0x0000003f)] ) ;
    }
    return ret.ts() ;
}

///////////////////////////////////////////////////////////////////////////////
// Ajaxアクセス処理.
///////////////////////////////////////////////////////////////////////////////

// scriptタグ内容と、表示タグ内容を分離して取得.
// HTMLパーサを使わないで処理するように変更.
convertResultByScript2View = function( s ) {
    var out = [] ;
    // Javascriptソースを取得.
    out[ 0 ] = "" ;
    s = cutTagByGetTargetTagInner( out,"SCRIPT",s ) ;
    var scriptSrc = out[ 0 ] ;
    if( $base.isNull( scriptSrc ) || ( scriptSrc = $base.trim( scriptSrc )).length <= 0 ) {
        scriptSrc = "" ;
    }
    // スタイルシートソースを取得.
    out[ 0 ] = "" ;
    s = cutTagByGetTargetTagInner( out,"STYLE",s ) ;
    var cssSrc = out[ 0 ] ;
    if( ( cssSrc = $base.trim( cssSrc )).length <= 0 ) {
        cssSrc = "" ;
    }
    return [s,scriptSrc,cssSrc] ;
}


// 指定タグ条件をテキストデータから抜粋し、タグ内容を保存.
cutTagByGetTargetTagInner = function( out,tagName,string ) {
    var pos = readSearchTagToPos( tagName,string ) ;
    var len = pos.length ;
    // ４の倍数で無ければ処理しない.
    if( len % 4 != 0 ) {
        return string ;
    }
    // ターゲット情報を結合.
    var s ;
    var buf = new StrBuf() ;
    for( var i = 0 ; i < len ; i += 4 ) {
        s = string.substring( pos[ i+1 ],pos[ i+2 ] ) ;
        s = ParserUtil.trim( s ) ;
        if( $base.startsWith( s,"<!--" ) && $base.endsWith( s,"-->" ) ) {
            s = ParserUtil.trim( s.substring( 4,s.length-3 ) ) ;
        }
        buf.ad( s ).ad( "\n" ) ;
    }
    out[ 0 ] = buf.ts() ;
    buf = null ;
    s = null ;
    // 対象文字列から、今回の範囲を除外.
    for( var i = len-1 ; i >= 0 ; i -= 4 ) {
        string = string.substring( 0,pos[ i-3 ] ) +
            string.substring( pos[ i ] ) ;
    }
    return string ;
}

// 指定条件のタグ範囲の位置情報を取得.
readSearchTagToPos = function( tagName,string ) {
    var pos = [] ;
    var tmp = [-1,-1] ;
    var st,ed ;
    var next ;
    var tg ;
    var endTag = false ;
    var len = string.length ;
    next = 0 ;
    while( true ) {
        st = ParserUtil.indexOfCote( string,"<",next ) ;
        if( st == -1 ) {
            break ;
        }
        ed = ParserUtil.indexParCote( string,"<",">",st ) ;
        if( ed == -1 ) {
            next = st+1 ;
            continue ;
        }
        ed ++ ;
        // HTMLコメント情報を検出.
        if( st+3 < len && string[ st+1 ] == "!" && string[ st+2 ] == "-" && string[ st+3 ] == "-" ) {
            while( true ) {
                if( string[ ed-2 ] == "-" && string[ ed-1 ] == "-" ) {
                    next = ed+1 ;
                    break ;
                }
                ed = ParserUtil.indexOfCote( string,"-->",ed+1 ) ;
                if( ed == -1 ) {
                    break ;
                }
                ed ++ ;
            }
            if( ed == -1 ) {
                break ;
            }
            continue ;
        }
        // ターゲットタグ名を取得.
        tg = ParserUtil.toIndexFirstString( string,endTag,st,-1 ) ;
        if( tg != null && tg.toUpperCase() == tagName ) {
            if( !endTag ) {
                tmp[ 0 ] = st ;
                tmp[ 1 ] = ed ;
                endTag = true ;
            }
            else {
                if( tmp[ 0 ] != -1 ) {
                    pos[pos.length] = tmp[0] ;
                    pos[pos.length] = tmp[1] ;
                    pos[pos.length] = st ;
                    pos[pos.length] = ed ;
                }
                tmp[ 0 ] = -1 ;
                tmp[ 1 ] = -1 ;
                endTag = false ;
            }
            next = ed+1 ;
        }
        else {
            next = st+1 ;
        }
    }
    return pos ;
}

// Ajax取得内容に対して、scriptタグが存在する場合は、実行させる.
resultAjaxScript = function( id,s,scriptId,inner ) {
    var vs = convertResultByScript2View( s ) ;
    if( $base.useString( id ) && $base.useString( vs[0] ) ) {
        fastInnerHTML( id,vs[ 0 ] ) ;
    }
    // javascript実行.
    if( $base.useString( vs[1] ) ) {
        if( !$base.useString( scriptId ) ) {
            eval( vs[1] ) ;
        }
        else {
            innerJS( "_js" + scriptId + "_$",vs[ 1 ],inner ) ;
        }
    }
    // スタイルシート実行.
    if( $base.useString( vs[2] ) ) {
        if( $base.useString( scriptId ) ) {
            innerCSS( "_css" + scriptId + "_$",vs[ 2 ],inner ) ;
        }
    }
    return vs[0] ;
} ;

// seabassで利用するAjax処理.
SeabassAjax = {
    ajaxObj : null,
    // accessAjaxでオープン中のAjaxをクローズ.
    close : function() {
        var xmlhttp = SeabassAjax.ajaxObj ;
        SeabassAjax.ajaxObj = null ;
        if( !$base.isNull( xmlhttp )  ) {
            try {
                xmlhttp.abort() ;
            } catch( e ) {
            }
        }
    },
    // Ajax処理.
    connection : function( url,sendParams,callFunc,sessionId ) {
//var time = new Date().getTime() ;
        // Ajaxオブジェクトを生成.
        SeabassAjax.close() ;
        var xmlhttp = null ;
        if( typeof( XMLHttpRequest ) == "function" ) {
            xmlhttp = new XMLHttpRequest();
        }
        else if(window.ActiveXObject) {
            try {
                xmlhttp = new ActiveXObject("Msxml2.XMLHTTP");
            } catch (e) {
                xmlhttp = null ;
            }
            if( $base.isNull( xmlhttp ) ) {
                try {
                    xmlhttp = new ActiveXObject("Microsoft.XMLHTTP");
                } catch (e) {
                    xmlhttp = null;
                }
            }
        }
        // オープン中のAjaxをajaxObjに登録.
        SeabassAjax.ajaxObj = xmlhttp ;
        var sync = ( !$base.isNull( callFunc ) ) ? true : false ;
        
        // パラメータがMap形式の場合.
        if( valueof( sendParams ) == "map" ) {
            sendParams = convertParams( sendParams,false ) ;
        }
        // クッキ非対応の場合.
        if( sessionId != false ) {
            sendParams = $base.addNoCookieBySession( sendParams ) ;
        }
        // パラメータが存在する場合.
        if( $base.useString( sendParams ) ) {
            sendParams += "&t=" + (new Date().getTime()) ;
            // コネクションオープン.
            xmlhttp.open("POST",url,sync);
            // POST用ContentTypeをセット.
            try {
                if( typeof( xmlhttp.setRequestHeader ) != 'undefined' ) {
                    xmlhttp.setRequestHeader( "Content-Type",
                        //"application/x-www-form-urlencoded; charset=UTF-8" ) ;
                        "application/x-www-form-urlencoded" ) ;
                }
            } catch( e ) {
                return "" ;
            }
        }
        else {
            url += "?t=" + (new Date().getTime()) ;
            xmlhttp.open("GET",url,sync);
        }
        
        // 非同期処理の場合.
        if( sync ) {
            // IEの場合は、onreadystatechangeを利用する.
            if( isMSIE ) {
                xmlhttp.onreadystatechange = function() {
                    if( xmlhttp.readyState == 4 ) {
                        try {
                            // エラー.
                            if( xmlhttp.status >= 400 ) {
                                callFunc( {result:"error",state:xmlhttp.status,value:xmlhttp.responseText} ) ;
                            }
                            // 正常処理.
                            else if( xmlhttp.status == 200 ) {
                                var result = xmlhttp.responseText ;
                                if( !$base.isNull( callFunc ) ) {
                                    callFunc( result ) ;
                                }
                            }
                            // その他.
                            else {
                                if( !$base.isNull( callFunc ) ) {
                                    callFunc( "" ) ;
                                }
                            }
                        } catch( e ) {
                            // エラー処理.
                            if( !$base.isNull( callFunc ) ) {
                                callFunc( {result:"error",state:500,value:e.toString()} ) ;
                            }
                        } finally {
                            // 接続処理終了.
                            SeabassAjax.close() ;
                            xmlhttp = null ;
                        }
                    }
                }
            }
            // IE以外の場合は、onloadを利用する.
            else {
                xmlhttp.onload = function() {
                    try {
                        // エラー.
                        if( xmlhttp.status >= 400 ) {
                            callFunc( {result:"error",state:xmlhttp.status,value:xmlhttp.responseText} ) ;
                        }
                        // 正常処理.
                        else if( xmlhttp.status == 200 ) {
                            var result = xmlhttp.responseText ;
                            if( !$base.isNull( callFunc ) ) {
                                callFunc( result ) ;
                            }
                        }
                        // その他ステータスの場合.
                        else {
                            if( !$base.isNull( callFunc ) ) {
                                callFunc( "" ) ;
                            }
                        }
                    } catch( e ) {
                        // エラー処理.
                        if( !$base.isNull( callFunc ) ) {
                            var s = e.toString() ;
                            callFunc( {result:"error",state:500,value:s} ) ;
                        }
                    } finally {
                        // 接続処理終了.
                        SeabassAjax.close() ;
                        xmlhttp = null ;
                    }
                }
            }
        }
        // 送信処理.
        try {
            if( !$base.useString( sendParams ) ) {
                xmlhttp.send( null ) ;
            }
            else {
                xmlhttp.send(sendParams) ;
            }
        } catch( e ) {
            var s = e.toString() ;
            SeabassAjax.close() ;
            xmlhttp = null ;
            return {result:"error",state:500,value:s} ;
        }
        
        // 同期処理の場合.
        if( !sync ) {
            var state = xmlhttp.status ;
            var result = xmlhttp.responseText ;
            // 接続処理終了.
            SeabassAjax.close() ;
            xmlhttp = null ;
            // 正常終了.
            if( state == "200" ) {
                return result ;
            }
            // エラーの場合.
            else {
                return {result:"error",state:state,value:result} ;
            }
        }
        return "" ;
    }
}

// Ajax実行処理.
accessAjax = function( url,sendParams,callFunc,sessionId ) {
    return SeabassAjax.connection( url,sendParams,callFunc,sessionId ) ;
}

// scriptタグが含まれている場合にJavascript実行するAjax.
accessAjaxToJsExecution = function( id,url,sendParams,scriptId,innerId,func ) {
    var s = accessAjax( url,sendParams ) ;
    if( !$base.useString( scriptId ) ) {
        scriptId = "_autoId_" + convertUrlParamsByMD5( url ) ;
    }
    var res = resultAjaxScript( id,s,scriptId,innerId ) ;
    if( typeof( func ) == "function" ) {
        func( res ) ;
        return null ;
    }
    return res ;
} ;

// Ajax戻りチェック処理.
resultAjax = function( res,viewMessageFunc ) {
    if( typeof( viewMessageFunc ) != "function" ) {
        viewMessageFunc = alert ;
    }
    if( typeof( res ) != "string" ) {
        // 楽観的ロック状態が発生した場合.
        if( valueof( res ) == "map" && res.result == "error" && res.state == 409 ) {
            viewMessageFunc( "他のユーザが既に更新しています.\n" +
                "恐れ入りますが、もう一度始めから作業を行ってください." ) ;
            return false ;
        }
        viewMessageFunc( "エラーが発生しました。管理者にお問い合わせください" ) ;
        return false ;
    }
    if( $base.startsWith( res,"@error," ) ) {
        viewMessageFunc( res.substring( "@error,".length ) ) ;
        return false ;
    }
    return true ;
}

// JSファイルをAjaxで読み込んで実行するAjax.
jsAjax = function( file,sendParams ) {
    var s = accessAjax( file,sendParams ) ;
    if( $base.useString( s ) ) {
        eval( s ) ;
    }
} ;

// Javascriptを動的に読み込む.
includeJS =  function(file,params,name,id) {
    // パラメータがMap形式の場合.
    if( !$base.isNull( params ) ) {
        var t = valueof( params ) ;
        if( t == "map" ) {
            params = convertParams( params ) ;
        }
        else if( t != "string" ) {
            params = null ;
        }
        if( !$base.isNull( params ) ) {
            if( file.indexOf( "?" ) != -1 ) {
                file += "&" + params ;
            }
            else {
                file += "?" + params ;
            }
        }
    }
    var script = document.createElement("script");
    includeAttribute(script, "charset", "utf-8");
    includeAttribute(script, "type", "text/javascript");
    includeAttribute(script, "src", file);
    includeAttribute(script, "language", "javascript");
    if( $base.useString( name ) ) {
        includeAttribute(script, "name", name );
    }
    if( $base.useString( id ) ) {
        var di = document.getElementById( id ) ;
        if( $base.isNull( di ) ) {
            return ;
        }
        if( di.innerHTML.length > 0 ) {
            di.removeChild(script) ;
            di.appendChild(script);
        }
        else {
            di.appendChild(script);
        }
    }
    else {
        var heads = document.getElementsByTagName("head");
        if( !$base.isNull( heads ) && heads.length > 0 ) {
            var befScriptEm = null ;
            var befScriptEms = document.getElementsByTagName("script");
            if( !$base.isNull( befScriptEms ) && befScriptEms.length > 0 ) {
                var urlName = $base.getURL()+file ;
                for( var i = 0 ; i < befScriptEms.length ; i ++ ) {
                    if( befScriptEms[i].src == urlName ) {
                        befScriptEm = befScriptEms[i] ;
                        break ;
                    }
                }
            }
            if( $base.isNull( befScriptEm ) ) {
                heads[0].appendChild(script);
            }
            else {
                var pa = befScriptEm.parentNode ;
                if( $base.isNull( pa ) ) {
                    heads[0].appendChild(script);
                }
                else {
                    pa.removeChild( befScriptEm ) ;
                    pa.appendChild(script);
                }
            }
        }
    }
} ;

// スタイルシートを動的に読み込む.
includeCSS = function(path,params) {
    // パラメータがMap形式の場合.
    if( !$base.isNull( params ) ) {
        var t = valueof( params ) ;
        if( t == "map" ) {
            params = convertParams( params ) ;
        }
        else if( t != "string" ) {
            params = null ;
        }
        if( !$base.isNull( params ) ) {
            if( path.indexOf( "?" ) != -1 ) {
                path += "&" + params ;
            }
            else {
                path += "?" + params ;
            }
        }
    }
    var link = document.createElement("link");
    includeAttribute(link, "charset", "utf-8");
    includeAttribute(link, "rel", "stylesheet");
    includeAttribute(link, "type", "text/css");
    includeAttribute(link, "href", path);
    var heads = document.getElementsByTagName("head");
    if( !$base.isNull( heads ) && heads.length > 0 ) {
        var befLinkEm = null ;
        var befLinkEms = document.getElementsByTagName("link");
        if( !$base.isNull( befLinkEms ) && befLinkEms.length > 0 ) {
            var urlName = $base.getURL()+path ;
            for( var i = 0 ; i < befLinkEms.length ; i ++ ) {
                if( befLinkEms[i].href == urlName ) {
                    befLinkEm = befLinkEms[i] ;
                    break ;
                }
            }
        }
        if( $base.isNull( befLinkEm ) ) {
            heads[0].appendChild(link);
        }
        else {
            var pa = befLinkEm.parentNode ;
            if( $base.isNull( pa ) ) {
                heads[0].appendChild(link);
            }
            else {
                pa.removeChild( befLinkEm ) ;
                pa.appendChild(link);
            }
        }
    }
}

// Javascriptを直接挿入.
var _innerJSCnd = 0 ;
innerJS = function( name,value,inner ) {
    if( !$base.useString( name ) ) {
        name = "js_" + _innerJSCnd ;
        _innerJSCnd ++ ;
    }
    name = $base.trim( name ) ;
    var scriptId = null ;
    if( !$base.endsWith( name,"Id" ) ) {
        scriptId = name + "Id" ;
    }
    else {
        scriptId = name ;
    }
    var script = document.createElement("script");
    includeAttribute(script, "type", "text/javascript");
    includeAttribute(script, "id", scriptId );
    if( isMSIE ) {
        script.text = value ;
    }
    else {
        script.appendChild(document.createTextNode(value)) ;
    }
    if( !$base.useString( inner ) ) {
        var heads = document.getElementsByTagName("head");
        if( !$base.isNull( heads ) && heads.length > 0 ) {
            var befScriptEm = document.getElementById( scriptId ) ;
            if( $base.isNull( befScriptEm ) ) {
                heads[0].appendChild(script);
            }
            else {
                var pa = befScriptEm.parentNode ;
                if( $base.isNull( pa ) ) {
                    heads[0].appendChild(script);
                }
                else {
                    pa.removeChild( befScriptEm ) ;
                    pa.appendChild(script);
                }
            }
        }
    }
    else {
        var di = document.getElementById( inner ) ;
        if( $base.isNull( di ) ) {
            return ;
        }
        if( $base.isNull( document.getElementById( scriptId ) ) ) {
            di.appendChild(script);
        }
        else {
            try {
                di.removeChild(script) ;
            } catch( e ) {
                try {
                    fastInnerHTML( di,"" ) ;
                } catch( ee ) {
                }
            }
            di.appendChild(script);
        }
    }
}

// スタイルシートを直接挿入.
var _innerCSSCnd = 0 ;
innerCSS = function( name,value,inner ) {
    if( !$base.useString( name ) ) {
        name = "css_" + _innerCSSCnd ;
        _innerCSSCnd ++ ;
    }
    name = $base.trim( name ) ;
    var cssId = null ;
    if( !$base.endsWith( name,"Id" ) ) {
        cssId = name + "Id" ;
    }
    else {
        cssId = name ;
    }
    var css = document.createElement("style");
    includeAttribute(css, "id",cssId );
    includeAttribute(css, "type","text/css" );
    if( css.styleSheet ) {
        // IEでのStyleSeet追加処理.
        css.styleSheet.cssText  = value ;
    }
    else {
        // IE以外のStyleSeet追加処理.
        css.appendChild(document.createTextNode(value)) ;
    }
    if( !$base.useString( inner ) ) {
        var heads = document.getElementsByTagName("head");
        if( !$base.isNull( heads ) && heads.length > 0 ) {
            var befLinkEm = document.getElementById( cssId ) ;
            if( $base.isNull( befLinkEm ) ) {
                heads[0].appendChild(css);
            }
            else {
                var pa = befLinkEm.parentNode ;
                if( $base.isNull( pa ) ) {
                    heads[0].appendChild(css);
                }
                else {
                    pa.removeChild( befLinkEm ) ;
                    pa.appendChild(css);
                }
            }
        }
    }
    else {
        var di = document.getElementById( inner ) ;
        if( $base.isNull( di ) ) {
            return ;
        }
        if( $base.isNull( document.getElementById( cssId ) ) ) {
            di.appendChild(css);
        }
        else {
            di.removeChild(css) ;
            di.appendChild(css);
        }
    }
}

// 指定IDの要素を削除.
removeElement = function( id ) {
    var em = document.getElementById( id ) ;
    if( !$base.isNull( em ) ) {
        var pa = em.parentNode ;
        if( !$base.isNull( pa ) ) {
            pa.removeChild( em ) ;
        }
    }
}

// ダミーIFrameを追加.
dummyFrame = function( name,inner ) {
    if( !$base.useString( name ) ) {
        return ;
    }
    name = $base.trim( name ) ;
    var fmId = null ;
    if( !$base.endsWith( name,"Id" ) ) {
        fmId = name + "Id" ;
    }
    else {
        fmId = name ;
    }
    
    var fm = document.createElement("iframe");
    includeAttribute(fm, "id",fmId );
    if( isMSIE && $base.isSSL() ) {
        // IE系で、SSLの場合は、src要素が必須.
        includeAttribute(fm, "src","/@js/ref?ref=&mime=text/html" );
    }
    includeAttribute(fm, "name", name);
    
    /*
    includeAttribute(fm, "width", "0");
    includeAttribute(fm, "height", "0");
    includeAttribute(fm, "border", "0");
    includeAttribute(fm, "marginheight", "0");
    includeAttribute(fm, "marginwidth", "0");
    includeAttribute(fm, "frameborder", "0");
    includeAttribute(fm, "hspace", "0");
    */
    
    includeAttribute(fm, "style","width:0px; height:0px; border: 0px;");
    if( !$base.useString( inner ) ) {
        var befFrameEm = document.getElementById( fmId ) ;
        if( $base.isNull( befFrameEm ) ) {
            $base.getBody().appendChild(fm);
            fm.contentWindow.name = fm.name;
        }
        else {
            var pa = befFrameEm.parentNode ;
            if( $base.isNull( pa ) ) {
                $base.getBody().appendChild(fm);
                fm.contentWindow.name = fm.name;
            }
            else {
                pa.removeChild( befFrameEm ) ;
                pa.appendChild(fm);
                fm.contentWindow.name = fm.name;
            }
        }
    }
    else {
        var di = document.getElementById( inner ) ;
        if( $base.isNull( di ) ) {
            return ;
        }
        if( $base.isNull( document.getElementById( fmId ) ) ) {
            di.appendChild(fm);
            fm.contentWindow.name = fm.name;
        }
        else {
            di.removeChild(fm) ;
            di.appendChild(fm);
            fm.contentWindow.name = fm.name;
        }
    }
}

// (Include系)attribute追加.
includeAttribute = function(node, attr, value) {
    if(value == null || node == null || attr == null) return;
    if(attr.toLowerCase() == "style") {
        if(value == null) {
            return;
        }
        var styles = value.split(";");
        var pos;
        for(var i=0;i<styles.length;i++) {
            var attributes = styles[i].split(":");
            if(attributes.length == 2) {
                var attr = $base.trim(attributes[0]);
                try {
                    while((pos = attr.search(/-/)) != -1) {
                        var strBefore = attr.substring(0, pos);
                        var strToUpperCase = attr.substring(pos + 1, pos + 2);
                        var strAfter = attr.substring(pos + 2, attr.length);
                        attr = strBefore + strToUpperCase.toUpperCase() + strAfter;
                    }
                    var value = $base.trim(attributes[1]).toLowerCase();
                    if( attributes[0].toLowerCase() == "float" ) {
                        if( !$base.isNull( node.style.styleFloat ) ) {
                            node.style.styleFloat = value ;
                        }
                        else if( !$base.isNull( node.style.cssFloat ) ) {
                             node.style.cssFloat = value ;
                        }
                        else {
                            node.style[attr] = value;
                        }
                    }
                    else {
                        node.style[attr] = value;
                    }
                }
                catch (e) {
                    dbg( e ) ;
                }
            }
        }
    }
    else {
        node.setAttribute(attr, value);
    }
}

///////////////////////////////////////////////////////////////////////////////
// json変換.
///////////////////////////////////////////////////////////////////////////////
$json = {
    // json形式に変換.
    encode : function( value ) {
        if( $base.isNull( value ) ) {
            return "\"\"" ;
        }
        var t = $json.valueof( value ) ;
        if( t == "array" ) {
            return $json.evalByArrayString( "",value ) ;
        }
        else if( t == "map" ) {
            t = null ;
            return $json.evalByMapString( "",value ) ;
        }
        return $json.evalByString( t,value ) ;
    },
    // json形式の文字列を変換.
    decode : function( value ) {
        if( $base.isNull( value ) || typeof( value ) != "string" ) {
            return null ;
        }
        var ret = eval( value ) ;
        return ret ;
    },
    // サーバ向けエンコード.
    encodeServer : function( value ) {
        return $json.encode( value ) ;
    },
    // Arrayタイプから、eval実行可能内容を生成.
    evalByArrayString : function( o,v ) {
        o += "[" ;
        var len = v.length ;
        for( var i = 0 ; i < len ; i ++ ) {
            if( i != 0 ) {
                o += "," ;
            }
            var t = $json.valueof( v[i] ) ;
            if( t == "element" ) {
                continue ; // elementオブジェクトの内容は無視する.
            }
            else if( t == "array" ) {
                o = $json.evalByArrayString( o,v[i] ) ;
            }
            else if( t == "map" ) {
                o = $json.evalByMapString( o,v[i] ) ;
            }
            else {
                o += $json.evalByString( t,v[i] ) ;
            }
        }
        return o + "]" ;
    },
    // Mapタイプから、eval実行可能内容を生成.
    evalByMapString : function( o,v ) {
        o += "{" ;
        var cnt = 0 ;
        for( var k in v ) {
            if( cnt != 0 ) {
                o += "," ;
            }
            o += "\"" + k + "\":" ;
            var t = $json.valueof( v[k] ) ;
            if( t == "element" ) {
                continue ; // elementオブジェクトの内容は無視する.
            }
            else if( t == "array" ) {
                o = $json.evalByArrayString( o,v[k] ) ;
            }
            else if( t == "map" ) {
                o = $json.evalByMapString( o,v[k] ) ;
            }
            else {
                o += $json.evalByString( t,v[k] ) ;
            }
            cnt ++ ;
        }
        return o + "}" ;
    },
    // 指定タイプから、eval実行可能内容を生成.
    evalByString : function( t,v ) {
        if( t == "string" ) {
            return "\""+$json.stringByCote( v )+"\"" ;
        }
        else if( t == "boolean" ) {
            return ""+v ;
        }
        else if( t == "number" ) {
            return ""+v ;
        }
        else if( t == "date" ) {
            return "new Date(" + v.getTime() + ")" ;
        }
        return "\"\"" ;
    },
    // 指定内容タイプを取得.
    valueof : function( val ) {
        if( $base.isNull( val ) ) {
            return "null" ;
        }
        var t = typeof( val ) ;
        if( t == "string" ) {
            return "string" ;
        }
        if( t == "boolean" ) {
            return "boolean" ;
        }
        else if( t == "number" ) {
            return "number" ;
        }
        else if( t == "function" ) {
            return "function" ;
        }
        else if( t == "date" ) {
            return "date" ;
        }
        else if( t == "object" ) {
            if( val instanceof Element ) {
                return "element" ;
            }
            if( val instanceof Date ) {
                return "date" ;
            }
            else if( val instanceof Array ) {
                if( val.length == 0 ) {
                    return "array" ;
                }
                return $json.arrayOrMapValueTo( val ) ;
            }
        }
        return $json.arrayOrMapValueTo( val ) ;
    },
    // 指定内容タイプがArrayかMapか取得.
    arrayOrMapValueTo : function( val ) {
        if( val instanceof Element ) {
            return "element" ;
        }
        if( typeof( val.length ) == "number" ) {
            return "array" ;
        }
        for( var k in val ) {
            return "map" ;
        }
        return "object" ;
    },
    // 文字列内のコーテーション対応.
    stringByCote : function( val ) {
        var len = val.length ;
        var yen = 0 ;
        var ret = new StrBuf() ;
        for( var i = 0 ; i < len ; i ++ ) {
            var c = val.charAt( i ) ;
            if( c == '\\' ) {
                yen ++ ;
                ret.ad( c ) ;
            }
            else if( c == '\"' ) {
                if( yen > 0 ) {
                    ret.ad( "\\\\" ) ;
                }
                else {
                    ret.ad( "\\" ) ;
                }
                yen = 0 ;
                ret.ad( c ) ;
            }
            else {
                yen = 0 ;
                ret.ad( c ) ;
            }
        }
        return ret.ts() ;
    }
} ;

// typeof拡張.
valueof = function(value) {
    return $json.valueof(value) ;
} ;

///////////////////////////////////////////////////////////////////////////////
// seabass HTML系の処理メソッド.
// Copyright (c) 2009 masahito suzuki, Inc. All Rights Reserved.
///////////////////////////////////////////////////////////////////////////////

////////////////////////////////////////////////////////////////////////////////
// ブラウザ系.
////////////////////////////////////////////////////////////////////////////////

// 最大化状態の新しいWindowを生成.
createMaxWindow = function( url,title,params ) {
    if( $base.useString( url ) ) {
        if( !$base.isNull( params ) ) {
            var t = valueof( params ) ;
            if( t == "map" ) {
                params = convertParams( params ) ;
            }
            else if( t != "string" ) {
                params = null ;
            }
            if( !$base.isNull( params ) ) {
                if( url.indexOf( "?" ) != -1 ) {
                    url += "&" + params ;
                }
                else {
                    url += "?" + params ;
                }
            }
        }
        if( !$base.useString( title ) ) {
            title = "" ;
        }
        var x = screen.availWidth ;
        var y = screen.availHeight ;
        if( isMSIE ) {
            x -= 7 ;
        }
        w =window.open(
            url, title ,
            "WIDTH="+x+",HEIGHT="+y+
            //",SCROLLBARS=yes,RESIZABLE=yes,TOOLBAR=no,MENUBAR=no,LOCATION=no,STATUS=no,FULLSCREEN=yes") ;
            ",SCROLLBARS=yes,RESIZABLE=yes,TOOLBAR=no,MENUBAR=no,LOCATION=no,STATUS=no,DIRECTORIES=no") ;
        w.moveTo(0,0) ;
        w.focus();
    }
}

// URL遷移.
forwardURL = function( url,params,newWindow,oneMode ) {
    if( $base.useString( url ) == true ) {
        if( !$base.isNull( params ) ) {
            var t = valueof( params ) ;
            if( t == "map" ) {
                params = convertParams( params ) ;
            }
            else if( t != "string" ) {
                params = null ;
            }
            if( !$base.isNull( params ) ) {
                if( url.indexOf( "?" ) != -1 ) {
                    url += "&" + params ;
                }
                else {
                    url += "?" + params ;
                }
            }
        }
        if( newWindow == true ) {
            var wname = "" ;
            if( oneMode ) {
                var p = url.indexOf( "?" ) ;
                if( p == -1 ) {
                    wname = url ;
                }
                else {
                    wname = url.substring( 0,p ) ;
                }
                wname = md5( wname ) ;
            }
            window.open( url,wname ) ;
        }
        else {
            window.location = url ;
        }
    }
} ;

// サブミット.
submitTo = function( formName ) {
    if( typeof( document[formName] ) != "undefined" ) {
        document[formName].submit() ;
        return true ;
    }
}

// GETパラメータを取得.
getGetParams = function( s ) {
    var ret = {} ;
    if( !$base.useString( s ) ) {
        s = window.location.search ;
    }
    if( s.length > 0 ) {
        if( $base.startsWith( s,"?" ) ) {
            s = s.substring( 1 ) ;
        }
        var vals = s.substring(0, s.length).split('&') ;
        var len = vals.length ;
        for( var i = 0 ; i < len ; i ++ ) {
            if( vals[i].indexOf( "=" ) >= 0 ) {
                var kv = vals[i].split('=') ;
                kv[1] = decodeURIComponent( kv[1] ) ;
                if( kv[1] == "true" ) {
                    ret[kv[0]] = true ;
                }
                else if( kv[1] == "false" ) {
                    ret[kv[0]] = false ;
                }
                else if( $base.isNumeric( kv[1] ) ) {
                    ret[kv[0]] = parseInt( kv[1] ) ;
                }
                else {
                    ret[kv[0]] = kv[1] ;
                }
            }
        }
    }
    return ret ;
} ;

// 指定IDにBase64形式の画像を表示.
viewImageByBase64 = function( id,mimeType,data ) {
    if( $base.isNull( id ) || $base.useString( mimeType ) == false || $base.isNull( data ) ) {
        return ;
    }
    $(id).src = "data:"+mimeType+";base64,"+data ;
} ;

// 指定イメージの内容を置き換える.
changeImage = function( id,url,backWindow ) {
    if( $base.isNull( id ) || $base.useString( url ) == false ) {
        return ;
    }
    if( !$base.startsWith( id,"_img_" ) ) {
        id = "_img_" + id ;
    }
    if( !$base.endsWith( id,"Id" ) ) {
        id = id + "Id" ;
    }
    var params = "t="+new Date().getTime() ;
    var p = url.indexOf( "?" ) ;
    if( p <= -1 ) {
        params = "t="+new Date().getTime() ;
        params = $base.addNoCookieBySession( params ) ;
    }
    else {
        params = url.substring( p+1 ) ;
        url = url.substring( 0,p ) ;
        params += "&t="+new Date().getTime() ;
        params = $base.addNoCookieBySession( params ) ;
    }
    url = url + "?" + params ;
    if( $base.isNull( backWindow ) == false && ( backWindow == true || backWindow == "true" ) ) {
        if( $base.isNull( window.opener ) == false && $base.isNull( window.opener.document ) == false &&
            $base.isNull( window.opener.document.getElementById(id) ) == false ) {
            window.opener.document.getElementById(id).src=url ;
        }
    }
    else {
        $(id).src=url ;
    }
}

var _BROWSER_WIDTH_ETC = 17 ;

// ブラウザwidthを取得.
width = function( scroll ){
    if( scroll != true || isSAFARI || isCHROME ) {
        if(window.innerWidth){
            return window.innerWidth;
        }else if(document.documentElement && document.documentElement.clientWidth){
            return document.documentElement.clientWidth;
        }else {
            var b = $base.getBody() ;
            if ( b && b.clientWidth){
                return b.clientWidth;
            }
        }
    }
    else {
        var ret = -1 ;
        if(document.documentElement && document.documentElement.scrollWidth){
            ret = document.documentElement.scrollWidth;
        }
        var b = $base.getBody() ;
        if ( b && b.scrollWidth){
            if( ret != -1 && b.scrollWidth < ret ) {
                var sc = ret - b.scrollWidth ;
                if( sc < _BROWSER_WIDTH_ETC ) {
                    ret = ret - _BROWSER_WIDTH_ETC ;
                }
                else {
                    ret = b.scrollWidth ;
                }
            }
        }
        return ret ;
    }
    return -1 ;
}

// ブラウザHeightを取得.
height = function( scroll ) {
    if( scroll != true || isMSIE6 || isSAFARI || isCHROME ) {
        if(window.innerHeight){
            return window.innerHeight;
        }else if(document.documentElement && document.documentElement.clientHeight){
            return document.documentElement.clientHeight;
        }else {
            var b = $base.getBody() ;
            if ( b && b.clientHeight){
                return b.clientHeight;
            }
        }
    }
    else {
        var ret = -1 ;
        if(document.documentElement && document.documentElement.scrollHeight){
            ret = document.documentElement.scrollHeight;
        }
        var b = $base.getBody() ;
        if ( b && b.scrollHeight ){
            if( ret != -1 && b.scrollHeight < ret ) {
                var sc = ret - b.scrollHeight ;
                if( sc < _BROWSER_WIDTH_ETC ) {
                    ret = ret - _BROWSER_WIDTH_ETC ;
                }
                else {
                    ret = b.scrollHeight ;
                }
            }
        }
        return ret-1 ;
    }
    return -1 ;
}

// ブラウザMAXWidth値を取得.
maxWidth = function() {
    var xScroll ;
    var yScroll;
    if (window.innerHeight && window.scrollMaxY) {
        xScroll = window.innerWidth + window.scrollMaxX;
        yScroll = window.innerHeight + window.scrollMaxY;
    } else if (document.body.scrollHeight > document.body.offsetHeight){
        xScroll = document.body.scrollWidth;
        yScroll = document.body.scrollHeight;
    } else {
        xScroll = document.body.offsetWidth;
        yScroll = document.body.offsetHeight;
        if (document.documentElement && document.documentElement.scrollWidth > xScroll) {
            xScroll = document.documentElement.scrollWidth;
            yScroll = document.documentElement.scrollHeight;
        }
    }
    if( xScroll <= 0 ) {
        xScroll = 0 ;
    }
    var w = width( true ) ;
    if( xScroll < w ) {
        xScroll = w ;
    }
    if( yScroll <= 0 ) {
        yScroll = 0 ;
    }
    var h = height() ;
    if( yScroll < h ) {
        yScroll = h ;
    }
    if( isMOZILLA || isCHROME ) {
        if( height(false) != yScroll ) {
            xScroll -= _BROWSER_WIDTH_ETC ;
        }
    }
    return xScroll ;
}

// ブラウザMAXHeight値を取得.
maxHeight = function() {
    var xScroll ;
    var yScroll;
    if (window.innerHeight && window.scrollMaxY) {
        xScroll = window.innerWidth + window.scrollMaxX;
        yScroll = window.innerHeight + window.scrollMaxY;
    } else if (document.body.scrollHeight > document.body.offsetHeight){
        xScroll = document.body.scrollWidth;
        yScroll = document.body.scrollHeight;
    } else {
        xScroll = document.body.offsetWidth;
        yScroll = document.body.offsetHeight;
        if (document.documentElement && document.documentElement.scrollWidth > xScroll) {
            xScroll = document.documentElement.scrollWidth;
            yScroll = document.documentElement.scrollHeight;
        }
    }
    if( yScroll <= 0 ) {
        yScroll = 0 ;
    }
    var h = height() ;
    if( yScroll < h ) {
        yScroll = h ;
    }
    if( isMOZILLA || isMSIE ) {
        if( height(false) != yScroll ) {
            yScroll += _BROWSER_WIDTH_ETC ;
        }
    }
    return yScroll ;
}

////////////////////////////////////////////////////////////////////////////////
// ドキュメント系.
////////////////////////////////////////////////////////////////////////////////

// 対象スタイルシートにWidht,Heightを割り当てる.
putStyleWidhtHeight = function( clazz,width,height,etc ) {
    var prop = new StrBuf() ;
    if( width > 0 ) {
        width /= 100 ;
        var x = Math.ceil( width() * width ) ;
        prop.ad( " width: " ).ad( x ).ad( "px;" ) ;
    }
    if( height > 0 ) {
        height /= 100 ;
        var y = Math.ceil( height() * height ) ;
        prop.ad( " height: " ).ad( y ).ad( "px;" ) ;
    }
    if( etc != null && ( etc = $base.trim( etc ) ).length > 0 ) {
        prop.ad( etc ) ;
        if( endsWith( etc,";" ) == false ) {
            prop.ad( ";" ) ;
        }
    }
    prop = prop.ts() ;
    if( prop.length > 0 ) {
        addCssValue( clazz,prop ) ;
    }
} ;

// スクロールＸ位置を取得.
getScrollX = function() {
    return $base.getBody().scrollLeft || document.documentElement.scrollLeft ;
}

// スクロールY位置を取得.
getScrollY = function() {
    return $base.getBody().scrollTop  || document.documentElement.scrollTop ;
}

// クラス情報を取得.
getElementsByClassName = function(clazz) {
    var ret = [];
    var elems = (document.getElementsByTagName("*") || document.all);
    for (var i = 0; i < elems.length; i++) {
        if (elems[i].className == clazz) {
            ret[ret.length] = elems[i];
        }
    }
    return ret;
}

// 現在フォーカス中のタグを取得.
getActiveFocus = function( mode ) {
    if( mode != true ) {
        mode = false ;
    }
    if( getGlobal('_$focus$Flag') == false ) {
        var allTags = ( document.getElementsByTagName('*') || document.all );
        var allTagsLen = allTags.length;
        // modeがtrueの場合は、全タグをフォーカス対象とする.
        if( mode ) {
            for (var i=0; i<allTagsLen; i++) {
                if( $base.isNull( allTags[i].onfocus ) ) {
                    allTags[i].onfocus = function(){
                        setGlobal('_$now$focus',this ) ;
                    }
                }
                else {
                    var n = $base.trim( allTags[i].onfocus.toString() ) ;
                    eval( "allTags["+i+"].onfocus =" + n.substring( 0,n.length-1 ) +
                        "\nsetGlobal('_$now$focus',this);}" ) ;
                }
            }
        }
        else {
            // modeがfalse及び、指定されていない場合は、
            // フォーカス条件を取得する個所は、入力条件のみとする.
            for (var i=0; i<allTagsLen; i++) {
                var tagName = allTags[i].tagName.toUpperCase() ;
                if( tagName == "INPUT" || tagName == "SELECT" || tagName == "TEXTAREA" ) {
                    var type = allTags[i].type.toUpperCase() ;
                    if( tagName != "INPUT" ||
                        ( tagName == "INPUT" && type != "BUTTON" && type != "SUBMIT" && type != "RESET" &&
                            type != "HIDDEN" && type != "IMAGE" ) ) {
                        if( $base.isNull( allTags[i].onfocus ) ) {
                            allTags[i].onfocus = function(){
                                setGlobal('_$now$focus', this);
                            }
                        }
                        else {
                            var n = $base.trim( allTags[i].onfocus.toString() ) ;
                            eval( "allTags["+i+"].onfocus =" + n.substring( 0,n.length-1 ) +
                                "\nsetGlobal('_$now$focus',this);}" ) ;
                        }
                    }
                }
            }
        }
        setGlobal('_$focus$Flag',true ) ;
    }
    return getGlobal('_$now$focus') ;
}

// Textフォーカス移動処理.
MoveFocus = {
    // 現在のテキストカーソル位置を取得.
    getTextPos : function(id) {
        var o = $( id ) ;
        if( !$base.isNull( o ) ) {
            var tagName = o.tagName.toUpperCase() ;
            if( tagName == "INPUT" ) {
                try {
                    if( document.selection ) {
                        o.focus();
                        var docRange = document.selection.createRange();
                        var range = o.createTextRange();
                        range.setEndPoint('EndToStart', docRange);
                        return range.text.length;
                    } else if( o.setSelectionRange ) {
                        o.focus();
                        return o.selectionStart ;
                    }
                } catch( err ) {}
            }
        }
        return -1 ;
    },
    // フォーカス移動.
    moveByFocus : function( mode,id ) {
        var o = $( id ) ;
        if( !$base.isNull( o ) ) {
            var tagName = o.tagName.toUpperCase() ;
            var typeName = o.type.toUpperCase() ;
            // テキスト系の場合.
            if( ( tagName == "INPUT" && typeName == "TEXT" ) || tagName == "TEXTAREA" ) {
                if( mode ) {
                    // IE.
                    if( !$base.isNull( o.createTextRange ) ) {
                        o.focus() ;
                        var range = o.createTextRange();
                        range.move('character', 0);
                        range.select();
                    }
                    // fireFox.
                    else if( !$base.isNull( o.setSelectionRange ) ) {
                        o.focus() ;
                        o.setSelectionRange(0,0);
                    }
                }
                else {
                    // IE.
                    if( !$base.isNull( o.createTextRange ) ) {
                        o.focus() ;
                        var range = o.createTextRange();
                        range.move('character', o.value.length);
                        range.select();
                    }
                    // fireFox.
                    else if( !$base.isNull( o.setSelectionRange ) ) {
                        o.focus() ;
                        o.setSelectionRange(o.value.length,o.value.length);
                    }
                }
            }
            // テキスト系以外の場合.
            else {
                o.focus() ;
            }
        }
    },
    // textデータ長を取得.
    lengthByText : function( id ) {
        var o = $( id ) ;
        if( !$base.isNull( o ) ) {
            var tagName = o.tagName.toUpperCase() ;
            if( tagName == "INPUT" ) {
                return o.value.length ;
            }
        }
        return -1 ;
    },
    // キーイベントキャンセル.
    cancellKey : function(event) {
        cancellKey( event ) ;
    },
    // IDフォーカス移動.
    move : function(event,nowId,befId,nextId,max) {
        event = getEvent( event ) ;
        if( $base.isNull( max ) ) {
            max = 0 ;
        }
        var nowTag = $(nowId) ;
        var tagName = nowTag.tagName.toUpperCase() ;
        var typeName = nowTag.type.toUpperCase() ;
        var keyCd = getKeyCode( event ) ;
        var target = null;
        var startFlag = false ;
        // 現在のフォーカスがテキストタグの場合.
        if( tagName == "INPUT" && ( typeName == "TEXT" || typeName == "PASSWORD" ) ) {
            var actionKeyFlag = false ;
            // 最大文字数入力で、フォーカス移動する場合.
            if( max > 0 ) {
                // maxLengthを指定長に変更.
                nowTag.maxLength=max ;
            }
            switch( keyCd ) {
                case 8 :// バックスペース.
                    if( MoveFocus.lengthByText( nowId ) <= 0 ) {
                        MoveFocus.cancellKey(event) ;
                        target = befId ;
                    }
                    actionKeyFlag = true ;
                    break ;
                case 13 : case 40 :// 改行、または下矢印.
                case 118 : // F7.
                    target = nextId ;
                    startFlag = true ;
                    actionKeyFlag = true ;
                    MoveFocus.cancellKey(event) ;
                    break ;
                case 38 :// 上矢印
                case 117 : // F6.
                    target = befId ;
                    actionKeyFlag = true ;
                    MoveFocus.cancellKey(event) ;
                    break ;
                case 39 :// 右矢印.
                    var p = MoveFocus.getTextPos( nowId ) ;
                    if( p >= MoveFocus.lengthByText( nowId ) || MoveFocus.lengthByText( nowId ) <= 0 ) {
                        MoveFocus.cancellKey(event) ;
                        target = nextId ;
                        startFlag = true ;
                    }
                    actionKeyFlag = true ;
                    break ;
                case 37 :// 左矢印.
                     var p = MoveFocus.getTextPos( nowId ) ;
                    if( p <= 0 ) {
                        MoveFocus.cancellKey(event) ;
                        target = befId ;
                    }
                    actionKeyFlag = true ;
                    break ;
                case 46 :// deleteボタン.
                    actionKeyFlag = true ;
                    break ;
            }
            if( !$base.isNull( target ) ) {
                var o = $( target ) ;
                if( !$base.isNull( o ) ) {
                    MoveFocus.moveByFocus( startFlag,target ) ;
                    return false ;
                }
            }
            // アクションキーが押されてなく、文字制限が存在する場合.
            if( !actionKeyFlag && max > 0 ) {
                var val = nowTag.value ;
                if( val.length >= max ) {
                    // 次の移動位置が存在する場合は移動する.
                    if( !$base.isNull( nextId ) ) {
                        MoveFocus.moveByFocus( true,nextId ) ;
                    }
                }
            }
        }
        // 現在のフォーカスがボタン系または、リンクの場合.
        else if( tagName == "A" || ( tagName == "INPUT" &&
            ( typeName == "IMAGE" || typeName == "BUTTON" || typeName == "SUBMIT" || typeName == "RESET" ) ) ) {
            switch( keyCd ) {
                case 229 :// スペース.
                    // スペースの場合は、ボタンを押す.
                    nowTag.click() ;
                    MoveFocus.cancellKey(event) ;
                    break ;
                case 8 :// バックスペース.
                    // 何もしない.
                    MoveFocus.cancellKey(event) ;
                    break ;
                case 40 : case 39 : case 13 : case 118 : // 下矢印 or 右矢印 or 改行 or F7.
                    target = nextId ;
                    startFlag = true ;
                    MoveFocus.cancellKey(event) ;
                    break ;
                case 38 : case 37 : case 117 : // 上矢印 or 左矢印. or F6.
                    target = befId ;
                    MoveFocus.cancellKey(event) ;
                    break ;
            }
            if( !$base.isNull( target ) ) {
                var o = $( target ) ;
                if( !$base.isNull( o ) ) {
                    MoveFocus.moveByFocus( startFlag,target ) ;
                    return false ;
                }
            }
        }
        // 現在のフォーカスがチェックボックスの場合.
        else if( tagName == "INPUT" && typeName == "CHECKBOX" ) {
            switch( keyCd ) {
                case 229 :// スペース.
                    if( nowTag.checked ) {
                        nowTag.checked = false ;
                    }
                    else {
                        nowTag.checked = true ;
                    }
                    MoveFocus.cancellKey(event) ;
                    break ;
                case 39 : // 右矢印.
                    nowTag.checked = true ;
                    MoveFocus.cancellKey(event) ;
                    break ;
                case 8 : case 37 : // バックスペース or 左矢印.
                    nowTag.checked = false ;
                    MoveFocus.cancellKey(event) ;
                    break ;
                case 40 : case 13 : case 118 : // 下矢印 or 改行 or F7.
                    target = nextId ;
                    startFlag = true ;
                    MoveFocus.cancellKey(event) ;
                    break ;
                case 38 : case 117 : // 上矢印 or F6.
                    target = befId ;
                    MoveFocus.cancellKey(event) ;
                    break ;
            }
            if( !$base.isNull( target ) ) {
                var o = $( target ) ;
                if( !$base.isNull( o ) ) {
                    MoveFocus.moveByFocus( startFlag,target ) ;
                    return false ;
                }
            }
        }
        // 現在のフォーカスがセレクトボックスの場合.
        else if( tagName == "SELECT" ) {
            switch( keyCd ) {
                case 8 :// バックスペース.
                    MoveFocus.cancellKey(event) ;
                    // 上の条件に移動.
                    var op = nowTag.options ;
                    var len = op.length-1 ;
                    for( var i = len ; i >= 1 ; i -- ) {
                        if( op[i].selected ) {
                            op[i].selected = false ;
                            op[i-1].selected = true ;
                            break ;
                        }
                    }
                    break ;
                case 38 : case 117 : // 上矢印 or F6.
                    target = befId ;
                    MoveFocus.cancellKey(event) ;
                    break ;
                case 13 : case 40 : case 118 : // 改行 or 下矢印 or F7.
                    target = nextId ;
                    startFlag = true ;
                    MoveFocus.cancellKey(event) ;
                    break ;
                case 39 : // 右矢印.
                    // IEの場合だけ処理.
                    if( isMSIE ) {
                        MoveFocus.cancellKey(event) ;
                        // 下の条件に移動.
                        var op = nowTag.options ;
                        var len = op.length-1 ;
                        for( var i = 0 ; i < len ; i ++ ) {
                            if( op[i].selected ) {
                                op[i].selected = false ;
                                op[i+1].selected = true ;
                                break ;
                            }
                        }
                    }
                    break ;
                case 37 : // 左矢印.
                    // IEの場合だけ処理.
                    if( isMSIE ) {
                        MoveFocus.cancellKey(event) ;
                        // 上の条件に移動.
                        var op = nowTag.options ;
                        var len = op.length-1 ;
                        for( var i = len ; i >= 1 ; i -- ) {
                            if( op[i].selected ) {
                                op[i].selected = false ;
                                op[i-1].selected = true ;
                                break ;
                            }
                        }
                    }
                    break ;
            }
            if( !$base.isNull( target ) ) {
                var o = $( target ) ;
                if( !$base.isNull( o ) ) {
                    MoveFocus.moveByFocus( startFlag,target ) ;
                    return false ;
                }
            }
        }
        return false ;
    }
}

////////////////////////////////////////////////////////////////////////////////
// スタイルシート書き換え.
////////////////////////////////////////////////////////////////////////////////

// スタイルシートを書き換える.
addCssValue = function( selector, property ) {
    if( $base.isNull( selector ) || $base.isNull( property ) ) {
        return false ;
    }
    var sheets = getSheets() ;
    if( $base.isNull( sheets ) ) {
        return false ;
    }
    if( isMSIE == true ) {
        if( sheets[0].addRule ) { //IE
            sheets[0].addRule( selector, "{" + property + "}" );
            return true ;
        }
    }
    else {
        if( !$base.isNull( sheets[0].insertRule ) ) { //Mozilla
            sheets[0].insertRule( selector + "{" + property + "}", sheets[0].cssRules.length );
            return true ;
        }
    }
    return false;
}

// クラススタイルシートを書き換える.
addCssClass = function( clazz,property ) {
    if( !$base.startsWith( clazz,"." ) ) {
        clazz = "." + clazz ;
    }
    return addCssValue( clazz,property ) ;
}

// スタイルシートを取得する.
getCssValue = function( selector, property ) {
    var property = ( property.match( /-/ ) ) ? property.camelize( ) : property;
    var sheets = getSheets() ;
    if( $base.isNull( sheets ) ) {
        return false ;
    }
    var sheetLength = sheets.length ;
    var stylesheets = null ;
    for( var sheetLoop = 0 ; sheetLoop < sheetLength ; sheetLoop ++ ) {
        if( $base.isNull( sheets[sheetLoop].rules ) ) {
            stylesheets = sheets[sheetLoop].cssRules;    //Mozilla
        }
        else {
            stylesheets = sheets[sheetLoop].rules        //IE
        }
        selector = selector.toLowerCase() ;
        for( var i = 0, len = stylesheets.length; i < len; i++ ) {
            var css = stylesheets[i];
            if( !$base.isNull( css.selectorText ) && css.selectorText.toLowerCase() == selector ) {
                return css.style[ property ];
            }
        }
    }
    return null ;
}

// スタイルシート(指定クラス条件)を取得.
getCss = function( selector ) {
    var sheets = getSheets() ;
    if( $base.isNull( sheets ) ) {
        return false ;
    }
    var sheetLength = sheets.length ;
    var stylesheets = null ;
    for( var sheetLoop = 0 ; sheetLoop < sheetLength ; sheetLoop ++ ) {
        if( $base.isNull( sheets[sheetLoop].rules ) ) {
            stylesheets = sheets[sheetLoop].cssRules;    //Mozilla
        }
        else {
            stylesheets = sheets[sheetLoop].rules        //IE
        }
        selector = $base.trim( selector ).toLowerCase() ;
        if( !$base.startsWith( selector,"." ) ) {
            selector = "." + selector ;
        }
        var len = stylesheets.length ;
        for( var i = 0 ; i < len; i++ ) {
            var css = stylesheets[i];
            if( $base.useString( css.selectorText ) && css.selectorText.toLowerCase() == selector ) {
                return css ;
            }
        }
    }
    return null ;
}

// 指定要素での有効スタイルシート値を取得.
getActiveCssValue = function( element, property, pseudo ) {
    if( $base.isNull( pseudo ) ) {
        pseudo = "" ;
    }
    if( element.currentStyle ) {          //IE
        property = ( property.match( /-/ ) ) ? property.camelize( ) : property;
        return element.currentStyle[ property.camelize() ];
    }
    else {
        if( document.defaultView.getComputedStyle ) {    //Mozilla
            property = ( $base.isNull( property.match( /-/ ) ) ) ? property.deCamelize( ) : property;
            return document.defaultView.getComputedStyle( element, pseudo ).getPropertyValue( property );
        }
    }
    return "";
}

// スタイルシート一覧を取得.
getSheets = function() {
    if ( !$base.isNull( document.styleSheets ) ) {
        return document.styleSheets;
    }
    return null ;
}

// スタイルシート要素名を変換.
convertCSSName = function( mode,name ) {
    if( !$base.useString( name ) ) {
        return null ;
    }
    if( name.indexOf( "-" ) == -1 ) {
        var t = new StrBuf() ;
        var len = name.length ;
        var c ;
        for( var i = 0 ; i < len ; i ++ ) {
            c = name.charAt( i ) ;
            if( c >= 'A' && c <= 'Z' ) {
                t.ad( "-" ).ad( c.toLowerCase() ) ;
            }
            else {
                t.ad( c ) ;
            }
        }
        name = t.ts() ;
    }
    if( mode == "true" || mode == true ) {
        var t = new StrBuf() ;
        var len = name.length ;
        var c ;
        var n = false ;
        for( var i = 0 ; i < len ; i ++ ) {
            c = name.charAt( i ) ;
            if( c >= '-' ) {
                n = true ;
            }
            else if( n ) {
                n = false ;
                t.ad( c.toUpperCase() ) ;
            }
            else {
                t.ad( c ) ;
            }
        }
        name = t.ts() ;
    }
    return name ;
}

// 現在定義されているCSS以外の項目を定義させる.
setCssDefine = function( className,element,defineMap ) {
    // IE６とIE７のみ.
    if( isMSIE6 || isMSIE7 ) {
    //if( isMSIE ) {
        var map = {} ;
        var css = element.style ;
        var key ;
        for( var k in css ) {
            if( !$base.isNumeric( k ) ) {
                if( typeof( css[k] ) == "string" && $base.useString( css[k] ) ) {
                    map[k] = css[k] ;
                }
            }
        }
        if( !$base.startsWith( className,"." ) ) {
            className = "." + className ;
        }
        css = getCss( className ) ;
        if( !$base.isNull( css ) ) {
            css = css.style ;
            var len = css.length ;
            if( len == undefined ) {
                for( var k in css ) {
                    if( !$base.isNumeric( k ) ) {
                        if( typeof( css[k] ) == "string" && $base.useString( css[k] ) ) {
                            map[k] = css[k] ;
                        }
                    }
                }
            }
            var k ;
            for( var i = 0 ; i < len ; i ++ ) {
                k = css.item( i ) ;
                if( typeof( css[k] ) == "string" && $base.useString( css[k] ) ) {
                    map[k] = css.getPropertyValue( k ) ;
                }
            }
        }
        if( valueof( defineMap ) == "map" ) {
            for( var k in defineMap ) {
                key = $base.trim( k ) ;
                map[key] = defineMap[k] ;
            }
        }
        var buf = new StrBuf() ;
        var s ;
        for( var k in map ) {
            var s = map[k] ;
            if( typeof( s ) != "string" || !$base.useString( s ) ) {
                continue ;
            }
            s = $base.trim( s ) ;
            if( $base.endsWith( s,";" ) ) {
                s = s.substring( 0,s.length-1 ) ;
                s = $base.trim( s ) ;
            }
            if( $base.useString( s ) ) {
                buf.ad( k ).ad( ":" ).ad( s ).ad( ";" ) ;
            }
        }
        includeAttribute( element,"style",buf.ts() ) ;
    }
    else {
        var buf = new StrBuf() ;
        if( valueof( defineMap ) == "map" ) {
            for( var k in defineMap ) {
                var s = defineMap[k] ;
                if( typeof( s ) != "string" || !$base.useString( s ) ) {
                    continue ;
                }
                s = $base.trim( s ) ;
                if( $base.endsWith( s,";" ) ) {
                    s = s.substring( 0,s.length-1 ) ;
                    s = $base.trim( s ) ;
                }
                if( $base.useString( s ) ) {
                    buf.ad( k ).ad( ":" ).ad( s ).ad( ";" ) ;
                }
            }
            includeAttribute( element,"style",buf.ts() ) ;
        }
        else {
            includeAttribute( element,"style","" ) ;
        }
    }
}

// 指定クラス名から、対象要素を取得.
getCssElement = function( className,name ) {
    if( !$base.useString( className ) || !$base.useString( name ) ) {
        return null ;
    }
    if( !$base.startsWith( className,"." ) ) {
        className = "." + className ;
    }
    name = $base.trim( name ).toLowerCase() ;
    var css = getCss( className ) ;
    if( !$base.isNull( css ) ) {
        css = css.style ;
        var len = css.length ;
        if( len == undefined ) {
            name = $base.changeString( name,"-","" ) ;
            for( var k in css ) {
                if( !$base.isNumeric( k ) ) {
                    if( name == k.toLowerCase() ) {
                        return css[k] ;
                    }
                }
            }
        }
        else {
            var k ;
            for( var i = 0 ; i < len ; i ++ ) {
                k = css.item( i ) ;
                if( name == k.toLowerCase() ) {
                    return css.getPropertyValue(k) ;
                }
            }
        }
    }
    return null ;
}

// クラス名から取得したカラー値を数値変換.
cssColorByNumber = function( color ) {
    if( $base.useString( color ) ) {
        color = $base.trim( color ).toLowerCase() ;
        if( $base.startsWith( color,"#" ) ) {
            color = color.substring( 1 ) ;
            if( color.length == 3 ) {
                color = color.charAt( 0 ) + "0" +
                    color.charAt( 1 ) + "0" +
                    color.charAt( 2 ) + "0" ;
            }
            return $base.convert16To10( color ) ;
        }
        else if( $base.startsWith( color,"rgb(" ) ) {
            color = color.substring( 4,color.length-1 ) ;
            color = color.split( "," ) ;
            return ( parseInt( color[0] ) << 16 ) |
                ( parseInt( color[1] ) << 8 ) |
                parseInt( color[2] ) ;
        }
    }
    return 0 ;
}

////////////////////////////////////////////////////////////////////////////////
// Validate系.
////////////////////////////////////////////////////////////////////////////////

// 文字列判別.
var STR_NUMBER = 0x00000001 ;       // 数値判別.
var STR_ALPHABET = 0x00000002 ;     // アルファベット判別.
var STR_ASCII = 0x00000003 ;        // アスキー判別.
var STR_KANA = 0x00000004 ;         // カタカナ判別.
var STR_HIRA = 0x00000008 ;         // ひらがな判別.

// ひらがな／カタカナ全文字種別.
var KANA_ALL = "アィイウウェエォオカガキギクグケゲコゴサザシジスズセゼソゾタダチヂッツヅテデトドナニヌネノハバパヒビピフブプヘベペホボポマミムメモャヤュユョヨラリルレロヮワヰヲンー" ;
var KANA2_ALL = "ｱｨｲｳｳｪｴｫｵｶｷｸｹｺｻｼｽｾｿﾀﾁｯﾂﾃﾄﾅﾆﾇﾈﾉﾊﾋﾌﾍﾎﾏﾐﾑﾒﾓｬﾔｭﾕｮﾖﾗﾘﾙﾚﾛヮﾜｦﾝｰﾞﾟ" ;
var HIRA_ALL = "あぃいぅうぇえぉおかがきぎくぐけげこごさざしじすずせぜそぞただちぢっつづてでとどなにぬねのはばぱひびぴふぶぷへべぺほぼぽまみむめもゃやゅゆょよらりるれろゎわゐゑをんー" ;

// Validateチェック.
var _use_validate_flag = false ;
var _all_validate_message = "" ;

// メッセージ出力IDを生成.
create_messageId = function( id,no ) {
    if( $base.useString( id ) ) {
        if( !$base.endsWith( id,"Id" ) ) {
            if( !$base.isNumeric( no ) ) {
                no = 0 ;
            }
            id = id + "_" + no + "_Id" ;
        }
        return id ;
    }
    return "" ;
}

// 正常メッセージを設定.
validate_successMessage = function( message,id,no ) {
    if( $base.useString( message) == false ) {
        return false ;
    }
    var viewId = "smsgId" ;
    if( !$base.useString( id ) ) {
        id = "main" ;
    }
    else {
        id = create_messageId( id,no ) ;
    }
    viewId = viewId + id ;
    if( $base.isNull( $( viewId ) ) ) {
        return false ;
    }
    if( $base.useString( _all_validate_message ) ) {
        _all_validate_message += "<br>" ;
    }
    _all_validate_message += "[(s)id:" + id + "]:" + message ;
    if( $base.useString( $( viewId ).innerHTML ) == false ) {
        _use_validate_flag = true ;
        fastInnerHTML( viewId,message + "<br>" ) ;
    }
    else {
        _use_validate_flag = true ;
        fastInnerHTML( viewId,$( viewId ).innerHTML + message + "<br>" ) ;
    }
    return true ;
}

// 正常メッセージ互換.
setSuccessMessage = validate_successMessage ;

// 指定位置のエラーメッセージを設定.
validate_errorMessage = function( message,id,no ) {
    if( $base.useString( message ) == false ) {
        return false ;
    }
    var viewId = "emsgId" ;
    if( $base.useString( id ) == false ) {
        id = "main" ;
    }
    else {
        id = create_messageId( id,no ) ;
    }
    viewId = viewId + id ;
    if( $base.isNull( $( viewId ) ) ) {
        return false ;
    }
    if( $base.useString( _all_validate_message ) ) {
        _all_validate_message += "<br>" ;
    }
    _all_validate_message += "[(e)id:" + id + "]:" + message ;
    if( $base.useString( $( viewId ).innerHTML ) == false ) {
        _use_validate_flag = true ;
        fastInnerHTML( viewId,message + "<br>" ) ;
    }
    else {
        _use_validate_flag = true ;
        fastInnerHTML( viewId,$( viewId ).innerHTML + message + "<br>" ) ;
    }
    return true ;
}

// エラーメッセージ互換.
setErrorMessage = validate_errorMessage ;

// すべてのメッセージを削除する.
validate_clear_all_message = function() {
    _all_validate_message = "" ;
    _use_validate_flag = false ;
    var tags = document.getElementsByTagName( "span" ) ;
    if( tags.length > 0 ) {
        var len = tags.length ;
        var tag ;
        for( var i = 0 ; i < len ; i ++ ) {
            tag = tags[ i ] ;
            if( $base.isNull( tag ) == false &&
                $base.isNull( tag.id ) == false ) {
                if( $base.startsWith( tag.id,"emsgId" ) ||
                    $base.startsWith( tag.id,"smsgId" ) ) {
                    fastInnerHTML( tag,"" ) ;
                }
            }
        }
    }
}

// validateエラーが検知されたかチェック.
is_validate = function() {
    var ret = _use_validate_flag ;
    _use_validate_flag = false ;
    return ret ;
}

// validateエラー確認.
check_validate = function( formName ) {
    validate_clear_all_message() ;
    _validate_by_form( formName ) ;
    if( is_validate() ) {
        window.scrollTo(0,0) ;
        return false ;
    }
    return true ;
}

// validateチェック+submit処理(VTag-Framework用).
validate_submit = function( formName ) {
    _validate_by_form( formName ) ;
    if( is_validate() ) {
        //window.scrollTo(0,0) ;
        var b = $base.getBody() ;
        if( !$base.isNull( b ) ) {
            b.scrollTop = 0 ;
        }
        return false ;
    }
    if( typeof( document[formName] ) != "undefined" ) {
        document[formName].submit() ;
        return true ;
    }
    return false ;
}

// validateチェック+submit処理(VTag-Framework用).
validate_submit_conf = function( formName,message ) {
    _validate_by_form( formName ) ;
    if( is_validate() ) {
        //window.scrollTo(0,0) ;
        var b = $base.getBody() ;
        if( !$base.isNull( b ) ) {
            b.scrollTop = 0 ;
        }
        return false ;
    }
    if( !$base.useString( message ) ) {
        message = "この内容で処理します。よろしいですが？" ;
    }
    if( window.confirm( message ) ) {
        if( typeof( document[formName] ) != "undefined" ) {
            document[formName].submit() ;
            return true ;
        }
    }
    return false ;
}

// validateチェック+submit処理(VLTag-Framework用).
validate_lite_submit = function( formName ) {
    executionVL( formName ) ;
    if( is_validate() ) {
        //window.scrollTo(0,0) ;
        var b = $base.getBody() ;
        if( !$base.isNull( b ) ) {
            b.scrollTop = 0 ;
        }
        return false ;
    }
    if( typeof( document[formName] ) != "undefined" ) {
        document[formName].submit() ;
        return true ;
    }
    return false ;
}

// validateチェック+submit処理&確認(VLTag-Framework用).
validate_lite_submit_conf = function( formName,message ) {
    executionVL( formName ) ;
    if( is_validate() ) {
        //window.scrollTo(0,0) ;
        var b = $base.getBody() ;
        if( !$base.isNull( b ) ) {
            b.scrollTop = 0 ;
        }
        return false ;
    }
    if( !$base.useString( message ) ) {
        message = "この内容で処理します。よろしいですが？" ;
    }
    if( window.confirm( message ) ) {
        if( typeof( document[formName] ) != "undefined" ) {
            document[formName].submit() ;
            return true ;
        }
    }
    return false ;
}


// 文字列判別.
validate_string = function( type,name,message,id,no ) {
    if( $base.isNull( type ) || $base.useString( name ) == false ||
        $base.useString( message ) == false ) {
        return false ;
    }
    if( $base.useString( id ) == false ) {
        id = name ;
    }
    var val = $$(id,no) ;
    if( $base.useString( val ) == false ) {
        validate_errorMessage( message,id,no ) ;
        return true ;
    }
    // 数値存在チェック.
    var result = true ;
    var flag = ( type & STR_NUMBER ) != 0  ;
    if( flag )
    {
        var buf = new StrBuf() ;
        var len = val.length ;
        var dotCount = 0 ;
        var c ;
        for( var i = 0 ; i < len ; i ++ ) {
            c = val.charAt( i ) ;
            if( i == 0 && ( c == '+' || c == '-' ) ) {
            }
            else if( dotCount == 0 && c == '.' ) {
                dotCount ++ ;
            }
            else if( c >= '0' && c <= '9' ) {
                result = ( !flag ) ? false : result ;
            }
            else {
                buf.append( c ) ;
            }
        }
        val = buf.toString() ;
    }
    // アルファベットチェック.
    var flag = ( type & STR_ALPHABET ) != 0  ;
    if( flag )
    {
        var buf = new StrBuf() ;
        var len = val.length ;
        var c ;
        for( var i = 0 ; i < len ; i ++ ) {
            c = val.charAt( i ) ;
            if( ( c >= 'a' && c <= 'z' ) ||
                ( c >= 'A' && c <= 'Z' ) ) {
                result = ( !flag ) ? false : result ;
            } else {
                buf.append( c ) ;
            }
        }
        val = buf.toString() ;
    }
    // カナチェック.
    var flag = ( type & STR_KANA ) != 0  ;
    if( flag )
    {
        var buf = new StrBuf() ;
        // 全角.
        var len = val.length ;
        var c ;
        for( var i = 0 ; i < len ; i ++ ) {
            c = val.substring( i,i+1 ) ;
            if( KANA_ALL.indexOf( c ) == -1 ) {
                buf.append( c ) ;
            } else {
                result = ( !flag ) ? false : result ;
            }
        }
        val = buf.toString() ;
        buf = new StrBuf() ;
        // 半角.
        len = val.length ;
        for( var i = 0 ; i < len ; i ++ ) {
            c = val.substring( i,i+1 ) ;
            if( KANA2_ALL.indexOf( c ) == -1 ) {
                buf.append( c ) ;
            } else {
                result = ( !flag ) ? false : result ;
            }
        }
        val = buf.toString() ;
    }
    // ひらがなチェック.
    var flag = ( type & STR_HIRA ) != 0  ;
    if( flag )
    {
        var buf = new StrBuf() ;
        // 全角.
        var len = val.length ;
        var c ;
        for( var i = 0 ; i < len ; i ++ ) {
            c = val.substring( i,i+1 ) ;
            if( HIRA_ALL.indexOf( c ) == -1 ) {
                buf.append( c ) ;
            } else {
                result = ( !flag ) ? false : result ;
            }
        }
        val = buf.toString() ;
    }
    // チェック対象の文字列が存在する場合.
    if( !result ) {
        validate_errorMessage( message,id,no ) ;
        return true ;
    }
    return false ;
}

// 正規表現判別.
validate_match = function( match,name,message,id,no ) {
    if( $base.isNull( match ) || $base.useString( name ) == false ||
        $base.useString( message) == false ) {
        return false ;
    }
    if( $base.useString( id ) == false ) {
        id = name ;
    }
    var val = $$(id,no) ;
    if( $base.useString( val ) == false ) {
        validate_errorMessage( message,id,no ) ;
        return true ;
    }
    if( match.test(val) == false ) {
        validate_errorMessage( message,id,no ) ;
        return true ;
    }
    return false ;
}

// 日付判別
validate_date = function( name,message,id,no ) {
    if( $base.useString( name ) == false || $base.useString( message ) == false ) {
        return false ;
    }
    if( $base.useString( id ) == false ) {
        id = name ;
    }
    var match = /^\d{2,4}\/([1][0-2]|[0][1-9]|[1-9])\/([3][0-1]|[1-2][0-9]|[0][1-9]|[1-9])$/ ;
    if( validate_match( match,name,message,id,no ) ) {
        return true ;
    }
    // 正規表現チェック後、日付変換して、ずれがないかチェック.
    var dt = null ;
    var y = null ;
    var m = null ;
    var d = null ;
    try {
        var c = $$(id,no) ;
        if( $base.useString( c ) == false ) {
            validate_errorMessage( message,id,no ) ;
            return true ;
        }
        var b = 0 ;
        var p = c.indexOf( "/",b ) ;
        y = parseInt( c.substring( b,p ) ) ;
        b = p + 1 ;
        var p = c.indexOf( "/",b ) ;
        m = parseInt( c.substring( b,p ) ) ;
        b = p + 1 ;
        d = parseInt( c.substring( b ) ) ;
        dt = new Date( y,m-1,d ) ;
    } catch( E ) {
        validate_errorMessage( message,id,no ) ;
        return true ;
    }
    if( dt.getFullYear() != y || (dt.getMonth()+1) != m || dt.getDate() != d ) {
        validate_errorMessage( message,id,no ) ;
        return true ;
    }
    return false ;
}

// 時間判別
validate_time = function( name,message,id,no ) {
    var match = /^([0-1][0-9]|[2][0-3]|[0-9])\:([0-5][0-9]|[0-9])$/ ;
    return validate_match( match,name,message,id,no ) ;
}

// 郵便番号判別.
validate_zip = function( name,message,id,no ) {
    var match = /^\d{3}-\d{4}$/ ;
    return validate_match( match,name,message,id,no ) ;
}

// 電話番号判別.
validate_tel = function( name,message,id,no ) {
    var match = /^[0-9]+\-[0-9]+\-[0-9]+$/ ;
    return validate_match( match,name,message,id,no ) ;
}

// ISBN番号判別.
validate_isbn = function( name,message,id,no ) {
    var match = /ISBN\x20(?=.{13}$)\d{1,5}([- ])\d{1,7}\1\d{1,6}\1(\d|X)$/ ;
    return validate_match( match,name,message,id,no ) ;
}

// IPアドレス判別.
validate_ip = function( name,message,id,no ) {
    var match = /^(([0-2]*[0-9]+[0-9]+)\.([0-2]*[0-9]+[0-9]+)\.([0-2]*[0-9]+[0-9]+)\.([0-2]*[0-9]+[0-9]+))$/ ;
    return validate_match( match,name,message,id,no ) ;
}

// URL判別.
validate_url = function( name,message,id,no ) {
    var match = /^(http|https|ftp):\/\/(([A-Z0-9][A-Z0-9_-]*)(\.[A-Z0-9][A-Z0-9_-]*)+)(:(\d+))?\/?/i ;
    return validate_match( match,name,message,id,no ) ;
}

// E-MAIL判別.
validate_email = function( name,message,id,no ) {
    var match = /\w{1,}[@][\w\-]{1,}([.]([\w\-]{1,})){1,3}$/ ;
    return validate_match( match,name,message,id,no ) ;
}

// 指定日付が現在時間より前かチェック.
validagte_nowDate = function( name,message,id,no ) {
    if( $base.useString( name ) == false || $base.useString( message ) == false ) {
        return false ;
    }
    var y = $$( name + "Year",no ) ;
    var m = $$( name + "Month",no ) ;
    var d = $$( name + "Day",no ) ;
    if( $base.isNull(y) == true || y.disabled == true ||
        $base.isNull(m) == true || m.disabled == true ||
        $base.isNull(d) == true || d.disabled == true ) {
        return false ;
    }
    if( $base.useString( id ) == false ) {
        id = name ;
    }
    var now = new Date() ;
    var check = new Date( parseInt( y.value ),
        parseInt( m.value )-1,
        parseInt( d.value ) ) ;
    if( now.getTime() >= check.getTime() ) {
        validate_errorMessage( message,id,no ) ;
        return true ;
    }
    return false ;
}

// 指定日付が、対象名の内容より前かチェック.
validate_dateBySrcDest = function( src,dest,message,id,no ) {
    if( $base.useString( src ) == false || $base.useString( dest ) == false ||
        $base.useString( message ) == false ) {
        return false ;
    }
    var sy = $$( src + "Year",no ) ;
    var sm = $$( src + "Month",no ) ;
    var sd = $$( src + "Day",no ) ;
    var dy = $$( dest + "Year",no ) ;
    var dm = $$( dest + "Month",no ) ;
    var dd = $$( dest + "Day",no ) ;
    if( $base.isNull( sy ) == true || sy.disabled == true ||
        $base.isNull( sm ) == true || sm.disabled == true ||
        $base.isNull( sd ) == true || sd.disabled == true ||
        $base.isNull( dy ) == true || dy.disabled == true ||
        $base.isNull( dm ) == true || dm.disabled == true ||
        $base.isNull( dd ) == true || dd.disabled == true ) {
        return false ;
    }
    if( $base.useString( id ) == false ) {
        id = dest ;
    }
    var srcTime = new Date( parseInt( sy.value ),
        parseInt( sm.value )-1,
        parseInt( sd.value ) ) ;
    var destTime = new Date( parseInt( sy.value ),
        parseInt( sm.value )-1,
        parseInt( sd.value ) ) ;
    if( srcTime.getTime() >= destTime.getTime() ) {
        validate_errorMessage( message,id,no ) ;
        return true ;
    }
    return false ;
}

// ファイルアップロード画像タイプチェック.
validate_image = function( name,message,id,no ) {
    if( $base.useString( name ) == false || $base.useString( message ) == false ) {
        return false ;
    }
    if( $base.useString( id ) == false ) {
        id = name ;
    }
    if( validate_no_use( name,message,id ) ) {
        return true ;
    }
    // サポート画像は、JPEG,GIF,PNGとする.
    var c = $$(id,no) ;
    if( $base.endsWith( c,".jpeg" ) == false &&
        $base.endsWith( c,".jpg" ) == false &&
        $base.endsWith( c,".jpe" ) == false &&
        $base.endsWith( c,".jfif" ) == false &&
        $base.endsWith( c,".jfi" ) == false &&
        $base.endsWith( c,".gif" ) == false &&
        $base.endsWith( c,".png" ) == false ) {
        validate_errorMessage( message,id,no ) ;
        return true ;
    }
    return false ;
}

// 指定拡張子チェック.
validate_fileNamePlus = function( plus,name,message,id,no ) {
    if( $base.useString( plus ) == false || $base.useString( name ) == false ||
        $base.useString( message ) == false ) {
        return false ;
    }
    if( $base.useString( id ) == false ) {
        id = name ;
    }
    if( validate_no_use( name,message,id ) ) {
        return true ;
    }
    var c = $$(id,no) ;
    if( plus.indexOf( "," ) != -1 ) {
        var t = plus.split( "," ) ;
        var len = t.length ;
        var errFlg = true ;
        for( var i = 0 ; i < len ; i ++ ) {
            var x = t[ i ] ;
            if( $base.startsWith( x,"." ) == false ) {
                x = "." + x ;
            }
            if( $base.endsWith( c,x ) == true ) {
                errFlg = false ;
                break ;
            }
        }
        if( errFlg ) {
            validate_errorMessage( message,id,no ) ;
            return true ;
        }
    }
    else {
        if( $base.startsWith( plus,"." ) == false ) {
            plus = "." + plus ;
        }
        if( $base.endsWith( c,plus ) == false ) {
            validate_errorMessage( message,id,no ) ;
            return true ;
        }
    }
    return false ;
}

// 指定開始条件不正チェック.
validate_startsWith = function( src,name,message,id,no ) {
    if( $base.isNull( src ) || $base.useString( name ) == false ||
        $base.useString( message) == false ) {
        return false ;
    }
    if( $base.useString( id ) == false ) {
        id = name ;
    }
    if( validate_no_use( name,message,id ) == true ) {
        return false ;
    }
    var c = $$(id,no) ;
    if( $base.startsWith( c,src ) == false ) {
        validate_errorMessage( message,id,no ) ;
        return true ;
    }
    return false ;
}

// 指定終了条件不正チェック.
validate_endsWith = function( src,name,message,id,no ) {
    if( $base.isNull( src ) || $base.useString( name ) == false ||
        $base.useString( message) == false ) {
        return false ;
    }
    if( $base.useString( id ) == false ) {
        id = name ;
    }
    if( validate_no_use( name,message,id ) == true ) {
        return false ;
    }
    var c = $$(id,no) ;
    if( $base.endsWith( c,src ) == false ) {
        validate_errorMessage( message,id,no ) ;
        return true ;
    }
    return false ;
}

// 指定条件非存在チェック.
validate_no_use = function( name,message,id,no ) {
    if( $base.useString( name ) == false || $base.useString( message) == false ) {
        return false ;
    }
    if( $base.useString( id ) == false ) {
        id = name ;
    }
    var val = $$(id,no) ;
    if( $base.useString( val ) == false ) {
        validate_errorMessage( message,id,no ) ;
        return true ;
    }
    if( /\S/.test(val) == false ) {
        validate_errorMessage( message,id,no ) ;
        return true ;
    }
    return false ;
}

// 指定条件存在チェック.
validate_use = function( name,message,id,no ) {
    if( $base.useString( name ) == false || $base.useString( message) == false ) {
        return false ;
    }
    if( $base.useString( id ) == false ) {
        id = name ;
    }
    var val = $$(id,no) ;
    if( $base.useString( val ) == false ) {
        return false ;
    }
    if( !/\S/.test(val) == false ) {
        validate_errorMessage( message,id,no ) ;
        return true ;
    }
    return false ;
}

// 指定条件が、指定数より少ないかチェック.
validate_min = function( size,name,message,id,no ) {
    if( $base.isNull( size ) || $base.useString( name ) == false ||
        $base.useString( message ) == false ) {
        return false ;
    }
    size = parseInt( size ) ;
    if( $base.useString( id ) == false ) {
        id = name ;
    }
    var val = $$(id,no) ;
    if( $base.useString( val ) == false ) {
        validate_errorMessage( message,id,no ) ;
        return true ;
    }
    if( val.length < size ) {
        validate_errorMessage( message,id,no ) ;
        return true ;
    }
    return false ;
}

// 指定条件が、指定数より多いかチェック.
validate_max = function( size,name,message,id,no ) {
    if( $base.isNull( size ) || $base.useString( name ) == false ||
        $base.useString( message) == false ) {
        return false ;
    }
    size = parseInt( size ) ;
    if( $base.useString( id ) == false ) {
        id = name ;
    }
    var val = $$(id,no) ;
    if( $base.useString( val ) == false ) {
        validate_errorMessage( message,id,no ) ;
        return true ;
    }
    if( val.length > size ) {
        validate_errorMessage( message,id,no ) ;
        return true ;
    }
    return false ;
}

// 指定条件が、指定数より多い／少ないかチェック.
validate_minMax = function( min,max,name,message,id,no ) {
    if( $base.isNull( min ) || $base.isNull( max ) ||
        $base.useString( name ) == false ||
        $base.useString( message) == false ) {
        return false ;
    }
    min = parseInt( min ) ;
    max = parseInt( max ) ;
    if( min <= 0 ) {
        min = 0x7fffffff ;
    }
    if( max <= 0 ) {
        max = 0x7fffffff ;
    }
    if( $base.useString( id ) == false ) {
        id = name ;
    }
    var val = $$(id,no) ;
    if( $base.useString( val ) == false ) {
        validate_errorMessage( message,id,no ) ;
        return true ;
    }
    if( val.length < min || val.length > max ) {
        validate_errorMessage( message,id,no ) ;
        return true ;
    }
    return false ;
}

////////////////////////////////////////////////////////////////////////////////
// StringUtil.
////////////////////////////////////////////////////////////////////////////////

// 文字関連.
stringUtil = {
    // 指定内容の文字長を取得.
    length : function( s ) {
        var len ;
        if( typeof( s ) != "string" ||
            ( len = s.length ) <= 0 ) {
            return 0 ;
        }
        var cnt = 0 ;
        var hanKana = KANA2_ALL ;
        var c ;
        for( var i = 0 ; i < len ; i ++ ) {
            c = s.charCodeAt( i ) ;
            if( c > 255 ) {
                if( hanKana.indexOf( s[i] ) != -1 ) {
                    cnt ++ ;
                }
                else {
                    cnt += 2 ;
                }
            }
            else {
                cnt ++ ;
            }
        }
        return cnt ;
    },
    // 最後から、指定長の文字列を取得.
    lastToLength : function( s,length ) {
        var len ;
        if( typeof( s ) != "string" ||
            ( len = s.length ) <= 0 ) {
            return "" ;
        }
        var cnt = 0 ;
        var hanKana = KANA2_ALL ;
        var c ;
        var a ;
        var ret = "" ;
        for( var i = len-1 ; i >= 0 ; i -- ) {
            if( length <= cnt ) {
                break ;
            }
            c = s.charCodeAt( i ) ;
            a = s.charAt( i ) ;
            if( c > 255 ) {
                if( hanKana.indexOf( a ) != -1 ) {
                    cnt ++ ;
                }
                else {
                    cnt += 2 ;
                }
            }
            else {
                cnt ++ ;
            }
            ret = a + ret ;
        }
        return ret ;
    }
} ;

////////////////////////////////////////////////////////////////////////////////
// 漢字変換[socialIME].
////////////////////////////////////////////////////////////////////////////////
var socialIME = function( w,m,u ) {
    if( !$base.useString( w ) ) {
        return [] ;
    }
    if( m != true && m != "true" ) {
        m = false ;
    }
    else {
        m = true ;
    }
    if( !$base.useString( u ) ) {
        u = "" ;
    }
    var res = accessAjax(
        '/~seabass/etc/ime/socialImeAjax',{"word":w,"mode":m,"user":u}) ;
    if( $base.useString( res ) ) {
        var ret = [] ;
        var p = res.indexOf( ",",0 ) ;
        if( p == -1 ) {
            ret[0] = res ;
        }
        else {
            var b = 0 ;
            var c ;
            while( true ) {
                c = $base.trim( res.substring( b,p ) ) ;
                if( $base.useString( c ) ) {
                    c = $base.changeString( c,"\'","’" ) ;
                    c = $base.changeString( c,"\"","”" ) ;
                    c = $base.changeString( c,"(","（" ) ;
                    c = $base.changeString( c,")","）" ) ;
                    c = $base.changeString( c,"<","＜" ) ;
                    c = $base.changeString( c,">","＞" ) ;
                    ret[ret.length] = c ;
                }
                b = p+1 ;
                if( ( p = res.indexOf( ",",b ) ) == -1 ) {
                    c = $base.trim( res.substring( b ) ) ;
                    if( $base.useString( c ) ) {
                        c = $base.changeString( c,"\'","’" ) ;
                        c = $base.changeString( c,"\"","”" ) ;
                        c = $base.changeString( c,"(","（" ) ;
                        c = $base.changeString( c,")","）" ) ;
                        c = $base.changeString( c,"<","＜" ) ;
                        c = $base.changeString( c,">","＞" ) ;
                        ret[ret.length] = c ;
                    }
                    break ;
                }
            }
        }
        return ret ;
    }
    return [] ;
}

////////////////////////////////////////////////////////////////////////////////
// マウススクロール.
////////////////////////////////////////////////////////////////////////////////
Scroll = {
    noMoveMode: false,
    moveAdd : 1,
    firstMovePos : 12,
    moveFlag : false,
    befY : -1,
    // 初期処理.
    init : function() {
        // イベント登録.
        var bd = $base.getBody() ;
        $base.addEvent( bd,"mousedown",Scroll.mouseDown ) ;
        $base.addEvent( bd,"mouseup",Scroll.mouseUp ) ;
        $base.addEvent( bd,"selectstart",Scroll.selectStart ) ;
    },
    // 終了処理.
    destroy : function() {
        Scroll.moveFlag = false ;
        Scroll.befY = -1 ;
    },
    // マウスクリック.
    mouseDown : function( e ) {
        e = getEvent( e ) ;
        // マウスクリック時に、入力系アイテムを選択した状態の場合は、
        // スクロール処理は行わない.
        if( !$base.isNull( ( value = getActiveElement( e ) ) ) ) {
            var tagName = value.tagName.toLowerCase() ;
            if( tagName == "input" || tagName == "textarea" ||
                tagName == "select" ) {
                $base.removeEvent( $base.getBody(),"mousemove",Scroll.mouseMove ) ;
                Scroll.mouseUp( e ) ;
                return ;
            }
        }
        $base.addEvent( $base.getBody(),"mousemove",Scroll.mouseMove ) ;
        Scroll.befY = e.clientY ;
        Scroll.moveFlag = false ;
    },
    // マウスクリック解除.
    mouseUp : function( e ) {
        $base.removeEvent( $base.getBody(),"mousemove",Scroll.mouseMove ) ;
        Scroll.moveFlag = false ;
        Scroll.befY = -1 ;
        $base.getBody().style.cursor='default' ;
    },
    // マウス移動.
    mouseMove : function( e ) {
        clearSelect() ;
        e = getEvent( e ) ;
        var noAcc = false ;
        var y = e.clientY ;
        if( !Scroll.moveFlag ) {
            // マウスクリック後、一定以上の距離が動いた場合は、
            // 移動処理に切り替える.
            if( Scroll.befY >= 0 ) {
                var yy = y - Scroll.befY ;
                var yy = ( yy < 0 ) ? yy * -1 : yy ;
                if( yy > Scroll.firstMovePos ) {
                    Scroll.moveFlag = true ;
                    noAcc = true ;
                }
                else {
                    return ;
                }
            }
            else {
                return ;
            }
        }
        if( ( isMSIE && e.button != 1 ) ||
            y < 0 || y > height() ) {
            Scroll.mouseUp( e ) ;
            return ;
        }
        var sy = ( y - Scroll.befY ) * -1 ;
        Scroll.befY = y ;
        // POPUPウィンドウが表示されている場合は、処理しない.
        if( popup.isPopup() ) {
            return ;
        }
        // スクロールモードがONの場合は、スクロール処理.
        if( !Scroll.noMoveMode ) {
            if( !noAcc ) {
                sy = Scroll._$acc( sy ) ;
            }
            var yy = getScrollY() ;
            window.scrollTo( getScrollX(), sy + yy ) ;
            if( sy != 0 ) {
                if( yy + sy != sy + getScrollY() ) {
                    $base.getBody().style.cursor='pointer' ;
                }
                else {
                    $base.getBody().style.cursor='no-drop' ;
                }
            }
        }
    },
    // セレクト開始処理.
    selectStart : function( e ) {
        cencellEvent( e ) ;
        return false ;
    },
    // マウス加速度計算.
    _$acc : function( c ) {
        if( c == 0 ) {
            return 0 ;
        }
        var f = false ;
        if( c < 0 ) {
            f = true ;
            c = c * -1 ;
        }
        if( c >= 27 ) {
            c = c * 4.5 ;
        }
        else if( c >= 25 ) {
            c = c * 4 ;
        }
        else if( c >= 17 ) {
            c = c * 3.5 ;
        }
        else if( c >= 12 ) {
            c = c * 3 ;
        }
        else if( c >= 8 ) {
            c = c * 2.5 ;
        }
        else if( c >= 5 ) {
            c = c * 2 ;
        }
        else if( c >= 3 ) {
            c = c * 1.5 ;
        }
        if( f ) {
            c = c * -1 ;
        }
        return parseInt( c ) ;
    }
}

////////////////////////////////////////////////////////////////////////////////
// ポップアップWindow関連.
////////////////////////////////////////////////////////////////////////////////

// popupウインドウ.
popup = {
    _DEFAULT_GROUP:"_default",
    _MOVE_VIEW_WINDOW_TIMING:50,
    initFlagMap:{},
    seqId:0,
    target_url:null,
    wmap:{},
    create_window_name:{},
    beforeGroup:null,
    closeCallback:{},
    resultCallback:{},
    endViewCallback:{},
    moveMousePos:{},
    targetMouseMove : null,
    windowColor : null,
    title:{},
    // ポップアップウィンドウ表示初期処理.
    init : function( group ) {
        if( !$base.useString( group ) ) {
            group = popup._DEFAULT_GROUP ;
        }
        var b = $base.getBody() ;
        if( !$base.isNull( b ) ) {
            var pop = document.createElement("span");
            includeAttribute(pop, "id", "popup-" + group + "-window-seabassId");
            includeAttribute(pop, "class", "popup-window-seabass");
            var phead = document.createElement("div");
            includeAttribute(phead, "id", "popup-" + group + "-window-seabass-headId");
            includeAttribute(phead, "class", "popup-window-seabass-head");
            pop.appendChild( phead ) ;
            var pbody = document.createElement("div");
            includeAttribute(pbody, "id", "popup-" + group + "-window-seabass-bodyId");
            includeAttribute(pbody, "class", "popup-window-seabass-body");
            pop.appendChild( pbody ) ;
            setCssDefine( "popup-window-seabass",pop,{ display:"none"} ) ;
            pop.style.display = "none" ;
            // IE6の場合は、selectタグ対策として、iframeを追加.
            if( isMSIE6 ) {
                var iframe = document.createElement("iframe");
                includeAttribute( iframe, "id","popup-" + group + "-window-seabass-dummy-frameId" );
                if( $base.isSSL() ) {
                    // SSLの場合は、src要素が必須.
                    includeAttribute( iframe, "src","/@js/ref?ref=&mime=text/html" );
                }
                includeAttribute( iframe, "name", "popup-" + group + "-window-seabass-dummy-frame" );
                includeAttribute( iframe, "style","position:absolute; left:0px; top:0px; width:0px; height:0px; border: 0px; display:none;" );
                b.appendChild(iframe);
            }
            b.appendChild(pop);
            popup.initFlagMap[group] = true ;
        }
    },
    // ポップアップウィンドウ破棄処理.
    destroy : function( group ) {
        if( !$base.useString( group ) ) {
            group = popup._DEFAULT_GROUP ;
        }
        var em = document.getElementById( "popup-" + group + "-window-seabassId" ) ;
        if( !$base.isNull( em ) ) {
            var pa = em.parentNode ;
            if( !$base.isNull( pa ) ) {
                pa.removeChild( em ) ;
            }
        }
    },
    // ポップアップウィンドウクローズ.
    close : function( group ) {
        if( !$base.useString( group ) ) {
            group = popup._DEFAULT_GROUP ;
        }
        // クローズコールバック処理.
        if( !$base.isNull( popup.closeCallback[group] ) ) {
            var res = popup.closeCallback[group]() ;
            if( res == false ) {
                return false ;
            }
        }
        var name = popup.wmap[group] ;
        if( !$base.isNull( name ) ) {
            var em = document.getElementById( "popup-" + group + "-window-seabassId" ) ;
            if( !$base.isNull( em ) ) {
                if( isMSIE6 ) {
                    var iframe = document.getElementById( "popup-" + group + "-window-seabass-dummy-frameId" ) ;
                    includeAttribute( iframe, "style","position:absolute; left:0px; top:0px; width:0px; height:0px; border: 0px; display:none;" );
                }
                // ウィンドウ非表示.
                em.style.display="none" ;
                // フォーカスを再指定(IE6のみ).
                if( isMSIE6 ) {
                    window.blur() ;
                    window.focus() ;
                }
                // グループ名に対するスタイルシートと、Javascriptを削除.
                var scriptId = md5( group ) ;
                removeElement( "_js_" + scriptId + "__$_$_Id" ) ;
                removeElement( "_css_" + scriptId + "__$_$_Id" ) ;
                // 後処理.
                popup.closeCallback[group] = null ;
                popup.resultCallback[group] = null ;
                popup.endViewCallback[group] = null ;
                popup.wmap[group] = null ;
                popup.create_window_name[name] = false ;
                popup.moveMousePos[group] = null ;
                popup.targetMouseMove = null ;
            }
        }
    },
    // POPUPWindowが存在するかチェック.
    isPopup : function() {
        for( var k in popup.wmap ) {
            if( $base.useString( popup.wmap[ k ] ) ) {
                return true ;
            }
        }
        return false ;
    },
    // 現在POPUPWindowが存在する個数を取得.
    getPopupSize : function() {
        var ret = 0 ;
        for( var k in popup.wmap ) {
            if( $base.useString( popup.wmap[ k ] ) ) {
                ret ++ ;
            }
        }
        return ret ;
    },
    // 表示内容を直接指定してPopupWindowを表示.
    window : function( name,value,title,w,h,group,closeCallback,resultCallback,hmode,closeMode ) {
        if( !$base.useString( value ) ) {
            return ;
        }
        if( !$base.useString( group ) ) {
            group = popup._DEFAULT_GROUP ;
        }
        if( !$base.useString( title ) ) {
            title = "window" ;
        }
        var name = popup._newWindow( name+group,group ) ;
        if( !$base.isNull( name ) && popup._eqWindow( name,group ) ) {
            popup.view( name,value,title,w,h,group,closeCallback,resultCallback,hmode,closeMode ) ;
        }
    },
    // AjaxでPopupWindowを表示.
    ajax : function( url,params,title,w,h,group,closeCallback,resultCallback,hmode,closeMode ) {
        if( !$base.useString( url ) ) {
            return ;
        }
        if( !$base.useString( group ) ) {
            group = popup._DEFAULT_GROUP ;
        }
        if( !$base.useString( title ) ) {
            title = "window" ;
        }
        var name = popup._newWindow( url,group ) ;
        if( !$base.isNull( name ) && popup._eqWindow( name,group ) ) {
            var res = popup.nextAjax( null,url,params,group,true ) ;
            if( $base.isNull( res ) ) {
                return ;
            }
            popup.view( name,res[0],title,w,h,group,closeCallback,resultCallback,hmode,closeMode ) ;
            popup._accessAjaxToExecution( res,md5( group ) ) ;
        }
    },
    // POPUP画面内ページ内容切り替え等で、Ajaxを利用する場合に利用する.
    nextAjax : function( viewId,url,sendParams,group,mode ) {
        if( !$base.useString( url ) ) {
            return ;
        }
        if( !$base.useString( group ) ) {
            group = popup._DEFAULT_GROUP ;
        }
        if( mode == true || mode == "true" ) {
            mode = true ;
        }
        var s = accessAjax( url,sendParams ) ;
        if( typeof( s ) == "string" ) {
            var scriptId = md5( group ) ;
            if( $base.useString( viewId ) ) {
                var res = popup._accessAjaxToJs_by_result( s,scriptId,true ) ;
                fastInnerHTML( viewId,res[ 0 ] ) ;
                popup._accessAjaxToExecution( res,scriptId ) ;
            }
            else {
                return popup._accessAjaxToJs_by_result( s,scriptId,mode ) ;
            }
        }
        return null ;
    },
    // accessAjaxToJsの実行結果に対する処理.
    _accessAjaxToJs_by_result : function( s,scriptId,mode ) {
        var vs = convertResultByScript2View( s ) ;
        if( mode == true || mode == "true" ) {
            return vs ;
        }
        // javascript実行.
        popup._accessAjaxToExecution( vs,scriptId ) ;
        return vs[0] ;
    },
    // _accessAjaxToJs_by_resultのJavascript、StyleSheetを実行.
    _accessAjaxToExecution : function( vs,scriptId ) {
        // javascript実行.
        if( $base.useString( vs[1] ) ) {
            if( !$base.useString( scriptId ) ) {
                eval( vs[1] ) ;
            }
            else {
                innerJS( "_js_" + scriptId + "__$_$_Id",vs[ 1 ],null ) ;
            }
        }
        // スタイルシート実行.
        if( $base.useString( vs[2] ) ) {
            if( $base.useString( scriptId ) ) {
                innerCSS( "_css_" + scriptId + "__$_$_Id",vs[ 2 ],null ) ;
            }
        }
    },
    // width調整.
    _getWidth : function() {
        bw = width( true ) ;
        if( bw == width( false ) ) {
            if( isMSIE ) {
                bw = bw - 16 ;
            }
            else {
                bw = bw - 26 ;
            }
        }
        return bw ;
    },
    // height調整.
    _getHeight : function() {
        return height( false ) - ( width( false ) - popup._getWidth() ) ;
    },
    // 新しいWindowを生成時の処理.
    _newWindow : function( url,group ) {
        var name = md5( url ) ;
        if( popup.wmap[group] != name ) {
            popup.close( group ) ;
        }
        return name ;
    },
    // 同一Windowが存在する場合の処理.
    _eqWindow : function( name,group ) {
        // POPUP-Windowが既に存在し、対象GroupがActiveでない場合.
        if( popup.create_window_name[name] == true ) {
            // 選択Windowは非アクティブ状態.
            if( popup.beforeGroup != group ) {
                var bd = $base.getBody() ;
                if( !$base.isNull( bd ) ) {
                    var em = document.getElementById( "popup-" + group + "-window-seabassId" ) ;
                    popup.destroy( group ) ;
                    bd.appendChild( em ) ;
                    // アクティブ／非アクティブカラーの切り替え.
                    popup._activeNoActiveColor( group ) ;
                    em = null ;
                    popup.wmap[group] = name ;
                    popup.create_window_name[name] = true ;
                    popup.beforeGroup = group ;
                    return false ;
                }
            }
            // 選択Windowはアクティブ状態.
            else {
                popup.wmap[group] = name ;
                popup.create_window_name[name] = true ;
                return false ;
            }
        }
        return true ;
    },
    // アクティブ／非アクティブウィンドウの色分け処理.
    _activeNoActiveColor : function( group ) {
        if( $base.isNull( popup.windowColor ) || popup.windowColor.length <= 0 ) {
            return ;
        }
        //alert( "popup.windowColor[0]:" + popup.windowColor[0] + " popup.windowColor[1]:" + popup.windowColor[1] ) ;
        var em = document.getElementById( "popup-" + group + "-window-seabass-headId" ) ;
        em.style.backgroundColor = popup.windowColor[0] ;
        for( var k in popup.wmap ) {
            if( k != group && !$base.isNull( popup.wmap[k] ) ) {
                em = document.getElementById( "popup-" + k + "-window-seabass-headId" ) ;
                em.style.backgroundColor = popup.windowColor[1] ;
            }
        }
    },
    // ウィンドウ移動開始.
    _startMoveWindow : function( event,name,group ) {
        popup._eqWindow( name,group ) ;
        event = getEvent( event ) ;
        var pos = popup.moveMousePos[group] ;
        if( $base.isNull( pos ) ) {
            pos = [event.clientX,event.clientY,new Date().getTime()] ;
        }
        else {
            pos[0] = event.clientX ;
            pos[1] = event.clientY ;
        }
        popup.moveMousePos[group] = pos ;
        popup.targetMouseMove = group ;
        Scroll.mouseUp( event ) ;
        $base.getBody().style.cursor = "move" ;
        cencellEvent( event ) ;
        return false ;
    },
    // ウィンドウ移動停止処理.
    _stopMoveWindow : function( event ) {
        if( $base.isNull( popup.targetMouseMove ) ) {
            return true ;
        }
        var group = popup.targetMouseMove ;
        event = getEvent( event ) ;
        var pos = popup.moveMousePos[group] ;
        if( !$base.isNull( pos ) ) {
            pos[0] = -1 ;
            pos[1] = -1 ;
            pos[2] = -1 ;
            popup.moveMousePos[group] = pos ;
        }
        popup.targetMouseMove = null ;
        $base.getBody().style.cursor = "default" ;
        cencellEvent( event ) ;
        return false ;
    },
    // ウィンドウ移動処理.
    _moveWindow : function( event ) {
        if( $base.isNull( popup.targetMouseMove ) ) {
            return true ;
        }
        var group = popup.targetMouseMove ;
        event = getEvent( event ) ;
        var pos = popup.moveMousePos[group] ;
        if( $base.isNull( pos ) || pos[0] < 0 || pos[1] < 0 ) {
            cencellEvent( event ) ;
            return false ;
        }
        clearSelect() ;
        if( new Date().getTime() < pos[ 2 ] + popup._MOVE_VIEW_WINDOW_TIMING ) {
            cencellEvent( event ) ;
            return false ;
        }
        var x = event.clientX - pos[0] ;
        var y = event.clientY - pos[1] ;
        pos[0] = event.clientX ;
        pos[1] = event.clientY ;
        pos[2] = new Date().getTime() ;
        popup.moveMousePos[group] = pos ;
        var em = document.getElementById( "popup-" + group + "-window-seabassId" ) ;
        var px = em.style.left ;
        px = parseInt( px.substring( 0,px.length-2 ) ) ;
        var py = em.style.top ;
        py = parseInt( py.substring( 0,py.length-2 ) ) ;
        x = x + px ;
        y = y + py ;
        em.style.left = x+"px" ;
        em.style.top = y+"px" ;
        if( isMSIE6 ) {
            em = document.getElementById( "popup-" + group + "-window-seabass-dummy-frameId" ) ;
            em.style.left = x+"px" ;
            em.style.top = y+"px" ;
        }
        cencellEvent( event ) ;
        return false ;
    },
    // ポップアップ移動処理系のイベント登録.
    initEvent : function() {
        bodys = $base.getBody() ;
        $base.addEvent( bodys,"mouseup",popup._stopMoveWindow ) ;
        $base.addEvent( bodys,"mousemove",popup._moveWindow ) ;
    },
    // PopupWindowを表示.
    view : function( name,value,title,w,h,group,closeCallback,resultCallback,hmode,closeMode ) {
        if( !$base.useString( group ) ) {
            group = popup._DEFAULT_GROUP ;
        }
        if( popup.initFlagMap[group] != true ) {
            popup.init( group ) ;
        }
        else {
            popup.destroy( group ) ;
            popup.init( group ) ;
        }
        popup.beforeGroup = group ;
        if( !$base.useString( value ) ) {
            return ;
        }
        var bw = popup._getWidth() ;
        var bh = popup._getHeight() ;
        if( w == "max" ) {
            w = bw ;
        }
        else {
            // 表示座標を決める.
            if( $base.endsWith( w,"%" ) ) {
                w = parseInt( ( bw * parseInt( w.substring( 0,w.length-1 ) ) ) / 100 ) ;
            }
            else if( !$base.isNumeric( w ) || w <= 0 ) {
                w = parseInt( bw * 0.90 ) ;
            }
            else {
                w = parseInt( w ) ;
            }
        }
        if( h == "max" ) {
            h = bh ;
        }
        else {
            if( $base.endsWith( h,"%" ) ) {
                h = parseInt( ( bh * parseInt( h.substring( 0,h.length-1 ) ) ) / 100 ) ;
            }
            else if( !$base.isNumeric( h ) || h <= 0 ) {
                h = parseInt( bh * 0.90 ) ;
            }
            else {
                h = parseInt( h ) ;
            }
        }
        var lft = parseInt( ( ( bw / 2 ) - ( w / 2 ) ) ) ;
        var tp = parseInt( ( ( bh / 2 ) - ( h / 2 ) ) ) ;
        if( lft <= 0 ) {
            lft = 0 ;
        }
        if( tp <= 0 ) {
            tp = 0 ;
        }
        //if( ( lft + w ) > bw ) {
        //    w = bw - lft ;
        //}
        //if( ( tp + h ) > bh ) {
        //    h = bh - tp ;
        //}
        if( !$base.isNull( hmode ) && $base.isNumeric( hmode ) ) {
            hmode = parseInt( hmode ) ;
            if( hmode < 100 ) {
                var n = {
                    "filter":("alpha(opacity="+hmode+")"),
                    "-moz-opacity":("0."+hmode),
                    "opacity":("0."+hmode)
                } ;
                hmode = n ;
                n = null ;
            }
            else {
                hmode = null ;
            }
        }
        else {
            hmode = null ;
        }
        // Windowのボディーをセット.
        var em = document.getElementById( "popup-" + group + "-window-seabass-bodyId" ) ;
        if( !$base.isNull( hmode ) ) {
            setCssDefine( "popup-window-seabass-body",em,hmode ) ;
        }
        else {
            setCssDefine( "popup-window-seabass-body",em,{} ) ;
        }
        fastInnerHTML( em,value ) ;
        var pbuf = new StrBuf() ;
        pbuf.ad( "<span onmousedown='javascript:popup._startMoveWindow( event,\"" ).ad( name ).ad( "\",\"" ).ad( group ).ad( "\" ); return false;'>" ).
            ad( "<div class='popup-window-seabass-head-left' id='popup-" ).ad( group ).ad( "-window-seabass-head-leftId'" ).
            ad( ">&nbsp;" ).ad( title ).ad( "</div>" ).
            ad( "<div class='popup-window-seabass-head-right' id='popup-" ).ad( group ).ad( "-window-seabass-head-rightId'>" ).
                ad( "<input type='button' id='popup-" ).ad( group ).ad( "-window-seabass-buttonId' " ).
                ad( "class='popup-window-seabass-button' value='閉&nbsp;じ&nbsp;る'" ) ;
        if( closeMode == true || closeMode == "true" ) {
            pbuf.ad( " disabled " ) ;
        }
        pbuf.ad( " onmousedown='javascript:cencellEvent(event);return false;'" ).
            ad( " onmouseup=javascript:popup.close('" ).ad( group ).ad( "');>&nbsp;</div></span>" ).ts()
        // Windowのヘッダをセット.
        fastInnerHTML( "popup-" + group + "-window-seabass-headId",pbuf.ts() ) ;
        pbuf = null ;
        em = document.getElementById( "popup-" + group + "-window-seabass-headId" ) ;
        setCssDefine( "popup-window-seabass-head",em,{margin:"0px",width:w+"px",height:"32px","font-size":"14px"} ) ;
        em = document.getElementById( "popup-" + group + "-window-seabass-head-leftId" ) ;
        includeAttribute(em, "style",
            new StrBuf().ad( "padding-top:8px;" ).
                ad( "padding-left:15px;" ).
                ad( "text-align:left;" ).
                ad( "width:" ).ad( (w-165) ).ad( "px;" ).
                ad( "float:left;" ).ts() ) ;
        em = document.getElementById( "popup-" + group + "-window-seabass-head-rightId" ) ;
        includeAttribute(em, "style",
            new StrBuf().ad( "margin-left:" ).ad( (w-100) ).ad( "px;" ).
                ad( "padding-top:6px;" ).
                ad( "padding-right:10px;" ).
                ad( "text-align:right;" ).ts() ) ;
        // 移動イベント追加.
        em = document.getElementById( "popup-" + group + "-window-seabassId" ) ;
        // 計算した条件をポップアップウィンドウに割り当て.
        if( !$base.isNull( em ) ) {
            setCssDefine( "popup-window-seabass",em,{
                position:"absolute",
                left:(lft+getScrollX()) + "px",top:(tp+getScrollY()) + "px",
                width:w + "px",height:h + "px"
            } ) ;
            if( !$base.useString( em.style.display ) || em.style.display == "none" ) {
                // IE6の場合は、selectタグ対策として、iframeを再定義.
                if( isMSIE6 ) {
                    var iframe = document.getElementById( "popup-" + group + "-window-seabass-dummy-frameId" ) ;
                    includeAttribute( iframe, "style",
                        new StrBuf().ad( "position:absolute;left:" ).ad( (lft+getScrollX()) ).ad( "px;top:" ).ad( (tp+getScrollY()) ).ad( "px;" ).
                            ad( "width:" ).ad( w ).ad( "px; height:" ).ad( h ).ad( "px; border: 0px;" ).
                            ad( "filter:alpha(opacity=0);-moz-opacity:0;opacity:0;" ).ts() ) ;
                    iframe.style.display = "block" ;
                }
                em.style.display = "block" ;
            }
            // 閉じるボタンにフォーカスを当てることで、[popup.prohibitionOperation(true)]で
            // 配置した、非入力化条件より下になる問題を解決.
            // 2010/03/19 masahito suzuki.
            var btn = document.getElementById( "popup-" + group + "-window-seabass-buttonId" ) ;
            if( !$base.isNull( btn ) ) {
                btn.focus() ;
            }
            var pbody = document.getElementById( "popup-" + group + "-window-seabass-bodyId" ) ;
            includeAttribute(pbody, "style", "overflow:auto; width:" + w + "px; height:" + ( h - 32 ) + "px;");
        }
        // ウィンドウ名を登録.
        popup.wmap[group] = name ;
        popup.create_window_name[name] = true ;
        popup.title[group] = title ;
        if( !$base.isNull( closeCallback ) && typeof( closeCallback ) == "function" ) {
            var _popupCloseFunc = closeCallback ;
            popup.closeCallback[group] = function() {
                var res = _popupCloseFunc() ;
                if( res != false ) {
                    if( popup.getPopupSize() <= 1 ) {
                        popup.prohibitionOperation( true ) ;
                    }
                    return true ;
                }
                return false ;
            }
        }
        else {
            popup.closeCallback[group] = function() {
                if( popup.getPopupSize() <= 1 ) {
                    popup.prohibitionOperation( true ) ;
                }
                return true ;
            }
        }
        if( !$base.isNull( resultCallback ) && typeof( resultCallback ) == "function" ) {
            popup.resultCallback[group] = resultCallback ;
        }
        else {
            popup.resultCallback[group] = null ;
        }
        // スクロールをTOPに戻す.
        document.getElementById( "popup-" + group + "-window-seabass-bodyId" ).scrollTop = 0 ;
        // ウィンドウカラーが定義されていない場合は、スタイルシートから取得する.
        if( popup.windowColor == null ) {
            popup.windowColor = [] ;
            var color = getCssElement( "popup-window-seabass-head","background-color" ) ;
            if( !$base.isNull( color ) ) {
                color = cssColorByNumber( color ) ;
                popup.windowColor[0] = "#" + $base.convert10To16( color,6 ) ;
                popup.windowColor[1] = "#" + $base.convert10To16(
                    ( ( ( ( ( color & 0x00ff000000 ) >> 24 ) / 2 ) << 24 ) |
                    ( ( ( ( color & 0x0000ff0000 ) >> 16 ) / 2 ) << 16 ) |
                    ( ( ( ( color & 0x000000ff00 ) >> 8 ) / 2 ) << 8 ) |
                    ( ( color & 0x00000000ff ) / 2 ) ) ,6
                ) ;
            }
        }
        // アクティブ／非アクティブカラーの切り替え.
        popup._activeNoActiveColor( group ) ;
        // 表示完了後のコールバック実行.
        if( !$base.isNull( popup.endViewCallback[group] ) ) {
            popup.endViewCallback[group]() ;
            popup.endViewCallback[group] = null ;
        }
    },
    // ポップアップ展開後のコールバック設定.
    setEndPopupCallback : function( func,group ) {
        if( !$base.useString( group ) ) {
            group = popup._DEFAULT_GROUP ;
        }
        popup.endViewCallback[group] = func ;
    },
    // ポップアップ利用完了後のコールバック設定.
    setSuccessPopupCallback : function( func,group ) {
        if( !$base.useString( group ) ) {
            group = popup._DEFAULT_GROUP ;
        }
        popup.resultCallback[group] = func ;
    },
    // ポップアップ利用完了後のコールバック.
    successCallback : function( res,group ) {
        if( !$base.useString( group ) ) {
            group = popup._DEFAULT_GROUP ;
        }
        if( !$base.isNull( popup.resultCallback[group] ) ) {
            popup.resultCallback[group]( res ) ;
        }
    },
    // ウィンドウタイトルを取得.
    getWindowTitle : function( group ) {
        if( !$base.useString( group ) ) {
            group = popup._DEFAULT_GROUP ;
        }
        return popup.title[group] ;
    },
    // ウィンドウタイトルを設定.
    setWindowTitle : function( newTitle,group ) {
        if( !$base.useString( newTitle ) ) {
            return ;
        }
        if( !$base.useString( group ) ) {
            group = popup._DEFAULT_GROUP ;
        }
        var em = document.getElementById( "popup-" + group + "-window-seabass-head-leftId" ) ;
        if( !$base.isNull( em ) ) {
            fastInnerHTML( em,"&nbsp;" + newTitle ) ;
            popup.title[group] = newTitle ;
        }
    },
    // body条件を置き換える.
    changeBody : function( group,value ) {
        if( !$base.useString( value ) ) {
            return ;
        }
        if( !$base.useString( group ) ) {
            group = popup._DEFAULT_GROUP ;
        }
        var em = document.getElementById( "popup-" + group + "-window-seabass-bodyId" ) ;
        if( !$base.isNull( em ) ) {
            fastInnerHTML( em,value ) ;
        }
    },
    // 画面操作禁止条件が存在するかチェック.
    isProhibitionOperation : function() {
        return !$base.isNull( document.getElementById( "viewOperation_seabass-dummy_Id" ) ) ;
    },
    // 画面操作禁止処理.
    // cancelMode=false : 画面操作禁止処理.
    // cancelMode=true : 画面操作キャンセル処理.
    prohibitionOperation : function( cancelMode,color,op ) {
        var em = document.getElementById( "viewOperation_seabass-dummy_Id" ) ;
        if( !$base.isNull( em ) ) {
            em.parentNode.removeChild( em ) ;
            if( isMSIE6 ) {
                var iem = document.getElementById( "viewOperation_seabass-dummy-frame_Id" ) ;
                if( !$base.isNull( iem ) ) {
                    iem.parentNode.removeChild( iem ) ;
                }
            }
        }
        if( cancelMode != true ) {
            var b = $base.getBody() ;
            if( !$base.isNull( b ) ) {
                color = ( $base.isNull( color ) ) ? "#1f1f1f" : color ;
                op = ( !$base.isNumeric( op ) ) ? 50 : op ;
                if( isMSIE6 ) {
                    var iframeTag = document.createElement("iframe");
                    includeAttribute( iframeTag, "id","viewOperation_seabass-dummy-frame_Id" );
                    includeAttribute( iframeTag, "name", "viewOperation_seabass-dummy-frame" );
                    includeAttribute( iframeTag, "frameborder", "0" );
                    includeAttribute( iframeTag, "allowtransparency", "true" );
                    if( $base.isSSL() ) {
                        // SSLの場合は、src要素が必須.
                        includeAttribute( iframe, "src","/@js/ref?ref=&mime=text/html" );
                    }
                    includeAttribute( iframeTag, "style",new StrBuf().ad( "position:absolute; left:0px; top:0px; width:" ).
                            ad( width( true ) ).ad( "px; height:" ).ad( height( false ) ).ad( "px; border: 0px; display:block;" ).
                            ad( "filter:alpha(opacity=0);-moz-opacity:0;opacity:0;" ).ts() ) ;
                    b.appendChild(iframeTag);
                }
                var divTag = document.createElement("div");
                includeAttribute( divTag, "id","viewOperation_seabass-dummy_Id" );
                includeAttribute( divTag, "name", "viewOperation_seabass-dummy" );
                includeAttribute( divTag, "style",new StrBuf().ad( "position:absolute; left:0px; top:0px; width:" ).
                    ad( maxWidth() ).ad( "px; height:" ).ad( maxHeight() ).ad( "px; border: 0px; display:block;" ).
                    ad( "background-color:" ).ad( color ).ad( ";filter:alpha(opacity=" ).ad( op ).
                    ad( ");-moz-opacity:" ).ad( (op*0.01) ).ad( ";opacity:" ).ad( (op*0.01) ).ad( ";" ).ts() ) ;
                b.appendChild(divTag);
            }
        }
    }
}

// タッチパネル用数値入力POPUP画面を生成.
TouchPanel = {
    _BUTTON_EVENT:"onmouseup",
    group : "touchpanel_group",
    maxLength : 32,
    viewMaxLength : 32,
    imeMaxLength : 16,
    imeMaxButton : 10,
    inputValue : "",
    _imeMode : false,
    _imeView : "",
    _imeToElement : null,
    _imeToOffset : 0,
    _imeToList : null,
    _hInfo:85,
    //_hInfo:null,
    // 初期化処理.
    init : function( group,maxLength,viewMaxLength ) {
        if( !$base.useString( group ) ) {
            this.group = group ;
        }
        if( $base.isNumeric( maxLength ) ) {
            this.maxLength = maxLength ;
        }
        if( $base.isNumeric( viewMaxLength ) ) {
            this.viewMaxLength = viewMaxLength ;
        }
    },
    // 入力内容表示用.
    _$inputView : function() {
        return "<div class='touchpanel_input_view' id='_$touchpanel_input_viewId'></div>" ;
    },
    // 数値キー.
    _shiftKeyFlag : false,
    _$inKey : function( c,sz ) {
        if( TouchPanel._imeMode ) {
            return ;
        }
        var out = TouchPanel.inputValue ;
        if( c == "shift" ) {
            TouchPanel._shiftKeyFlag = !TouchPanel._shiftKeyFlag ;
            var title = popup.getWindowTitle( TouchPanel.group ) ;
            if( $base.endsWith( title,"]" ) ) {
                title = title.substring( 0,title.length-3 ) ;
            }
            if( TouchPanel._shiftKeyFlag ) {
                popup.setWindowTitle( title+"[大]",TouchPanel.group ) ;
            }
            else {
                popup.setWindowTitle( title,TouchPanel.group ) ;
            }
            return ;
        }
        if( TouchPanel._shiftKeyFlag ) {
            c = c.toUpperCase() ;
        }
        var em = document.getElementById( "_$touchpanel_input_viewId" ) ;
        var len = out.length ;
        if( len >= sz ) {
            return ;
        }
        if( len+c.length >= sz ) {
            if( c.length == 2 && c.charAt(0) == '/' ) {
                out += c.charAt(1) ;
                this._$append( out ) ;
                return ;
            }
            c = c.substring( 0,c.length-((len+c.length)-sz) ) ;
        }
        if( c.length == 2 && c.charAt(0) == '/' ) {
            out += c.charAt(1) ;
            this._$append( out ) ;
            return ;
        }
        else if( c == '＝' ) {
            out += '=' ;
            this._$append( out ) ;
            return ;
        }
        if( c.charAt(0) == '0' ) {
            if( len <= 0 ) {
                //out = '0.' ;
                out = "0" ;
            }
            else if( len == 1 && out.charAt(0) == '-' ) {
                //out = '-0.' ;
                out = "-0" ;
            }
            else {
                out += c ;
            }
            this._$append( out ) ;
            return ;
        }
        else if( c == '.' ) {
            if( len <= 0 ) {
                //out = "0." ;
                out = "0" ;
            }
            else if( len == 1 && out.charAt(0) == '-' ) {
                //out = "-0." ;
                out = "-0" ;
            }
            else if( out.indexOf( "." ) == -1 ) {
                out += "." ;
            }
            this._$append( out ) ;
        }
        else if( c == '+' || c == '-' ) {
            if( len == 0 ) {
                if( c == '+' ) {
                    return ;
                }
                out = c ;
                this._$append( out ) ;
            }
            else {
                if( $base.startsWith( out,"-" ) ) {
                    if( c == '+' ) {
                        out = out.substring( 1 ) ;
                        this._$append( out ) ;
                    }
                }
                else if( c == '-' ) {
                    if( $base.startsWith( out,"-" ) ) {
                        out = "-" + c + out.substring( 1 ) ;
                    }
                    else {
                        out = c + out ;
                    }
                    this._$append( out ) ;
                }
            }
        }
        else {
            if( len == 0 ) {
                out = c ;
            }
            else {
                out = out + c ;
            }
            this._$append( out ) ;
        }
    },
    // カナ文字入力用処理.
    _dactenKana : false,
    _hdactenKana : false,
    _childKana : false,
    _$inKeyKana : function( c,sz ) {
        var spKey = false ;
        var title = popup.getWindowTitle( TouchPanel.group ) ;
        // 濁点処理.
        if( c == "d." ) {
            if( this._dactenKana ) {
                this._dactenKana = false ;
            }
            else {
                this._dactenKana = true ;
            }
            this._hdactenKana = false ;
            this._childKana = false ;
            spKey = true ;
        }
        // 半濁点処理.
        else if( c == "h." ) {
            if( this._hdactenKana ) {
                this._hdactenKana = false ;
            }
            else {
                this._hdactenKana = true ;
            }
            this._dactenKana = false ;
            this._childKana = false ;
            spKey = true ;
        }
        // 小文字.
        else if( c == "c." ) {
            if( this._childKana ) {
                this._childKana = false ;
            }
            else {
                this._childKana = true ;
            }
            this._dactenKana = false ;
            this._hdactenKana = false ;
            spKey = true ;
        }
        // 濁点・半濁点・小文字ボタンが押された場合.
        if( spKey ) {
            if( $base.endsWith( title,"]" ) ) {
                title = title.substring( 0,title.length-3 ) ;
            }
            var addTitle = "" ;
            if( this._dactenKana ) {
                addTitle = "[゛]" ;
            }
            else if( this._hdactenKana ) {
                addTitle = "[゜]" ;
            }
            else if( this._childKana ) {
                addTitle = "[小]" ;
            }
            else {
                popup.setWindowTitle( title,TouchPanel.group ) ;
                return ;
            }
            popup.setWindowTitle( title + addTitle,TouchPanel.group ) ;
            return ;
        }
        if( this._dactenKana ) {
            switch( c ) {
                case 'か' : c = "が" ; break ;case 'き' : c = "ぎ" ; break ;case 'く' : c = "ぐ" ; break ;
                case 'け' : c = "げ" ; break ;case 'こ' : c = "ご" ; break ;case 'さ' : c = "ざ" ; break ;
                case 'し' : c = "じ" ; break ;case 'す' : c = "ず" ; break ;case 'せ' : c = "ぜ" ; break ;
                case 'そ' : c = "ぞ" ; break ;case 'た' : c = "だ" ; break ;case 'ち' : c = "ぢ" ; break ;
                case 'つ' : c = "づ" ; break ;case 'て' : c = "で" ; break ;case 'と' : c = "ど" ; break ;
                case 'は' : c = "ば" ; break ;case 'ひ' : c = "び" ; break ;case 'ふ' : c = "ぶ" ; break ;
                case 'へ' : c = "べ" ; break ;case 'ほ' : c = "ぼ" ; break ;
                case 'カ' : c = "ガ" ; break ;case 'キ' : c = "ギ" ; break ;case 'ク' : c = "ぐ" ; break ;
                case 'ケ' : c = "ゲ" ; break ;case 'コ' : c = "ゴ" ; break ;case 'サ' : c = "ザ" ; break ;
                case 'シ' : c = "ジ" ; break ;case 'ス' : c = "ズ" ; break ;case 'セ' : c = "ゼ" ; break ;
                case 'ソ' : c = "ゾ" ; break ;case 'タ' : c = "ダ" ; break ;case 'チ' : c = "ヂ" ; break ;
                case 'ツ' : c = "ヅ" ; break ;case 'テ' : c = "デ" ; break ;case 'ト' : c = "ド" ; break ;
                case 'ハ' : c = "バ" ; break ;case 'ヒ' : c = "ビ" ; break ;case 'フ' : c = "ブ" ; break ;
                case 'ヘ' : c = "ベ" ; break ;case 'ホ' : c = "ボ" ; break ;case 'ウ' : c = "ヴ" ; break ;
                default :return ;
            }
        }
        else if( this._hdactenKana ) {
            switch( c ) {
                case 'は' : c = "ぱ" ; break ;case 'ひ' : c = "ぴ" ; break ;case 'ふ' : c = "ぷ" ; break ;
                case 'へ' : c = "ぺ" ; break ;case 'ほ' : c = "ぽ" ; break ;
                case 'ハ' : c = "パ" ; break ;case 'ヒ' : c = "ピ" ; break ;case 'フ' : c = "プ" ; break ;
                case 'ヘ' : c = "ペ" ; break ;case 'ホ' : c = "ポ" ; break ;
                default :return ;
            }
        }
        else if( this._childKana ) {
            switch( c ) {
                case 'あ' : c = "ぁ" ; break ;case 'い' : c = "ぃ" ; break ;case 'う' : c = "ぅ" ; break ;
                case 'え' : c = "ぇ" ; break ;case 'お' : c = "ぉ" ; break ;case 'や' : c = "ゃ" ; break ;
                case 'ゆ' : c = "ゅ" ; break ;case 'よ' : c = "ょ" ; break ;case 'つ' : c = "っ" ; break ;
                case 'ア' : c = "ァ" ; break ;case 'イ' : c = "ィ" ; break ;case 'ウ' : c = "ゥ" ; break ;
                case 'エ' : c = "ェ" ; break ;case 'オ' : c = "ォ" ; break ;case 'ヤ' : c = "ャ" ; break ;
                case 'ユ' : c = "ュ" ; break ;case 'ヨ' : c = "ョ" ; break ;case 'ツ' : c = "ッ" ; break ;
                default :return ;
            }
        }
        if( $base.endsWith( title,"]" ) ) {
            title = title.substring( 0,title.length-3 ) ;
            popup.setWindowTitle( title,TouchPanel.group ) ;
        }
        if( TouchPanel._imeMode ) {
            if( TouchPanel._imeView.length+1 <= TouchPanel.imeMaxLength ) {
                TouchPanel._imeView += c ;
            }
            TouchPanel._$viewInputIME( false ) ;
        }
        else {
            var out = TouchPanel.inputValue ;
            out = out + c ;
            this._$append( out ) ;
        }
        this._dactenKana = false ;
        this._hdactenKana = false ;
        this._childKana = false ;
    },
    // backspaceキー.
    _$bsKey : function() {
        if( TouchPanel._imeMode ) {
            var out = TouchPanel._imeView ;
            var len = out.length ;
            if( len <= 1 ) {
                out = "" ;
            }
            else {
                out = out.substring( 0,len-1 ) ;
            }
            TouchPanel._imeView = out ;
            TouchPanel._$viewInputIME( false ) ;
        }
        else {
            var out = TouchPanel.inputValue ;
            var len = out.length ;
            if( len <= 1 ) {
                out = "" ;
            }
            else {
                out = out.substring( 0,len-1 ) ;
            }
            this._$append( out ) ;
        }
    },
    // クリアキー.
    _$csKey : function() {
        if( TouchPanel._imeMode ) {
            TouchPanel._imeView = "" ;
            TouchPanel._$viewInputIME( false ) ;
        }
        else {
            this._$append( "" ) ;
            if( TouchPanel._shiftKeyFlag ) {
                TouchPanel._$inKey( null,"shift",-1 ) ;
            }
        }
    },
    // 確定キー.
    _$result : function( cname ) {
        var out = TouchPanel.inputValue ;
        if( $base.useString( cname ) ) {
            if( $base.startsWith( out,"-" ) && out.length == 1 ) {
                out[0] = "0" ;
            }
            else if( $base.endsWith( out,"." ) ) {
                out += "0" ;
            }
            TouchPanel._$append( out ) ;
            out = $base.changeString( out,"_"," " ) ;
            var em = $(cname) ;
            if( $base.isNull( em ) ) {
                popup.close( TouchPanel.group ) ;
            }
            em.value = out ;
            // フォーカスを再割り当てして、クリア.
            em.focus() ;
            em.blur() ;
            popup.close( TouchPanel.group ) ;
        }
    },
    // データ反映.
    _befView : null,
    _$append : function( val ) {
        var em = document.getElementById( "_$touchpanel_input_viewId" ) ;
        if( $base.isNull( em ) ) {
            return ;
        }
        if( !$base.useString( val ) ) {
            val = "" ;
        }
        if( TouchPanel._befView == val ) {
            return ;
        }
        TouchPanel._befView = val ;
        TouchPanel.inputValue = val ;
        var viewValue ;
        if( val.length > 0 ) {
            viewValue = "<span class='touchpanel_input_count_view'>("+("00".substring( (""+(val.length)).length )+val.length)+")</span>" +
                stringUtil.lastToLength( val,TouchPanel.viewMaxLength ) ;
        }
        else {
            viewValue = "　"
        }
        fastInnerHTML( em,viewValue ) ;
    },
    // ウィンドウクローズ後のコールバック.
    _$callback_close : function() {
        TouchPanel._befView = null ;
        TouchPanel.inputValue = "" ;
        TouchPanel._shiftKeyFlag = false ;
        TouchPanel._dactenKana = false ;
        TouchPanel._hdactenKana = false ;
        TouchPanel._childKana = false ;
        TouchPanel._imeMode = false ;
        TouchPanel._imeView = "" ;
        TouchPanel._imeToElement = null ;
        TouchPanel._imeToOffset = 0 ;
        TouchPanel._imeToList = null ;
    },
    // 入力キー設定.
    _$outputInKey : function( clazz,evt,length,lst ) {
        var len = lst.length ;
        var res = "" ;
        for( var i = 0 ; i < len ; i += 2 ) {
            res += "<input type=button class='"+clazz+"' value='"+lst[i]+"' " +
                evt+"=javascript:TouchPanel._$inKey('"+lst[i+1]+"',"+length+"); >" ;
        }
        return res ;
    },
    // 入力キー(カナ系)設定.
    _$outputInKeyKana : function( clazz,evt,length,lst ) {
        var len = lst.length ;
        var res = "" ;
        for( var i = 0 ; i < len ; i += 2 ) {
            res += "<input type=button class='"+clazz+"' value='"+lst[i]+"' " +
                evt+"=javascript:TouchPanel._$inKeyKana('"+lst[i+1]+"',"+length+"); >" ;
        }
        return res ;
    },
    // 特殊キーを設定.
    _$specialKey : function( evt,cname ) {
        return new StrBuf().ad( "<input type=button class='touchpanel_special_input_button' value='clear' " ).ad( evt ).
            ad( "=javascript:TouchPanel._$csKey(); >" ).
            ad( "<input type=button class='touchpanel_special_input_button' value='ＢＳ' " ).ad( evt ).
            ad( "=javascript:TouchPanel._$bsKey(); >" ).
            ad( "<input type=button class='touchpanel_special_input_button' value='確定' " ).ad( evt ).
            ad( "=javascript:TouchPanel._$result('" ).ad( cname ).ad( "'); >" ).ts() ;
    },
    // 利用上意味を成さないキーを設定.
    _$nonKey : function( clazz,len ) {
        var res = new StrBuf() ;
        for( var i = 0 ; i < len ; i ++ ) {
            res.ad( "<input type=button class='" ).ad( clazz ).ad( "' value=' '>" ) ;
        }
        return res.ts() ;
    },
    // ウィンドウ初期化共通処理.
    _$initWindow : function( cname ) {
        if( $base.useString( cname ) ) {
            TouchPanel.inputValue = $(cname).value ;
        }
        else {
            TouchPanel.inputValue = "" ;
        }
        TouchPanel._befView = null ;
        if( TouchPanel.inputValue.length > 0 ) {
            TouchPanel.inputValue = $base.changeString( TouchPanel.inputValue," ","_" ) ;
            TouchPanel._$append( TouchPanel.inputValue ) ;
        }
        else {
            TouchPanel._$append( "" ) ;
        }
    },
    // ウィンドウ内容チェンジ.
    _$changeWindow : function( em,cname,length ) {
        popup.setWindowTitle( em.title,this.group ) ;
        popup.changeBody( this.group,em.value( cname,length ) ) ;
        TouchPanel._shiftKeyFlag = false ;
        TouchPanel._befView = null ;
        TouchPanel._$append( TouchPanel.inputValue ) ;
    },
    // IME開始/終了.
    _$startIME : function( noEndFlag ) {
        if( noEndFlag == false ) {
            TouchPanel._imeMode = false ;
        }
        else {
            TouchPanel._imeMode = !TouchPanel._imeMode ;
        }
        TouchPanel._imeView = "" ;
        TouchPanel._imeToOffset = 0 ;
        TouchPanel._imeToList = null ;
        if( !TouchPanel._imeMode ) {
            this._$viewInputIME( true ) ;
        }
        else {
            this._$viewInputIME( false ) ;
        }
    },
    // IME入力内容をタイトル表示.
    _$viewInputIME : function( clearMode ) {
        var title = popup.getWindowTitle( TouchPanel.group ) ;
        var mode = "" ;
        if( $base.endsWith( title,"]" ) ) {
            mode = title.substring( title.length-3,title.length ) ;
            title = title.substring( 0,title.length-3 ) ;
        }
        if( $base.endsWith( title,")" ) ) {
            title = title.substring( 0,title.lastIndexOf( "(" ) ) ;
        }
        if( clearMode != true ) {
            title = title + "(変換:<span class='touchpanel_input_ime_view'>" + TouchPanel._imeView + "</span>)" + mode ;
        }
        else {
            title = title + mode ;
        }
        popup.setWindowTitle( title,TouchPanel.group ) ;
    },
    // IME変換処理.
    _$convertIME : function() {
        if( !TouchPanel._imeMode || TouchPanel._imeToElement == null ||
            TouchPanel.inputValue.length >= TouchPanel._imeToElement[2] ||
            !$base.useString( TouchPanel._imeView ) ) {
            return false ;
        }
        TouchPanel._imeToList = socialIME( TouchPanel._imeView,false ) ;
        TouchPanel._$convertIME_View() ;
        return true ;
    },
    // IME変換候補選択.
    _$convertIME_View : function() {
        if( !TouchPanel._imeMode ) {
            return ;
        }
        if( TouchPanel._imeToOffset <= 0 ) {
            TouchPanel._imeToOffset = 0 ;
        }
        var maxLen = TouchPanel._imeToList.length ;
        var off = TouchPanel._imeToOffset ;
        var len = TouchPanel.imeMaxButton ;
        var buf = new StrBuf() ;
        if( off <= 0 ) {
            buf.ad( "<input type=button class=touchpanel_special_input_button value='last' " ).
                ad( TouchPanel._BUTTON_EVENT ).ad( "=javascript:TouchPanel._$lastIME(); >" ) ;
        }
        else {
            buf.ad( "<input type=button class=touchpanel_special_input_button value='←' " ).
                ad( TouchPanel._BUTTON_EVENT ).ad( "=javascript:TouchPanel._$beforeIME(); >" ) ;
        }
        if( maxLen <= off + len ) {
            buf.ad( "<input type=button class=touchpanel_special_input_button value='start' " ).
                ad( TouchPanel._BUTTON_EVENT ).ad( "=javascript:TouchPanel._$firstIME(); >" ) ;
        }
        else {
            buf.ad( "<input type=button class=touchpanel_special_input_button value='→' " ).
                ad( TouchPanel._BUTTON_EVENT ).ad( "=javascript:TouchPanel._$nextIME(); >" ) ;
        }
        buf.ad( TouchPanel._$nonKey( "touchpanel_special_input_button",6 ) ).
            ad( "<input type=button class=touchpanel_special_input_button value='exit' " ).
            ad( TouchPanel._BUTTON_EVENT ).ad( "=javascript:TouchPanel._$cancelIME(true); >" ).
            ad( "<input type=button class=touchpanel_special_input_button value='cancel' " ).
            ad( TouchPanel._BUTTON_EVENT ).ad( "=javascript:TouchPanel._$cancelIME(false); >" ) ;
        
        if( maxLen <= 0 ) {
            buf.ad( "<input type=button class='touchpanel_ime_input_button' value='" ).ad( TouchPanel._imeView ).ad( "' " ).
                ad( TouchPanel._BUTTON_EVENT ).ad( "=javascript:TouchPanel._$resultIME('" ).ad( TouchPanel._imeView ).ad( "'); >" ) ;
        }
        for( var i = 0 ; i < len ; i ++ ) {
            if( maxLen <= off + i ) {
                break ;
            }
            buf.ad( "<input type=button class='touchpanel_ime_input_button' value='" ).ad( "(" ).ad( (off+i+1) ).
                ad( ")" ).ad( TouchPanel._imeToList[off+i] ).ad( "' " ).
                ad( TouchPanel._BUTTON_EVENT ).ad( "=javascript:TouchPanel._$resultIME('" ).
                ad( TouchPanel._imeToList[off+i] ).ad( "'); >" ) ;
        }
        fastInnerHTML( "_$touchpanel_input_buttons_viewId",buf.ts() ) ;
    },
    // IME-最初の候補を表示.
    _$firstIME : function() {
        TouchPanel._imeToOffset = 0 ;
        TouchPanel._$convertIME_View() ;
    },
    // IME-最後の候補を表示.
    _$lastIME : function() {
        TouchPanel._imeToOffset = TouchPanel._imeToList.length - TouchPanel.imeMaxButton ;
        TouchPanel._$convertIME_View() ;
    },
    // IME-次の候補を表示.
    _$nextIME : function() {
        TouchPanel._imeToOffset += TouchPanel.imeMaxButton ;
        TouchPanel._$convertIME_View() ;
    },
    // IME前の候補を表示.
    _$beforeIME : function() {
        TouchPanel._imeToOffset -= TouchPanel.imeMaxButton ;
        TouchPanel._$convertIME_View() ;
    },
    // IME-キャンセル.
    _$cancelIME : function( mode ) {
        if( mode == true ) {
            mode = true ;
        }
        var r = TouchPanel._imeToElement ;
        var v = TouchPanel._imeView ;
        TouchPanel._imeToElement = null ;
        TouchPanel._imeToOffset = 0 ;
        TouchPanel._imeToList = null ;
        TouchPanel._$changeWindow( r[0],r[1],r[2] ) ;
        if( mode != true ) {
            TouchPanel._imeView = v ;
            TouchPanel._imeMode = true ;
            TouchPanel._$viewInputIME() ;
        }
    },
    // IME-確定.
    _$resultIME : function( val ) {
        len = TouchPanel._imeToElement[3] ;
        if( TouchPanel.inputValue.length + val.length > len ) {
            val = val.substring( 0,( len - TouchPanel.inputValue.length ) ) ;
        }
        TouchPanel.inputValue += val ;
        var r = TouchPanel._imeToElement ;
        TouchPanel._imeView = "" ;
        TouchPanel._imeMode = false ;
        TouchPanel._imeToElement = null ;
        TouchPanel._imeToOffset = 0 ;
        TouchPanel._imeToList = null ;
        TouchPanel._$changeWindow( r[0],r[1],r[2] ) ;
    },
    // 数値用タッチパネル入力用POPUP.
    number : {
        width : 450,
        height : 520,
        title : "数値入力",
        // タッチパネル用数値ポップアップウィンドウ初期化.
        init : function( t,w,h ) {
            if( $base.useString( t ) ) {
                this.title = t ;
            }
            if( $base.isNumeric( w ) ) {
                this.width = w ;
            }
            if( $base.isNumeric( h ) ) {
                this.height = h ;
            }
        },
        // タッチパネル用表示データ.
        value : function( cname,length ) {
            TouchPanel._$startIME( false ) ;
            return new StrBuf().ad( TouchPanel._$inputView() ).
                ad( "<div id='_$touchpanel_input_buttons_viewId' class='touchpanel_input_buttons_view'>&nbsp;" ).
                ad( TouchPanel._$nonKey( "touchpanel_special_input_button",3 ) ).
                ad( TouchPanel._$specialKey( TouchPanel._BUTTON_EVENT,cname ) ).
                ad( "<br>&nbsp;" ).
                ad( TouchPanel._$outputInKey( "touchpanel_number_input_button",TouchPanel._BUTTON_EVENT,
                    length,["．",".","－","-","＋","+"] ) ).
                ad( "<br>&nbsp;" ).
                ad( TouchPanel._$outputInKey( "touchpanel_number_input_button",TouchPanel._BUTTON_EVENT,
                    length,["１","1","２","2","３","3"] ) ).
                ad( "<br>&nbsp;" ).
                ad( TouchPanel._$outputInKey( "touchpanel_number_input_button",TouchPanel._BUTTON_EVENT,
                    length,["４","4","５","5","６","6"] ) ).
                ad( "<br>&nbsp;" ).
                ad( TouchPanel._$outputInKey( "touchpanel_number_input_button",TouchPanel._BUTTON_EVENT,
                    length,["７","7","８","8","９","9"] ) ).
                ad( "<br>&nbsp;" ).
                ad( TouchPanel._$outputInKey( "touchpanel_number_input_button",TouchPanel._BUTTON_EVENT,
                    length,["０","0","00","00","000","000"] ) ).
                ad( "</div>" ).ts() ;
        },
        // タッチパネル用数値ポップアップウィンドウ表示.
        window : function( cname,length ) {
            if( !$base.isNumeric( length ) ) {
                length = TouchPanel.maxLength ;
            }
            popup.window( "TouchPanel.number."+cname,this.value( cname,length ),
                this.title,this.width,this.height,TouchPanel.group,TouchPanel._$callback_close,null,TouchPanel._hInfo ) ;
            TouchPanel._$initWindow( cname ) ;
        }
    },
    // 英数系.
    alpha : {
        width : 740,
        height : 445,
        title : "英数入力",
        // タッチパネル用キーボードポップアップウィンドウ初期化.
        init : function( t,w,h ) {
            if( $base.useString( t ) ) {
                this.title = t ;
            }
            if( $base.isNumeric( w ) ) {
                this.width = w ;
            }
            if( $base.isNumeric( h ) ) {
                this.height = h ;
            }
        },
        // 特殊キー「英数用」を設定.
        specialKeyByAlpha : function( evt,cname,length ) {
            return new StrBuf().ad( "<input type=button class='touchpanel_special_input_button' value='仮名' " ).ad( evt ).
                ad( "=javascript:TouchPanel._$changeWindow(TouchPanel.hiraKana,'" ).ad( cname ).ad( "'," ).ad( length ).ad( "); >" ).
                ad( TouchPanel._$nonKey( "touchpanel_special_input_button",4 ) ).
                ad( "<input type=button class='touchpanel_special_input_button' value='space' " ).ad( evt ).
                ad( "=javascript:TouchPanel._$inKey('_'," ).ad( length ).ad( "); >" ).
                ad( "<input type=button class='touchpanel_special_input_button' value='大小' " ).ad( evt ).
                ad( "=javascript:TouchPanel._$inKey('shift',-1); >" ).ts() ;
        },
        // タッチパネル用表示データ.
        value : function( cname,length ) {
            TouchPanel._$startIME( false ) ;
            return new StrBuf().ad( TouchPanel._$inputView() ).
                ad( "<div id='_$touchpanel_input_buttons_viewId' class='touchpanel_input_buttons_view'>&nbsp;" ).
                ad( this.specialKeyByAlpha( TouchPanel._BUTTON_EVENT,cname,length ) ).
                ad( TouchPanel._$specialKey( TouchPanel._BUTTON_EVENT,cname ) ).
                ad( "<br>&nbsp;" ).
                ad( TouchPanel._$outputInKey( "touchpanel_keybord_input_button",TouchPanel._BUTTON_EVENT,
                    length,["0","/0","1","1","2","2","3","3","4","4","5","5","6","6","7","7","8","8","9","9"] ) ).
                ad( "<br>&nbsp;" ).
                ad( TouchPanel._$outputInKey( "touchpanel_keybord_input_button",TouchPanel._BUTTON_EVENT,
                    length,["Q","q","W","w","E","e","R","r","T","t","Y","y","U","u","I","i","O","o","P","p"] ) ).
                ad( "<br>&nbsp;" ).
                ad( TouchPanel._$outputInKey( "touchpanel_keybord_input_button",TouchPanel._BUTTON_EVENT,
                    length,["A","a","S","s","D","d","F","f","G","g","H","h","J","j","K","k","L","l","@","@"] ) ).
                ad( "<br>&nbsp;" ).
                ad( TouchPanel._$outputInKey( "touchpanel_keybord_input_button",TouchPanel._BUTTON_EVENT,
                    length,["Z","z","X","x","C","c","V","v","B","b","N","n","M","m",".","/.",",",",",":",":"] ) ).
                ad( "<br>&nbsp;" ).
                ad( TouchPanel._$outputInKey( "touchpanel_keybord_input_button",TouchPanel._BUTTON_EVENT,
                    length,["!","!","?","?","#","#","%","%","(","(",")",")","＝","＝","＋","/+","－","/-","＊","*"] ) ).
                ad( "<br>&nbsp;</div>" ).ts() ;
        },
        // タッチパネル用キーボードポップアップウィンドウ表示.
        window : function( cname,length ) {
            if( !$base.isNumeric( length ) ) {
                length = TouchPanel.maxLength ;
            }
            var evt = TouchPanel._BUTTON_EVENT ;
            popup.window( "TouchPanel.window."+cname,this.value( cname,length ),
                this.title,this.width,this.height,TouchPanel.group,TouchPanel._$callback_close,null,TouchPanel._hInfo ) ;
            TouchPanel._$initWindow( cname ) ;
        }
    },
    // 平仮名系.
    hiraKana : {
        width : 740,
        height : 445,
        title : "仮名入力",
        // タッチパネル用キーボードポップアップウィンドウ初期化.
        init : function( t,w,h ) {
            if( $base.useString( t ) ) {
                this.title = t ;
            }
            if( $base.isNumeric( w ) ) {
                this.width = w ;
            }
            if( $base.isNumeric( h ) ) {
                this.height = h ;
            }
        },
        // 特殊キー「仮名用」を設定.
        specialKeyByHiraKana : function( evt,cname,length ) {
            return new StrBuf().ad( "<input type=button class='touchpanel_special_input_button' value='カナ' " ).ad( evt ).
                ad( "=javascript:TouchPanel._$changeWindow(TouchPanel.kataKana,'" ).ad( cname ).ad( "'," ).ad( length ).ad( "); >" ).
                ad( "<input type=button class='touchpanel_special_input_button' value='゛' " ).ad( evt ).
                ad( "=javascript:TouchPanel._$inKeyKana('d.'," ).ad( length ).ad( "); >" ).
                ad( "<input type=button class='touchpanel_special_input_button' value='゜' " ).ad( evt ).
                ad( "=javascript:TouchPanel._$inKeyKana('h.'," ).ad( length ).ad( "); >" ).
                ad( "<input type=button class='touchpanel_special_input_button' value='漢字' " ).ad( evt ).
                ad( "=javascript:TouchPanel._$startIME(); >" ).
                ad( "<input type=button class='touchpanel_special_input_button' value='変換' " ).ad( evt).
                ad( "=javascript:TouchPanel._$convertIME(); >" ).
                ad( "<input type=button class='touchpanel_special_input_button' value='space' " ).ad( evt ).
                ad( "=javascript:TouchPanel._$inKey('_'," ).ad( length ).ad( "); >").
                ad( "<input type=button class='touchpanel_special_input_button' value='小' " ).ad( evt ).
                ad( "=javascript:TouchPanel._$inKeyKana('c.'," ).ad( length ).ad( "); >" ).ts() ;
        },
        // タッチパネル用表示データ.
        value : function( cname,length ) {
            TouchPanel._$startIME( false ) ;
            TouchPanel._imeToElement = [ this,cname,length ] ;
            return new StrBuf().ad( TouchPanel._$inputView() ).
                ad( "<div id='_$touchpanel_input_buttons_viewId' class='touchpanel_input_buttons_view'>&nbsp;" ).
                ad( this.specialKeyByHiraKana( TouchPanel._BUTTON_EVENT,cname,length ) ).
                ad( TouchPanel._$specialKey( TouchPanel._BUTTON_EVENT,cname ) ).
                ad( "<br>&nbsp;" ).
                ad( TouchPanel._$outputInKeyKana( "touchpanel_keybord_input_button",TouchPanel._BUTTON_EVENT,
                    length,["あ","あ","か","か","さ","さ","た","た","な","な","は","は","ま","ま","や","や","ら","ら","わ","わ"] ) ).
                ad( "<br>&nbsp;" ).
                ad( TouchPanel._$outputInKeyKana( "touchpanel_keybord_input_button",TouchPanel._BUTTON_EVENT,
                    length,["い","い","き","き","し","し","ち","ち","に","に","ひ","ひ","み","み","ゆ","ゆ","り","り","を","を"] ) ).
                ad( "<br>&nbsp;" ).
                ad( TouchPanel._$outputInKeyKana( "touchpanel_keybord_input_button",TouchPanel._BUTTON_EVENT,
                    length,["う","う","く","く","す","す","つ","つ","ぬ","ぬ","ふ","ふ","む","む","よ","よ","る","る","ん","ん"] ) ).
                ad( "<br>&nbsp;" ).
                ad( TouchPanel._$outputInKeyKana( "touchpanel_keybord_input_button",TouchPanel._BUTTON_EVENT,
                    length,["え","え","け","け","せ","せ","て","て","ね","ね","へ","へ","め","め","！","！","れ","れ","、","、"] ) ).
                ad( "<br>&nbsp;" ).
                ad( TouchPanel._$outputInKeyKana( "touchpanel_keybord_input_button",TouchPanel._BUTTON_EVENT,
                    length,["お","お","こ","こ","そ","そ","と","と","の","の","ほ","ほ","も","も","？","？","ろ","ろ","。","。"] ) ).
                ad( "<br>&nbsp;</div>" ).ts() ;
        },
        // タッチパネル用キーボードポップアップウィンドウ表示.
        window : function( cname,length ) {
            if( !$base.isNumeric( length ) ) {
                length = TouchPanel.maxLength ;
            }
            var evt = TouchPanel._BUTTON_EVENT ;
            popup.window( "TouchPanel.window."+cname,this.value( cname,length ),
                this.title,this.width,this.height,TouchPanel.group,TouchPanel._$callback_close,null,TouchPanel._hInfo ) ;
            TouchPanel._$initWindow( cname ) ;
        }
    },
    // カタカナ系.
    kataKana : {
        width : 740,
        height : 445,
        title : "カナ入力",
        // タッチパネル用キーボードポップアップウィンドウ初期化.
        init : function( t,w,h ) {
            if( $base.useString( t ) ) {
                this.title = t ;
            }
            if( $base.isNumeric( w ) ) {
                this.width = w ;
            }
            if( $base.isNumeric( h ) ) {
                this.height = h ;
            }
        },
        // 特殊キー「カタカナ用」を設定.
        specialKeyByKatakana : function( evt,cname,length ) {
            return new StrBuf().ad( "<input type=button class='touchpanel_special_input_button' value='英数' " ).ad( evt ).
                ad( "=javascript:TouchPanel._$changeWindow(TouchPanel.alpha,'" ).ad( cname ).ad( "'," ).ad( length ).ad( "); >" ).
                ad( "<input type=button class='touchpanel_special_input_button' value='゛' " ).ad( evt ).
                ad( "=javascript:TouchPanel._$inKeyKana('d.'," ).ad( length ).ad( "); >" ).
                ad( "<input type=button class='touchpanel_special_input_button' value='゜' " ).ad( evt ).
                ad( "=javascript:TouchPanel._$inKeyKana('h.'," ).ad( length ).ad( "); >" ).
                ad( TouchPanel._$nonKey( "touchpanel_special_input_button",2 ) ).
                ad( "<input type=button class='touchpanel_special_input_button' value='space' " ).ad( evt ).
                ad( "=javascript:TouchPanel._$inKey('_'," ).ad( length ).ad( "); >" ).
                ad( "<input type=button class='touchpanel_special_input_button' value='小' " ).ad( evt ).
                ad( "=javascript:TouchPanel._$inKeyKana('c.'," ).ad( length ).ad( "); >" ).ts() ;
        },
        // タッチパネル用表示データ.
        value : function( cname,length ) {
            TouchPanel._$startIME( false ) ;
            TouchPanel._imeToElement = [ this,cname,length ] ;
            return new StrBuf().ad( TouchPanel._$inputView() ).
                ad( "<div id='_$touchpanel_input_buttons_viewId' class='touchpanel_input_buttons_view'>&nbsp;" ).
                ad( this.specialKeyByKatakana( TouchPanel._BUTTON_EVENT,cname,length ) ).
                ad( TouchPanel._$specialKey( TouchPanel._BUTTON_EVENT,cname ) ).
                ad( "<br>&nbsp;" ).
                ad( TouchPanel._$outputInKeyKana( "touchpanel_keybord_input_button",TouchPanel._BUTTON_EVENT,
                    length,["ア","ア","カ","カ","サ","サ","タ","タ","ナ","ナ","ハ","ハ","マ","マ","ヤ","ヤ","ラ","ラ","ワ","ワ"] ) ).
                ad( "<br>&nbsp;" ).
                ad( TouchPanel._$outputInKeyKana( "touchpanel_keybord_input_button",TouchPanel._BUTTON_EVENT,
                    length,["イ","イ","キ","キ","シ","シ","チ","チ","ニ","ニ","ヒ","ヒ","ミ","ミ","ユ","ユ","リ","リ","ヲ","ヲ"] ) ).
                ad( "<br>&nbsp;" ).
                ad( TouchPanel._$outputInKeyKana( "touchpanel_keybord_input_button",TouchPanel._BUTTON_EVENT,
                    length,["ウ","ウ","ク","ク","ス","ス","ツ","ツ","ヌ","ヌ","フ","フ","ム","ム","ヨ","ヨ","ル","ル","ン","ン"] ) ).
                ad( "<br>&nbsp;" ).
                ad( TouchPanel._$outputInKeyKana( "touchpanel_keybord_input_button",TouchPanel._BUTTON_EVENT,
                    length,["エ","エ","ケ","ケ","セ","セ","テ","テ","ネ","ネ","ヘ","ヘ","メ","メ","ー","ー","レ","レ","、","、"] ) ).
                ad( "<br>&nbsp;" ).
                ad( TouchPanel._$outputInKeyKana( "touchpanel_keybord_input_button",TouchPanel._BUTTON_EVENT,
                    length,["オ","オ","コ","コ","ソ","ソ","ト","ト","ノ","ノ","ホ","ホ","モ","モ","？","？","ロ","ロ","。","。"] ) ).
                ad( "<br>&nbsp;</div>" ).ts() ;
        },
        // タッチパネル用キーボードポップアップウィンドウ表示.
        window : function( cname,length ) {
            if( !$base.isNumeric( length ) ) {
                length = TouchPanel.maxLength ;
            }
            var evt = TouchPanel._BUTTON_EVENT ;
            popup.window( "TouchPanel.window."+cname,this.value( cname,length ),
                this.title,this.width,this.height,TouchPanel.group,TouchPanel._$callback_close,null,TouchPanel._hInfo ) ;
            TouchPanel._$initWindow( cname ) ;
        }
    }
}

// タッチパネルモードを取得.
getTouchPanelMode = function() {
    var ret = getGlobal( "_$touch_panel_mode" ) ;
    if( $base.isNull( ret ) ) {
        var md = getCookie( "seabass_tablet_mode" ) ;
        if( md == "true" ) {
            ret = true ;
        }
        else {
            ret = false ;
        }
        setGlobal( "_$touch_panel_mode",ret ) ;
    }
    return ret ;
}

////////////////////////////////////////////////////////////////////////////////
// ポップアップ系イベント登録.
////////////////////////////////////////////////////////////////////////////////

// タブレットモードでない場合は、マウスジェスチャーをOFFにする。
if( !$base.isNull( getCookie( "seabass_tablet_mode" ) ) && getCookie( "seabass_tablet_mode" ) == "true" ) {
    $base.addEvent( $base.getBody(),"load",Scroll.init ) ;
}

// タブレットモードでない場合は、マウスジェスチャーをOFFにする。
// ただし、範囲選択を無効にするための処理を有効にする.
//if( $base.isNull( getCookie( "seabass_tablet_mode" ) ) ||
//    getCookie( "seabass_tablet_mode" ) == "false" ) {
//    Scroll.noMoveMode = true ;// スクロールさせない.
//}

//$base.addEvent( $base.getBody(),"load",Scroll.init ) ;
$base.addEvent( $base.getBody(),"load",popup.initEvent ) ;

////////////////////////////////////////////////////////////////////////////////
// WebApp初期化処理.
////////////////////////////////////////////////////////////////////////////////

// Webアプリケーション用初期化処理.
_$initWebApp = function() {
    webAppByNotKey() ;
    emergencyMessage() ;
}

////////////////////////////////////////////////////////////////////////////////
// テーブル操作処理.
////////////////////////////////////////////////////////////////////////////////

Table = {
    // テーブル内の情報を置き換える.
    change : function( target,res ) {
        if( $base.isNull( target ) ) {
            return false ;
        }
        var id ;
        var em ;
        if( typeof( target ) == "string" ) {
            id = target ;
            em = $(target) ;
        }
        else {
            id = target.id ;
            em = target ;
        }
        if( $base.isNull( em ) ) {
            return false ;
        }
        var tableIdFlag = false ;
        if( em.tagName.toUpperCase() == "TABLE" ) {
            tableIdFlag = true ;
            em = em.getElementsByTagName("tbody")[0] ;
            if( $base.isNull( em ) ) {
                return false ;
            }
        }
        if( tableIdFlag || !$base.useString( id ) ) {
            res = new StrBuf( "<table><tbody>" ).ad( res ).ad( "</tbody></table>" ).ts() ;
        }
        else {
            res = new StrBuf( "<table><tbody id='").ad( id ).ad( "'>" ).ad( res ).ad( "</tbody></table>" ).ts() ;
        }
        var dummyEm = document.createElement( "div" ) ;
        dummyEm.innerHTML = res ;
        dummyEm = dummyEm.getElementsByTagName("tbody")[0] ;
        if( !$base.isNull( dummyEm ) ) {
            var parentEm = em.parentNode ;
            if( !$base.isNull( parentEm ) ) {
                parentEm.replaceChild( dummyEm,em ) ;
                return true ;
            }
        }
        return false ;
    },
    // １行追加.
    add : function( parentEm,res,no ) {
        if( $base.isNull( parentEm ) ) {
            return false ;
        }
        var targetEm = null ;
        if( $base.isNumeric( no ) ) {
            no = parseInt( no ) ;
            var targetEm = parentEm.childNodes ;
            if( $base.isNull( targetEm ) || no <= -1 || no >= targetEm.length ) {
                return false ;
            }
        }
        if( typeof( res ) == "string" ) {
            res = new StrBuf( "<table><tbody>" ).ad( res ).ad( "</tbody></table>" ).ts() ;
            var dummyEm = document.createElement( "div" ) ;
            dummyEm.innerHTML = res ;
            dummyEm = dummyEm.getElementsByTagName("tbody")[0] ;
            if( $base.isNull( dummyEm ) || $base.isNull( ( dummyEm = dummyEm.childNodes[ 0 ] ) ) ) {
                return false ;
            }
            res = dummyEm ;
        }
        if( !$base.isNull( targetEm ) ) {
            parentEm.insertBefore( res,targetEm[no+1] ) ;
        }
        else {
            parentEm.appendChild( res ) ;
        }
        return true ;
    },
    // １行削除.
    remove : function( parentEm,no ) {
        if( $base.isNull( parentEm ) ) {
            return false ;
        }
        var targetEm = null ;
        if( $base.isNumeric( no ) ) {
            no = parseInt( no ) ;
            var targetEm = parentEm.childNodes ;
            if( $base.isNull( targetEm ) || no <= -1 || no >= targetEm.length ) {
                return false ;
            }
            parentEm.removeChild( targetEm[ no ] ) ;
            return true ;
        }
        return false ;
    }
}

////////////////////////////////////////////////////////////////////////////////
// 特殊効果.
////////////////////////////////////////////////////////////////////////////////

// メッセージブリンク.
blinkMessage = function( clazz,time ) {
    var _func = function() {
        var allTags = ( document.getElementsByTagName('*') || document.all );
        if( $base.isNull( allTags ) ) {
            return ;
        }
        var obj ;
        for (i = 0; i < allTags.length; i++) {
            obj = allTags[i];
            if (obj.className == clazz) {
                if (obj.style.visibility == "visible") {
                    obj.style.visibility = "hidden";
                } else {
                    obj.style.visibility = "visible";
                }
            }
        }
    }
    if( $base.isNull( __VAL_GLOVAL__['_$blinkId'] ) ) {
        __VAL_GLOVAL__['_$blinkId'] = {} ;
    }
    __VAL_GLOVAL__['_$blinkId'][ clazz ] = setInterval( _func, time);
}

// メッセージブリンク停止.
stopBlinkMessage = function( clazz ) {
    var ids = __VAL_GLOVAL__['_$blinkId'] ;
    if( $base.isNull( ids ) || $base.isNull( ids[ clazz ] ) ) {
        return ;
    }
    clearInterval( ids[ clazz ] ) ;
    ids[ clazz ] = null ;
    // 全てのメッセージを表示可能に戻す.
    var allTags = ( document.getElementsByTagName('*') || document.all );
    if( $base.isNull( allTags ) ) {
        return ;
    }
    var obj ;
    for (i = 0; i < allTags.length; i++) {
        obj = allTags[i];
        if (obj.className == clazz) {
            if (obj.style.visibility != "visible") {
                obj.style.visibility = "visible";
            }
        }
    }
}

// 指定クラスのアイテムをロック／アンロック.
on_off = function( clazz,flag ) {
    // 全てのメッセージを表示可能に戻す.
    var allTags = ( document.getElementsByTagName('*') || document.all );
    if( $base.isNull( allTags ) ) {
        return ;
    }
    var flag = !flag ;
    var obj ;
    for (i = 0; i < allTags.length; i++) {
        obj = allTags[i];
        if (obj.className == clazz) {
            obj.disabled = flag ;
        }
    }
}

